************************************************************************
      SUBROUTINE FPOST(ITYP,IFILEN,ITFILM,UE,MFILE,MSHOW)
************************************************************************
*   Purpose: - performs the nonsteady postprocess:
*                   - output for film generation
*                   - output for AVS
*                   - output for GMV
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CXX(10)*15,CFILE*15
C
      DATA CXX/'#ns/#DX1       ','#ns/#DX2       ','#ns/#DX3       ',
     *         '#ns/#DX4       ','#ns/#DX5       ','#ns/#DX6       ',
     *         '#ns/#DX7       ','#ns/#DX8       ','#ns/#DX9       ',
     *         '#ns/#DX10      '/
C
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSSAV/  INSAV,INSAVN
      COMMON /NSSAVF/ DTFILM,DTFILO,DTAVS,DTAVSO,DTGMV,DTGMVO,
     *                IFUSAV,IFPSAV,IFXSAV,IAVS,IGMV,IFINIT
      COMMON /NSPTS/  KPU(2),KPP(4),KPX(4),KPI(2),DPI(2,2),DPF(2)
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      CHARACTER CPARM1*60,CMESH1*60,CFILE1*60,CSTART*60,CSOL*60
      COMMON /FILES/ IMESH1,MMESH1,CPARM1,CMESH1,MFILE1,CFILE1,
     *               ISTART,MSTART,CSTART,ISOL,MSOL,CSOL
C
      SAVE 
C-----------------------------------------------------------------------
C
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
C *** Coefficient of exact solution and fem basis functions
      EXTERNAL UE,EM30,EM31,E030,E031
C=======================================================================
      SUB='FPOST '
C
C
C
      NGRAPH=MAX(IAVS,IGMV)
C
      ILEV=NLEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
C
      CALL PTSDAT(TIMENS,DBLE(NY))
C
C=======================================================================
C *** write the solution vector if ABS(ISOL)=1
C=======================================================================
C
      IF ((ITYP.EQ.0).AND.(ABS(ISOL).EQ.1)) THEN
       IF (ISOL.EQ.1) THEN
        IFMTS=0
       ELSE
        IFMTS=1
       ENDIF
       CALL  OF0 (MSOL,CSOL,IFMTS)
       CALL  OWA1 (DWORK(KU1),'DU12P ',NUP,MSOL,IFMTS)
       CLOSE(MSOL)
      ENDIF
C
C=======================================================================
C *** write unformatted time dep. solution vector
C=======================================================================
C
      IF ((ITYP.EQ.1).AND.(INSAV.GT.0)) THEN
      IF (MOD(ITNS,INSAV).EQ.0) THEN
       IFILEN=IFILEN+1
       ITWX=MOD(IFILEN+INSAVN-1,INSAVN)+1
       CALL  OF0 (39,CXX(ITWX),0)
       CALL  OWA1 (DWORK(KU1),'DU12P ',NUP,39,0)
       REWIND(39)
       CLOSE (39)
       IF (IER.NE.0) GOTO 99999
      ENDIF
      ENDIF
C
C=======================================================================
C
      IF ((ITYP.EQ.1).AND.((TIMENS-DTFILO).GE.DTFILM)) THEN
       ITFILM=ITFILM+1
       WRITE(40,*) REAL(TIMENS)
      ENDIF
C
C=======================================================================
C *** write velocities 
C=======================================================================
C
       KMOV1=L(LD1)
       KMOV2=KMOV1+NVT
       KAUXM=L(KLAUX(NLEV))
C
       CALL  INTUVD(DWORK(KU1),DWORK(KU2),DWORK(KMOV1),DWORK(KMOV2),
     *              DWORK(KAUXM),NVT,NEL,NVBD,
     *              KWORK(L(LMID)),KWORK(L(LVERT)),KWORK(L(LVBD)),
     *              KWORK(L(KLMBD(NLEV))),DWORK(L(LCORVG)),UE)
C
       IF ((ITYP.EQ.1).AND.(IFUSAV.GT.0)
     *                .AND.((TIMENS-DTFILO).GE.DTFILM)) THEN
        CFILE='#film/#DU      '
        IF ((ITFILM.GE.0).AND.(ITFILM.LT.10)) 
     *       WRITE(CFILE(10:10),'(I1.1)') ITFILM
        IF ((ITFILM.GE.10).AND.(ITFILM.LT.100)) 
     *       WRITE(CFILE(10:11),'(I2.2)') ITFILM
        IF ((ITFILM.GE.100).AND.(ITFILM.LT.1000)) 
     *       WRITE(CFILE(10:12),'(I3.3)') ITFILM
        IF ((ITFILM.GE.1000).AND.(ITFILM.LT.10000)) 
     *       WRITE(CFILE(10:13),'(I4.4)') ITFILM
        IF (ITFILM.GE.10000) STOP
C
        CALL OF0 (39,CFILE,0)
        IF (IER.NE.0) GOTO 99998
        CALL  OWA1 (DWORK(KMOV1),'DUF   ',KNVT(IFUSAV),39,0)
        CALL  OWA1 (DWORK(KMOV2),'DUF   ',KNVT(IFUSAV),39,0)
        REWIND(39)
        CLOSE (39)
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (((ITYP.EQ.0).AND.(IAVS.GT.0)).OR.
     *     ((ITYP.EQ.0).AND.(IGMV.GT.0)).OR.
     *     ((ITYP.EQ.1).AND.(IAVS.GT.0)
     *                 .AND.((TIMENS-DTAVSO).GE.DTAVS)) .OR.
     *     ((ITYP.EQ.1).AND.(IGMV.GT.0)
     *                 .AND.((TIMENS-DTGMVO).GE.DTGMV))) THEN
        CALL ZNEW (2*KNVT(NGRAPH),-2,LAVSU,'AVSU  ')
        IF (IER.NE.0) GOTO 99998
        KAVS1=L(LAVSU)
        KAVS2=KAVS1+KNVT(NGRAPH)
        DO 100 IVTA=1,KNVT(NGRAPH)
        VWORK(KAVS1+IVTA-1)=REAL(DWORK(KMOV1+IVTA-1))
100     VWORK(KAVS2+IVTA-1)=REAL(DWORK(KMOV2+IVTA-1))
       ENDIF
C
      IF (ITYP.EQ.1) THEN
       IF (MSHOW.GE.2) 
     *  WRITE(MTERM,1001) DWORK(KMOV1+KPU(1)-1),DWORK(KMOV2+KPU(1)-1),
     *                    DWORK(KMOV1+KPU(2)-1),DWORK(KMOV2+KPU(2)-1)
       IF (MSHOW.GE.1) 
     *  WRITE(MFILE,1001) DWORK(KMOV1+KPU(1)-1),DWORK(KMOV2+KPU(1)-1),
     *                    DWORK(KMOV1+KPU(2)-1),DWORK(KMOV2+KPU(2)-1)
       WRITE(41,*) REAL(TIMENS),REAL(DWORK(KMOV1+KPU(1)-1))
       WRITE(42,*) REAL(TIMENS),REAL(DWORK(KMOV2+KPU(1)-1))
       WRITE(43,*) REAL(TIMENS),REAL(DWORK(KMOV1+KPU(2)-1))
       WRITE(44,*) REAL(TIMENS),REAL(DWORK(KMOV2+KPU(2)-1))
      ENDIF
C
C=======================================================================
C *** write PRESSURE 
C=======================================================================
C
       KPL  =L(LD1)
       KAUXM=L(LD2)
       LAREA=KLAREA(NLEV)
C
       CALL  INTPV (DWORK(KP),DWORK(KPL),DWORK(KAUXM),VWORK(L(LAREA)),
     *              KWORK(L(LVERT)))
       IF (IER.NE.0) GOTO 99999
C
       IF ((ITYP.EQ.1).AND.(IFPSAV.GT.0)
     *                .AND.((TIMENS-DTFILO).GE.DTFILM)) THEN
        CFILE='#film/#DP      '
        IF ((ITFILM.GE.0).AND.(ITFILM.LT.10)) 
     *       WRITE(CFILE(10:10),'(I1.1)') ITFILM
        IF ((ITFILM.GE.10).AND.(ITFILM.LT.100)) 
     *       WRITE(CFILE(10:11),'(I2.2)') ITFILM
        IF ((ITFILM.GE.100).AND.(ITFILM.LT.1000)) 
     *       WRITE(CFILE(10:12),'(I3.3)') ITFILM
        IF ((ITFILM.GE.1000).AND.(ITFILM.LT.10000)) 
     *       WRITE(CFILE(10:13),'(I4.4)') ITFILM
        IF (ITFILM.GE.10000) STOP
C
        CALL OF0 (39,CFILE,0)
        IF (IER.NE.0) GOTO 99998
        CALL  OWA1 (DWORK(KPL),'DPL   ',KNVT(IFPSAV),39,0)
        REWIND(39)
        CLOSE (39)
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (((ITYP.EQ.0).AND.(IAVS.GT.0)).OR.
     *     ((ITYP.EQ.0).AND.(IGMV.GT.0)).OR.
     *     ((ITYP.EQ.1).AND.(IAVS.GT.0)
     *                 .AND.((TIMENS-DTAVSO).GE.DTAVS)) .OR.
     *     ((ITYP.EQ.1).AND.(IGMV.GT.0)
     *                 .AND.((TIMENS-DTGMVO).GE.DTGMV))) THEN
        CALL ZNEW (KNVT(NGRAPH),-2,LAVSP,'AVSP  ')
        IF (IER.NE.0) GOTO 99998
        KAVSP=L(LAVSP)
        DO 200 IVTA=1,KNVT(NGRAPH)
200     VWORK(KAVSP+IVTA-1)=REAL(DWORK(KPL+IVTA-1))
       ENDIF
C
      IF (ITYP.EQ.1) THEN
       IF (MSHOW.GE.2) 
     *  WRITE(MTERM,1002) DWORK(KPL+KPP(1)-1),DWORK(KPL+KPP(2)-1),
     *                    DWORK(KPL+KPP(3)-1),DWORK(KPL+KPP(4)-1)
       IF (MSHOW.GE.1) 
     *  WRITE(MFILE,1002) DWORK(KPL+KPP(1)-1),DWORK(KPL+KPP(2)-1),
     *                    DWORK(KPL+KPP(3)-1),DWORK(KPL+KPP(4)-1)
       WRITE(45,*) REAL(TIMENS),REAL(DWORK(KPL+KPP(1)-1))
       WRITE(46,*) REAL(TIMENS),REAL(DWORK(KPL+KPP(2)-1))
       WRITE(47,*) REAL(TIMENS),REAL(DWORK(KPL+KPP(3)-1))
       WRITE(48,*) REAL(TIMENS),REAL(DWORK(KPL+KPP(4)-1))
      ENDIF
C
       CALL  BDPRES(DWORK(KPL),KWORK(L(LVERT)),KWORK(L(LNPR)),
     *              KWORK(L(LVBD)),KWORK(L(LMM)),
     *              DWORK(L(LCORVG)),DWORK(L(LVBDP)),
     *              KNVBD(NLEV),P5,P6)
C
      IF (ITYP.EQ.1) THEN
       IF (MSHOW.GE.2) 
     *  WRITE(MTERM,1003) P5,P6
       IF (MSHOW.GE.1) 
     *  WRITE(MFILE,1003) P5,P6
       WRITE(49,*) REAL(TIMENS),REAL(P5)
       WRITE(50,*) REAL(TIMENS),REAL(P6)
      ENDIF
C
C=======================================================================
C *** write lift and drag 
C=======================================================================
C
       IF ((IELT.EQ.0).OR.(IELT.EQ.2)) 
     *  CALL  BDFORC(DWORK(KU1),DWORK(KU2),DWORK(KP),KWORK(L(LVERT)),
     *               KWORK(L(LMID)),KWORK(L(LVBD)),KWORK(L(LEBD)),
     *               KWORK(L(LMM)),DWORK(L(LCORVG)),EM31,DFW,DAW)
C
       IF ((IELT.EQ.1).OR.(IELT.EQ.3)) 
     *  CALL  BDFORC(DWORK(KU1),DWORK(KU2),DWORK(KP),KWORK(L(LVERT)),
     *               KWORK(L(LMID)),KWORK(L(LVBD)),KWORK(L(LEBD)),
     *               KWORK(L(LMM)),DWORK(L(LCORVG)),EM30,DFW,DAW)
C
      IF (ITYP.EQ.1) THEN
       IF (MSHOW.GE.2) 
     *  WRITE(MTERM,1004) DFW,DAW
       IF (MSHOW.GE.1) 
     *  WRITE(MFILE,1004) DFW,DAW
       WRITE(51,*) REAL(TIMENS),REAL(DFW)
       WRITE(52,*) REAL(TIMENS),REAL(DAW)
      ENDIF
C
C=======================================================================
C *** write streamfunction 
C=======================================================================
C
       KISO =L(LD1)
       KVIND=L(LD2)
C
       CALL  U2ISO (DWORK(L(LCORVG)),KWORK(L(LVERT)),KWORK(L(LMID)),
     *              KWORK(L(LADJ)),DWORK(KVIND),DWORK(KISO),
     *              DWORK(KU1),DWORK(KU2))
       IF (IER.NE.0) GOTO 99999
C
       IF ((ITYP.EQ.1).AND.(IFXSAV.GT.0)
     *                .AND.((TIMENS-DTFILO).GE.DTFILM)) THEN
        CFILE='#film/#DX      '
        IF ((ITFILM.GE.0).AND.(ITFILM.LT.10)) 
     *       WRITE(CFILE(10:10),'(I1.1)') ITFILM
        IF ((ITFILM.GE.10).AND.(ITFILM.LT.100)) 
     *       WRITE(CFILE(10:11),'(I2.2)') ITFILM
        IF ((ITFILM.GE.100).AND.(ITFILM.LT.1000)) 
     *       WRITE(CFILE(10:12),'(I3.3)') ITFILM
        IF ((ITFILM.GE.1000).AND.(ITFILM.LT.10000)) 
     *       WRITE(CFILE(10:13),'(I4.4)') ITFILM
        IF (ITFILM.GE.10000) STOP
C
        CALL OF0 (39,CFILE,0)
        IF (IER.NE.0) GOTO 99998
        CALL  OWA1 (DWORK(KISO),'DISO  ',KNVT(IFXSAV),39,0)
        REWIND(39)
        CLOSE (39)
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (((ITYP.EQ.0).AND.(IAVS.GT.0)).OR.
     *     ((ITYP.EQ.0).AND.(IGMV.GT.0)).OR.
     *     ((ITYP.EQ.1).AND.(IAVS.GT.0)
     *                 .AND.((TIMENS-DTAVSO).GE.DTAVS)) .OR.
     *     ((ITYP.EQ.1).AND.(IGMV.GT.0)
     *                 .AND.((TIMENS-DTGMVO).GE.DTGMV))) THEN
        CALL ZNEW (KNVT(NGRAPH),-2,LAVSI,'AVSI  ')
        IF (IER.NE.0) GOTO 99998
        KAVSI=L(LAVSI)
        DO 300 IVTA=1,KNVT(NGRAPH)
300     VWORK(KAVSI+IVTA-1)=REAL(DWORK(KISO+IVTA-1))
       ENDIF
C
      IF (ITYP.EQ.1) THEN
       IF (MSHOW.GE.2) 
     *  WRITE(MTERM,1005) DWORK(KISO+KPX(1)-1)-DWORK(KISO+KPX(2)-1)
       IF (MSHOW.GE.1) 
     *  WRITE(MFILE,1005) DWORK(KISO+KPX(1)-1)-DWORK(KISO+KPX(2)-1)
       WRITE(53,*) REAL(TIMENS),REAL( DWORK(KISO+KPX(1)-1)
     *                               -DWORK(KISO+KPX(2)-1))
      ENDIF
C
C=======================================================================
C
      IF ((ITYP.EQ.1).AND.((TIMENS-DTFILO).GE.DTFILM)) THEN
       DTFILO=TIMENS
      ENDIF
C
C=======================================================================
C *** write AVS and/or GMV
C=======================================================================
C
      IF (((ITYP.EQ.0).AND.(IAVS.GT.0)).OR.
     *    ((ITYP.EQ.0).AND.(IGMV.GT.0)).OR.
     *    ((ITYP.EQ.1).AND.(IAVS.GT.0)
     *                .AND.((TIMENS-DTAVSO).GE.DTAVS)) .OR.
     *    ((ITYP.EQ.1).AND.(IGMV.GT.0)
     *                .AND.((TIMENS-DTGMVO).GE.DTGMV))) THEN
C
       IF (((ITYP.EQ.0).AND.(IAVS.GT.0)).OR.
     *     ((ITYP.EQ.1).AND.(IAVS.GT.0)
     *                 .AND.((TIMENS-DTAVSO).GE.DTAVS))) THEN
       CFILE='#avs/u.        '
       IF ((ITNS+IFINIT.GE.0).AND.(ITNS+IFINIT.LT.10)) 
     *      WRITE(CFILE(8:8),'(I1.1)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.10).AND.(ITNS+IFINIT.LT.100)) 
     *      WRITE(CFILE(8:9),'(I2.2)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.100).AND.(ITNS+IFINIT.LT.1000)) 
     *      WRITE(CFILE(8:10),'(I3.3)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.1000).AND.(ITNS+IFINIT.LT.10000)) 
     *      WRITE(CFILE(8:11),'(I4.4)') ITNS+IFINIT
       IF (ITNS+IFINIT.GE.10000) STOP
C
       CALL XAVS2D(39,CFILE,KNEL(IAVS),KNVT(IAVS),
     *             KWORK(L(KLVERT(IAVS))),DWORK(L(LCORVG)),
     *             VWORK(KAVS1),VWORK(KAVS2),VWORK(KAVSP),
     *             VWORK(KAVSI))
       DTAVSO=TIMENS
       ENDIF
C
       IF (((ITYP.EQ.0).AND.(IGMV.GT.0)).OR.
     *     ((ITYP.EQ.1).AND.(IGMV.GT.0)
     *                 .AND.((TIMENS-DTGMVO).GE.DTGMV))) THEN
       CFILE='#gmv/u.        '
       IF ((ITNS+IFINIT.GE.0).AND.(ITNS+IFINIT.LT.10)) 
     *      WRITE(CFILE(8:8),'(I1.1)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.10).AND.(ITNS+IFINIT.LT.100)) 
     *      WRITE(CFILE(8:9),'(I2.2)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.100).AND.(ITNS+IFINIT.LT.1000)) 
     *      WRITE(CFILE(8:10),'(I3.3)') ITNS+IFINIT
       IF ((ITNS+IFINIT.GE.1000).AND.(ITNS+IFINIT.LT.10000)) 
     *      WRITE(CFILE(8:11),'(I4.4)') ITNS+IFINIT
       IF (ITNS+IFINIT.GE.10000) STOP
C
       CALL XGMV2D(39,CFILE,KNEL(IGMV),KNVT(IGMV),
     *             KWORK(L(KLVERT(IGMV))),DWORK(L(LCORVG)),
     *             VWORK(KAVS1),VWORK(KAVS2),VWORK(KAVSP),
     *             VWORK(KAVSI),TIMENS)
       DTGMVO=TIMENS
       ENDIF
C
       CALL ZDISP(0,LAVSI,'AVSI  ')
       CALL ZDISP(0,LAVSP,'AVSP  ')
       CALL ZDISP(0,LAVSU,'AVSU  ')
       IF (IER.NE.0) GOTO 99998
      ENDIF
C
C
      GOTO 99999
C
C=======================================================================
C     Error case
C=======================================================================
99998 WRITE(MTERM,*) 'IER', IER
      WRITE(MTERM,*) 'IN SUBROUTINE ',SUB
C
1000  FORMAT (6E12.5)
1001  FORMAT ('P(VELO) ',4(D12.5))
1002  FORMAT ('P(PRES) ',4(D12.5))
1003  FORMAT ('I(PRES) ',2(D12.5))
1004  FORMAT ('I(FORCE)',2(D12.5))
1005  FORMAT ('P(FLUX) ',1(D12.5))
c
c
c
99999 END

************************************************************************
      SUBROUTINE  VANCAS (U1,U2,P,U1OLD,U2OLD,POLD,F1,F2,FP,
     *                    A,KCOLA,KLDA,B1,B2,KCOLB,KLDB,NU,NP,
     *                    KMBD,KVERT,KMID,KNPR,NMBD)
************************************************************************
C
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DOUBLE PRECISION BB1,BB2
      REAL  A,B1,B2
C
      PARAMETER (NNVE=4)
      DIMENSION U1(*),U2(*),P(*),U1OLD(*),U2OLD(*),POLD(*)
      DIMENSION F1(*),F2(*),FP(*)
      DIMENSION A(*),KCOLA(*),KLDA(*),B1(*),B2(*),KCOLB(*),KLDB(*)
      DIMENSION KMBD(*),KVERT(NNVE,*),KMID(NNVE,*),KNPR(*)
C
C *** Local arrays for informations about one element
      DIMENSION AA(4),BB1(4),BB2(4),FF1(4),FF2(4),IU(4),BDBC(4)
C
C *** Usual data for mesh management
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      SAVE 
C
C-----------------------------------------------------------------------
C *** Update  UOLD:=U
      CALL  LCP1 (U1,U1OLD,NU)
      CALL  LCP1 (U2,U2OLD,NU)
      CALL  LCP1 (P ,POLD ,NP)
C
C=======================================================================
C     Block Gauss-Seidel on Schur Complement
C=======================================================================
C *** Loop over all elements
C
      DO 1  IEL=1,NEL
      FFP=FP(IEL)
C
C-----------------------------------------------------------------------
C *** Loop over all 4 U-nodes of that element
      DO 11  II=1,4
C
      IMID=KMID(II,IEL)
      I=IMID-NVT
      IU(II)=I
      IF (KNPR(IMID).EQ.0)  THEN
       BDBC(II)=.FALSE.
      ELSE
       BDBC(II)=.TRUE.
      ENDIF
C
C *** Put on AA(.) the diagonal entry of matrix A
      IA1=KLDA(I)
      AA(II)=DBLE(A(IA1))
C
C *** Initial setting of FF1,FF2
      FF1(II)=F1(I)
      FF2(II)=F2(I)
C
      IF (BDBC(II)) GOTO 13
C
C *** Put all off-diagonal entries of A to the right hand side
      IA2=KLDA(I+1)-1
      DO 110  IA=IA1+1,IA2
      J=KCOLA(IA)
      AOFF=DBLE(A(IA))
      FF1(II)=FF1(II)-AOFF*U1(J)
      FF2(II)=FF2(II)-AOFF*U2(J)
110   CONTINUE
C
C-----------------------------------------------------------------------
C *** Get BB1,BB2 and modify FF1,FF2
      IB1=KLDB(I)
      IB2=KLDB(I+1)-1
      JP1=KCOLB(IB1)
      JP2=KCOLB(IB2)
C
      IF (JP1.EQ.IEL)  THEN
          PJP=P(JP2)
          BB1(II)=DBLE(B1(IB1))
          BB2(II)=DBLE(B2(IB1))
          FF1(II)=FF1(II)-DBLE(B1(IB2))*PJP
          FF2(II)=FF2(II)-DBLE(B2(IB2))*PJP
      ELSE IF (JP2.EQ.IEL)  THEN
          PJP=P(JP1)
          BB1(II)=DBLE(B1(IB2))
          BB2(II)=DBLE(B2(IB2))
          FF1(II)=FF1(II)-DBLE(B1(IB1))*PJP
          FF2(II)=FF2(II)-DBLE(B2(IB1))*PJP
      ELSE
          WRITE(MTERM,*) 'ERROR in SMOOTH: IEL entry in B not found'
          STOP
      ENDIF
C
      GOTO 11
C
C-----------------------------------------------------------------------
C *** The case that II is a Dirichlet boundary node
13    CONTINUE
      IB=KLDB(I)
      JP=KCOLB(IB)
      BB1(II)=DBLE(B1(IB))
      BB2(II)=DBLE(B2(IB))
C
11    CONTINUE
C
C-----------------------------------------------------------------------
C *** Calling the subroutine ELUPDT for element update 
      CALL  ELUPDT (U1,U2,P,IEL,IU,BDBC,AA,BB1,BB2,FF1,FF2,FFP)
C
1     CONTINUE
C
C=======================================================================
C
C *** Relaxation   U:= RLXSM*U + (1-RLXSM)*UOLD
      IF (RLXSM.NE.1D0) THEN
       A1= 1D0-RLXSM
       A2=     RLXSM
       CALL  LLC1 (U1OLD,U1,NU,A1,A2)
       CALL  LLC1 (U2OLD,U2,NU,A1,A2)
       CALL  LLC1 (POLD ,P ,NP,A1,A2)
      ENDIF
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE  ELUPDT  (U1,U2,P,IEL,IU,BDBC,AA,BB1,BB2,FF1,FF2,FFP)
************************************************************************
*    Purpose: - Executes block Gauss-Seidel update on (U1,U2,P)
*               for all unknowns of the element IEL
************************************************************************
C
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DOUBLE PRECISION  BB1,BB2
C
      DIMENSION U1(*),U2(*),P(*)
C
C *** Local arrays for informations about the element
      DIMENSION AA(4),BB1(4),BB2(4),FF1(4),FF2(4),IU(4),BDBC(4)
      DIMENSION AI(4),DD1(4),DD2(4),UU1(4),UU2(4)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE 
C
C-----------------------------------------------------------------------
C
      DO 1  II=1,4
      IF (BDBC(II))  THEN
          DD1(II)=0D0
          DD2(II)=0D0
      ELSE
          DD1(II)=BB1(II)
          DD2(II)=BB2(II)
      ENDIF
      IF (DABS(AA(II)).LT.1.D-10)  THEN
         WRITE(MTERM,*)'ERROR in ELUPDT: diagonal entry is nearly zero'
         WRITE(MTERM,*)'II, I, BNDR(II) : ',II,IU(II),BDBC(II)
         RETURN
      ENDIF
      AI(II)=1D0/AA(II)
1     CONTINUE
C
C *** Factorization loop
C
      DP=0.D0
      DO 2  II=1,4
      DP =DP  - AI(II)*(BB1(II)*DD1(II)+BB2(II)*DD2(II))
      FFP=FFP - AI(II)*(BB1(II)*FF1(II)+BB2(II)*FF2(II))
2     CONTINUE
C
C *** Solution loop
C
      IF (DABS(DP).LT.1.D-10)  THEN
         WRITE(MTERM,*)'ERROR in ELUPDT: DP is nearly zero'
         RETURN
      ENDIF
      PP=FFP/DP
      DO 3  II=1,4
      UU1(II)=AI(II)*(FF1(II)-DD1(II)*PP)
      UU2(II)=AI(II)*(FF2(II)-DD2(II)*PP)
3     CONTINUE
C
C *** Updating the global solution vector (U1,U2,P)
C
      P(IEL)=PP
      DO 4  II=1,4
      IF (BDBC(II)) GOTO 4
      I=IU(II)
      U1(I)=UU1(II)
      U2(I)=UU2(II)
4     CONTINUE
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE  VANCAE (U1,U2,P,U1OLD,U2OLD,POLD,F1,F2,FP,
     *                    A,KCOLA,KLDA,B1,B2,KCOLB,KLDB,NU,NP,
     *                    KMBD,KVERT,KMID,KNPR,NMBD,RLXPAR,DMAXU,DMAXP)
************************************************************************
C
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DOUBLE PRECISION BB1,BB2
      REAL  A,B1,B2
C
      PARAMETER (NNVE=4)
      DIMENSION U1(*),U2(*),P(*),U1OLD(*),U2OLD(*),POLD(*)
      DIMENSION F1(*),F2(*),FP(*)
      DIMENSION A(*),KCOLA(*),KLDA(*),B1(*),B2(*),KCOLB(*),KLDB(*)
      DIMENSION KMBD(*),KVERT(NNVE,*),KMID(NNVE,*),KNPR(*)
C
C *** Local arrays for informations about one element
      DIMENSION AA(4),BB1(4),BB2(4),FF1(4),FF2(4),  IU(4),  BDBC(4)
C
C *** Usual data for mesh management
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      SAVE 
C
C-----------------------------------------------------------------------
      DMAXU=0D0
      DMAXP=0D0
C
C *** Update  UOLD:=U
      CALL  LCP1 (U1,U1OLD,NU)
      CALL  LCP1 (U2,U2OLD,NU)
      CALL  LCP1 (P ,POLD ,NP)
C
C=======================================================================
C     Block Gauss-Seidel on Schur Complement
C=======================================================================
C *** Loop over all elements
C
      DO 1  IEL=1,NEL
      FFP =FP(IEL)
      FFPH=FFP
C
C-----------------------------------------------------------------------
C *** Loop over all 4 U-nodes of that element
      DO 11  II=1,4
C
      IMID=KMID(II,IEL)
      I=IMID-NVT
      IU(II)=I
      IF (KNPR(IMID).EQ.0)  THEN
         BDBC(II)=.FALSE.
      ELSE
         BDBC(II)=.TRUE.
      ENDIF
C
C *** Put on AA(.) the diagonal entry of matrix A
      IA1=KLDA(I)
      AA(II)=DBLE(A(IA1))
C
C *** Initial setting of FF1,FF2
      FF1(II)=F1(I)
      FF2(II)=F2(I)
C
      IF (BDBC(II)) GOTO 13
C
C *** Put all off-diagonal entries of A to the right hand side
      IA2=KLDA(I+1)-1
      DO 110  IA=IA1+1,IA2
      J=KCOLA(IA)
      AOFF=DBLE(A(IA))
      FF1(II)=FF1(II)-AOFF*U1(J)
      FF2(II)=FF2(II)-AOFF*U2(J)
 110  CONTINUE
C
C-----------------------------------------------------------------------
C *** Get BB1,BB2 and modify FF1,FF2
      IB1=KLDB(I)
      IB2=KLDB(I+1)-1
      JP1=KCOLB(IB1)
      JP2=KCOLB(IB2)
C
      IF (JP1.EQ.IEL)  THEN
          PJP=P(JP2)
          BB1(II)=DBLE(B1(IB1))
          BB2(II)=DBLE(B2(IB1))
          FF1(II)=FF1(II)-DBLE(B1(IB2))*PJP
          FF2(II)=FF2(II)-DBLE(B2(IB2))*PJP
          IB3    =IB1
          JP3    =JP1
      ELSE IF (JP2.EQ.IEL)  THEN
          PJP=P(JP1)
          BB1(II)=DBLE(B1(IB2))
          BB2(II)=DBLE(B2(IB2))
          FF1(II)=FF1(II)-DBLE(B1(IB1))*PJP
          FF2(II)=FF2(II)-DBLE(B2(IB1))*PJP
          IB3    =IB2
          JP3    =JP2
      ELSE
          WRITE(MTERM,*) 'ERROR in SMOOTH: IEL entry in B not found'
          STOP
      ENDIF
C
      AH=DBLE(A(IA1))
      ICOLA1=KCOLA(IA1)
      PJP=P(JP3)
      DMAXU=MAX(DMAXU,ABS(FF1(II)-AH*U1(ICOLA1)-DBLE(B1(IB3))*PJP))
      DMAXU=MAX(DMAXU,ABS(FF2(II)-AH*U2(ICOLA1)-DBLE(B2(IB3))*PJP))
      FFPH=FFPH-BB1(II)*U1(IU(II))-BB2(II)*U2(IU(II))
C
      GOTO 11
C
C-----------------------------------------------------------------------
C *** The case that II is a Dirichlet boundary node
13    CONTINUE
      IB=KLDB(I)
      JP=KCOLB(IB)
      BB1(II)=DBLE(B1(IB))
      BB2(II)=DBLE(B2(IB))
C
      FFPH=FFPH-BB1(II)*U1(IU(II))-BB2(II)*U2(IU(II))
C
11    CONTINUE
C
      DMAXP=MAX(DMAXP,FFPH)
C
C-----------------------------------------------------------------------
C *** Calling the subroutine ELUPDT for element update 
      CALL  ELUPDT (U1,U2,P,IEL,IU,BDBC,AA,BB1,BB2,FF1,FF2,FFP)
C
1     CONTINUE
C
C=======================================================================
C
C *** Relaxation   U:= RLXPAR*U + (1-RLXPAR)*UOLD
      IF (RLXPAR.NE.1D0) THEN
       A1= 1D0-RLXPAR
       A2=     RLXPAR
       CALL  LLC1 (U1OLD,U1,NU,A1,A2)
       CALL  LLC1 (U2OLD,U2,NU,A1,A2)
       CALL  LLC1 (POLD ,P ,NP,A1,A2)
      ENDIF
C
C
C
      END
C
C
C

************************************************************************
      DOUBLE PRECISION FUNCTION   COEFST (X,Y,IA,IB,IBLOC,BFIRST)
*
*     Coefficient for the Stokes-block
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
C
C
      IF ((IA.EQ.1).AND.(IB.EQ.1)) THEN
       COEFST=1D0
      ELSE
       COEFST=NY
      ENDIF
C
      END
C
************************************************************************
      DOUBLE PRECISION FUNCTION COEFFN(IA,IB,U1L1,U1L2,U2L1,U2L2,
     *                                 A1L,A2L,DELTA,DCMASS)
*
*     Coefficient for the convective-block
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNAB=21)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS),U1L1(*),U1L2(*),U2L1(*),U2L2(*)
C
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /COAUX1/ KDFG,KDFL,IDFL
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
C
      DU1=0D0
      DU2=0D0
C 
      IF (DCMASS.NE.0D0) THEN
C
       DO 10 JDFL=1,IDFL
       HBAS=DBAS(KDFL(JDFL),1)
       DU1=DU1+(A1L*U1L1(KDFG(JDFL))+A2L*U2L1(KDFG(JDFL)))*HBAS
       DU2=DU2+(A1L*U1L2(KDFG(JDFL))+A2L*U2L2(KDFG(JDFL)))*HBAS
10     CONTINUE
C
       IF ((IA.EQ.1).AND.(IB.EQ.2)) COEFFN=DU1
       IF ((IA.EQ.1).AND.(IB.EQ.3)) COEFFN=DU2
       IF ((IA.EQ.2).AND.(IB.EQ.3)) COEFFN=DELTA*DU1*DU2
       IF ((IA.EQ.3).AND.(IB.EQ.2)) COEFFN=DELTA*DU1*DU2
C
       IF ((IA.EQ.1).AND.(IB.EQ.1)) COEFFN=DCMASS/THSTEP
C
       IF (IPRECA.EQ.4) THEN      
        IF ((IA.EQ.2).AND.(IB.EQ.2)) COEFFN=DELTA*DU1**2+NY
        IF ((IA.EQ.3).AND.(IB.EQ.3)) COEFFN=DELTA*DU2**2+NY
       ELSE
        IF ((IA.EQ.2).AND.(IB.EQ.2)) COEFFN=DELTA*DU1**2
        IF ((IA.EQ.3).AND.(IB.EQ.3)) COEFFN=DELTA*DU2**2
       ENDIF
C
      ELSE
C
       COEFFN=0D0
       IF ((IA.EQ.1).AND.(IB.EQ.1)) COEFFN=-1D0/THSTEP
C
      ENDIF
C
C
      END
C
************************************************************************
      DOUBLE PRECISION FUNCTION   COEFFB (X,Y,IA,IB,IBLOC,BFIRST)
*
*     Coefficient for the B1/B2-blocks
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
C
      COEFFB= -1.D0
C
      END
C
************************************************************************
      DOUBLE PRECISION FUNCTION    RHS  (X,Y,IA,IBLOC,BFIRST)
*
*     Right hand side yielding the exact solution UE
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
      RHS=FDATIN(5,IBLOC,X,Y,TIMENS,RE)
C
      END
C
C
************************************************************************
      DOUBLE PRECISION FUNCTION    UE  (X,Y,IBLOC)
*
*     Exact solution - velocity,  only boundary conditions
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C     
      UE=FDATIN(1,IBLOC,X,Y,TIMENS,RE)
C
      END
C
************************************************************************
      DOUBLE PRECISION FUNCTION    PE  (X,Y)
*
*     Exact solution - pressure,  only for dummy use
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C     
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C     
      PE=FDATIN(4,IBLOC,X,Y,TIMENS,RE)
C
      END
C
*************************************************************************
      DOUBLE PRECISION FUNCTION    UEX(X,Y,IBLOC)
C
C     x-Ableitung der exakten Loesung
*************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C     
      UEX=FDATIN(2,IBLOC,X,Y,TIMENS,RE)
C
      END
C
*************************************************************************
      DOUBLE PRECISION FUNCTION    UEY(X,Y,IBLOC)
C
C     y-Ableitung der exakten Loesung
*************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
      UEY=FDATIN(3,IBLOC,X,Y,TIMENS,RE)
C
      END

************************************************************************
      SUBROUTINE  NSDEF (MFILE,MSHOW,BSTOP,BNLEND)  
************************************************************************
*   Purpose: - solver for the stationary incompressible Navier Stokes
*              equations via fixed point defect correction plus
*              imultigrid for linear Oseen problems
*            - nonlinear version:
*                   - fixed point defect correction as outer iteration
*                   - mg as solver for the linear auxiliary Oseen
*                     problems
*                   - nonlinear parameter optimization for the 
*                     correction from the linear solver step
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120,CFILE*60
C
C *** Arrays for multigrid modul M010 
      DIMENSION  KOFFX(NNLEV),KOFFD(NNLEV),KOFFB(NNLEV),  KNEQ(NNLEV),
     *           KIT(NNLEV),KIT0(NNLEV)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
      COMMON /NSCOUN/ NNONL,NMG
      COMMON /NSEXL/  ITEXL,LTML,TIML11,TIML12,TIML31,TIML32
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTIME/ TTMG,TTS,TTE,TTD,TTP,TTR,IMTIME
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
      SAVE
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C     E X T E R N A L S
C-----------------------------------------------------------------------
C *** Coefficient of stiffness matrix
      EXTERNAL COEFFN
C *** definition of finite elements
      EXTERNAL E030,E031,EM30,EM31
C *** Multigrid components
      EXTERNAL  YAX,YPROL,YREST,YSM,YEX,YEXA,YDBC,YSTEP
C
C=======================================================================
C     Initialization
C=======================================================================
C
C *** Initialization of the offset arrays KOFFX,KOFFB,KOFFD and KNEQ
      DO 10 ILEV=NLMIN,NLMAX
      KOFFX(ILEV)=L(KLUP(ILEV))-1
      KOFFB(ILEV)=L(KLF12P(ILEV))-1
      KOFFD(ILEV)=L(KLAUX(ILEV))-1
      KNEQ(ILEV)=KNUP(ILEV)
10    CONTINUE
C
C=======================================================================
C     First generation of the nonlinear block A on level NLMAX
C=======================================================================
C
      CALL ZTIME(TTT0)
      BSTOP =.FALSE.
      BNLEND=.FALSE.
C
      ISETLV=2
      ILEV=NLMAX
      CALL  SETLEV (ISETLV)
C
      IF (INLMAX.GT.1) THEN
       IDEFUP=1
      ELSE
       IDEFUP=0
      ENDIF
C
      IF (INLMAX.GT.1) THEN
       CALL LCP1 (DWORK(KF1),DWORK(L(LD1)),NU)
       CALL LCP1 (DWORK(KF2),DWORK(L(LD2)),NU)
       CALL LCP1 (DWORK(KFP),DWORK(L(LDP)),NP)
      ENDIF
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      CALL XMADF2(KM1,KST1,KA1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *            L(LD1),L(LD2),L(LDP),KU1,KU2,KP,NA,NU,NP,
     *            KWORK(L(KLMBD(NLEV))),KNMBD(NLEV),INEUM,THSTEP,ISTAT)
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
C
C
      CALL ZTIME(TTT0)
      IF ((ISTOK.NE.1).OR.((ISTOK.EQ.1).AND.(IPRECA.EQ.4))) THEN
C
       IF (ITEXL.NE.0) THEN
        IF (ITEXL.EQ.1) THEN
         DTIM2=TIML12
         DTIM1=TIML11
        ENDIF       
        IF (ITEXL.EQ.3) THEN
         DTIM2=TIML32
         DTIM1=TIML31
        ENDIF       
        IF (ITEXL.LT.0) THEN
         A1L  =0D0
         A2L  =1D0
         ITEXL=ABS(ITEXL)        
        ELSE
         A1L  =-DTIM1/DTIM2
         A2L  =(DTIM1+DTIM2)/DTIM2
        ENDIF
C
        IF (IUPW.EQ.1) THEN
         CALL GUPWD(DWORK(L(LTML)),DWORK(L(LTML)+NU),
     *              DWORK(KU1),DWORK(KU2),A1L,A2L,
     *              DWORK(KU1),DWORK(KU2),
     *              DWORK(L(LD1)),DWORK(L(LD2)),VWORK(KA1),KWORK(KCOLA),
     *              KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *              DWORK(L(LCORVG)),IDEFUP)
        ELSE
         IF (IELT.EQ.0) 
     *    CALL SUPWDG(DWORK(L(LTML)),DWORK(L(LTML)+NU),
     *                DWORK(KU1),DWORK(KU2),A1L,A2L,
     *                DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E031,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.1) 
     *    CALL SUPWDG(DWORK(L(LTML)),DWORK(L(LTML)+NU),
     *                DWORK(KU1),DWORK(KU2),A1L,A2L,
     *                DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E030,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.2) 
     *    CALL SUPWNP(DWORK(L(LTML)),DWORK(L(LTML)+NU),
     *                DWORK(KU1),DWORK(KU2),A1L,A2L,
     *                DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM31,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.3) 
     *    CALL SUPWNP(DWORK(L(LTML)),DWORK(L(LTML)+NU),
     *                DWORK(KU1),DWORK(KU2),A1L,A2L,
     *                DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM30,COEFFN,IDEFUP,1D0)
        ENDIF
C
        IF (ITEXL.EQ.3) CALL LCP1(DWORK(KU1),DWORK(L(LTML)),NUP)
        IF (ITEXL.GT.0) CALL LLC1(DWORK(L(LTML)),DWORK(KU1),NUP,
     *                            A1L,A2L)
       ELSE
        IF (IUPW.EQ.1) THEN
         CALL GUPWD (DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *               1D0,0D0,DWORK(KU1),DWORK(KU2),
     *               DWORK(L(LD1)),DWORK(L(LD2)),
     *               VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *               KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *               IDEFUP)
        ELSE
         IF (IELT.EQ.0) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E031,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.1) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E030,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.2) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM31,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.3) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM30,COEFFN,IDEFUP,1D0)
        ENDIF
       ENDIF
C
      ENDIF
      CALL ZTIME(TTT1)
      TTUPW=TTUPW+TTT1-TTT0
C
C
      CALL ZTIME(TTT0)
      CALL BDRYA  (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *             KWORK(L(KLMBD(ILEV))),KNMBD(ILEV))
C
      IF (INLMAX.GT.1) THEN
       CALL BDRY0 (DWORK(L(LD1)),DWORK(L(LD2)),KWORK(L(KLMBD(ILEV))),
     *             KNMBD(ILEV))
      ENDIF
      CALL ZTIME(TTT1)
      TTBDR=TTBDR+TTT1-TTT0
C
C=======================================================================
C     Calculation of initial defects
C=======================================================================
C
      CALL ZTIME(TTT0)
      IF (INLMAX.GT.1) THEN
       CALL  RESDFK(DWORK(KU1),DWORK(KU2),DWORK(KP),
     *              DWORK(L(LD1)),DWORK(L(LD2)),DWORK(L(LDP)),
     *              DWORK(KF1),DWORK(KF2),DWORK(KFP),NU,NP,RESU,RESDIV)
       RESOLD=SQRT(RESU*RESU+RESDIV*RESDIV)
       RES0  =RESOLD
       RES   =RESOLD
       EPSRES=DMPD*RESOLD
      ELSE
       RES   =0D0
       RESOLD=0D0
       EPSRES=0D0
      ENDIF
C
C=======================================================================
C     Solution
C=======================================================================
C
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.1) WRITE(MFILE,1)
C
      IF (MSHOW.GE.2) WRITE(MTERM,1001)
      IF (MSHOW.GE.1) WRITE(MFILE,1001)
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.1) WRITE(MFILE,1)
      INL=0
      IF (MSHOW.GE.2) WRITE(MTERM,1002)  INL,RESU,RESDIV,RESOLD
      IF (MSHOW.GE.1) WRITE(MFILE,1002)  INL,RESU,RESDIV,RESOLD
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.1) WRITE(MFILE,1)
C
      OMEGA=OMGINI
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Loop of nonlinear iteration
C=======================================================================
C
      DO 222  INL=1,INLMAX
      NNONL=NNONL+1
C
      IF (LU1OLD.NE.0) THEN
       CALL ZTIME(TTT0)
       CALL  LCP1 (DWORK(KU1),DWORK(L(LU1OLD)),NU)
       CALL  LCP1 (DWORK(KU2),DWORK(L(LU2OLD)),NU)
       CALL  LCP1 (DWORK(KP ),DWORK(L(LPOLD )),NP)
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
      ENDIF
C
C=======================================================================
C *** Generate the A blocks for all coarse levels
C=======================================================================
C
      IF (NLMAX.GT.NLMIN)  THEN
        DO 22  ILEV=NLMAX-1,NLMIN,-1
        CALL ZTIME(TTT0)
        ISETLV=2
        CALL  SETLEV (ISETLV)
C
        I1=ILEV+1
        KU1F=L(KLUP(I1))
        KU2F=KU1F+KNU(I1)
        KVERTF=L(KLVERT(I1))
        KMIDF =L(KLMID (I1))
        KADJF =L(KLADJ (I1))
        CALL  RESTRU (DWORK(KU1),DWORK(KU2),DWORK(KU1F),DWORK(KU2F),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),KWORK(L(LADJ)),
     *                NU,NP,NVT,KWORK(KVERTF),KWORK(KMIDF),KWORK(KADJF),
     *                KNU(I1),KNP(I1),KNVT(I1) )
C
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        CALL XMADF3(KM1,KST1,KA1,KCOLA,KLDA,NA,NU,THSTEP,ISTAT)
        CALL ZTIME(TTT1)
        TTADF=TTADF+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        IF ((ISTOK.NE.1).OR.((ISTOK.EQ.1).AND.(IPRECA.EQ.4))) THEN
         IF (IUPW.EQ.1) THEN
          CALL GUPWD (DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),0)
         ELSE
          IF (IELT.EQ.0) 
     *     CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                 1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                 DWORK(L(LD1)),DWORK(L(LD2)),
     *                 VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                 KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                 E031,COEFFN,0,1D0)
          IF (IELT.EQ.1) 
     *      CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                 1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                 DWORK(L(LD1)),DWORK(L(LD2)),
     *                 VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                 KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                 E030,COEFFN,0,1D0)
          IF (IELT.EQ.2) 
     *     CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                 1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                 DWORK(L(LD1)),DWORK(L(LD2)),
     *                 VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                 KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                 EM31,COEFFN,0,1D0)
          IF (IELT.EQ.3) 
     *     CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                 1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                 DWORK(L(LD1)),DWORK(L(LD2)),
     *                 VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                 KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                 EM30,COEFFN,0,1D0)
         ENDIF
        ENDIF
        CALL ZTIME(TTT1)
        TTUPW=TTUPW+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        CALL  BDRYA (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *               KWORK(L(KLMBD(ILEV))),KNMBD(ILEV))
C
        CALL ZTIME(TTT1)
        TTBDR=TTBDR+TTT1-TTT0
C
22      CONTINUE
      ENDIF
C
C=======================================================================
C *** Perform MG for Oseen equations
C=======================================================================
C
      CALL ZTIME(TTT0)
C
      ISETLV=2
      ILEV=NLMAX
      CALL  SETLEV (ISETLV)
C
      CALL ZNEW (NUP,-1,LDEF,'DDEF  ')
      IF (IER.NE.0) GOTO 99999
C
      CALL LCP1(DWORK(KF1)   ,DWORK(L(LDEF)),NUP)
      CALL LCP1(DWORK(L(LD1)),DWORK(KF1)    ,NUP)
C
      CALL LCL1 (DWORK(KU1),NUP)
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C
      IRELMG=1
      ITMG=ILMIN
      IF (ILMAX.GT.ILMIN) THEN
       IDEFMG=1
      ELSE
       IDEFMG=0
      ENDIF
C
      CALL  M011 (DWORK(1),DWORK(1),DWORK(1),KOFFX,KOFFB,KOFFD,
     *            KNEQ,ILMAX,ITMG,DMPMG,EPSMG,
     *            YAX,YPROL,YREST,YSM,YSM,YEX,YEXA,YDBC,YSTEP,
     *            KIT0,KIT,IRELMG,IDEFMG,RHOLMG,BMG)
      NMG=NMG+ITMG
C
C=======================================================================
C    End of multigrid iteration
C=======================================================================
C
C *** Set finest level NLMAX
      ISETLV=2
      ILEV=NLMAX
      CALL  SETLEV (ISETLV)
C
      CALL  ZTIME(TTT0)
C
      CALL LCP1(DWORK(L(LDEF)),DWORK(KF1),NUP)
      CALL ZDISP(0,LDEF,'DDEF  ')
      IF (IER.NE.0) GOTO 99999
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C
C=======================================================================
C *** Calculate the optimal correction
C=======================================================================
C
      CALL  ZTIME(TTT0)
      CALL  XOPTCN (KU1,KU2,KP,L(LU1OLD),L(LU2OLD),L(LPOLD),KF1,KF2,KFP,
     *              L(LD1),L(LD2),L(LDP),KAUX1,KAUX2,KAUXP,KA1,KCOLA,
     *              KLDA,KB1,KB2,KCOLB,KLDB,KST1,KM1,NA,NU,NP,DELU,
     *              DELP,OMEGA,KWORK(L(KLMBD(ILEV))),KNMBD(ILEV),INEUM)
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
       IF (BMG.AND.(ABS(OMEGA).GE.1D-2).AND.(ISTAT.EQ.1)) BSTOP=.TRUE.
C
C=======================================================================
C *** Calculation of defects
C=======================================================================
C
      IF (INLMAX.GT.1) THEN
       CALL  ZTIME(TTT0)
       CALL LCP1 (DWORK(KF1),DWORK(L(LD1)),NU)
       CALL LCP1 (DWORK(KF2),DWORK(L(LD2)),NU)
       CALL LCP1 (DWORK(KFP),DWORK(L(LDP)),NP)
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
C
       CALL  ZTIME(TTT0)
       CALL XMADF2(KM1,KST1,KA1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *             L(LD1),L(LD2),L(LDP),KU1,KU2,KP,NA,NU,NP,
     *             KWORK(L(KLMBD(NLEV))),KNMBD(NLEV),INEUM,THSTEP,ISTAT)
       CALL ZTIME(TTT1)
       TTADF=TTADF+TTT1-TTT0
C
       CALL  ZTIME(TTT0)
       IF ((ISTOK.NE.1).OR.((ISTOK.EQ.1).AND.(IPRECA.EQ.4))) THEN
        IF (IUPW.EQ.1) THEN
         CALL GUPWD (DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *               1D0,0D0,DWORK(KU1),DWORK(KU2),
     *               DWORK(L(LD1)),DWORK(L(LD2)),
     *               VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *               KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *               IDEFUP)
        ELSE
         IF (IELT.EQ.0) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E031,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.1) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                E030,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.2) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM31,COEFFN,IDEFUP,1D0)
         IF (IELT.EQ.3) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(L(LD1)),DWORK(L(LD2)),
     *                VWORK(KA1),NA,KWORK(KCOLA),KWORK(KLDA),
     *                KWORK(L(LVERT)),KWORK(L(LMID)),DWORK(L(LCORVG)),
     *                EM30,COEFFN,IDEFUP,1D0)
        ENDIF
       ENDIF
       CALL ZTIME(TTT1)
       TTUPW=TTUPW+TTT1-TTT0
C
       CALL ZTIME(TTT0)
       CALL BDRYA  (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *              KWORK(L(KLMBD(ILEV))),KNMBD(ILEV))
C
       CALL BDRY0 (DWORK(L(LD1)),DWORK(L(LD2)),
     *             KWORK(L(KLMBD(ILEV))),KNMBD(ILEV))
       CALL ZTIME(TTT1)
       TTBDR=TTBDR+TTT1-TTT0
C
C=======================================================================
C *** Calculation of defects and norms
C=======================================================================
C
       CALL  ZTIME(TTT0)
       CALL  RESDFK(DWORK(KU1),DWORK(KU2),DWORK(KP),
     *              DWORK(L(LD1)),DWORK(L(LD2)),DWORK(L(LDP)),
     *              DWORK(KF1),DWORK(KF2),DWORK(KFP),NU,NP,RESU,RESDIV)
C
       RES   =SQRT(RESU*RESU+RESDIV*RESDIV)
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
       IF ( RES/RESOLD.GT.1D2) BSTOP=.TRUE.
C
       RESOLD=RES
       RHO   =(RES/RES0)**(1D0/DBLE(INL))
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
      ELSE
       RES   =0D0
       RESU  =0D0
       RESDIV=0D0
       RESOLD=0D0
       RHO   =0D0
      ENDIF
C
C=======================================================================
C *** Control of terminating the nonlinear iteration
C=======================================================================
C
      IF ((DELU.LE.EPSUR).AND.(DELP.LE.EPSPR)   .AND.
     *    (RESU.LE.EPSD) .AND.(RESDIV.LE.EPSDIV).AND.
     *    (RES.LE.EPSRES).AND.(INL.GE.INLMIN)) BNLEND=.TRUE.
      IF ((DELU.LE.EPSUR).AND.(DELP.LE.EPSPR)   .AND.
     *    (INLMIN.EQ.INLMAX).AND.(INLMIN.EQ.1)) BNLEND=.TRUE.
C
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,1003) INL,DELU,DELP,RESU,RESDIV,RES,RHO,OMEGA,RHOLMG
      IF (MSHOW.GE.1) 
     * WRITE(MFILE,1003) INL,DELU,DELP,RESU,RESDIV,RES,RHO,OMEGA,RHOLMG
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
       IF (BSTOP) GOTO 221
C
C=======================================================================
C *** Autosave
C=======================================================================
C
      IF (IAUSAV.NE.0) THEN
      IF (MOD(INL,IAUSAV).EQ.0) THEN
       CALL ZTIME(TTT0)
       CFILE='#data/#AUTOSAV   '
       CALL  OF0 (39,CFILE,0)
       CALL  OWA1 (DWORK(KU1),'DU12P ',NUP, 39,0)
       REWIND(39)
       CLOSE(39)
       CALL ZTIME(TTT1)
       TTPOST=TTPOST+TTT1-TTT0
      ENDIF
      ENDIF
C
C=======================================================================
C *** Return if BNLEND=true
C=======================================================================
      IF ((BNLEND).OR.((INLMIN.EQ.INLMAX).AND.(INLMIN.EQ.1))
     *            .OR.(ABS(OMEGA).LT.1D-1)) GOTO 221
C
C
C
222   CONTINUE
C
C=======================================================================
C *** End of the nonlinear loop
C=======================================================================
C
221   IF (MSHOW.GE.4) THEN
      WRITE(MTERM,*) NNONL,NMG
      WRITE(MTERM,*) ' MULTIGRID COMPONENTS [in percent]:',TTMG
      WRITE(MTERM,*) ' smoothing     :', 1.D2*TTS/TTMG
      WRITE(MTERM,*) ' solver        :', 1.D2*TTE/TTMG
      WRITE(MTERM,*) ' defect calc.  :', 1.D2*TTD/TTMG
      WRITE(MTERM,*) ' prolongation  :', 1.D2*TTP/TTMG
      WRITE(MTERM,*) ' restriction   :', 1.D2*TTR/TTMG
      WRITE(MTERM,1)
      ENDIF
C
      IF (MSHOW.GE.3) THEN
      WRITE(MFILE,*) NNONL,NMG
      WRITE(MFILE,*) ' MULTIGRID COMPONENTS [in percent]:',TTMG
      WRITE(MFILE,*) ' smoothing     :', 1.D2*TTS/TTMG
      WRITE(MFILE,*) ' solver        :', 1.D2*TTE/TTMG
      WRITE(MFILE,*) ' defect calc.  :', 1.D2*TTD/TTMG
      WRITE(MFILE,*) ' prolongation  :', 1.D2*TTP/TTMG
      WRITE(MFILE,*) ' restriction   :', 1.D2*TTR/TTMG
      WRITE(MFILE,1)
      ENDIF
C
      IF (INL.GT.INLMAX)  INL=INLMAX
C
   1  FORMAT(80('-'))
1001  FORMAT(' IT RELU',5X,'RELP',5X,'DEF-U',4X,'DEF-DIV',2X,
     *       'DEF-TOT',2X,'RHONL ',3X,'OMEGNL',3X,'RHOMG')
1002  FORMAT(I3,18X,3(D9.2))
1003  FORMAT(I3,8(D9.2))
C
C
C
99999 END

************************************************************************
*    M011   (edited from M010)                                         *
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* M011                                                                 *
*                                                                      *
* Purpose  Solution of a linear system  A*X = B  using                 *
*          multigrid iteration                                         *
*          Double precision version                                    *
*                                                                      *
* Subroutines/functions called  LL21 , LLC1                            *
*                                                                      *
* Version from  08/25/90                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* DX       R*8    Starting address of vectors containing the           *
* DB       R*8    solution and the right hand side, DD is used as      *
* DD       R*8    auxiliary vector only                                *
* KOFFX           The actual starting address of DX on level ILEV      *
* KOFFB           is DX(1+KOFFX(ILEV)) (analogously for DB and DD)     *
* KOFFD           Total space required for all vectors is              *
*                 KNEQ(NLMIN)+...+KNEQ(NLMAX)                          *
*                 DX(1+KOFFX(NLMAX)) contains initial solution         *
*                 DB(1+KOFFB(NLMAX)) contains right hand side          *
* KNEQ     I*4    Number of equations for all levels                   *
* NLMAX    I*4    Iteration uses levels NLMIN to NLMAX,                *
* NLMIN    I*4    NLMAX  is the finest level                           *
* NIT      I*4    Maximum number of iterations                         *
*                 Iteration completed after reaching the finest level  *
* EPS1      R*8    Desired precision                                   *
*                 Stop if !!DEF!! < EPS1 !!DEFOLD!!                    *
* EPS2      R*8    Desired precision                                   *
*                 Stop if !!DEF!! < EPS2                               *
* KPRSM    I*4    Number of pre -smoothing steps for all levels        *
* KPOSM    I*4    Number of post-smoothing steps for all levels        *
* ICYCLE   I*4    <0: special cycle types (not yet implemented)        *
*                 =0: F-Cycle                                          *
*                 =1: V-Cycle                                          *
*                 =2: W-Cycle                                          *
*                 >2: Cycle of higher order                            *
* DAX      SUBR   CALL DAX(DX,DAX,NEQ,A1,A2)                           *
*                 Returns  DAX := A1*A*DX+A2*DAX                       *
* DPROL    SUBR   DPROL(DX1,DX2)                                       *
*                 Returns  DX2 := Prolongation(DX1)  to higher level   *
* DSTEP    SUBR   DPROL(DX,DD,DB,DSTEPP)                               *
*                 Returns  DSTEPP := optimal step size for correction  *
* DREST    SUBR   DREST(DD1,DD2)                                       *
*                 Returns  DD2 := Restriction(DD1)  to lower level     *
* DPRSM    SUBR   DPRSM(DX,DB,DD,NEQ,NPRSM)                            *
*                 Returns  DX  after  NPRSM:=KPRSM(ILEV)               *
*                 pre-smoothing steps, DD  is used as auxiliary vector *
* DPOSM    SUBR   Same as above, used for post-smoothing               *
* DEX      SUBR   DEX(DX,DB,DD,NEQ)                                    *
*                 Returns exact solution                               *
* DBC      SUBR   DBC(DX,NEQ)                                          *
*                 Copies boundary data onto components of  DX          *
* KIT0     I*4    auxiliary vectors of length  NLMAX                   *
* KIT      I*4                                                         *
*                                                                      *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* DX       R*8    Solution vector on DX(KOFFX(NLMAX))                  *
* ITE      I*4    Number of iterations                                 *
* IER      I*4    Error indicator                                      *
* RHOLMG   R*8    Multigrid convergence rate                           *
*                                                                      *
************************************************************************
C
      SUBROUTINE  M011 (DX,DB,DD,KOFFX,KOFFB,KOFFD,KNEQ,NIT,ITE,
     *                  EPS1,EPS2,DAX,DPROL,DREST,DPRSM,DPOSM,DEX,DEXA,
     *                  DBC,DSTEP,KIT0,KIT,IREL,IDEFMG,RHOLMG,BMGEND)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      PARAMETER (NNARR=299,NNLEV=9)
      DIMENSION DX(*),DB(*),DD(*),KOFFX(*),KOFFB(*),KOFFD(*)
      DIMENSION KNEQ(*),KIT0(*),KIT(*)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTIME/ TTMG,TTS,TTE,TTD,TTP,TTR,IMTIME
      SAVE 
C
      SUB='M011  '
      IF (ICHECK.GE.997) CALL OTRC('M011  ','05/13/91')
      IER=0
C
C
      BMGEND=.FALSE.
      BREL=IREL.EQ.1
      BMSG2=M.GE.2.OR.MT.GE.2
      MT0=MT
      MT=0
C
      BTIME=IMTIME.GT.0
      IF (BTIME) THEN
       IF (IMTIME.EQ.1) THEN
        TTMG=0D0
        TTS=0D0
        TTE=0D0
        TTD=0D0
        TTP=0D0
        TTR=0D0
       ENDIF
       CALL ZTIME(TTMG0)
      ENDIF
C
C
      NIT0=MAX(ITE,0)
      IF (ICYCLE.LT.0) THEN
       CALL WERR(-181,'M011  ')
       GOTO 99999
      ENDIF
      IF (NLMAX.LT.NLMIN.OR.NLMIN.LE.0.OR.NLMAX.GT.NNLEV) THEN
       CALL WERR(-182,'M011  ')
       GOTO 99999
      ENDIF
      ILEV=NLMAX
C
C *** special case - zero solution
      IF (BTIME) CALL ZTIME(TTD0)
      CALL LLI1(DB(1+KOFFB(NLMAX)),KNEQ(NLMAX),DMAX,INDMAX)
      IF (DMAX.LE.1D-12) THEN
       CALL LCP1(DB(1+KOFFB(NLMAX)),DX(1+KOFFX(NLMAX)),KNEQ(NLMAX))
       RHOLMG=0D0
       GOTO 99999
      ENDIF
C
      IF (BTIME) THEN
       CALL ZTIME(TTD1)
       TTD=TTD+TTD1-TTD0
      ENDIF
C
C *** special case - only one level
      IF (NLMIN.EQ.NLMAX) THEN
       IF (BTIME) CALL ZTIME(TTE0)
       CALL DEXA(DX(1+KOFFX(NLMAX)),DB(1+KOFFB(NLMAX)),
     *           DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),RHOLMG,EPS2,ITECG)
       IF (BTIME) THEN
        CALL ZTIME(TTE1)
        TTE=TTE+TTE1-TTE0
       ENDIF
       ITE=ITECG
       GOTO 99999
      ENDIF
C
C *** level counts
      KIT0(NLMAX)=1
      DO 2 ILEV=NLMIN+1,NLMAX-1
      IF (ICYCLE.EQ.0) THEN
       KIT0(ILEV)=2
      ELSE
       KIT0(ILEV)=ICYCLE
      ENDIF
2     CONTINUE
C
CCC      IF (BTIME) CALL ZTIME(TTS0)
CCC      IF (KPRSM(NLMAX).GT.0) 
CCC     * CALL DPRSM(DX(1+KOFFX(NLMAX)),DB(1+KOFFB(NLMAX)),
CCC     *            DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),KPRSM(NLMAX))
CCC
CCC      IF (BTIME) THEN
CCC       CALL ZTIME(TTS1)
CCC       TTS=TTS+TTS1-TTS0
CCC      ENDIF
C
      IF (IDEFMG.EQ.1) THEN
       IF (BTIME) CALL ZTIME(TTD0)
       CALL LCP1(DB(1+KOFFB(NLMAX)),DD(1+KOFFD(NLMAX)),KNEQ(NLMAX))
       CALL DAX(DX(1+KOFFX(NLMAX)),DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),
     *          -1D0,1D0)
C
       CALL LL21(DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),DEF)
       DEFOLD=DEF
C *** FD  is considered as initial defect
       FD=DEF
C
       IF (BTIME) THEN
        CALL ZTIME(TTD1)
        TTD=TTD+TTD1-TTD0
       ENDIF
C
       IF (DEF.LE.EPS2.AND..NOT.BREL) THEN
        ITE=0
        GOTO 1000
       ENDIF
      ENDIF
C
C
C *** Start multigrid iteration
      DO 100 ITE=1,NIT
C
C *** initialize level counts for all levels
      DO 101 ILEV=NLMIN,NLMAX
101   KIT(ILEV)=KIT0(ILEV)
C
      ILEV=NLMAX
110   IF (ILEV.NE.NLMIN) THEN
C
CCC      IF (ILEV.NE.NLMAX) THEN
CCC ***  defect on finest level already available
C
        IF (BTIME) CALL ZTIME(TTS0)
        IF (KPRSM(ILEV).GT.0) 
     *   CALL DPRSM(DX(1+KOFFX(ILEV)),DB(1+KOFFB(ILEV)),
     *              DD(1+KOFFD(ILEV)),KNEQ(ILEV),KPRSM(ILEV))
C
        IF (BTIME) THEN
         CALL ZTIME(TTS1)
         TTS=TTS+TTS1-TTS0
        ENDIF
C
        IF (BTIME) CALL ZTIME(TTD0)
        CALL LCP1(DB(1+KOFFB(ILEV)),DD(1+KOFFD(ILEV)),KNEQ(ILEV))
        CALL DAX(DX(1+KOFFX(ILEV)),DD(1+KOFFD(ILEV)),KNEQ(ILEV),
     *           -1D0,1D0)
C
        IF (BTIME) THEN
         CALL ZTIME(TTD1)
         TTD=TTD+TTD1-TTD0
        ENDIF
C
CCC       ENDIF
C
       ILEV=ILEV-1
C
C *** restriction of defect
       IF (BTIME) CALL ZTIME(TTR0)
       CALL DREST(DD(1+KOFFD(ILEV+1)),DB(1+KOFFB(ILEV)))
C
       IF (BTIME) THEN
        CALL ZTIME(TTR1)
        TTR=TTR+TTR1-TTR0
       ENDIF
C
C ***  choose zero as initial vector on lower level
       IF (BTIME) CALL ZTIME(TTD0)
       CALL LCL1(DX(1+KOFFX(ILEV)),KNEQ(ILEV))
       CALL DBC(DB(1+KOFFB(ILEV)),KNEQ(ILEV))
       IF (BTIME) THEN
        CALL ZTIME(TTD1)
        TTD=TTD+TTD1-TTD0
       ENDIF
C
       GOTO 110
C
      ENDIF
C
C *** exact solution on lowest level
      IF (BTIME) CALL ZTIME(TTE0)
      CALL DEX(DX(1+KOFFX(NLMIN)),DB(1+KOFFB(NLMIN)),DD(1+KOFFD(NLMIN)),
     *         KNEQ(NLMIN),RHOLMG)
C
      IF (BTIME) THEN
       CALL ZTIME(TTE1)
       TTE=TTE+TTE1-TTE0
      ENDIF
C
C
130   IF (ILEV.NE.NLMAX) THEN
       ILEV=ILEV+1
C
C *** DPROL  returns  DD:=PROL(DX)
      IF (BTIME) CALL ZTIME(TTP0)
      CALL DPROL(DX(1+KOFFX(ILEV-1)),DD(1+KOFFD(ILEV)))
      CALL DBC(DD(1+KOFFD(ILEV)),KNEQ(ILEV))
C
      CALL DSTEP(DX(1+KOFFX(ILEV)),DD(1+KOFFD(ILEV)),DB(1+KOFFB(ILEV)),
     *           DSTEPP)
      CALL LLC1(DD(1+KOFFD(ILEV)),DX(1+KOFFX(ILEV)),KNEQ(ILEV),DSTEPP,
     *          1D0)
C
      IF (BTIME) THEN
       CALL ZTIME(TTP1)
       TTP=TTP+TTP1-TTP0
      ENDIF
C
C
C *** Post-smoothing
      IF (BTIME) CALL ZTIME(TTS0)
      IF (KPOSM(ILEV).GT.0) 
     * CALL DPOSM(DX(1+KOFFX(ILEV)),DB(1+KOFFB(ILEV)),DD(1+KOFFD(ILEV)),
     *            KNEQ(ILEV),KPOSM(ILEV))
C
      IF (BTIME) THEN
       CALL ZTIME(TTS1)
       TTS=TTS+TTS1-TTS0
      ENDIF
C
       KIT(ILEV)=KIT(ILEV)-1
       IF (KIT(ILEV).EQ.0) THEN
        IF (ICYCLE.EQ.0) THEN
         KIT(ILEV)=1
        ELSE
         KIT(ILEV)=KIT0(ILEV)
        ENDIF
        GOTO 130
       ELSE
        GOTO 110
       ENDIF
C
      ENDIF
C
C
CCC      IF (BTIME) CALL ZTIME(TTS0)
CCC      IF (KPRSM(NLMAX).GT.0)  
CCC     * CALL DPRSM(DX(1+KOFFX(NLMAX)),DB(1+KOFFB(NLMAX)),
CCC     *           DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),KPRSM(NLMAX))
CCC
CCC      IF (BTIME) THEN
CCC       CALL ZTIME(TTS1)
CCC       TTS=TTS+TTS1-TTS0
CCC      ENDIF
C
C
      IF (IDEFMG.EQ.1) THEN
       IF (BTIME) CALL ZTIME(TTD0)
       CALL LCP1(DB(1+KOFFB(NLMAX)),DD(1+KOFFD(NLMAX)),KNEQ(NLMAX))
       CALL DAX(DX(1+KOFFX(NLMAX)),DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),
     *          -1D0,1D0)
C
      CALL LL21(DD(1+KOFFD(NLMAX)),KNEQ(NLMAX),DEF)
       IF (MT.GE.9) WRITE (6,10001) ITE,DEF
       IF (BMSG2) THEN
        MT=MT0
        WRITE (CPARAM,'(I15,D25.16)') ITE,DEF
        CALL OMSG(73,'M011  ')
        WRITE (MPROT,10001) ITE,DEF
        WRITE (*,10001) ITE,DEF
        MT=0
       ENDIF
C
       IF (BTIME) THEN
        CALL ZTIME(TTD1)
        TTD=TTD+TTD1-TTD0
       ENDIF
C
C=======================================================================
C ***  Unexpected STOP !!!
C=======================================================================
       IF ((DEF/DEFOLD.GT.1D3).OR.(DEF/FD.GT.5D3)) THEN
        BMGEND=.TRUE.
        GOTO 1000
       ENDIF
C
      DEFOLD=DEF
       IF (BREL) THEN
        IF (DEF.LE.FD*EPS1.AND.DEF.LE.EPS2.AND.ITE.GE.NIT0) GOTO 1000
       ELSE
        IF (DEF.LE.EPS2) GOTO 1000
       ENDIF
      ENDIF
C
100   CONTINUE
C
      ITE=NIT
      IF (IDEFMG.EQ.1) THEN
       MT=MT0
       RHOLMG=DEF/FD
       RHOLMG=RHOLMG**(1D0/DBLE(NIT))
       IF ((RHOLMG).GE.1D0) BMGEND=.TRUE.
       IF (MT.GE.9) WRITE (6,10000) NIT,DEF,FD,DEF/FD,RHOLMG
       IF (BMSG2) THEN
        WRITE (CPARAM,'(I15,4D25.16)') NIT,DEF,FD,DEF/FD,RHOLMG
        CALL OMSG(72,'M011  ')
        WRITE (MPROT,10000) NIT,DEF,FD,DEF/FD,RHOLMG
        WRITE (MPROT,*) 'IER=1 in M011'
       ENDIF
      ELSE
       RHOLMG=DBLE(NIT)
      ENDIF
C
      GOTO 99999
C
1000  IER=0
      MT=MT0
      RHOLMG=0.D0
      IF (FD.GE.1D-70) RHOLMG=(DEF/FD)**(1D0/DBLE(ITE))
      IF (MT.GE.9) WRITE (6,'(I15,4D25.16)') ITE,DEF,FD,DEF/FD,RHOLMG
      IF (BMSG2) THEN
       WRITE (CPARAM,'(I15,4D25.16)') ITE,DEF,FD,DEF/FD,RHOLMG
       CALL OMSG(72,'M011  ')
       WRITE (CPARAM,'(D25.16)')  RHOLMG
       CALL OMSG(76,'M011  ')
       WRITE (MPROT,10002) ITE,DEF,FD,DEF/FD,RHOLMG
      ENDIF
C
99999 MT=MT0 
      IF (BTIME) THEN
       CALL ZTIME(TTMG1)
       TTMG=TTMG+TTMG1-TTMG0
      ENDIF
C
10000 FORMAT (//' CONVERGENCE OF MG-METHOD FAILED'/
     *        ' NORM OF DEFECT AFTER',I6,' ITERATIONS',D12.3/
     *        ' NORM OF INITIAL DEFECT  ',D12.3/
     *        ' NORM OF DEF/INIT. DEF   ',D12.3/
     *        ' KONVERGENZRATE          ',D12.3)
10001 FORMAT (' ITERATION',I6,5X,'  RESIDUUM =',D12.3)
10002 FORMAT (' NUMBER OF ITERATIONS    ',I10/
     *        ' NORM OF DEFECT          ',D12.3/
     *        ' NORM OF INITIAL DEFECT  ',D12.3/
     *        ' NORM OF DEF/INIT. DEF   ',D12.3/
     *        ' KONVERGENZRATE          ',D12.3)
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE   PROLU  (DU1,DV1,DP1,DU2,DV2,DP2,
     *                     KVERT1,KMID1,KADJ1,NEQ1,NEL1,NVT1,
     *                     KVERT2,KMID2,KADJ2,NEQ2,NEL2,NVT2)
************************************************************************
*    Purpose:    Interpolates the coarse grid vector (DU1,DV1,DP1) to
*                the fine grid vector (DU2,DV2,DP2)
*-----------------------------------------------------------------------
*    Input:
*      DU1,DV1,DP1           - coarse grid vector
*      KVERT1,KMID1,..,NVT1  - data of the coarse grid
*      KVERT2,KMID2,..,NVT2  - data of the fine grid
*
*    Output:
*      DU2,DV2,DP2           - interpolated fine grid vector
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.46875D0,A2=-0.09375D0,A3=-0.03125D0,
     *           A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
C
      DIMENSION DU1(*),DV1(*),DP1(*),  DU2(*),DV2(*),DP2(*),
     *          KVERT1(NNVE,*),KMID1(NNVE,*),KADJ1(NNVE,*),
     *          KVERT2(NNVE,*),KMID2(NNVE,*),KADJ2(NNVE,*)
      SAVE
C-----------------------------------------------------------------------
C *** Zero initialization of (DU2,DV2)
      CALL  LCL1 (DU2,NEQ2)
      CALL  LCL1 (DV2,NEQ2)
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      DUH1=DU1(IM1)
      DUH2=DU1(IM2)
      DUH3=DU1(IM3)
      DUH4=DU1(IM4)
C
      DVH1=DV1(IM1)
      DVH2=DV1(IM2)
      DVH3=DV1(IM3)
      DVH4=DV1(IM4)
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** Prolongation of pressure
C
      DPH=DP1(IEL1)
      DP2(IELH1)=DPH
      DP2(IELH2)=DPH
      DP2(IELH3)=DPH
      DP2(IELH4)=DPH
C
C *** The edge IM1 and the corresponding fine inner node
C
      IF (KADJ1(1,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4
       DU2(IB)=DU2(IB)+   A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4
       DV2(IA)=DV2(IA)+   A1*DVH1+A2*DVH2+A3*DVH3+A4*DVH4
       DV2(IB)=DV2(IB)+   A1*DVH1+A4*DVH2+A3*DVH3+A2*DVH4
      ELSE
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH1+A2*DVH2+A3*DVH3+A4*DVH4)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH1+A4*DVH2+A3*DVH3+A2*DVH4)
      ENDIF
      IC=KMID2(2,IELH1)-NVT2
      DU2(IC)=A5*DUH1+A6*(DUH2+DUH4)+A7*DUH3
      DV2(IC)=A5*DVH1+A6*(DVH2+DVH4)+A7*DVH3
C
C *** The edge IM2 and the corresponding fine inner node
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1
       DU2(IB)=DU2(IB)+   A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1
       DV2(IA)=DV2(IA)+   A1*DVH2+A2*DVH3+A3*DVH4+A4*DVH1
       DV2(IB)=DV2(IB)+   A1*DVH2+A4*DVH3+A3*DVH4+A2*DVH1
      ELSE
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH2+A2*DVH3+A3*DVH4+A4*DVH1)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH2+A4*DVH3+A3*DVH4+A2*DVH1)
      ENDIF
      IC=KMID2(2,IELH2)-NVT2
      DU2(IC)=A5*DUH2+A6*(DUH3+DUH1)+A7*DUH4
      DV2(IC)=A5*DVH2+A6*(DVH3+DVH1)+A7*DVH4
C
C *** The edge IM3 and the corresponding fine inner node
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2
       DU2(IB)=DU2(IB)+   A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2
       DV2(IA)=DV2(IA)+   A1*DVH3+A2*DVH4+A3*DVH1+A4*DVH2
       DV2(IB)=DV2(IB)+   A1*DVH3+A4*DVH4+A3*DVH1+A2*DVH2
      ELSE
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH3+A2*DVH4+A3*DVH1+A4*DVH2)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH3+A4*DVH4+A3*DVH1+A2*DVH2)
      ENDIF
      IC=KMID2(2,IELH3)-NVT2
      DU2(IC)=A5*DUH3+A6*(DUH4+DUH2)+A7*DUH1
      DV2(IC)=A5*DVH3+A6*(DVH4+DVH2)+A7*DVH1
C
C *** The edge IM4 and the corresponding fine inner node
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3
       DU2(IB)=DU2(IB)+   A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3
       DV2(IA)=DV2(IA)+   A1*DVH4+A2*DVH1+A3*DVH2+A4*DVH3
       DV2(IB)=DV2(IB)+   A1*DVH4+A4*DVH1+A3*DVH2+A2*DVH3
      ELSE
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH4+A2*DVH1+A3*DVH2+A4*DVH3)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH4+A4*DVH1+A3*DVH2+A2*DVH3)
      ENDIF
      IC=KMID2(2,IELH4)-NVT2
      DU2(IC)=A5*DUH4+A6*(DUH1+DUH3)+A7*DUH2
      DV2(IC)=A5*DVH4+A6*(DVH1+DVH3)+A7*DVH2
C
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE   PROLUM (DU1,DV1,DU2,DV2,
     *                     KVERT1,KMID1,KADJ1,NEQ1,NEL1,NVT1,
     *                     KVERT2,KMID2,KADJ2,NEQ2,NEL2,NVT2)
************************************************************************
*    Purpose:    Interpolates the coarse grid vector (DU1,DV1) to
*                the fine grid vector (DU2,DV2)
*-----------------------------------------------------------------------
*    Input:
*      DU1,DV1               - coarse grid vector
*      KVERT1,KMID1,..,NVT1  - data of the coarse grid
*      KVERT2,KMID2,..,NVT2  - data of the fine grid
*
*    Output:
*      DU2,DV2               - interpolated fine grid vector
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.46875D0,A2=-0.09375D0,A3=-0.03125D0,
     *           A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
C
      DIMENSION DU1(*),DV1(*),DU2(*),DV2(*),
     *          KVERT1(NNVE,*),KMID1(NNVE,*),KADJ1(NNVE,*),
     *          KVERT2(NNVE,*),KMID2(NNVE,*),KADJ2(NNVE,*)
      SAVE
C-----------------------------------------------------------------------
C *** Zero initialization of (DU2,DV2)
      CALL  LCL1 (DU2,NEQ2)
      CALL  LCL1 (DV2,NEQ2)
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      DUH1=DU1(IM1)
      DUH2=DU1(IM2)
      DUH3=DU1(IM3)
      DUH4=DU1(IM4)
C
      DVH1=DV1(IM1)
      DVH2=DV1(IM2)
      DVH3=DV1(IM3)
      DVH4=DV1(IM4)
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** The edge IM1 and the corresponding fine inner node
C
      IF (KADJ1(1,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4
       DU2(IB)=DU2(IB)+   A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4
       DV2(IA)=DV2(IA)+   A1*DVH1+A2*DVH2+A3*DVH3+A4*DVH4
       DV2(IB)=DV2(IB)+   A1*DVH1+A4*DVH2+A3*DVH3+A2*DVH4
      ELSE
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH1+A2*DVH2+A3*DVH3+A4*DVH4)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH1+A4*DVH2+A3*DVH3+A2*DVH4)
      ENDIF
      IC=KMID2(2,IELH1)-NVT2
      DU2(IC)=A5*DUH1+A6*(DUH2+DUH4)+A7*DUH3
      DV2(IC)=A5*DVH1+A6*(DVH2+DVH4)+A7*DVH3
C
C *** The edge IM2 and the corresponding fine inner node
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1
       DU2(IB)=DU2(IB)+   A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1
       DV2(IA)=DV2(IA)+   A1*DVH2+A2*DVH3+A3*DVH4+A4*DVH1
       DV2(IB)=DV2(IB)+   A1*DVH2+A4*DVH3+A3*DVH4+A2*DVH1
      ELSE
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH2+A2*DVH3+A3*DVH4+A4*DVH1)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH2+A4*DVH3+A3*DVH4+A2*DVH1)
      ENDIF
      IC=KMID2(2,IELH2)-NVT2
      DU2(IC)=A5*DUH2+A6*(DUH3+DUH1)+A7*DUH4
      DV2(IC)=A5*DVH2+A6*(DVH3+DVH1)+A7*DVH4
C
C *** The edge IM3 and the corresponding fine inner node
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2
       DU2(IB)=DU2(IB)+   A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2
       DV2(IA)=DV2(IA)+   A1*DVH3+A2*DVH4+A3*DVH1+A4*DVH2
       DV2(IB)=DV2(IB)+   A1*DVH3+A4*DVH4+A3*DVH1+A2*DVH2
      ELSE
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH3+A2*DVH4+A3*DVH1+A4*DVH2)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH3+A4*DVH4+A3*DVH1+A2*DVH2)
      ENDIF
      IC=KMID2(2,IELH3)-NVT2
      DU2(IC)=A5*DUH3+A6*(DUH4+DUH2)+A7*DUH1
      DV2(IC)=A5*DVH3+A6*(DVH4+DVH2)+A7*DVH1
C
C *** The edge IM4 and the corresponding fine inner node
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3
       DU2(IB)=DU2(IB)+   A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3
       DV2(IA)=DV2(IA)+   A1*DVH4+A2*DVH1+A3*DVH2+A4*DVH3
       DV2(IB)=DV2(IB)+   A1*DVH4+A4*DVH1+A3*DVH2+A2*DVH3
      ELSE
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3)
       DV2(IA)=DV2(IA)+2D0*(A1*DVH4+A2*DVH1+A3*DVH2+A4*DVH3)
       DV2(IB)=DV2(IB)+2D0*(A1*DVH4+A4*DVH1+A3*DVH2+A2*DVH3)
      ENDIF
      IC=KMID2(2,IELH4)-NVT2
      DU2(IC)=A5*DUH4+A6*(DUH1+DUH3)+A7*DUH2
      DV2(IC)=A5*DVH4+A6*(DVH1+DVH3)+A7*DVH2
C
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE  RESTRD  (DU1,DV1,DP1,DU2,DV2,DP2,
     *                     KVERT1,KMID1,KADJ1,NEQ1,NEL1,NVT1,
     *                     KVERT2,KMID2,KADJ2,NEQ2,NEL2,NVT2)
************************************************************************
*    Purpose:    Restricts the  fine grid defect vector (DU2,DV2,DP2)
*                to the coarse grid defect vector (DU1,DV1,DP1)
*-----------------------------------------------------------------------
*    Input:
*      DU2,DV2,DP2           - fine grid defect vector
*      KVERT1,KMID1,..,NVT1  - data of the coarse grid
*      KVERT2,KMID2,..,NVT2  - data of the fine grid
*
*    Output:
*      DU1,DV1,DP1           - coarse grid defect vector
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.9375D0,A2=-0.09375D0,A3=-0.03125D0,
     *           A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
C
      DIMENSION DU1(*),DV1(*),DP1(*),  DU2(*),DV2(*),DP2(*),
     *          KVERT1(NNVE,*),KMID1(NNVE,*),KADJ1(NNVE,*),
     *          KVERT2(NNVE,*),KMID2(NNVE,*),KADJ2(NNVE,*)
C
      SAVE
C-----------------------------------------------------------------------
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** Restriction of pressure
C
      DP1(IEL1)= DP2(IELH1)+DP2(IELH2)+DP2(IELH3)+DP2(IELH4)
C
C
      I1=KMID2(1,IELH1)-NVT2
      I2=KMID2(4,IELH2)-NVT2
      I3=KMID2(1,IELH2)-NVT2
      I4=KMID2(4,IELH3)-NVT2
      I5=KMID2(1,IELH3)-NVT2
      I6=KMID2(4,IELH4)-NVT2
      I7=KMID2(1,IELH4)-NVT2
      I8=KMID2(4,IELH1)-NVT2
      I9=KMID2(2,IELH1)-NVT2
      I10=KMID2(2,IELH2)-NVT2
      I11=KMID2(2,IELH3)-NVT2
      I12=KMID2(2,IELH4)-NVT2
C
      DUH1= DU2(I1)
      DUH2= DU2(I2)
      DUH3= DU2(I3)
      DUH4= DU2(I4)
      DUH5= DU2(I5)
      DUH6= DU2(I6)
      DUH7= DU2(I7)
      DUH8= DU2(I8)
      DUH9= DU2(I9)
      DUH10=DU2(I10)
      DUH11=DU2(I11)
      DUH12=DU2(I12)
C
      DVH1= DV2(I1)
      DVH2= DV2(I2)
      DVH3= DV2(I3)
      DVH4= DV2(I4)
      DVH5= DV2(I5)
      DVH6= DV2(I6)
      DVH7= DV2(I7)
      DVH8= DV2(I8)
      DVH9= DV2(I9)
      DVH10=DV2(I10)
      DVH11=DV2(I11)
      DVH12=DV2(I12)
C
C *** The edge IM1
C
      IF (KADJ1(1,IEL1).NE.0) THEN
C     case of an inner edge
        IF (KADJ1(1,IEL1).GT.IEL1) THEN
           DU1(IM1)= A1*(DUH1+DUH2)+A2*(DUH4+DUH7)
     *                 +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                   +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
           DV1(IM1)= A1*(DVH1+DVH2)+A2*(DVH4+DVH7)
     *                 +A3*(DVH5+DVH6)+A4*(DVH3+DVH8)
     *                   +A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
        ELSE
           DU1(IM1)=DU1(IM1)+A2*(DUH4+DUH7)
     *                        +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                          +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
           DV1(IM1)=DV1(IM1)+A2*(DVH4+DVH7)
     *                        +A3*(DVH5+DVH6)+A4*(DVH3+DVH8)
     *                          +A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
        ENDIF
      ELSE
       DU1(IM1)=     A1*(DUH1+DUH2)+2D0*A2*(DUH4+DUH7)
     *          +2D0*A3*(DUH5+DUH6)+2D0*A4*(DUH3+DUH8)
     *          +    A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
       DV1(IM1)=     A1*(DVH1+DVH2)+2D0*A2*(DVH4+DVH7)
     *          +2D0*A3*(DVH5+DVH6)+2D0*A4*(DVH3+DVH8)
     *          +    A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
      ENDIF
C
C *** The edge IM2
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(2,IEL1).GT.IEL1) THEN
           DU1(IM2)= A1*(DUH3+DUH4)+A2*(DUH6+DUH1)
     *                 +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                   +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
           DV1(IM2)= A1*(DVH3+DVH4)+A2*(DVH6+DVH1)
     *                 +A3*(DVH7+DVH8)+A4*(DVH5+DVH2)
     *                   +A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
        ELSE
           DU1(IM2)=DU1(IM2)+A2*(DUH6+DUH1)
     *                        +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                          +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
           DV1(IM2)=DV1(IM2)+A2*(DVH6+DVH1)
     *                        +A3*(DVH7+DVH8)+A4*(DVH5+DVH2)
     *                          +A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
        ENDIF
      ELSE
       DU1(IM2)=     A1*(DUH3+DUH4)+2D0*A2*(DUH6+DUH1)
     *          +2D0*A3*(DUH7+DUH8)+2D0*A4*(DUH5+DUH2)
     *          +    A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
       DV1(IM2)=     A1*(DVH3+DVH4)+2D0*A2*(DVH6+DVH1)
     *          +2D0*A3*(DVH7+DVH8)+2D0*A4*(DVH5+DVH2)
     *          +    A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
      ENDIF
C
C *** The edge IM3
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(3,IEL1).GT.IEL1) THEN
           DU1(IM3)= A1*(DUH5+DUH6)+A2*(DUH8+DUH3)
     *                 +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                   +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
           DV1(IM3)= A1*(DVH5+DVH6)+A2*(DVH8+DVH3)
     *                 +A3*(DVH1+DVH2)+A4*(DVH7+DVH4)
     *                   +A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
        ELSE
           DU1(IM3)=DU1(IM3)+A2*(DUH8+DUH3)
     *                        +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                          +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
           DV1(IM3)=DV1(IM3)+A2*(DVH8+DVH3)
     *                        +A3*(DVH1+DVH2)+A4*(DVH7+DVH4)
     *                          +A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
        ENDIF
      ELSE
       DU1(IM3)=     A1*(DUH5+DUH6)+2D0*A2*(DUH8+DUH3)
     *          +2D0*A3*(DUH1+DUH2)+2D0*A4*(DUH7+DUH4)
     *          +    A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
       DV1(IM3)=     A1*(DVH5+DVH6)+2D0*A2*(DVH8+DVH3)
     *          +2D0*A3*(DVH1+DVH2)+2D0*A4*(DVH7+DVH4)
     *          +    A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
      ENDIF
C
C *** The edge IM4
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(4,IEL1).GT.IEL1) THEN
           DU1(IM4)= A1*(DUH7+DUH8)+A2*(DUH2+DUH5)
     *                 +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                   +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
           DV1(IM4)= A1*(DVH7+DVH8)+A2*(DVH2+DVH5)
     *                 +A3*(DVH3+DVH4)+A4*(DVH1+DVH6)
     *                   +A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
        ELSE
           DU1(IM4)=DU1(IM4)+A2*(DUH2+DUH5)
     *                        +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                          +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
           DV1(IM4)=DV1(IM4)+A2*(DVH2+DVH5)
     *                        +A3*(DVH3+DVH4)+A4*(DVH1+DVH6)
     *                          +A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
        ENDIF
      ELSE
       DU1(IM4)=     A1*(DUH7+DUH8)+2D0*A2*(DUH2+DUH5)
     *          +2D0*A3*(DUH3+DUH4)+2D0*A4*(DUH1+DUH6)
     *          +    A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
       DV1(IM4)=     A1*(DVH7+DVH8)+2D0*A2*(DVH2+DVH5)
     *          +2D0*A3*(DVH3+DVH4)+2D0*A4*(DVH1+DVH6)
     *          +    A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
      ENDIF
C
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE  RESTRM  (DU1,DV1,DU2,DV2,
     *                     KVERT1,KMID1,KADJ1,NEQ1,NEL1,NVT1,
     *                     KVERT2,KMID2,KADJ2,NEQ2,NEL2,NVT2)
************************************************************************
*    Purpose:    Restricts the  fine grid defect vector (DU2,DV2)
*                to the coarse grid defect vector (DU1,DV1)
*-----------------------------------------------------------------------
*    Input:
*      DU2,DV2               - fine grid defect vector
*      KVERT1,KMID1,..,NVT1  - data of the coarse grid
*      KVERT2,KMID2,..,NVT2  - data of the fine grid
*
*    Output:
*      DU1,DV1               - coarse grid defect vector
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.9375D0,A2=-0.09375D0,A3=-0.03125D0,
     *           A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
C
      DIMENSION DU1(*),DV1(*),DU2(*),DV2(*),
     *          KVERT1(NNVE,*),KMID1(NNVE,*),KADJ1(NNVE,*),
     *          KVERT2(NNVE,*),KMID2(NNVE,*),KADJ2(NNVE,*)
C
      SAVE
C-----------------------------------------------------------------------
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C
      I1=KMID2(1,IELH1)-NVT2
      I2=KMID2(4,IELH2)-NVT2
      I3=KMID2(1,IELH2)-NVT2
      I4=KMID2(4,IELH3)-NVT2
      I5=KMID2(1,IELH3)-NVT2
      I6=KMID2(4,IELH4)-NVT2
      I7=KMID2(1,IELH4)-NVT2
      I8=KMID2(4,IELH1)-NVT2
      I9=KMID2(2,IELH1)-NVT2
      I10=KMID2(2,IELH2)-NVT2
      I11=KMID2(2,IELH3)-NVT2
      I12=KMID2(2,IELH4)-NVT2
C
      DUH1= DU2(I1)
      DUH2= DU2(I2)
      DUH3= DU2(I3)
      DUH4= DU2(I4)
      DUH5= DU2(I5)
      DUH6= DU2(I6)
      DUH7= DU2(I7)
      DUH8= DU2(I8)
      DUH9= DU2(I9)
      DUH10=DU2(I10)
      DUH11=DU2(I11)
      DUH12=DU2(I12)
C
      DVH1= DV2(I1)
      DVH2= DV2(I2)
      DVH3= DV2(I3)
      DVH4= DV2(I4)
      DVH5= DV2(I5)
      DVH6= DV2(I6)
      DVH7= DV2(I7)
      DVH8= DV2(I8)
      DVH9= DV2(I9)
      DVH10=DV2(I10)
      DVH11=DV2(I11)
      DVH12=DV2(I12)
C
C *** The edge IM1
C
      IF (KADJ1(1,IEL1).NE.0) THEN
C     case of an inner edge
        IF (KADJ1(1,IEL1).GT.IEL1) THEN
           DU1(IM1)= A1*(DUH1+DUH2)+A2*(DUH4+DUH7)
     *                 +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                   +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
           DV1(IM1)= A1*(DVH1+DVH2)+A2*(DVH4+DVH7)
     *                 +A3*(DVH5+DVH6)+A4*(DVH3+DVH8)
     *                   +A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
        ELSE
           DU1(IM1)=DU1(IM1)+A2*(DUH4+DUH7)
     *                        +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                          +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
           DV1(IM1)=DV1(IM1)+A2*(DVH4+DVH7)
     *                        +A3*(DVH5+DVH6)+A4*(DVH3+DVH8)
     *                          +A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
        ENDIF
      ELSE
       DU1(IM1)=     A1*(DUH1+DUH2)+2D0*A2*(DUH4+DUH7)
     *          +2D0*A3*(DUH5+DUH6)+2D0*A4*(DUH3+DUH8)
     *          +    A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
       DV1(IM1)=     A1*(DVH1+DVH2)+2D0*A2*(DVH4+DVH7)
     *          +2D0*A3*(DVH5+DVH6)+2D0*A4*(DVH3+DVH8)
     *          +    A5*DVH9+A6*(DVH10+DVH12)+A7*DVH11
      ENDIF
C
C *** The edge IM2
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(2,IEL1).GT.IEL1) THEN
           DU1(IM2)= A1*(DUH3+DUH4)+A2*(DUH6+DUH1)
     *                 +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                   +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
           DV1(IM2)= A1*(DVH3+DVH4)+A2*(DVH6+DVH1)
     *                 +A3*(DVH7+DVH8)+A4*(DVH5+DVH2)
     *                   +A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
        ELSE
           DU1(IM2)=DU1(IM2)+A2*(DUH6+DUH1)
     *                        +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                          +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
           DV1(IM2)=DV1(IM2)+A2*(DVH6+DVH1)
     *                        +A3*(DVH7+DVH8)+A4*(DVH5+DVH2)
     *                          +A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
        ENDIF
      ELSE
       DU1(IM2)=     A1*(DUH3+DUH4)+2D0*A2*(DUH6+DUH1)
     *          +2D0*A3*(DUH7+DUH8)+2D0*A4*(DUH5+DUH2)
     *          +    A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
       DV1(IM2)=     A1*(DVH3+DVH4)+2D0*A2*(DVH6+DVH1)
     *          +2D0*A3*(DVH7+DVH8)+2D0*A4*(DVH5+DVH2)
     *          +    A5*DVH10+A6*(DVH11+DVH9)+A7*DVH12
      ENDIF
C
C *** The edge IM3
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(3,IEL1).GT.IEL1) THEN
           DU1(IM3)= A1*(DUH5+DUH6)+A2*(DUH8+DUH3)
     *                 +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                   +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
           DV1(IM3)= A1*(DVH5+DVH6)+A2*(DVH8+DVH3)
     *                 +A3*(DVH1+DVH2)+A4*(DVH7+DVH4)
     *                   +A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
        ELSE
           DU1(IM3)=DU1(IM3)+A2*(DUH8+DUH3)
     *                        +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                          +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
           DV1(IM3)=DV1(IM3)+A2*(DVH8+DVH3)
     *                        +A3*(DVH1+DVH2)+A4*(DVH7+DVH4)
     *                          +A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
        ENDIF
      ELSE
       DU1(IM3)=     A1*(DUH5+DUH6)+2D0*A2*(DUH8+DUH3)
     *          +2D0*A3*(DUH1+DUH2)+2D0*A4*(DUH7+DUH4)
     *          +    A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
       DV1(IM3)=     A1*(DVH5+DVH6)+2D0*A2*(DVH8+DVH3)
     *          +2D0*A3*(DVH1+DVH2)+2D0*A4*(DVH7+DVH4)
     *          +    A5*DVH11+A6*(DVH12+DVH10)+A7*DVH9
      ENDIF
C
C *** The edge IM4
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(4,IEL1).GT.IEL1) THEN
           DU1(IM4)= A1*(DUH7+DUH8)+A2*(DUH2+DUH5)
     *                 +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                   +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
           DV1(IM4)= A1*(DVH7+DVH8)+A2*(DVH2+DVH5)
     *                 +A3*(DVH3+DVH4)+A4*(DVH1+DVH6)
     *                   +A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
        ELSE
           DU1(IM4)=DU1(IM4)+A2*(DUH2+DUH5)
     *                        +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                          +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
           DV1(IM4)=DV1(IM4)+A2*(DVH2+DVH5)
     *                        +A3*(DVH3+DVH4)+A4*(DVH1+DVH6)
     *                          +A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
        ENDIF
      ELSE
       DU1(IM4)=     A1*(DUH7+DUH8)+2D0*A2*(DUH2+DUH5)
     *          +2D0*A3*(DUH3+DUH4)+2D0*A4*(DUH1+DUH6)
     *          +    A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
       DV1(IM4)=     A1*(DVH7+DVH8)+2D0*A2*(DVH2+DVH5)
     *          +2D0*A3*(DVH3+DVH4)+2D0*A4*(DVH1+DVH6)
     *          +    A5*DVH12+A6*(DVH9+DVH11)+A7*DVH10
      ENDIF
C
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE  RESTRU  (DU1,DV1,DU2,DV2,
     *                     KVERT1,KMID1,KADJ1,NEQ1,NEL1,NVT1,
     *                     KVERT2,KMID2,KADJ2,NEQ2,NEL2,NVT2 )
************************************************************************
*    Purpose:  Restricts the  fine grid solution vector (DU2,DV2) to
*              the coarse grid solution vector (DU1,DV1)
*
*    Remark:   RESTRU works for all cases of boundary conditions
*                
*-----------------------------------------------------------------------
*    Input:
*      DU2,DV2               - fine grid solution vector
*      KVERT1,KMID1,..,NVT1  - data of the coarse grid
*      KVERT2,KMID2,..,NVT2  - data of the fine grid
*
*    Output:
*      DU1,DV1               - coarse grid solution vector
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.1875D0, A2=0.375D0, A3=-0.0625D0)
      PARAMETER (R1=0.375D0, R2=0.75D0, R3=-0.125D0)
C
      DIMENSION DU1(*),DV1(*),  DU2(*),DV2(*),
     *          KVERT1(NNVE,*),KMID1(NNVE,*),KADJ1(NNVE,*),
     *          KVERT2(NNVE,*),KMID2(NNVE,*),KADJ2(NNVE,*)
      SAVE
C-----------------------------------------------------------------------
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
      I1=KMID2(1,IELH1)-NVT2
      I2=KMID2(4,IELH2)-NVT2
      I3=KMID2(1,IELH2)-NVT2
      I4=KMID2(4,IELH3)-NVT2
      I5=KMID2(1,IELH3)-NVT2
      I6=KMID2(4,IELH4)-NVT2
      I7=KMID2(1,IELH4)-NVT2
      I8=KMID2(4,IELH1)-NVT2
      I9=KMID2(2,IELH1)-NVT2
      I10=KMID2(2,IELH2)-NVT2
      I11=KMID2(2,IELH3)-NVT2
      I12=KMID2(2,IELH4)-NVT2
C
      DUH1= DU2(I1)
      DUH2= DU2(I2)
      DUH3= DU2(I3)
      DUH4= DU2(I4)
      DUH5= DU2(I5)
      DUH6= DU2(I6)
      DUH7= DU2(I7)
      DUH8= DU2(I8)
      DUH9= DU2(I9)
      DUH10=DU2(I10)
      DUH11=DU2(I11)
      DUH12=DU2(I12)
C
      DVH1= DV2(I1)
      DVH2= DV2(I2)
      DVH3= DV2(I3)
      DVH4= DV2(I4)
      DVH5= DV2(I5)
      DVH6= DV2(I6)
      DVH7= DV2(I7)
      DVH8= DV2(I8)
      DVH9= DV2(I9)
      DVH10=DV2(I10)
      DVH11=DV2(I11)
      DVH12=DV2(I12)
C
C *** The edge IM1
C
      IF (KADJ1(1,IEL1).NE.0) THEN
C     case of an inner edge
       IF (KADJ1(1,IEL1).GT.IEL1) THEN
        DU1(IM1)=A1*(DUH1+DUH2)  +A2*DUH9   +A3*(DUH8+DUH3+DUH10+DUH12)
        DV1(IM1)=A1*(DVH1+DVH2)  +A2*DVH9   +A3*(DVH8+DVH3+DVH10+DVH12)
       ELSE
        DU1(IM1)=DU1(IM1) +
     *           A1*(DUH1+DUH2)  +A2*DUH9   +A3*(DUH8+DUH3+DUH10+DUH12)
        DV1(IM1)=DV1(IM1) +
     *           A1*(DVH1+DVH2)  +A2*DVH9   +A3*(DVH8+DVH3+DVH10+DVH12)
       ENDIF
      ELSE
C     case of a boundary edge
        DU1(IM1)=R1*(DUH1+DUH2)  +R2*DUH9   +R3*(DUH8+DUH3+DUH10+DUH12)
        DV1(IM1)=R1*(DVH1+DVH2)  +R2*DVH9   +R3*(DVH8+DVH3+DVH10+DVH12)
      ENDIF
C
C *** The edge IM2
C
      IF (KADJ1(2,IEL1).NE.0) THEN
C     case of an inner edge
       IF (KADJ1(2,IEL1).GT.IEL1) THEN
        DU1(IM2)=A1*(DUH3+DUH4)  +A2*DUH10  +A3*(DUH2+DUH5+DUH9 +DUH11)
        DV1(IM2)=A1*(DVH3+DVH4)  +A2*DVH10  +A3*(DVH2+DVH5+DVH9 +DVH11)
       ELSE
        DU1(IM2)=DU1(IM2) +
     *           A1*(DUH3+DUH4)  +A2*DUH10  +A3*(DUH2+DUH5+DUH9 +DUH11)
        DV1(IM2)=DV1(IM2) +
     *           A1*(DVH3+DVH4)  +A2*DVH10  +A3*(DVH2+DVH5+DVH9 +DVH11)
       ENDIF
      ELSE
C     case of a boundary edge
        DU1(IM2)=R1*(DUH3+DUH4)  +R2*DUH10  +R3*(DUH2+DUH5+DUH9 +DUH11)
        DV1(IM2)=R1*(DVH3+DVH4)  +R2*DVH10  +R3*(DVH2+DVH5+DVH9 +DVH11)
      ENDIF
C
C *** The edge IM3
C
      IF (KADJ1(3,IEL1).NE.0) THEN
C     case of an inner edge
       IF (KADJ1(3,IEL1).GT.IEL1) THEN
        DU1(IM3)=A1*(DUH5+DUH6)  +A2*DUH11  +A3*(DUH4+DUH7+DUH10+DUH12)
        DV1(IM3)=A1*(DVH5+DVH6)  +A2*DVH11  +A3*(DVH4+DVH7+DVH10+DVH12)
       ELSE
        DU1(IM3)=DU1(IM3) +
     *           A1*(DUH5+DUH6)  +A2*DUH11  +A3*(DUH4+DUH7+DUH10+DUH12)
        DV1(IM3)=DV1(IM3) +
     *           A1*(DVH5+DVH6)  +A2*DVH11  +A3*(DVH4+DVH7+DVH10+DVH12)
       ENDIF
      ELSE
C     case of a boundary edge
        DU1(IM3)=R1*(DUH5+DUH6)  +R2*DUH11  +R3*(DUH4+DUH7+DUH10+DUH12)
        DV1(IM3)=R1*(DVH5+DVH6)  +R2*DVH11  +R3*(DVH4+DVH7+DVH10+DVH12)
      ENDIF
C
C *** The edge IM4
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
C     case of an inner edge
       IF (KADJ1(4,IEL1).GT.IEL1) THEN
        DU1(IM4)=A1*(DUH7+DUH8)  +A2*DUH12  +A3*(DUH6+DUH1+DUH9 +DUH11)
        DV1(IM4)=A1*(DVH7+DVH8)  +A2*DVH12  +A3*(DVH6+DVH1+DVH9 +DVH11)
       ELSE
        DU1(IM4)=DU1(IM4) +
     *           A1*(DUH7+DUH8)  +A2*DUH12  +A3*(DUH6+DUH1+DUH9 +DUH11)
        DV1(IM4)=DV1(IM4) +
     *           A1*(DVH7+DVH8)  +A2*DVH12  +A3*(DVH6+DVH1+DVH9 +DVH11)
       ENDIF
      ELSE
C     case of a boundary edge
        DU1(IM4)=R1*(DUH7+DUH8)  +R2*DUH12  +R3*(DUH6+DUH1+DUH9 +DUH11)
        DV1(IM4)=R1*(DVH7+DVH8)  +R2*DVH12  +R3*(DVH6+DVH1+DVH9 +DVH11)
      ENDIF
C
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE MR010 (DP1,DP2,KADJ1,KADJ2,NEL1,NEL2)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NNVE=4)
      DIMENSION DP1(*),DP2(*)
      DIMENSION KADJ1(NNVE,*),KADJ2(NNVE,*)
C
      SAVE
C-----------------------------------------------------------------------
C
      DO 10 IEL1=1,NEL1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** Restriction of pressure
C
      DP1(IEL1)= DP2(IELH1)+DP2(IELH2)+DP2(IELH3)+DP2(IELH4)
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE MP030(DU1,DU2,KVERT1,KVERT2,KMID1,KMID2,
     *                 KADJ1,KADJ2,NVT1,NVT2,NEL1,NEL2,NMT2)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.5D0,A2=-0.0625D0,A3=0D0,A4=0.0625D0)
      PARAMETER (A5=0.625D0,A6=0.125D0,A7=0.125D0,A8=0.125D0)
      DIMENSION DU1(*),DU2(*),KVERT1(NNVE,*),KVERT2(NNVE,*),
     *          KMID1(NNVE,*),KMID2(NNVE,*),KADJ1(NNVE,*),
     *          KADJ2(NNVE,*)
C
C
C
C *** Zero initialization of (DU2)
      CALL  LCL1 (DU2,NMT2)
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      DUH1=DU1(IM1)
      DUH2=DU1(IM2)
      DUH3=DU1(IM3)
      DUH4=DU1(IM4)
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** The edge IM1 and the corresponding fine inner node
C
      IF (KADJ1(1,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4
       DU2(IB)=DU2(IB)+   A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4
      ELSE
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4)
      ENDIF
      IC=KMID2(2,IELH1)-NVT2
      DU2(IC)=A5*DUH1+A6*(DUH2+DUH4)+A7*DUH3
C
C *** The edge IM2 and the corresponding fine inner node
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1
       DU2(IB)=DU2(IB)+   A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1
      ELSE
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1)
      ENDIF
      IC=KMID2(2,IELH2)-NVT2
      DU2(IC)=A5*DUH2+A6*(DUH3+DUH1)+A7*DUH4
C
C *** The edge IM3 and the corresponding fine inner node
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2
       DU2(IB)=DU2(IB)+   A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2
      ELSE
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2)
      ENDIF
      IC=KMID2(2,IELH3)-NVT2
      DU2(IC)=A5*DUH3+A6*(DUH4+DUH2)+A7*DUH1
C
C *** The edge IM4 and the corresponding fine inner node
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3
       DU2(IB)=DU2(IB)+   A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3
      ELSE
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3)
      ENDIF
      IC=KMID2(2,IELH4)-NVT2
      DU2(IC)=A5*DUH4+A6*(DUH1+DUH3)+A7*DUH2
C
C
10    CONTINUE
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE MP031(DU1,DU2,KVERT1,KVERT2,KMID1,KMID2,
     *                 KADJ1,KADJ2,NVT1,NVT2,NEL1,NEL2,NMT2)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.46875D0,A2=-0.09375D0,A3=-0.03125D0,A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
      DIMENSION DU1(*),DU2(*),KVERT1(NNVE,*),KVERT2(NNVE,*),
     *          KMID1(NNVE,*),KMID2(NNVE,*),KADJ1(NNVE,*),
     *          KADJ2(NNVE,*)
C
C
C
C *** Zero initialization of (DU2)
      CALL  LCL1 (DU2,NMT2)
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      DUH1=DU1(IM1)
      DUH2=DU1(IM2)
      DUH3=DU1(IM3)
      DUH4=DU1(IM4)
C
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C
C
C *** The edge IM1 and the corresponding fine inner node
C
      IF (KADJ1(1,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4
       DU2(IB)=DU2(IB)+   A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4
      ELSE
       IA=KMID2(1,IELH1)-NVT2
       IB=KMID2(4,IELH2)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH1+A2*DUH2+A3*DUH3+A4*DUH4)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH1+A4*DUH2+A3*DUH3+A2*DUH4)
      ENDIF
      IC=KMID2(2,IELH1)-NVT2
      DU2(IC)=A5*DUH1+A6*(DUH2+DUH4)+A7*DUH3
C
C *** The edge IM2 and the corresponding fine inner node
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1
       DU2(IB)=DU2(IB)+   A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1
      ELSE
       IA=KMID2(1,IELH2)-NVT2
       IB=KMID2(4,IELH3)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH2+A2*DUH3+A3*DUH4+A4*DUH1)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH2+A4*DUH3+A3*DUH4+A2*DUH1)
      ENDIF
      IC=KMID2(2,IELH2)-NVT2
      DU2(IC)=A5*DUH2+A6*(DUH3+DUH1)+A7*DUH4
C
C *** The edge IM3 and the corresponding fine inner node
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2
       DU2(IB)=DU2(IB)+   A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2
      ELSE
       IA=KMID2(1,IELH3)-NVT2
       IB=KMID2(4,IELH4)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH3+A2*DUH4+A3*DUH1+A4*DUH2)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH3+A4*DUH4+A3*DUH1+A2*DUH2)
      ENDIF
      IC=KMID2(2,IELH3)-NVT2
      DU2(IC)=A5*DUH3+A6*(DUH4+DUH2)+A7*DUH1
C
C *** The edge IM4 and the corresponding fine inner node
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+   A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3
       DU2(IB)=DU2(IB)+   A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3
      ELSE
       IA=KMID2(1,IELH4)-NVT2
       IB=KMID2(4,IELH1)-NVT2
       DU2(IA)=DU2(IA)+2D0*(A1*DUH4+A2*DUH1+A3*DUH2+A4*DUH3)
       DU2(IB)=DU2(IB)+2D0*(A1*DUH4+A4*DUH1+A3*DUH2+A2*DUH3)
      ENDIF
      IC=KMID2(2,IELH4)-NVT2
      DU2(IC)=A5*DUH4+A6*(DUH1+DUH3)+A7*DUH2
C
C
10    CONTINUE
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE MR030(DU2,DU1,KVERT2,KVERT1,KMID2,KMID1,
     *                 KADJ2,KADJ1,NVT2,NVT1,NEL2,NEL1)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      PARAMETER (A1=1D0,A2=-0.0625D0,A3=0D0,A4=0.0625D0)
      PARAMETER (A5=0.625D0,A6=0.125D0,A7=0.125D0,A8=0.125D0)
      DIMENSION DU1(1),DU2(1),KVERT2(NNVE,1),KVERT1(NNVE,1),
     *          KMID1(NNVE,1),KMID2(NNVE,1),
     *          KADJ1(NNVE,1),KADJ2(NNVE,1)
C
C
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
      I1=KMID2(1,IELH1)-NVT2
      I2=KMID2(4,IELH2)-NVT2
      I3=KMID2(1,IELH2)-NVT2
      I4=KMID2(4,IELH3)-NVT2
      I5=KMID2(1,IELH3)-NVT2
      I6=KMID2(4,IELH4)-NVT2
      I7=KMID2(1,IELH4)-NVT2
      I8=KMID2(4,IELH1)-NVT2
      I9=KMID2(2,IELH1)-NVT2
      I10=KMID2(2,IELH2)-NVT2
      I11=KMID2(2,IELH3)-NVT2
      I12=KMID2(2,IELH4)-NVT2
C
      DUH1= DU2(I1)
      DUH2= DU2(I2)
      DUH3= DU2(I3)
      DUH4= DU2(I4)
      DUH5= DU2(I5)
      DUH6= DU2(I6)
      DUH7= DU2(I7)
      DUH8= DU2(I8)
      DUH9= DU2(I9)
      DUH10=DU2(I10)
      DUH11=DU2(I11)
      DUH12=DU2(I12)
C
C
C *** The edge IM1
C
      IF (KADJ1(1,IEL1).NE.0) THEN
C     case of an inner edge
        IF (KADJ1(1,IEL1).GT.IEL1) THEN
           DU1(IM1)= A1*(DUH1+DUH2)+A2*(DUH4+DUH7)
     *                 +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                   +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
        ELSE
           DU1(IM1)=DU1(IM1)+A2*(DUH4+DUH7)
     *                        +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                          +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
        ENDIF
      ELSE
       DU1(IM1)=     A1*(DUH1+DUH2)+2D0*A2*(DUH4+DUH7)
     *          +2D0*A3*(DUH5+DUH6)+2D0*A4*(DUH3+DUH8)
     *          +    A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
      ENDIF
C
C *** The edge IM2
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(2,IEL1).GT.IEL1) THEN
           DU1(IM2)= A1*(DUH3+DUH4)+A2*(DUH6+DUH1)
     *                 +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                   +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
        ELSE
           DU1(IM2)=DU1(IM2)+A2*(DUH6+DUH1)
     *                        +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                          +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
        ENDIF
      ELSE
       DU1(IM2)=     A1*(DUH3+DUH4)+2D0*A2*(DUH6+DUH1)
     *          +2D0*A3*(DUH7+DUH8)+2D0*A4*(DUH5+DUH2)
     *          +    A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
      ENDIF
C
C *** The edge IM3
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(3,IEL1).GT.IEL1) THEN
           DU1(IM3)= A1*(DUH5+DUH6)+A2*(DUH8+DUH3)
     *                 +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                   +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
        ELSE
           DU1(IM3)=DU1(IM3)+A2*(DUH8+DUH3)
     *                        +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                          +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
        ENDIF
      ELSE
       DU1(IM3)=     A1*(DUH5+DUH6)+2D0*A2*(DUH8+DUH3)
     *          +2D0*A3*(DUH1+DUH2)+2D0*A4*(DUH7+DUH4)
     *          +    A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
      ENDIF
C
C *** The edge IM4
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(4,IEL1).GT.IEL1) THEN
           DU1(IM4)= A1*(DUH7+DUH8)+A2*(DUH2+DUH5)
     *                 +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                   +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
        ELSE
           DU1(IM4)=DU1(IM4)+A2*(DUH2+DUH5)
     *                        +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                          +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
        ENDIF
      ELSE
       DU1(IM4)=     A1*(DUH7+DUH8)+2D0*A2*(DUH2+DUH5)
     *          +2D0*A3*(DUH3+DUH4)+2D0*A4*(DUH1+DUH6)
     *          +    A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
      ENDIF
C
C
10    CONTINUE
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE MP010 (DP1,DP2,KADJ1,KADJ2,NEL1,NEL2)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION DP1(*),DP2(*)
      DIMENSION KADJ1(NNVE,*),KADJ2(NNVE,*)
      SAVE
C-----------------------------------------------------------------------
C
      DO 10 IEL1=1,NEL1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C *** Prolongation of pressure
C
      DPH=DP1(IEL1)
      DP2(IELH1)=DPH
      DP2(IELH2)=DPH
      DP2(IELH3)=DPH
      DP2(IELH4)=DPH
C
10    CONTINUE
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE MR031(DU2,DU1,KVERT2,KVERT1,KMID2,KMID1,
     *                 KADJ2,KADJ1,NVT2,NVT1,NEL2,NEL1)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      PARAMETER (A1=0.9375D0,A2=-0.09375D0,A3=-0.03125D0,A4=0.15625D0)
      PARAMETER (A5=0.5625D0,A6=0.1875D0,A7=0.0625D0,A8=0.1875D0)
      DIMENSION DU1(1),DU2(1),KVERT2(NNVE,1),KVERT1(NNVE,1),
     *          KMID1(NNVE,1),KMID2(NNVE,1),
     *          KADJ1(NNVE,1),KADJ2(NNVE,1)
C
C
C
      DO 10 IEL1=1,NEL1
C
      IM1=KMID1(1,IEL1)-NVT1
      IM2=KMID1(2,IEL1)-NVT1
      IM3=KMID1(3,IEL1)-NVT1
      IM4=KMID1(4,IEL1)-NVT1
C
      IELH1=IEL1
      IELH2=KADJ2(2,IELH1)
      IELH3=KADJ2(2,IELH2)
      IELH4=KADJ2(2,IELH3)
C
C
C
C
      I1=KMID2(1,IELH1)-NVT2
      I2=KMID2(4,IELH2)-NVT2
      I3=KMID2(1,IELH2)-NVT2
      I4=KMID2(4,IELH3)-NVT2
      I5=KMID2(1,IELH3)-NVT2
      I6=KMID2(4,IELH4)-NVT2
      I7=KMID2(1,IELH4)-NVT2
      I8=KMID2(4,IELH1)-NVT2
      I9=KMID2(2,IELH1)-NVT2
      I10=KMID2(2,IELH2)-NVT2
      I11=KMID2(2,IELH3)-NVT2
      I12=KMID2(2,IELH4)-NVT2
C
      DUH1= DU2(I1)
      DUH2= DU2(I2)
      DUH3= DU2(I3)
      DUH4= DU2(I4)
      DUH5= DU2(I5)
      DUH6= DU2(I6)
      DUH7= DU2(I7)
      DUH8= DU2(I8)
      DUH9= DU2(I9)
      DUH10=DU2(I10)
      DUH11=DU2(I11)
      DUH12=DU2(I12)
C
C
C *** The edge IM1
C
      IF (KADJ1(1,IEL1).NE.0) THEN
C     case of an inner edge
        IF (KADJ1(1,IEL1).GT.IEL1) THEN
           DU1(IM1)= A1*(DUH1+DUH2)+A2*(DUH4+DUH7)
     *                 +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                   +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
        ELSE
           DU1(IM1)=DU1(IM1)+A2*(DUH4+DUH7)
     *                        +A3*(DUH5+DUH6)+A4*(DUH3+DUH8)
     *                          +A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
        ENDIF
      ELSE
       DU1(IM1)=     A1*(DUH1+DUH2)+2D0*A2*(DUH4+DUH7)
     *          +2D0*A3*(DUH5+DUH6)+2D0*A4*(DUH3+DUH8)
     *          +    A5*DUH9+A6*(DUH10+DUH12)+A7*DUH11
      ENDIF
C
C *** The edge IM2
C
      IF (KADJ1(2,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(2,IEL1).GT.IEL1) THEN
           DU1(IM2)= A1*(DUH3+DUH4)+A2*(DUH6+DUH1)
     *                 +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                   +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
        ELSE
           DU1(IM2)=DU1(IM2)+A2*(DUH6+DUH1)
     *                        +A3*(DUH7+DUH8)+A4*(DUH5+DUH2)
     *                          +A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
        ENDIF
      ELSE
       DU1(IM2)=     A1*(DUH3+DUH4)+2D0*A2*(DUH6+DUH1)
     *          +2D0*A3*(DUH7+DUH8)+2D0*A4*(DUH5+DUH2)
     *          +    A5*DUH10+A6*(DUH11+DUH9)+A7*DUH12
      ENDIF
C
C *** The edge IM3
C
      IF (KADJ1(3,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(3,IEL1).GT.IEL1) THEN
           DU1(IM3)= A1*(DUH5+DUH6)+A2*(DUH8+DUH3)
     *                 +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                   +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
        ELSE
           DU1(IM3)=DU1(IM3)+A2*(DUH8+DUH3)
     *                        +A3*(DUH1+DUH2)+A4*(DUH7+DUH4)
     *                          +A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
        ENDIF
      ELSE
       DU1(IM3)=     A1*(DUH5+DUH6)+2D0*A2*(DUH8+DUH3)
     *          +2D0*A3*(DUH1+DUH2)+2D0*A4*(DUH7+DUH4)
     *          +    A5*DUH11+A6*(DUH12+DUH10)+A7*DUH9
      ENDIF
C
C *** The edge IM4
C
      IF (KADJ1(4,IEL1).NE.0) THEN 
C     case of an inner edge
        IF (KADJ1(4,IEL1).GT.IEL1) THEN
           DU1(IM4)= A1*(DUH7+DUH8)+A2*(DUH2+DUH5)
     *                 +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                   +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
        ELSE
           DU1(IM4)=DU1(IM4)+A2*(DUH2+DUH5)
     *                        +A3*(DUH3+DUH4)+A4*(DUH1+DUH6)
     *                          +A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
        ENDIF
      ELSE
       DU1(IM4)=     A1*(DUH7+DUH8)+2D0*A2*(DUH2+DUH5)
     *          +2D0*A3*(DUH3+DUH4)+2D0*A4*(DUH1+DUH6)
     *          +    A5*DUH12+A6*(DUH9+DUH11)+A7*DUH10
      ENDIF
C
C
10    CONTINUE
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE  YAX (DX,DAX,NEQ,A1,A2)  
************************************************************************
*
*   Purpose: - performs the matrix-vector-operation
*
*                   DAX:= A1*(A*DX) + A2*DAX
*
*              of dimension NEQ   (A1,A2 given scalar variables)
*
*            - DX,DAX  have the structure  D=(D1,D2,DP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** global constants
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
      DIMENSION DX(*),DAX(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C-----------------------------------------------------------------------
C
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE
C=======================================================================
C     Getting all parameters for MATML
C=======================================================================
C *** addresses for the current level ILEV
C
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2=1+NU
      IP=I2+NU
C
      KMBD =L(KLMBD(ILEV))
      NMBD= KNMBD(ILEV)
C
C=======================================================================
C
      CALL MATML(DAX(1),DAX(I2),DAX(IP),DX(1),DX(I2),DX(IP),A1,A2,
     *            VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *            VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *            NU,NP,KWORK(KMBD),NMBD,INEUM)
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE  YDBC (DX,NEQ)  
************************************************************************
*
*   Purpose: - sets Dirichlet boundary components of DX=(D1,D2) to 0
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** global constants
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
      DIMENSION DX(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
C-----------------------------------------------------------------------
C
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE
C=======================================================================
C     Getting all parameters for DX
C=======================================================================
C *** addresses for the current level ILEV
C
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2=1+NU
C
      KMBD =L(KLMBD(ILEV))
      NMBD= KNMBD(ILEV)
C
      CALL  BDRY0 (DX(1),DX(I2),KWORK(KMBD),NMBD)
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE   YEX (DX,DB,DD,NEQ,RHO)  
************************************************************************
*
*   Purpose: - computes on level ILEV on DX the solution of
*              
*                         A*DX=DB  
*               
*              with a certain accuracy controled by variables on
*              COMMON blocks 
*  
*            - DX,DB,DD have the structure  D=(D1,D2,DP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
C
      DIMENSION DX(*),DB(*),DD(*)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C
C=======================================================================
C     Getting all parameters for SMOOTH
C=======================================================================
C
C *** addresses for the current level ILEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2=1+NU
      IP=I2+NU
C
      KVERT=L(LVERT)
      KMID =L(LMID )
      KNPR =L(LNPR )
      KMBD =L(KLMBD(ILEV))
      NMBD= KNMBD(ILEV)
C
      KAREA=L(KLAREA(ILEV))
C
C=======================================================================
C
      IF (ISL.EQ.1) THEN
C
       DO 11 ITE=1,NSL
C
       CALL  VANCAE (DX(1),DX(I2),DX(IP),DD(1),DD(I2),DD(IP),
     *               DB(1),DB(I2),DB(IP),
     *               VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *               VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *               NU,NP,KWORK(KMBD),KWORK(KVERT),
     *               KWORK(KMID),KWORK(KNPR),NMBD,RLXSL,DMAXU,DMAXP)
C
       IF (INEUM.EQ.0) CALL TOL20A(DX(IP),VWORK(KAREA),NP,INEUM)
C
       RES=MAX(DMAXU,DMAXP)
       IF (ITE.EQ.1) RESINI=RES
       RHO=(RES/RESINI)**(1D0/DBLE(ITE))
ccc       write(6,*) ite,res,DMAXU,DMAXP,DMPSL*RESINI,RHO
       IF ((RES.LT.EPSSL).AND.(RES.LT.DMPSL*RESINI)) GOTO 99999
C
11     CONTINUE
C
      ENDIF
C
C
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE   YEXA (DX,DB,DD,NEQ,RHO,EPS,ITE)  
************************************************************************
*
*   Purpose: - computes on level ILEV on DX the solution of
*              
*                         A*DX=DB  
*               
*              with a certain accuracy controled by variables on
*              COMMON blocks 
*  
*            - DX,DB,DD have the structure  D=(D1,D2,DP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
C
      DIMENSION DX(*),DB(*),DD(*)
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C
C=======================================================================
C     Getting all parameters for SMOOTH
C=======================================================================
C
C *** addresses for the current level ILEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2=1+NU
      IP=I2+NU
C
      KVERT=L(LVERT)
      KMID =L(LMID )
      KNPR =L(LNPR )
      KMBD =L(KLMBD(ILEV))
      NMBD= KNMBD(ILEV)
C
      KAREA=L(KLAREA(ILEV))
C
C=======================================================================
C
      IF (ISL.EQ.1) THEN
C
       DO 11 ITE=1,NSL
C
       CALL  VANCAE (DX(1),DX(I2),DX(IP),DD(1),DD(I2),DD(IP),
     *               DB(1),DB(I2),DB(IP),
     *               VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *               VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *               NU,NP,KWORK(KMBD),KWORK(KVERT),
     *               KWORK(KMID),KWORK(KNPR),NMBD,RLXSL,DMAXU,DMAXP)
C
       IF (INEUM.EQ.0) CALL TOL20A(DX(IP),VWORK(KAREA),NP,INEUM)
C
       RES=MAX(DMAXU,DMAXP)
       IF (ITE.EQ.1) RESINI=RES
       RHO=(RES/RESINI)**(1D0/DBLE(ITE))
ccc       write(6,*) ite,res,DMAXU,DMAXP,DMPSL*RESINI,RHO
       IF ((RES.LT.EPSMG).AND.(RES.LT.DMPMG*RESINI)) GOTO 99999
C
11     CONTINUE
C
      ENDIF
C
C
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE  YPROL (DUC,DUF)  
************************************************************************
*
*   Purpose: - performs the prolongation   DUF:=p(DUC)
*              with
*                  DUF   - fine correction vector on level ILEV
*                  DUC   - coarse correction vector on level ILEV-1
*  
*            - DUF and DUC have the structure  DU=(DU1,DU2,DP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
C
      DIMENSION DUF(*),DUC(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE 
C
C=======================================================================
C     Getting all parameters for PROLU
C=======================================================================
C
C *** addresses for the fine level ILEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2F=1+NU
      IPF=I2F+NU
C
      KVERTF=L(LVERT)
      KMIDF =L(LMID )
      KADJF =L(LADJ )
C
C *** addresses for the coarse level ILEV-1
      I1=ILEV-1
      NUC=KNU(I1)
      NPC=KNP(I1)
      NVTC=KNVT(I1)
      NMTC=KNMT(I1)
      I2C=1+NUC
      IPC=I2C+NUC
C
      KVERTC=L(KLVERT(I1))
      KMIDC =L(KLMID (I1))
      KADJC =L(KLADJ (I1))
C
C=======================================================================
C
      CALL PROLU (DUC(1),DUC(I2C),DUC(IPC),DUF(1),DUF(I2F),DUF(IPF),
     *            KWORK(KVERTC),KWORK(KMIDC),KWORK(KADJC),NUC,NPC,NVTC,
     *            KWORK(KVERTF),KWORK(KMIDF),KWORK(KADJF),NU,NP,NVT)
C
      IF (ABS(IINT).EQ.2) THEN
       KPLC=L(LD1)
       KPLF=L(LD2)
C
       CALL C2N2DM(DUC(IPC),DWORK(KPLC),KWORK(KMIDC),
     *             KWORK(KADJC),NPC,NMTC,NVTC,0)
C
       IF (IINT.GT.0) THEN
        CALL MP031(DWORK(KPLC),DWORK(KPLF),KWORK(KVERTC),KWORK(KVERTF),
     *             KWORK(KMIDC),KWORK(KMIDF),KWORK(KADJC),KWORK(KADJF),
     *             NVTC,NVT,NPC,NP,NMT)
       ELSE
        CALL MP030(DWORK(KPLC),DWORK(KPLF),KWORK(KVERTC),KWORK(KVERTF),
     *             KWORK(KMIDC),KWORK(KMIDF),KWORK(KADJC),KWORK(KADJF),
     *             NVTC,NVT,NPC,NP,NMT)
       ENDIF
C
       CALL C2N2DM(DUF(IPF),DWORK(KPLF),KWORK(KMIDF),
     *             KWORK(KADJF),NP,NMT,NVT,1)
      ENDIF
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE   YREST (DDF,DDC)  
************************************************************************
*
*   Purpose: - performs the defect restriction   DDC:=r(DDF)
*              with
*                  DDF - fine defect vector on level ILEV+1
*                  DDC - coarse defect vector on level ILEV
*  
*            - DDF and DDC have the structure  DD=(DD1,DD2,DDP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
C
      DIMENSION DDF(*),DDC(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE
C
C=======================================================================
C     Getting all parameters for RESTRD
C=======================================================================
C
C *** addresses for the coarse level ILEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2C=1+NU
      IPC=I2C+NU
C
      KVERTC=L(LVERT)
      KMIDC =L(LMID )
      KADJC =L(LADJ )
C
C *** addresses for the fine level ILEV+1
      I1=ILEV+1
      NUF=KNU(I1)
      NPF=KNP(I1)
      NVTF=KNVT(I1)
      NMTF=KNMT(I1)
      I2F=1+NUF
      IPF=I2F+NUF
C
      KVERTF=L(KLVERT(I1))
      KMIDF =L(KLMID (I1))
      KADJF =L(KLADJ (I1))
C
C=======================================================================
C
      CALL RESTRD(DDC(1),DDC(I2C),DDC(IPC),DDF(1),DDF(I2F),DDF(IPF),
     *            KWORK(KVERTC),KWORK(KMIDC),KWORK(KADJC),NU,NP,NVT,
     *            KWORK(KVERTF),KWORK(KMIDF),KWORK(KADJF),NUF,NPF,NVTF)
C
      IF (ABS(IINT).EQ.2) THEN
       KPLC=L(LD1)
       KPLF=L(LD2)
C
       CALL C2N2DM(DDF(IPF),DWORK(KPLF),KWORK(KMIDF),KWORK(KADJF),
     *             NPF,NMTF,NVTF,0)
C
       IF (IINT.GT.0) THEN
        CALL MR031(DWORK(KPLF),DWORK(KPLC),KWORK(KVERTF),KWORK(KVERTC),
     *             KWORK(KMIDF),KWORK(KMIDC),KWORK(KADJF),KWORK(KADJC),
     *             NVTF,NVT,NPF,NP)
       ELSE
        CALL MR030(DWORK(KPLF),DWORK(KPLC),KWORK(KVERTF),KWORK(KVERTC),
     *             KWORK(KMIDF),KWORK(KMIDC),KWORK(KADJF),KWORK(KADJC),
     *             NVTF,NVT,NPF,NP)
       ENDIF
C
       CALL C2N2DM(DDC(IPC),DWORK(KPLC),KWORK(KMIDC),KWORK(KADJC),
     *             NP,NMT,NVT,1)
      ENDIF
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE  YSM (DX,DB,DD,NEQ,NSMO)  
************************************************************************
*
*   Purpose: - performs NSMO smoothing steps applied to the system
*                          A*DX = DB
*              of dimension NEQ using the auxiliary vector DD
*
*            - DX,DB,DD have the structure  D=(D1,D2,DP)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
C
      DIMENSION DX(*),DB(*),DD(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE
C
C=======================================================================
C     Getting all parameters for SMOOTH
C=======================================================================
C
C *** addresses for the current level ILEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
      I2=1+NU
      IP=I2+NU
C
      KVERT=L(LVERT)
      KMID =L(LMID )
      KNPR =L(LNPR )
      KMBD =L(KLMBD(ILEV))
      NMBD= KNMBD(ILEV)
C
      KAREA=L(KLAREA(ILEV))
C
C=======================================================================
C
      IF (ISM.EQ.1) THEN
       DO 11  ITE=1,NSMO
       CALL VANCAS (DX(1),DX(I2),DX(IP),DD(1),DD(I2),DD(IP),
     *              DB(1),DB(I2),DB(IP),
     *              VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *              VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *              NU,NP,KWORK(KMBD),KWORK(KVERT),KWORK(KMID),
     *              KWORK(KNPR),NMBD)
C
       IF (INEUM.EQ.0) CALL TOL20A(DX(IP),VWORK(KAREA),NP,INEUM)
C
11     CONTINUE
      ENDIF
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE   YSTEP (DX,DD,DB,ALPHA)  
************************************************************************
*
*   Purpose: - performs step size control for prolongation with
*                  DX    - old fine solution vector on level ILEV
*                  DD    - fine correction vector on level ILEV
*                  DB    - fine right hand side vector on level ILEV
*                  ALPHA - relaxation parameter according to some
*                          optimization criterion but within the limits
*                          AMINMG and AMAXMG (COMMON /RPARM/)
*  
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9, NNWORK=1)
C
      DIMENSION DX(*),DD(*),DB(*)
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SAVE 
C
C=======================================================================
C     Getting all parameters for PROLU
C=======================================================================
C
C
C *** Setting of given ALPHA
      IF (AMINMG.EQ.AMAXMG) THEN
       ALPHA=AMINMG
       RETURN
      ENDIF
C
C
C *** Calculation of optimal ALPHA
      IF (AMINMG.NE.AMAXMG) THEN
C
       ISETLV=2
       CALL SETLEV (ISETLV)
C
       CALL LCP1 (DB,DWORK(L(LD1)),NUP)
       CALL YAX(DX,DWORK(L(LD1)),NUP,-1D0,1D0)
       DO 100 IEQ=NUP,NUP-NEL+1,-1
100    DWORK(L(LD1)+IEQ-1)=-DWORK(L(LD1)+IEQ-1)
       CALL LSP1(DD,DWORK(L(LD1)),NUP,DBY)
C
C
       CALL YAX(DD,DWORK(L(LD1)),NUP,1D0,0D0)
       DO 110 IEQ=NUP,NUP-NEL+1,-1
110    DWORK(L(LD1)+IEQ-1)=-DWORK(L(LD1)+IEQ-1)
       CALL LSP1(DD,DWORK(L(LD1)),NUP,DBX)
C
       ALPHA=DBY/DBX
       IF (ALPHA.LT.AMINMG) ALPHA=AMINMG
       IF (ALPHA.GT.AMAXMG) ALPHA=AMAXMG
ccc       WRITE(*,*)'ALPHA=====',ALPHA,DBY,DBX,ILEV
C
       RETURN
C
      ENDIF
C
C
      END

      BLOCK DATA ZVALUE1
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*1
      PARAMETER (NNARR=299,NNLEV=9)
      PARAMETER (NBLOCA=1,NBLOCB=2,NBLOCF=2)
      PARAMETER (NBLA1=NBLOCA*NNLEV,NBLB1=NBLOCB*NNLEV,
     *           NBLF1=NBLOCF*NNLEV)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM(120)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /TABLE/  KTYPE(NNARR),KLEN(NNARR),KLEN8(NNARR),IFLAG
      COMMON /MACROD/ NMAEL,NMAVT,NMAEDG,NMAVE,NMAVEL,NMABCT,NMAVBD
      COMMON /MACROA/ LMACVG,LMACMG,LMAVT,LMAMID,LMAADJ,LMAVEL,LMAMEL,
     *                LMANPR,LMAMM,LMAVBD,LMAEBD,LMABCT,LMAVBP,LMAMBP,
     *                LMAVE
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
      DATA M/2/,MT/2/,MKEYB/5/,MTERM/6/,IER/0/,ICHECK/1/
      DATA MERR/11/,MPROT/12/,MSYS/13/,MTRC/14/,IRECL8/512/
      DATA SUB/'MAIN  '/
      DATA FMT/'(3D25.16)','(5E16.7)','(6I12)'/
      DATA CPARAM/120*' '/
      DATA NEL/0/,NVT/0/,NMT/0/,NVE/0/,NBCT/0/,NVEL/0/,NVBD/0/
      DATA LCORVG/0/,LCORMG/0/,LVERT/0/,LMID/0/,LADJ/0/,LVEL/0/,LMEL/0/,
     *     LNPR/0/,LMM/0/,LVBD/0/,LEBD/0/,LBCT/0/,LVBDP/0/,LMBDP/0/
      DATA KTYPE/NNARR*0/,KLEN/NNARR*0/,KLEN8/NNARR*0/,IFLAG/0/
      DATA NMAEL/0/,NMAVT/0/,NMAEDG/0/,NMAVE/0/,NMAVEL/0/,NMABCT/0/,
     *     NMAVBD/0/
      DATA LMACVG/0/,LMACMG/0/,LMAVT/0/,LMAMID/0/,LMAADJ/0/,LMAVEL/0/,
     *     LMAMEL/0/,LMANPR/0/,LMAMM/0/,LMAVBD/0/,LMAEBD/0/,LMABCT/0/,
     *     LMAVBP/0/,LMAMBP/0/,LMAVE/0/
      DATA KNEL/NNLEV*0/,KNVT/NNLEV*0/,KNMT/NNLEV*0/,
     *          KNVEL/NNLEV*0/,KNVBD/NNLEV*0/
      DATA KLCVG/NNLEV*0/,KLCMG/NNLEV*0/,KLVERT/NNLEV*0/,
     *     KLMID/NNLEV*0/,KLADJ/NNLEV*0/,KLVEL/NNLEV*0/,
     *     KLMEL/NNLEV*0/,KLNPR/NNLEV*0/,KLMM/NNLEV*0/,
     *     KLVBD/NNLEV*0/,KLEBD/NNLEV*0/,KLBCT/NNLEV*0/,
     *     KLVBDP/NNLEV*0/,KLMBDP/NNLEV*0/
      DATA ILEV/0/,NLEV/0/,NLMIN/0/,NLMAX/0/,
     *     ICYCLE/0/,KPRSM/NNLEV*0/,KPOSM/NNLEV*0/
      DATA KLMBD/NNLEV*0/,KLDBD/NNLEV*0/,KNMBD/NNLEV*0/,
     *     KLNPRO/NNLEV*0/,INEUM/0/
      DATA KLA/NNLEV*0/,KLST/NBLA1*0/,KLM/NBLA1*0/,
     *     KLCOLA/NNLEV*0/,KLLDA/NNLEV*0/,
     *     KLB1/NNLEV*0/,KLB2/NNLEV*0/,KLCOLB/NNLEV*0/,KLLDB/NNLEV*0/,
     *     KLUP/NNLEV*0/,KLF12P/NNLEV*0/,KLAUX/NNLEV*0/,KLAREA/NNLEV*0/,
     *     LU1OLD/0/,LU2OLD/0/,LPOLD/0/,LD1/0/,LD2/0/,LDP/0/
      DATA KNA/NNLEV*0/,KNB/NNLEV*0/,KNU/NNLEV*0/,KNP/NNLEV*0/,
     *     KNUP/NNLEV*0/
C
      DATA NA/0/,NB/0/,NU/0/,NP/0/,NUP/0/
      DATA KA1/0/,KST1/0/,KM1/0/,KCOLA/0/,KLDA/0/,KB1/0/,
     *     KB2/0/,KCOLB/0/,KLDB/0/,KU1/0/,KU2/0/,KP/0/,
     *     KF1/0/,KF2/0/,KFP/0/,KAUX1/0/,KAUX2/0/,KAUXP/0/
C
      END
      

************************************************************************
      DOUBLE PRECISION FUNCTION PARX(T,IBCT)
************************************************************************
*   parxypre.f:
*     - contains the parametrization functions:
*           PARX, PARY, TMAX
*       for the preprocessing variant ('rdparm')
*     - the COMMON-block /TDATA/ is used frequently and has to be
*       initialized by the modul 'initxx.f'
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNWORK=1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
C
      DIMENSION KWORK(1)
      EQUIVALENCE (DWORK(1),KWORK(1))
C
      COMMON /TDATA/ NBCT_T,NNCOMP,NNNPAR,
     *               LNCOMP,LICPTR,LITYP,LNSPLN,LNPAR,
     *               LIPPTR,LXPAR,LYPAR
C
      DATA INIT  /0/
      SAVE
C=======================================================================
C *** IBCT dependent quantities
      NCOMP=KWORK(L(LNCOMP)+IBCT-1)
      ICPTR=KWORK(L(LICPTR)+IBCT-1)
C
C *** determine boundary component ICOMP of part IBCT and
C     the ICOMP-dependent quantities
C
      ICOMP=T+1.d0
      tdiff=T-ICOMP+1.d0
      if(tdiff.lt.0d0 .or. tdiff.ge.1d0) then
        write(*,*)'error in PARX (userpre): conflict with ICOMP'
        stop
      endif
      iicomp=ICPTR+ICOMP-1
      ITYP=KWORK(L(LITYP)+iicomp)
      NSPLIN=KWORK(L(LNSPLN)+iicomp)
      NPAR=KWORK(L(LNPAR)+iicomp)
      IPPTR=KWORK(L(LIPPTR)+iicomp)
C
C *** pointer for the LXPAR/LYPAR-arrays
      KXPAR=L(LXPAR)+IPPTR
      KYPAR=L(LYPAR)+IPPTR      
C=======================================================================
C   ITYP=1:  line      
C=======================================================================
      if(ITYP.eq.1) then
C      
        if(NSPLIN.ne.1 .or. NPAR.ne.2) then
          write(*,*)'error in PARX (userpre): conflict at ITYP=1'
          stop
        endif
        x1=DWORK(KXPAR)
        xdiff=DWORK(KXPAR+1)
        PARX=x1 + xdiff*tdiff        
C=======================================================================
C   ITYP=2:  part of a circle      
C=======================================================================        
      else if(ITYP.eq.2) then
C      
        if(NSPLIN.ne.1 .or. NPAR.ne.3) then
          write(*,*)'error in PARX (userpre): conflict at ITYP=2'
          stop
        endif
        xm=DWORK(KXPAR)
        r=DWORK(KXPAR+1)
        phi1=DWORK(KXPAR+2)
        phi2=DWORK(KYPAR+2)
        phi=phi1 + tdiff*(phi2-phi1)
        PARX=xm + r*COS(phi)
C=======================================================================
C   ITYP=3:  spline
C=======================================================================        
      else if(ITYP.eq.3) then
C      
C *** determine "number of the subspline -1"=ISPLIN and tt=t_tilde
        ttdif=tdiff*NSPLIN
        ISPLIN=ttdif
        tt=ttdif-ISPLIN
        if(tt.lt.0d0 .or. tt.ge.1d0 .or. ISPLIN.gt.NSPLIN-1) then
          write(*,*)'error in PARX (userpre): conflict with ISPLIN'
          stop
        endif
C      
C *** determine cubic spline-function values at 'tt'
        phi1=(2d0*tt*tt - 3d0*tt)*tt + 1d0
        phi2=(-2d0*tt + 3d0)*tt*tt
        phi3=(tt*tt - 2d0*tt + 1d0)*tt
        phi4=(tt - 1d0)*tt*tt
C      
C *** determine parameter constants
        kk=KXPAR + 4*ISPLIN
        c1=DWORK(kk)
        c2=DWORK(kk+1)
        c3=DWORK(kk+2)
        c4=DWORK(kk+3)
C
        PARX=c1*phi1+c2*phi2+c3*phi3+c4*phi4
C=======================================================================      
      else
        write(*,*)'error in PARX (userpre): wrong ITYP-value'
        stop
      endif
C
      END
************************************************************************
      DOUBLE PRECISION FUNCTION PARY(T,IBCT)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNARR=299, NNWORK=1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
C
      DIMENSION KWORK(1)
      EQUIVALENCE (DWORK(1),KWORK(1))
C
      COMMON /TDATA/ NBCT_T,NNCOMP,NNNPAR,
     *               LNCOMP,LICPTR,LITYP,LNSPLN,LNPAR,
     *               LIPPTR,LXPAR,LYPAR
C
      save
C=======================================================================
C *** IBCT dependent quantities
      NCOMP=KWORK(L(LNCOMP)+IBCT-1)
      ICPTR=KWORK(L(LICPTR)+IBCT-1)
C
C *** determine boundary component ICOMP of part IBCT and
C     the ICOMP-dependent quantities
C
      ICOMP=T+1.d0
      tdiff=T-ICOMP+1.d0
      if(tdiff.lt.0d0 .or. tdiff.ge.1d0) then
        write(*,*)'error in PARY (userpre): conflict with ICOMP'
        stop
      endif
      iicomp=ICPTR+ICOMP-1
      ITYP=KWORK(L(LITYP)+iicomp)
      NSPLIN=KWORK(L(LNSPLN)+iicomp)
      NPAR=KWORK(L(LNPAR)+iicomp)
      IPPTR=KWORK(L(LIPPTR)+iicomp)
C
C *** pointer for the LXPAR/LYPAR-arrays
      KXPAR=L(LXPAR)+IPPTR
      KYPAR=L(LYPAR)+IPPTR      
C=======================================================================
C   ITYP=1:  line      
C=======================================================================
      if(ITYP.eq.1) then
C      
        if(NSPLIN.ne.1 .or. NPAR.ne.2) then
          write(*,*)'error in PARY (userpre): conflict at ITYP=1'
          stop
        endif
        y1=DWORK(KYPAR)
        ydiff=DWORK(KYPAR+1)
        PARY=y1 + ydiff*tdiff        
C=======================================================================
C   ITYP=2:  part of a circle      
C=======================================================================        
      else if(ITYP.eq.2) then
C      
        if(NSPLIN.ne.1 .or. NPAR.ne.3) then
          write(*,*)'error in PARY (userpre): conflict at ITYP=2'
          stop
        endif
        ym=DWORK(KYPAR)
        r=DWORK(KXPAR+1)
        phi1=DWORK(KXPAR+2)
        phi2=DWORK(KYPAR+2)
        phi=phi1 + tdiff*(phi2-phi1)
        PARY=ym + r*SIN(phi)
C=======================================================================
C   ITYP=3:  spline
C=======================================================================        
      else if(ITYP.eq.3) then
C      
C *** determine "number of the subspline -1"=ISPLIN and tt=t_tilde
        ttdif=tdiff*NSPLIN
        ISPLIN=ttdif
        tt=ttdif-ISPLIN
        if(tt.lt.0d0 .or. tt.ge.1d0 .or. ISPLIN.gt.NSPLIN-1) then
          write(*,*)'error in PARY (userpre): conflict with ISPLIN'
          stop
        endif
C      
C *** determine cubic spline-function values at 'tt'
        phi1=(2d0*tt*tt - 3d0*tt)*tt + 1d0
        phi2=(-2d0*tt + 3d0)*tt*tt
        phi3=(tt*tt - 2d0*tt + 1d0)*tt
        phi4=(tt - 1d0)*tt*tt
C      
C *** determine parameter constants
        kk=KYPAR + 4*ISPLIN
        c1=DWORK(kk)
        c2=DWORK(kk+1)
        c3=DWORK(kk+2)
        c4=DWORK(kk+3)
C
        PARY=c1*phi1+c2*phi2+c3*phi3+c4*phi4
C=======================================================================      
      else
        write(*,*)'error in PARY (userpre): wrong ITYP-value'
        stop
      endif
C
      END
************************************************************************
      DOUBLE PRECISION FUNCTION TMAX(IBCT)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNARR=299, NNWORK=1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
C
      DIMENSION KWORK(1)
      EQUIVALENCE (DWORK(1),KWORK(1))
C
      COMMON /TDATA/ NBCT_T,NNCOMP,NNNPAR,
     *               LNCOMP,LICPTR,LITYP,LNSPLN,LNPAR,
     *               LIPPTR,LXPAR,LYPAR
C
      save
C=======================================================================
      NCOMP=KWORK(L(LNCOMP)+IBCT-1)
C
      TMAX=NCOMP
      END

************************************************************************
      SUBROUTINE SUPWDG(U1L1,U1L2,U2L1,U2L2,A1L,A2L,U1,U2,D1,D2,A,NA,
     *                  KCOLA,KLDA,KVERT,KMID,DCORVG,ELE,COEFFN,
     *                  IDEF,DCMASS)
************************************************************************
*     Purpose: -  Adds the SUPG-part on matrix block A after
*                 it was initialized by the linear part
*              -  The input vector Ui is the old velocity field
*              -  The input vectors UjLi are the transport directions
*     PARAMETRIC VERSION
************************************************************************
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      REAL A
C
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4)
C
      DIMENSION A(*),KCOLA(*),KLDA(*)
      DIMENSION U1L1(*),U1L2(*),U2L1(*),U2L2(*),U1(*),U2(*),D1(*),D2(*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
      DIMENSION KENTRY(NNBAS,NNBAS),DENTRY(NNBAS,NNBAS)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     1                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
     SAVE 
C
C
      ICUB=ICUBN
C
      IF (IPRECA.EQ.4) THEN
       DNY=NY
      ELSE
       DNY=0D0
      ENDIF
C
      IF ((IPRECA.EQ.4).AND.(IMASS.EQ.1)) THEN
       CT0=DCMASS/THSTEP
      ELSE
       CT0=0D0
      ENDIF
C
C
      DO 1 I = 1,NNDER
1     BDER(I)=.FALSE.
C
      DO 2 I=1,3
2     BDER(I)=.TRUE.
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IDFL=NDFL(IELTYP)
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
C
************************************************************************
C *** Calculation of the matrix - storage technique 7 or 8
************************************************************************
      ICUBP=ICUB
      CALL ELE(0D0,0D0,-2)
C
      DUMAX=0D0
      IF (A2L.EQ.0D0) THEN
       DO 10 IEQ=1,NMT
       DU1=U1L1(IEQ)
       DU2=U1L2(IEQ)
       DUNORM=SQRT(DU1**2+DU2**2)
       DUMAX=MAX(DUMAX,DUNORM)
10     CONTINUE
      ELSE       
       DO 20 IEQ=1,NMT
       DU1=A1L*U1L1(IEQ)+A2L*U2L1(IEQ)
       DU2=A1L*U1L2(IEQ)+A2L*U2L2(IEQ)
       DUNORM=SQRT(DU1**2+DU2**2)
       DUMAX=MAX(DUMAX,DUNORM)
20     CONTINUE
      ENDIF       
C
      IF (DUMAX.LT.1D-8) DUMAX=1D-8
C
C
C *** Loop over all elements
      DO 100 IEL=1,NEL
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
C *** Determine local DELTA for streamline-diffusion
      CALL DELTSD(U1L1,U1L2,U2L1,U2L2,A1L,A2L,IEL,DUMAX,DELTA)
      IF (ISTOK.EQ.1) DELTA=0D0
C
C *** Determine entry positions in matrix
      DO 110 JDOFE=1,IDFL
      ILD=KLDA(KDFG(JDOFE))
      KENTRY(JDOFE,JDOFE)=ILD
      DENTRY(JDOFE,JDOFE)=0D0
      JCOL0=ILD
      DO 111 IDOFE=1,IDFL
      IF (IDOFE.EQ.JDOFE) GOTO 111
      IDFG=KDFG(IDOFE)
      DO 112 JCOL=JCOL0,NA
      IF (KCOLA(JCOL).EQ.IDFG) GOTO 113
112   CONTINUE
113   JCOL0=JCOL+1
      KENTRY(JDOFE,IDOFE)=JCOL
      DENTRY(JDOFE,IDOFE)=0D0
111   CONTINUE
110   CONTINUE
C
C *** Evaluation of coordinates of the vertices
      DO 120 IVE = 1, NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
120   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
C *** Loop over all cubature points
      DO 200 ICUBP = 1, NCUBP
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C *** Jacobian of the bilinear mapping onto the reference element
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
      OM=DOMEGA(ICUBP)*DETJ
C
      CALL ELE(XI1,XI2,-3)
      IF (IER.LT.0) GOTO 99999
C
C *** Evaluation of velocity in cubature points
      IF (DCMASS.NE.0D0) THEN
C
       DU1=0D0
       DU2=0D0
       IF (A2L.EQ.0D0) THEN
        DO 210 JDFL=1,IDFL
        HBAS=DBAS(KDFL(JDFL),1)
        IF (ABS(HBAS).GE.1D-8) THEN
         JDFG=KDFG(JDFL)
         DU1=DU1+U1L1(JDFG)*HBAS
         DU2=DU2+U1L2(JDFG)*HBAS
        ENDIF
210     CONTINUE
       ELSE
        DO 220 JDFL=1,IDFL
        HBAS=DBAS(KDFL(JDFL),1)
        IF (ABS(HBAS).GE.1D-8) THEN
         JDFG=KDFG(JDFL)
         DU1=DU1+(A1L*U1L1(JDFG)+A2L*U2L1(JDFG))*HBAS
         DU2=DU2+(A1L*U1L2(JDFG)+A2L*U2L2(JDFG))*HBAS
         ENDIF
220     CONTINUE
       ENDIF
C
C ***  Summing up over all pairs of multiindices
       DO 230 JDOFE=1,IDFL
       JDOFEH=KDFL(JDOFE)
       HBASJ1=DBAS(JDOFEH,1)
       HBASJ2=DBAS(JDOFEH,2)
       HBASJ3=DBAS(JDOFEH,3)
       HSUMJ=HBASJ2*DU1+HBASJ3*DU2
C
       DO 240 IDOFE=1,IDFL
       IF (IDOFE.EQ.JDOFE) THEN
        AH= HSUMJ*(DELTA*HSUMJ+HBASJ1)
     *     +  DNY*(HBASJ2**2+HBASJ3**2)+CT0*HBASJ1**2
       ELSE
        IDOFEH=KDFL(IDOFE)
        HBASI1=DBAS(IDOFEH,1)
        HBASI2=DBAS(IDOFEH,2)
        HBASI3=DBAS(IDOFEH,3)
        HSUMI=HBASI2*DU1+HBASI3*DU2
        AH= HSUMI*(DELTA*HSUMJ+HBASJ1)
     *    +   DNY*(HBASJ2*HBASI2+HBASJ3*HBASI3)
     *    +   CT0*HBASJ1*HBASI1
       ENDIF
C
       DENTRY(JDOFE,IDOFE)=DENTRY(JDOFE,IDOFE)+OM*AH
240    CONTINUE
230    CONTINUE
C
      ELSE
C
C ***  Summing up over 1 pair of multiindices
       DO 250 JDOFE=1,IDFL
       HBASJ1=DBAS(KDFL(JDOFE),1)
C
       DO 260 IDOFE=1,IDFL
       HBASI1=DBAS(KDFL(IDOFE),1)
C
       AH=-1D0/THSTEP*HBASJ1*HBASI1
C
       DENTRY(JDOFE,IDOFE)=DENTRY(JDOFE,IDOFE)+OM*AH
260    CONTINUE
250    CONTINUE
C
      ENDIF
C
200   CONTINUE
C
C
      DO 400 JDOFE=1,IDFL
      DO 400 IDOFE=1,IDFL
      DENTH=THSTEP*DENTRY(JDOFE,IDOFE)
C
      IF (IDEF.LT.2) THEN
       IA   =KENTRY(JDOFE,IDOFE)
       A(IA)=A(IA)+REAL(DENTH)
      ENDIF
C
      IF (IDEF.GT.0) THEN 
       IDFG=KDFG(IDOFE)
       JDFG=KDFG(JDOFE)
       D1(JDFG)= D1(JDFG)-DENTH*U1(IDFG)
       D2(JDFG)= D2(JDFG)-DENTH*U2(IDFG)
      ENDIF 
C
400   CONTINUE
C
100   CONTINUE
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE SUPWNP(U1L1,U1L2,U2L1,U2L2,A1L,A2L,U1,U2,D1,D2,A,NA,
     *                  KCOLA,KLDA,KVERT,KMID,DCORVG,ELE,COEFFN,
     *                  IDEF,DCMASS)
************************************************************************
*     Purpose: -  Adds the SUPG-part on matrix block A after
*                 it was initialized by the linear part
*              -  The input vector Ui is the old velocity field
*              -  The input vectors UjLi are the transport directions
*     NONPARAMETRIC VERSION
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      REAL A
C
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNCOF=6)
C
      DIMENSION A(*),KCOLA(*),KLDA(*)
      DIMENSION U1L1(*),U1L2(*),U2L1(*),U2L2(*),U1(*),U2(*),D1(*),D2(*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
      DIMENSION KENTRY(NNBAS,NNBAS),DENTRY(NNBAS,NNBAS)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
ccc   COMMON /UPTIME/ TTU0,TTU11,TTU12,TTU13,TTU2,TTU3,TTU4
C
      SAVE 
C
C
ccc   CALL ZTIME(TTT0)
      ICUB=ICUBN
C
      IF (IPRECA.EQ.4) THEN
       DNY=NY
      ELSE
       DNY=0D0
      ENDIF
C
      IF ((IPRECA.EQ.4).AND.(IMASS.EQ.1)) THEN
       CT0=DCMASS/THSTEP
      ELSE
       CT0=0D0
      ENDIF
C
C
      DO 1 I = 1,NNDER
1     BDER(I)=.FALSE.
C
      DO 2 I=1,3
2     BDER(I)=.TRUE.
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IDFL=NDFL(IELTYP)
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
C
************************************************************************
C *** Calculation of the matrix - storage technique 7 or 8
************************************************************************
C
      DUMAX=0D0
      IF (A2L.EQ.0D0) THEN
       DO 10 IEQ=1,NMT
       DU1=U1L1(IEQ)
       DU2=U1L2(IEQ)
       DUNORM=SQRT(DU1**2+DU2**2)
       DUMAX=MAX(DUMAX,DUNORM)
10     CONTINUE
      ELSE       
       DO 20 IEQ=1,NMT
       DU1=A1L*U1L1(IEQ)+A2L*U2L1(IEQ)
       DU2=A1L*U1L2(IEQ)+A2L*U2L2(IEQ)
       DUNORM=SQRT(DU1**2+DU2**2)
       DUMAX=MAX(DUMAX,DUNORM)
20     CONTINUE
      ENDIF       
C
      IF (DUMAX.LT.1D-8) DUMAX=1D-8
C
C
ccc   CALL ZTIME(TTT1)
ccc   TTU0=TTU0+TTT1-TTT0
C *** Loop over all elements
      DO 100 IEL=1,NEL
ccc   CALL ZTIME(TTT0)
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
C *** Determine local DELTA for streamline-diffusion
      CALL DELTSD(U1L1,U1L2,U2L1,U2L2,A1L,A2L,IEL,DUMAX,DELTA)
      IF (ISTOK.EQ.1) DELTA=0D0
C
C *** Determine entry positions in matrix
      DO 110 JDOFE=1,IDFL
      ILD=KLDA(KDFG(JDOFE))
      KENTRY(JDOFE,JDOFE)=ILD
      DENTRY(JDOFE,JDOFE)=0D0
      JCOL0=ILD
      DO 111 IDOFE=1,IDFL
      IF (IDOFE.EQ.JDOFE) GOTO 111
      IDFG=KDFG(IDOFE)
      DO 112 JCOL=JCOL0,NA
      IF (KCOLA(JCOL).EQ.IDFG) GOTO 113
112   CONTINUE
113   JCOL0=JCOL+1
      KENTRY(JDOFE,IDOFE)=JCOL
      DENTRY(JDOFE,IDOFE)=0D0
111   CONTINUE
110   CONTINUE
C
C *** Evaluation of coordinates of the vertices
      DO 120 IVE = 1, NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
120   CONTINUE
ccc   CALL ZTIME(TTT1)
ccc   TTU11=TTU11+TTT1-TTT0
ccc   CALL ZTIME(TTT0)
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
ccc   CALL ZTIME(TTT1)
ccc   TTU2=TTU2+TTT1-TTT0
C *** Dummy call - ELE may save arithmetic operations
ccc   CALL ZTIME(TTT0)
      CALL ELE(0D0,0D0,-2)
      IF (IER.LT.0) GOTO 99999
ccc   CALL ZTIME(TTT1)
ccc   TTU3=TTU3+TTT1-TTT0
C
C *** Loop over all cubature points
      DO 200 ICUBP = 1, NCUBP
ccc   CALL ZTIME(TTT0)
C
C *** Cubature points on the reference element
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C
C *** Jacobian of the bilinear mapping onto the reference element
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C
C *** Cubature points on actual Element + weights
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1
     *  +0.5D0*(DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2
      OM=DOMEGA(ICUBP)*DETJ
C
ccc   CALL ZTIME(TTT1)
ccc   TTU2=TTU2+TTT1-TTT0
ccc   CALL ZTIME(TTT0)
      CALL ELE(XX,YY,-3)
      IF (IER.LT.0) GOTO 99999
C
ccc   CALL ZTIME(TTT1)
ccc   TTU4=TTU4+TTT1-TTT0
ccc   CALL ZTIME(TTT0)
C *** Evaluation of velocity in cubature points
      IF (DCMASS.NE.0D0) THEN
C
       DU1=0D0
       DU2=0D0
       IF (A2L.EQ.0D0) THEN
        DO 210 JDFL=1,IDFL
        HBAS=DBAS(KDFL(JDFL),1)
        IF (ABS(HBAS).GE.1D-8) THEN
         JDFG=KDFG(JDFL)
         DU1=DU1+U1L1(JDFG)*HBAS
         DU2=DU2+U1L2(JDFG)*HBAS
        ENDIF
210     CONTINUE
       ELSE
        DO 220 JDFL=1,IDFL
        HBAS=DBAS(KDFL(JDFL),1)
        IF (ABS(HBAS).GE.1D-8) THEN
         JDFG=KDFG(JDFL)
         DU1=DU1+(A1L*U1L1(JDFG)+A2L*U2L1(JDFG))*HBAS
         DU2=DU2+(A1L*U1L2(JDFG)+A2L*U2L2(JDFG))*HBAS
         ENDIF
220     CONTINUE
       ENDIF
C
C ***  Summing up over all pairs of multiindices
       DO 230 JDOFE=1,IDFL
       JDOFEH=KDFL(JDOFE)
       HBASJ1=DBAS(JDOFEH,1)
       HBASJ2=DBAS(JDOFEH,2)
       HBASJ3=DBAS(JDOFEH,3)
       HSUMJ=HBASJ2*DU1+HBASJ3*DU2
C
       DO 240 IDOFE=1,IDFL
       IF (IDOFE.EQ.JDOFE) THEN
        AH= HSUMJ*(DELTA*HSUMJ+HBASJ1)
     *     +  DNY*(HBASJ2**2+HBASJ3**2)+CT0*HBASJ1**2
       ELSE
        IDOFEH=KDFL(IDOFE)
        HBASI1=DBAS(IDOFEH,1)
        HBASI2=DBAS(IDOFEH,2)
        HBASI3=DBAS(IDOFEH,3)
        HSUMI=HBASI2*DU1+HBASI3*DU2
        AH= HSUMI*(DELTA*HSUMJ+HBASJ1)
     *    +   DNY*(HBASJ2*HBASI2+HBASJ3*HBASI3)
     *    +   CT0*HBASJ1*HBASI1
       ENDIF
C
       DENTRY(JDOFE,IDOFE)=DENTRY(JDOFE,IDOFE)+OM*AH
240    CONTINUE
230    CONTINUE
ccc   CALL ZTIME(TTT1)
ccc   TTU12=TTU12+TTT1-TTT0
C
      ELSE
C
C ***  Summing up over 1 pair of multiindices
       DO 250 JDOFE=1,IDFL
       HBASJ1=DBAS(KDFL(JDOFE),1)
C
       DO 260 IDOFE=1,IDFL
       HBASI1=DBAS(KDFL(IDOFE),1)
C
       AH=-1D0/THSTEP*HBASJ1*HBASI1
C
       DENTRY(JDOFE,IDOFE)=DENTRY(JDOFE,IDOFE)+OM*AH
260    CONTINUE
250    CONTINUE
ccc   CALL ZTIME(TTT1)
ccc   TTU12=TTU12+TTT1-TTT0
C
      ENDIF
C
200   CONTINUE
C
C
ccc   CALL ZTIME(TTT0)
      DO 400 JDOFE=1,IDFL
      DO 400 IDOFE=1,IDFL
      DENTH=THSTEP*DENTRY(JDOFE,IDOFE)
C
      IF (IDEF.LT.2) THEN
       IA   =KENTRY(JDOFE,IDOFE)
       A(IA)=A(IA)+REAL(DENTH)
      ENDIF
C
      IF (IDEF.GT.0) THEN 
       IDFG=KDFG(IDOFE)
       JDFG=KDFG(JDOFE)
       D1(JDFG)= D1(JDFG)-DENTH*U1(IDFG)
       D2(JDFG)= D2(JDFG)-DENTH*U2(IDFG)
      ENDIF 
C
400   CONTINUE
C
ccc   CALL ZTIME(TTT1)
ccc   TTU13=TTU13+TTT1-TTT0
100   CONTINUE
C
ccc   write(6,*) TTU0,TTU11,TTU12,TTU13,TTU2,TTU3,TTU4,NCUBP
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE  DELTSD  (U1L1,U1L2,U2L1,U2L2,A1L,A2L,IEL,DUMAX,DELTA)
************************************************************************
*     Calculates coefficient Delta for SD
*     RELOC = local RE
*     UNORM=local velocity norm
*     HLOCAL=local mesh width
************************************************************************
C
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNBAS=21,NNLEV=9,NNARR=299,NNWORK=1)
C
      DIMENSION U1L1(*),U1L2(*),U2L1(*),U2L2(*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      SAVE
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C
C
C
      AREA=DBLE(VWORK(L(KLAREA(ILEV))+IEL-1))
      HLOCAL=SQRT(AREA)
C
      IF (UPSAM.LT.0D0) THEN
C
       DELTA=ABS(UPSAM)*HLOCAL
C
      ELSE
C
       DU1=0D0
       DU2=0D0
       DO 10 IDOF=1,IDFL
       DU1=DU1+(A1L*U1L1(KDFG(IDOF))+A2L*U2L1(KDFG(IDOF)))
10     DU2=DU2+(A1L*U1L2(KDFG(IDOF))+A2L*U2L2(KDFG(IDOF)))
C
       UNORM=0.25D0*SQRT(DU1**2+DU2**2)
C
C       IF (UNORM.LE.1D-8) THEN
C        DELTA=0D0
C       ELSE
        RELOC=UNORM*HLOCAL/NY
        DELTA=UPSAM*HLOCAL/DUMAX*2D0*(RELOC/(1D0+RELOC))
C       ENDIF
C
      ENDIF
C
C      WRITE(6,*) DELTA,DELTA/(UPSAM*HLOCAL),RELOC,UNORM,HLOCAL
C
C
      END

************************************************************************
      SUBROUTINE  XOPTCN (KU1,KU2,KP,KU1OLD,KU2OLD,KPOLD,KF1,KF2,KFP,
     *                    KD1,KD2,KDP,KAUX1,KAUX2,KAUXP,KA1,KCOLA,KLDA,
     *                    KB1,KB2,KCOLB,KLDB,KST1,KM1,NA,NU,NP,
     *                    DELU,DELP,OMEGA,KMBD,NMBD,INEUM)
************************************************************************
*    Purpose: - Computes for given vectors U and UOLD the optimal 
*               weighted correction OMEGA*V with V:=U-UOLD
*
*    Input:
*      - vectors U,UOLD,F
*      - OMEGA for the new calculation of the nonlinear block A
*      - matrices and pointers A,...,ST,NA
*      - number of equations NU
*    Output:
*      - updated vector U
*      - optimal relaxation parameter OMEGA
*      - maximum relative changes  DELU 
*      - note that D is changed to  D=K*V with correction V=U-UOLD 
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)      
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      DIMENSION KMBD(*)
      DIMENSION VWORK(1),KWORK(1)
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      SAVE 
C
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C     E X T E R N A L S
C-----------------------------------------------------------------------
C *** Coefficient of stiffness matrix
      EXTERNAL COEFFN
C *** definition of finite elements
      EXTERNAL E030,E031,EM31,EM30
C
C-----------------------------------------------------------------------
C
      NUP=2*NU+NP
C
      IF (OMGMIN.EQ.OMGMAX) THEN
       IF (OMGMIN.LT.0D0) THEN
        OMEGA=ABS(OMGMIN)
        DELU=0D0
        DELP=0D0
        GOTO 99999
       ELSE
        OMEGA=OMGMIN
        GOTO 999
       ENDIF
      ENDIF
C
C=======================================================================
C *** Calculate on AUX the linearization point: UOLD+OMEGA*U
C=======================================================================
C
      CALL ZTIME(TTT0)
      AA1=1.0D0
      AA2=OMEGA
      CALL  LCP1 (DWORK(KU1   ),DWORK(KAUX1),NUP)
      CALL  LLC1 (DWORK(KU1OLD),DWORK(KAUX1),NUP,AA1,AA2)
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Calculate the new nonlinear block A at the point AUX
C=======================================================================
C
      CALL ZTIME(TTT0)
      CALL XMADF3(KM1,KST1,KA1,KCOLA,KLDA,NA,NU,THSTEP,ISTAT)
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      IF (IUPW.EQ.1) THEN
       CALL GUPWD (DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUX1),DWORK(KAUX2),
     *             1D0,0D0,DWORK(KAUX1),DWORK(KAUX2),
     *             DWORK(KAUX1),DWORK(KAUX2),VWORK(KA1),KWORK(KCOLA),
     *             KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),0)
      ELSE
       IF (IELT.EQ.0) 
     *  CALL SUPWDG(DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUX1),DWORK(KAUX2),
     *             1D0,0D0,DWORK(KAUX1),DWORK(KAUX2),
     *             DWORK(KAUX1),DWORK(KAUX2),VWORK(KA1),NA,KWORK(KCOLA),
     *             KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),E031,COEFFN,0,1D0)
       IF (IELT.EQ.1) 
     *  CALL SUPWDG(DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUX1),DWORK(KAUX2),
     *             1D0,0D0,DWORK(KAUX1),DWORK(KAUX2),
     *             DWORK(KAUX1),DWORK(KAUX2),VWORK(KA1),NA,KWORK(KCOLA),
     *             KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),E030,COEFFN,0,1D0)
       IF (IELT.EQ.2) 
     *  CALL SUPWNP(DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUX1),DWORK(KAUX2),
     *             1D0,0D0,DWORK(KAUX1),DWORK(KAUX2),
     *             DWORK(KAUX1),DWORK(KAUX2),VWORK(KA1),NA,KWORK(KCOLA),
     *             KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),EM31,COEFFN,0,1D0)
       IF (IELT.EQ.3) 
     *  CALL SUPWNP(DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUX1),DWORK(KAUX2),
     *             1D0,0D0,DWORK(KAUX1),DWORK(KAUX2),
     *             DWORK(KAUX1),DWORK(KAUX2),VWORK(KA1),NA,KWORK(KCOLA),
     *             KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),EM30,COEFFN,0,1D0)
      ENDIF
      CALL ZTIME(TTT1)
      TTUPW=TTUPW+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      CALL BDRYA (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),KMBD,NMBD)
      CALL ZTIME(TTT1)
      TTBDR=TTBDR+TTT1-TTT0
C
C=======================================================================
C *** Calculate the defect  D=F-K*UOLD
C=======================================================================
      CALL ZTIME(TTT0)
      CALL LCP1 (DWORK(KF1),DWORK(KD1),NUP)
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      CALL  MATML(DWORK(KD1),DWORK(KD2),DWORK(KDP),
     *             DWORK(KU1OLD),DWORK(KU2OLD),DWORK(KPOLD),-1D0,1D0,
     *             VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *             VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *             NU,NP,KMBD,NMBD,INEUM)
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
C
C=======================================================================
C *** Calculate the value  AUX=K*U
C=======================================================================
C
      CALL ZTIME(TTT0)
      CALL  MATML(DWORK(KAUX1),DWORK(KAUX2),DWORK(KAUXP),
     *             DWORK(KU1),DWORK(KU2),DWORK(KP),1D0,0D0,
     *             VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),
     *             VWORK(KB1),VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),
     *             NU,NP,KMBD,NMBD,INEUM)
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
C
C=======================================================================
C *** Calculate   SKV1:= (K*U,D)   = (AUX,D)
C *** Calculate   SKV2:= (K*U,K*U) = (AUX,AUX)
C=======================================================================
C
      CALL ZTIME(TTT0)
      CALL  LSP1 (DWORK(KAUX1),DWORK(KD1)  ,NUP,SKV1)
      CALL  LSP1 (DWORK(KAUX1),DWORK(KAUX1),NUP,SKV2)
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Calculate the optimal relaxation parameter OMEGA
C=======================================================================
C
      IF (SKV2.LT. 1.0D-40) THEN
          WRITE(MTERM,*) 'ERROR in OPTCOR: SKV2 is nearly zero'
          STOP
      ENDIF
C
      OMEGA=SKV1/SKV2
      IF (OMEGA.LT.ABS(OMGMIN)) OMEGA=ABS(OMGMIN)
      IF (OMEGA.GT.ABS(OMGMAX)) OMEGA=ABS(OMGMAX)
C
C=======================================================================
C *** Calculate the optimal correction  U:=UOLD+OMEGA*U
C=======================================================================
C
999   CALL ZTIME(TTT0)
      CALL  LLI1 (DWORK(KU1),NU,DELU1,INDU1)
      CALL  LLI1 (DWORK(KU2),NU,DELU2,INDU2)
      CALL  LLI1 (DWORK(KP) ,NP,DELP ,INDP )
C
      AA1= 1.D0
      AA2= OMEGA
      CALL  LLC1 (DWORK(KU1OLD),DWORK(KU1),NUP,AA1,AA2)
C
C=======================================================================
C *** relative maximum changes   DELU
C=======================================================================
C
      CALL  LLI1 (DWORK(KU1),NU,DELT1,INDT1)
      CALL  LLI1 (DWORK(KU2),NU,DELT2,INDT2)
      DELT=MAX(DELT1,DELT2)
      IF (ABS(DELT).LT.1D-8) DELT=1D0
      DELU=MAX(DELU1,DELU2)/DELT
C
      CALL  LLI1 (DWORK(KP) ,NP,DELT,INDT)
      IF (ABS(DELT).LT.1D-8) DELT=1D0
      DELP=DELP/DELT
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C
99999 END

************************************************************************
      SUBROUTINE GUPWD (U1L1,U1L2,U2L1,U2L2,A1L,A2L,U1,U2,D1,D2,
     *                  A,KCOLA,KLDA,KVERT,KMID,DCORVG,IDEF)
************************************************************************
*    Purpose: -  Adds the upwind-part on matrix block A after
*                it was initialized by the Stokes matrix
*             -  The input vector (U1 ,U2 ) is the old velocity field
*             -  The input vectors (UiL1,UiL2) in linear combination  
*                Ail are the transport direction
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      REAL A
C
      PARAMETER (NNVE=4)
      DIMENSION U1L1(*),U1L2(*),U2L1(*),U2L2(*),U1(*),U2(*),D1(*),D2(*)
      DIMENSION A(*),KCOLA(*),KLDA(*)
C
C *** Local arrays for informations about one element
      DIMENSION IMID(4),ISTORE(4,4),FLUX(4),UU1(4),UU2(4),XV(4),YV(4)
      DIMENSION ELMA(4,4)
C
C *** Usual data for mesh management
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
C
C *** user COMMON blocks
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
C
      SAVE 
C
C
*********************************************************************
*   weighted upwind nach Samarski
*********************************************************************
c
      PHIP(X)=(0.5D0+X)/(1D0+X)
      PHIM(X)=    0.5D0/(1D0-X)
*********************************************************************
C
C
C *** Loop over all finite elements IEL=1,...,NEL
C
c      write (*,*) 'upwind'
c	return
C
      DO 1  IEL=1,NEL
C
C *** XE,YE will be coordinates of the center of the element
      XE=0.D0
      YE=0.D0
C-----------------------------------------------------------------------
C *** 1. Loop over all 4 U-nodes: IMID,XV,YV,XE,YE,UU1,UU2
C
      DO 11  II=1,4
      I=KMID(II,IEL)-NVT
      IMID(II)=I
      IV=KVERT(II,IEL)
      XV(II)=DCORVG(1,IV)
      YV(II)=DCORVG(2,IV)
      XE=XE+XV(II)
      YE=YE+YV(II)
      UU1(II)=A1L*U1L1(I)+A2L*U2L1(I)
      UU2(II)=A1L*U1L2(I)+A2L*U2L2(I)
  11  CONTINUE
C
      XE=0.25D0*XE
      YE=0.25D0*YE
C-----------------------------------------------------------------------
C *** 2. Loop over all 4 U-nodes:  FLUX(.), ISTORE(.,.), ELMA(.,.)
C
      DO 12  II=1,4
C
C *** Setting II-1 modulo 4 on IM1
      IM1=II-1
      IF (IM1.LT.1) IM1=4
C *** Calculation of the flux  FLUX(II)
      XN=-YV(II)+YE
      YN= XV(II)-XE
      G1=0.5D0*(UU1(IM1)+UU1(II))
      G2=0.5D0*(UU2(IM1)+UU2(II))
      FLUX(II)=XN*G1+YN*G2
C *** Determine the indices ISTORE(II,JJ) to store the element matrix
C     entry ELMA(II,JJ) on array A
      I=IMID(II)
      IA1=KLDA(I)
      IA2=KLDA(I+1)-1
      DO 120  JJ=1,4
      J=IMID(JJ)
C *** Searching loop
      DO 1201  IA=IA1,IA2
      IF (KCOLA(IA).EQ.J)  GOTO 121
 1201 CONTINUE
C
C *** Error case
      WRITE(MTERM,*) 'ERROR in GUPWD: entry index IA not found'
      RETURN
C
  121 ISTORE(II,JJ)=IA
C
C *** Initialization of element matrix ELMA(.,.)
      ELMA(II,JJ)=0D0
C
  120 CONTINUE
  12  CONTINUE
C-----------------------------------------------------------------------
C *** 3. Loop over all 4 U-nodes:  Calculation of ELMA(.,.)
C
      DO 13  II=1,4
C *** Setting II-1 modulo 4 on IM1
      IM0=II
      IM1=II-1
      IF (IM1.LT.1) IM1=4
      IM2=II+1
      IF (IM2.GT.4) IM2=1
C *** Calculate the part corresponding to GAMMA(IM0) and GAMMA(IM2)
      FL0=FLUX(IM0)
      FL2=FLUX(IM2)
C
C
      IF (UPSAM.GE.0) THEN
C
       UPSRE=UPSAM*RE
C
       IF (FL0.GE.0D0) THEN
        DL0=PHIP(UPSRE*FL0)
       ELSE
        DL0=PHIM(UPSRE*FL0)
       ENDIF
C
       IF (FL2.GE.0D0) THEN
        DL2=PHIP(UPSRE*FL2)
       ELSE
        DL2=PHIM(UPSRE*FL2)
       ENDIF
C
      ELSE
C
       DL0=0D0
       DL2=0D0
       IF (FL0.GE.0.D0) DL0=1D0
       IF (FL2.GE.0.D0) DL2=1D0
C
      ENDIF
C
C
      H00=DL0*FL0
      H22=(1D0-DL2)*FL2
      ELMA(IM0,IM0) = H00-H22
      ELMA(IM0,IM2) =     H22
      ELMA(IM0,IM1) =-H00
  13  CONTINUE
C-----------------------------------------------------------------------
C *** 4. Loop over all 4 U-nodes:  Addding ELMA(.,.) to matrix A
C
      DO 14   II=1,4
      DO 140  JJ=1,4
      ELMH=THSTEP*ELMA(II,JJ)
C
      IF (IDEF.LT.2) THEN
       IA   =ISTORE(II,JJ)
       A(IA)=A(IA)+REAL(ELMH)
      ENDIF
C
      IF (IDEF.GT.0) THEN 
       D1(IMID(II))=D1(IMID(II))-ELMH*U1(IMID(JJ))
       D2(IMID(II))=D2(IMID(II))-ELMH*U2(IMID(JJ))
      ENDIF 
C
 140  CONTINUE
  14  CONTINUE
C-----------------------------------------------------------------------
C
  1   CONTINUE
C
      END
      

************************************************************************
      SUBROUTINE INIT1 (MDATA,CDATA,MFILE,MSHOW,IWORKG,IWMAXG)
************************************************************************
*
*   Purpose: - generates geometry for all levels
*            - allocates all arrays
*            - reads a start vector if ISTART=1 or 2
*            - generates linear matrices for all levels
*            - stores pointers for all arrays on COMMON blocks
*            - sets boundary parameters for all levels
*            - sets Dirichlet bc's for the finest level
*            - generates rhs for the finest level
*            - opens a file with unit number MFILE for user output
*            - etc
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299,NNAB=21,NNLEV=9,NNWORK=1)
      PARAMETER (NBLOCA=1,NBLOCB=2,NBLOCF=2)
      PARAMETER (NBLA1=NBLOCA*NNLEV,NBLB1=NBLOCB*NNLEV,NBLF1=
     *           NBLOCF*NNLEV)
C
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CDATA*60,CFILE*60
C
C *** Names of matrices and vectors (for messages only)
      CHARACTER CARRST*12,CARRM*12,CARRDB*12
      CHARACTER CFILST*12,CFILM*12
      CHARACTER ARRDA*6,ARRDST*6,ARRDB*6,ARRDF*6,ARRDFP*6,ARRDM*6
      DIMENSION CARRST(NNLEV),CARRM(NNLEV),CARRDB(NNLEV)
      DIMENSION CFILST(NNLEV),CFILM(NNLEV)
      DIMENSION ARRDA(NBLOCA),ARRDST(NBLOCA),ARRDM(NBLOCA)
      DIMENSION ARRDB(NBLOCB),ARRDF(NBLOCF)
C
C *** Names of matrices and vectors (for output and tracing)
      DATA CARRST/'#data/VST.1 ','#data/VST.2 ','#data/VST.3 ',
     *            '#data/VST.4 ','#data/VST.5 ','#data/VST.6 ',
     *            '#data/VST.7 ','#data/VST.8 ','#data/VST.9 '/
      DATA CARRM /'#data/VM.1  ','#data/VM.2  ','#data/VM.3  ',
     *            '#data/VM.4  ','#data/VM.5  ','#data/VM.6  ',
     *            '#data/VM.7  ','#data/VM.8  ','#data/VM.9  '/
      DATA CARRDB/'#data/VB.1  ','#data/VB.2  ','#data/VB.3  ',
     *            '#data/VB.4  ','#data/VB.5  ','#data/VB.6  ',
     *            '#data/VB.7  ','#data/VB.8  ','#data/VB.9  '/
      DATA CFILST/'#ns/ST1     ','#ns/ST2     ','#ns/ST3     ',
     *            '#ns/ST4     ','#ns/ST5     ','#ns/ST6     ',
     *            '#ns/ST7     ','#ns/ST8     ','#ns/ST9     '/
      DATA CFILM /'#ns/MA1     ','#ns/MA2     ','#ns/MA3     ',
     *            '#ns/MA4     ','#ns/MA5     ','#ns/MA6     ',
     *            '#ns/MA7     ','#ns/MA8     ','#ns/MA9     '/
      DATA ARRDA/'VA    '/,ARRDST/'DST   '/,ARRDF/'DF1   ','DF2   '/
      DATA ARRDM/'DM    '/
      DATA ARRDB/'DB1   ','DB2   '/,ARRDFP/'DFP   '/
C
C *** Structure of bilinear and linear forms 
      DIMENSION KABSTN(NBLOCA),KABST(2,NNAB,NBLOCA)
      DIMENSION KABBN(NBLOCB),KABB(2,NNAB,NBLOCB)
      DIMENSION KFN(NBLOCF),KF(NNAB,NBLOCF)
      DATA KABSTN/3/, KABBN/1,1/, KFN/1,1/
C
      DIMENSION BCONST(NBLOCA),BCONB(NBLOCB),BCONF(NBLOCF)
      DATA BCONST/.TRUE./, BCONB/.TRUE.,.TRUE./, BCONF/.FALSE.,.FALSE./
C
      DIMENSION BSNGLA(NBLOCA,NNLEV),BSNGLB(NBLOCB,NNLEV),BSNGLF(NBLOCF)
      DATA BSNGLA/NBLA1*.FALSE./,BSNGLB/NBLB1*.FALSE./
      DATA BSNGLF/.FALSE.,.FALSE./
C
      DIMENSION KLB(NBLOCB,NNLEV),KLF(NBLOCF,NNLEV),LF(NBLOCF)
      DIMENSION KNA(NNLEV),KNEQ(NNLEV),KNB(NNLEV),KNEQB(NNLEV)
      DIMENSION KLMH(NNLEV)
      DATA KLB/NBLB1*0/,KLF/NBLF1*0/,LF(1)/0/,LF(2)/0/
      DATA KLMH/NNLEV*0/
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA,KNB,KNU(NNLEV),KNP(NNLEV),KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      CHARACTER CPARM1*60,CMESH1*60,CFILE1*60,CSTART*60,CSOL*60
      COMMON /FILES/ IMESH1,MMESH1,CPARM1,CMESH1,MFILE1,CFILE1,
     *               ISTART,MSTART,CSTART,ISOL,MSOL,CSOL
C
      SAVE 
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C     E X T E R N A L S
C-----------------------------------------------------------------------
C *** Parametrization of the domain
      EXTERNAL PARX,PARY,TMAX
C *** Control of refinement - here: regular refinement
      EXTERNAL S2DI0,S2DB0
C *** Coefficient of stiffness matrix, right hand side, exact solution
      EXTERNAL COEFST,COEFFB,RHS,UE
C *** definition of finite elements
      EXTERNAL E030,E031,EM30,EM31,E010
C=======================================================================
C     Initialization
C=======================================================================
      SUB='INIT1 '
C
      CALL ZTIME(TTT0)
C
C *** Structure of bilinear and linear forms
C     B1 block
      KABB(1,1,1)=2
      KABB(2,1,1)=1
C     B2 block
      KABB(1,1,2)=3
      KABB(2,1,2)=1
C
      KF(1,1)=1
      KF(1,2)=1
C
      ISYMMA=0
C
C=======================================================================
C     Data input
C=======================================================================
C
C      CALL  OF0  (MDATA,CDATA,1)
      CALL  OPNDAT (MDATA, MSHOW, CDATA)
      CALL  GDAT (MDATA,MSHOW,IRMESH)
      CLOSE (MDATA)
      CFILE=CFILE1
      MFILE=MFILE1
C
C=======================================================================
C     Grid generation
C=======================================================================
C
      IF (IMESH1.EQ.1) THEN
       CALL RDPARM (CPARM1,MDATA)
       CLOSE(MDATA)
      ENDIF
C
      CALL  XORSC (MMESH1,CMESH1)
      IF (IER.NE.0) GOTO 99999
      CLOSE(MMESH1)
C
C
      IMID=1
      IADJ=1
      IVEL=0
      IDISP=1
      IBDP=2
C
      IF (IRMESH.EQ.0) THEN
       CALL XMSB2(IMID,IADJ,IVEL,IDISP,IBDP,S2DI0,S2DB0,PARX,PARY,TMAX)
       IF (IER.NE.0) GOTO 99999
      ELSE
       CALL XMORS2(IRMESH)
       IF (IER.NE.0) GOTO 99999
      ENDIF
C
C
      DO 11  II=NLMIN,NLMAX
      ILEV=II
      NVT=KNVT(II)
      NMT=KNMT(II)
      NEL=KNEL(II)
      NVBD=KNVBD(II)
      KNU(II)=NMT
      KNP(II)=NEL
      NUP=NMT+NMT+NEL
      KNUP(II)=NUP
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'ILEV,NVT,NMT,NEL,NVBD: ', II,NVT,NMT,NEL,NVBD
      IF (MSHOW.GE.1) 
     * WRITE(MFILE,*) 'ILEV,NVT,NMT,NEL,NVBD: ', II,NVT,NMT,NEL,NVBD
C
      IF (IBDR.GE.2) THEN
       CALL ZNEW(NVT+NMT,-3,KLNPRO(II),'KNPRO ')
       IF (IER.NE.0) GOTO 99999
       CALL XLCP3(KLNPR(II),KLNPRO(II),NVT+NMT)
       IF (IER.NE.0) GOTO 99999
      ENDIF
C
      CALL ZNEW(NVBD,3,KLMBD(II),'KMBD  ')
      CALL ZNEW(NVBD,1,KLDBD(II),'DDBD  ')
      IF (IER.NE.0) GOTO 99999
      CALL BDRNEU(KWORK(L(KLMBD(II))),KWORK(L(KLVBD(II))),
     *            KWORK(L(KLEBD(II))),KWORK(L(KLVERT(II))),
     *            KWORK(L(KLMID(II))),KWORK(L(KLNPR(II))),
     *            DWORK(L(KLDBD(II))),DWORK(L(KLMBDP(II))),NMBD,INEUM)
      IF (IER.NE.0) GOTO 99999
      KNMBD(II)=NMBD      
11    CONTINUE
C
C
      CALL ZTIME(TTT1)
      TTGRID=TTT1-TTT0
C
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'time for grid generation : ',
     *                                TTGRID
      IF (MSHOW.GE.1) WRITE(MFILE,*) 'time for grid generation : ', 
     *                                TTGRID
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
      IWORKG=IWORK
      IWMAXG=IWMAX
C
C=======================================================================
C     Generation of: - pointer structures
C                    - STOKES,B1,B2 blocks 
C=======================================================================
C
C *** Generation of Laplace/mass block
C
      CALL ZTIME(TTT0L)
      CALL ZTIME(TTT0)
      CALL XMAP7(KLCOLA,KLLDA,KNA,KNEQ,E031,ISYMMA)
      IF (IER.NE.0) GOTO 99999
C
C=======================================================================
C *** Generation of block ST
C=======================================================================
C
      IF (IPRECA.NE.4) THEN
       KABST (1,1,1)=2
       KABST (2,1,1)=2
       KABST (1,2,1)=3
       KABST (2,2,1)=3
       KABSTN(1)    =2
C
       ICLRA=1
       IF (IELT.EQ.0) 
     *  CALL XMAB07(KLST,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,E031,COEFST,
     *              BCONST,KABST,KABSTN,ICUBA,ISYMMA,CARRST,BSNGLA)
       IF (IELT.EQ.1) 
     *  CALL XMAB07(KLST,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,E030,COEFST,
     *              BCONST,KABST,KABSTN,ICUBA,ISYMMA,CARRST,BSNGLA)
       IF (IELT.EQ.2)
     *  CALL XMABM7(KLST,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,EM31,COEFST,
     *              BCONST,KABST,KABSTN,ICUBA,ISYMMA,CARRST,BSNGLA)
       IF (IELT.EQ.3)
     *  CALL XMABM7(KLST,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,EM30,COEFST,
     *              BCONST,KABST,KABSTN,ICUBA,ISYMMA,CARRST,BSNGLA)
       IF (IER.NE.0) GOTO 99999
      ENDIF
C
C=======================================================================
C *** Generation of mass matrix
C=======================================================================
C
      IF (ISTAT.NE.0) THEN
       KABST (1,1,1)=1
       KABST (2,1,1)=1
       KABSTN(1)    =1
C
       ICLRA=1
       IF (IELT.EQ.0)
     *  CALL XMAB07(KLMH,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,E031,
     *              COEFST,BCONST,KABST,KABSTN,ABS(ICUBM),ISYMMA,CARRM,
     *              BSNGLA)
       IF (IELT.EQ.1)
     *  CALL XMAB07(KLMH,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,E030,
     *              COEFST,BCONST,KABST,KABSTN,ABS(ICUBM),ISYMMA,CARRM,
     *              BSNGLA)
       IF (IELT.EQ.2)
     *  CALL XMABM7(KLMH,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,EM31,
     *              COEFST,BCONST,KABST,KABSTN,ABS(ICUBM),ISYMMA,CARRM,
     *              BSNGLA)
       IF (IELT.EQ.3) 
     *  CALL XMABM7(KLMH,KLCOLA,KLLDA,KNA,KNEQ,NBLOCA,ICLRA,EM30,
     *              COEFST,BCONST,KABST,KABSTN,ABS(ICUBM),ISYMMA,CARRM,
     *              BSNGLA)
       IF (IER.NE.0) GOTO 99999
C
C=======================================================================
C
       DO 20  II=NLMIN,NLMAX
C
       IF (IMASS.EQ.0) THEN
        CALL  ZNEW (KNU(II),1,KLM(II),'VMASS ')
        IF (IER.NE.0) GOTO 99999
C
        DO 21 INU=1,KNU(II)
C
        IF (IMASSL.EQ.0) THEN
         DMH=0D0
         DO 22 ILD=KWORK(L(KLLDA(II))+INU-1),KWORK(L(KLLDA(II))+INU)-1
22       DMH=DMH+DWORK(L(KLMH(II))+ILD-1)
        ELSE
         ILD=KWORK(L(KLLDA(II))+INU-1)
         DMH=DWORK(L(KLMH(II))+ILD-1)
        ENDIF
C
        DWORK(L(KLM(II))+INU-1)=DMH
CCC        WRITE(6,*) II,INU,DWORK(L(KLM(II))+INU-1),KLM(II),L(KLM(II))
21      CONTINUE
C
        CALL  ZDISP (0, KLMH(II),'VMASSH')
        IF (IER.NE.0) GOTO 99999
       ELSE
        KLM(II) =KLMH(II)
        KLMH(II)=0
       ENDIF
C
20     CONTINUE
C
      ENDIF
C
C=======================================================================
C *** Generation of blocks B1,B2
C=======================================================================
C
      IF (IPRECB.LT.2) THEN
       IF ((IELT.EQ.0).OR.(IELT.EQ.2)) 
     *      CALL XMAP9(KLCOLB,KLLDB,KNB,KNEQB,E031,E010)
       IF ((IELT.EQ.1).OR.(IELT.EQ.3)) 
     *      CALL XMAP9(KLCOLB,KLLDB,KNB,KNEQB,E030,E010)
       IF (IER.NE.0) GOTO 99999
C
       ICLRB=1
       IF ((IELT.EQ.0).OR.(IELT.EQ.2)) 
     *  CALL XMAB09(KLB,KLCOLB,KLLDB,KNB,NBLOCB,ICLRB,E031,E010,E010,
     *              COEFFB,BCONB,KABB,KABBN,ICUBB,CARRDB,BSNGLB)
       IF ((IELT.EQ.1).OR.(IELT.EQ.3)) 
     *  CALL XMAB09(KLB,KLCOLB,KLLDB,KNB,NBLOCB,ICLRB,E030,E010,E010,
     *              COEFFB,BCONB,KABB,KABBN,ICUBB,CARRDB,BSNGLB)
       IF (IER.NE.0) GOTO 99999
      ENDIF
C
C
      DO 13 ILEV=NLMIN,NLMAX
C
      IF (IPRECB.GE.2) THEN
       KNEQB(ILEV)=KNU(ILEV)
       KNB  (ILEV)=2*KNU(ILEV)
       CALL ZNEW(KNB(ILEV)  ,1,KLB(1,ILEV) ,ARRDB(1))
       CALL ZNEW(KNB(ILEV)  ,1,KLB(2,ILEV) ,ARRDB(2))
       CALL ZNEW(KNB(ILEV)  ,3,KLCOLB(ILEV),'KCOLB ')
       CALL ZNEW(KNU(ILEV)+1,3,KLLDB (ILEV),'LLDB  ')
       IF (IER.NE.0) GOTO 99999
C
       ISETLV=2
       CALL SETLEV(ISETLV)
       CALL BBUILD(KWORK(L(LVERT)),KWORK(L(LMID)),KWORK(L(LADJ)),
     *             DWORK(L(LCORVG)),
     *             DWORK(L(KLB(1,ILEV))),DWORK(L(KLB(2,ILEV))),
     *             KWORK(KCOLB),KWORK(KLDB),KNB(ILEV),NEL,NVT,NMT)
C
       CALL ZDISP (KNB(ILEV),KLB(1,ILEV) ,ARRDB(1))
       CALL ZDISP (KNB(ILEV),KLB(2,ILEV) ,ARRDB(2))
       CALL ZDISP (KNB(ILEV),KLCOLB(ILEV),'KCOLB ')
       IF (IER.NE.0) GOTO 99999
      ENDIF
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ILEV,NU,NA,NB:',ILEV,KNU(ILEV),
     *                                KNA(ILEV),KNB(ILEV)
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ILEV,NU,NA,NB:',ILEV,KNU(ILEV),
     *                                KNA(ILEV),KNB(ILEV)
C
      NEQ =KNEQ(ILEV)
      NEQB=KNEQB(ILEV)
      IF (NEQB.NE.NEQ.OR.NEQ.NE.KNU(ILEV).OR.KNEL(ILEV).NE.KNP(ILEV)) 
     *    THEN
        WRITE(MTERM,*) 'ERROR in INIT1: NEQ.NE.NEQB'
        STOP
      ENDIF
C
      KLB1(ILEV)=KLB(1,ILEV)
      KLB2(ILEV)=KLB(2,ILEV)
13    CONTINUE
C
C
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
C 
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
C
C=======================================================================
C     matrix restructuring
C=======================================================================
C
      DO 15 ILEV=NLMIN,NLMAX
       CALL ZTIME(TTT0)
       ISETLV=2
       CALL SETLEV(ISETLV)
C
       IF (IPRECA.EQ.0) THEN
        CALL ZCTYPE(2,KLST(ILEV),CARRST)
        IF (IER.NE.0) GOTO 99999
C
        IF (ISTAT.EQ.1) THEN
         CALL ZCTYPE(2,KLM(ILEV),CARRM)
         IF (IER.NE.0) GOTO 99999
        ENDIF
       ENDIF
C
C
       IF (IPRECA.EQ.2) THEN
        CALL ZCTYPE(2,KLST(ILEV),CARRST)
        IF (IER.NE.0) GOTO 99999
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  OWA2 (VWORK(L(KLST(ILEV))),CFILE,NA,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) GOTO 99999
        CALL ZDISP (0,KLST(ILEV),'STMAT ')
        IF (IER.NE.0) GOTO 99999
C
        IF (ISTAT.EQ.1) THEN
         CALL ZCTYPE(2,KLM(ILEV),CARRM)
         IF (IER.NE.0) GOTO 99999
         CALL  OF0 (59,CFILM(ILEV),0)
         CFILE='MASMAT'
         CALL  OWA2V (VWORK(L(KLM(ILEV))),CFILE,NA,59,0)
         REWIND(59)
         CLOSE (59)
         IF (IER.NE.0) GOTO 99999
         CALL ZDISP (0,KLM(ILEV),'MASMAT')
         IF (IER.NE.0) GOTO 99999
        ENDIF
       ENDIF
C
C
       IF (IPRECA.EQ.3) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  OWA1 (DWORK(L(KLST(ILEV))),CFILE,NA,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) GOTO 99999
        CALL ZDISP (0,KLST(ILEV),'STMAT ')
        IF (IER.NE.0) GOTO 99999
C
        IF (ISTAT.EQ.1) THEN
         CALL  OF0 (59,CFILM(ILEV),0)
         CFILE='MASMAT'
         CALL  OWA1 (DWORK(L(KLM(ILEV))),CFILE,NA,59,0)
         REWIND(59)
         CLOSE (59)
         IF (IER.NE.0) GOTO 99999
         CALL ZDISP (0,KLM(ILEV),'MASMAT')
         IF (IER.NE.0) GOTO 99999
        ENDIF
       ENDIF
C
C
       IF (IPRECB.EQ.0) THEN
        CALL ZCTYPE(2,KLB(1,ILEV),CARRDB)
        IF (IER.NE.0) GOTO 99999
        CALL ZCTYPE(2,KLB(2,ILEV),CARRDB)
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (IPRECB.EQ.2) THEN
        CALL ZDISP (0,KLB(1,ILEV) ,ARRDB(1))
        CALL ZDISP (0,KLB(2,ILEV) ,ARRDB(2))
        CALL ZDISP (0,KLCOLB(ILEV),'KCOLB ')
        CALL ZDISP (0,KLLDB (ILEV),'KLDB  ')
        IF (IER.NE.0) GOTO 99999
        KLB1(ILEV)=0
        KLB2(ILEV)=0
       ENDIF
C
       IF (IPRECB.EQ.3) THEN
        CALL ZCTYPE(2,KLB(1,ILEV),CARRDB)
        IF (IER.NE.0) GOTO 99999
        CALL ZCTYPE(2,KLB(2,ILEV),CARRDB)
        IF (IER.NE.0) GOTO 99999
        IPRECB=0
       ENDIF
C
       IF (IPRECB.EQ.4) THEN
        IPRECB=1
       ENDIF
C
       CALL ZTIME(TTT1)
       TTADF=TTADF+TTT1-TTT0
C
15    CONTINUE
C
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.0) WRITE(MFILE,*)
C
C=======================================================================
C    Allocation of:  - solution vector with boundary conditions on NLMAX
C                    - RHS on NLMAX and auxiliary vectors
C                    - UOLD-vector on level NLMAX
C=======================================================================
C
      DO 25  ILEV=NLMIN,NLMAX
C
      CALL ZTIME(TTT0)
      ISETLV=1
      CALL  SETLEV (ISETLV)
C
C=======================================================================
C *** Allocation of solution and defect vectors and right hand side 
C=======================================================================
C
      NEQ=KNEQ(ILEV)
      NUP=2*NEQ+NEL
C
      CALL ZNEW(NUP,1,LUP,'DU12P ')
      IF (IER.NE.0) GOTO 99999
      KLUP(ILEV)=LUP
C
      IF (ILEV.EQ.NLMAX)  THEN
        IF ((OMGMIN.GT.0D0).OR.(OMGMAX.GT.0D0)) THEN
         CALL ZNEW(NEQ,1,LU1OLD,'DU1OLD')
         IF (IER.NE.0) GOTO 99999
         CALL ZNEW(NEQ,1,LU2OLD,'DU2OLD')
         IF (IER.NE.0) GOTO 99999
         CALL ZNEW(NEL,1,LPOLD,'DPOLD ')
         IF (IER.NE.0) GOTO 99999
        ENDIF
C
        CALL ZNEW(NEQ,1,LD1,'DD1   ')
        IF (IER.NE.0) GOTO 99999
        CALL ZNEW(NEQ,1,LD2,'DD2   ')
        IF (IER.NE.0) GOTO 99999
        CALL ZNEW(NEL,1,LDP,'DDP   ')
        IF (IER.NE.0) GOTO 99999
      ENDIF
C
      CALL ZNEW(NUP,1,LF12P,'DF12P ')
      IF (IER.NE.0) GOTO 99999
      KLF12P(ILEV)=LF12P
C
C=======================================================================
C *** Allocation of iteration matrix A 
C=======================================================================
C
      NA=KNA(ILEV)
      CALL  ZNEW (NA,2,LA1,'VA    ')
      IF (IER.NE.0) GOTO 99999
      KLA(ILEV)=LA1
C
C=======================================================================
C *** calculation of a vector with the areas of all finite elements
C=======================================================================
C
      CALL ZNEW(NEL+1,2,LAREA,'VAREA ')
      IF (IER.NE.0) GOTO 99999
      KLAREA(ILEV)=LAREA
      CALL SETARE(VWORK(L(LAREA)),NEL,KWORK(L(LVERT)),DWORK(L(LCORVG))) 
C
C=======================================================================
C *** calculation of rhs and start vectors on finest level only
C=======================================================================
C
      IF (ILEV.EQ.NLMAX)  THEN
C
      LF(1)=0
      LF(2)=0
      ICLRF=1
      IF (IELT.EQ.0) 
     * CALL  XVB0 (LF,NEQ,NBLOCF,ICLRF,E031,
     *             RHS,BCONF,KF,KFN,ICUBF,ARRDF,BSNGLF)
      IF (IELT.EQ.1) 
     * CALL  XVB0 (LF,NEQ,NBLOCF,ICLRF,E030,
     *             RHS,BCONF,KF,KFN,ICUBF,ARRDF,BSNGLF)
      IF (IELT.EQ.2) 
     * CALL  XVBM0(LF,NEQ,NBLOCF,ICLRF,EM31,
     *             RHS,BCONF,KF,KFN,ICUBF,ARRDF,BSNGLF)
      IF (IELT.EQ.3) 
     * CALL  XVBM0(LF,NEQ,NBLOCF,ICLRF,EM30,
     *             RHS,BCONF,KF,KFN,ICUBF,ARRDF,BSNGLF)
      IF (IER.NE.0) GOTO 99999
      LF1=LF(1)
      LF2=LF(2)
C
C=======================================================================
C *** start vector as prolongation from level NLMAX
C=======================================================================
C
      IF (ABS(ISTART).EQ.1) THEN
       IF (ISTART.EQ.1) THEN
        IFMTS=0
       ELSE
        IFMTS=1
       ENDIF
       CFILE='DU12P '
       CALL  OF0 (MSTART,CSTART,IFMTS)
       CALL  ORA1 (DWORK(L(LUP)),CFILE,MSTART,IFMTS)
       CLOSE(MSTART)
      ENDIF
C
C=======================================================================
C *** start vector as prolongation from level NLMAX-1
C=======================================================================
C
      IF (ABS(ISTART).EQ.2) THEN
        I1=NLMAX-1
        KU1C=L(KLUP(I1))
        IF (ISTART.EQ.2) THEN
         IFMTS=0
        ELSE
         IFMTS=1
        ENDIF
        CFILE='DU12P '
        CALL  OF0 (MSTART,CSTART,IFMTS)
        CALL  ORA1 (DWORK(KU1C),CFILE,MSTART,IFMTS)
        CLOSE(MSTART)
        NUC=KNU(I1)
        NPC=KNP(I1)
        NVTC=KNVT(I1)
        KU2C=KU1C+NUC
        KPC=KU2C+NUC
        KVERTC=L(KLVERT(I1))
        KMIDC=L(KLMID(I1))
        KADJC=L(KLADJ(I1))
        KU1=L(LUP)
        KU2=KU1+NEQ
        KP=KU2+NEQ
C
        CALL  PROLU (DWORK(KU1C),DWORK(KU2C),DWORK(KPC),
     *               DWORK(KU1),DWORK(KU2),DWORK(KP),
     *               KWORK(KVERTC),KWORK(KMIDC),KWORK(KADJC),
     *               NUC, NPC, NVTC,
     *               KWORK(L(LVERT)),KWORK(L(LMID)),KWORK(L(LADJ)),
     *               NEQ, NEL, NVT)
      ENDIF
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Dirichlet boundary updates of solution and rhs vector
C=======================================================================
C
      CALL ZTIME(TTT0)
      IF ((IBDR.EQ.1).AND.(ISTAT.EQ.0)) THEN
       CALL PDSET (KWORK(L(KLVBD(NLEV))),KWORK(L(KLEBD(NLEV))),
     *             KWORK(L(KLVERT(NLEV))),KWORK(L(KLMID(NLEV))),
     *             KWORK(L(KLNPR(NLEV))),DWORK(L(LCORVG)),
     *             DWORK(L(KLMBDP(NLEV))),DWORK(L(LF1)),DWORK(L(LF2)),
     *             1D0)
      ENDIF
C
      KU1=L(LUP)
      KU2=KU1+NEQ
      CALL BDRSET (DWORK(KU1),DWORK(KU2),DWORK(L(LF1)),
     *             DWORK(L(LF2)),KWORK(L(KLMBD(NLEV))),
     *             DWORK(L(KLDBD(NLEV))),KWORK(L(LNPR)),
     *             KNMBD(NLEV),NVT,PARX,PARY,UE)
C
      CALL  LCP1 (DWORK(L(LF1)), DWORK(L(LF12P)),     NEQ)
      CALL  LCP1 (DWORK(L(LF2)), DWORK(L(LF12P)+NEQ), NEQ)
      CALL ZTIME(TTT1)
      TTBDR=TTBDR+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      CALL  ZDISP (0, LF1, ARRDF(1) )
      CALL  ZDISP (0, LF2, ARRDF(2) )
      IF (IER.NE.0) GOTO 99999
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      ENDIF
C
C=======================================================================
C *** Auxiliary vector on all levels
C=======================================================================
C
      CALL ZTIME(TTT0)
      CALL ZNEW(NUP,1,LAUX,'DAUX  ')
      IF (IER.NE.0) GOTO 99999
      KLAUX(ILEV)=LAUX
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
25    CONTINUE
C
C
      CALL ZTIME(TTT1)
      TTLIN=TTT1-TTT0L
C
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'time for initialization of linear operators : ', 
     *                TTLIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'time for initialization of linear operators : ', 
     *                TTLIN
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.0) WRITE(MFILE,*)
C
C
C
99999 END

************************************************************************
* Open file CDATA, read the MSHOW variable from the data file CDATA.
* Set the file pointer to the beginning of the file to allow complete
* parsing of the file.
************************************************************************
      SUBROUTINE OPNDAT (MDATA, MSHOW, CDATA)
      IMPLICIT NONE
      INTEGER MDATA, MSHOW
      CHARACTER*(*) CDATA
      
      INTEGER i

      CALL OF0 (MDATA,CDATA,1)
      DO 10 i=1,20
        READ (MDATA,*)
10    CONTINUE
      READ (MDATA,*) MSHOW
      REWIND (MDATA)
      
      END

************************************************************************
      SUBROUTINE GDAT (MDATA,MSHOW,IRMESH)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNLEV=9)
C
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C *** Standard COMMON blocks
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
C
C *** COMMON blocks for multigrid routine M010
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTIME/ TTMG,TTS,TTE,TTD,TTP,TTR,IMTIME
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSADAT/ TIMEMX,DTMIN,DTMAX,DTFACT,TIMEIN,EPSADI,EPSADL,
     *                EPSADU,IEPSAD,IADIN,IREPIT,IADTIM
      COMMON /NSSAV/  INSAV,INSAVN
      COMMON /NSSAVF/ DTFILM,DTFILO,DTAVS,DTAVSO,DTGMV,DTGMVO,
     *                IFUSAV,IFPSAV,IFXSAV,IAVS,IGMV,IFINIT
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
      COMMON /NSEXL/  ITEXL,LTML,TIML11,TIML12,TIML31,TIML32
C
      CHARACTER CPARM1*60,CMESH1*60,CFILE1*60,CSTART*60,CSOL*60
      COMMON /FILES/ IMESH1,MMESH1,CPARM1,CMESH1,MFILE1,CFILE1,
     *               ISTART,MSTART,CSTART,ISOL,MSOL,CSOL
C
      SAVE 
C
C-----------------------------------------------------------------------
C *** Input file
C-----------------------------------------------------------------------
C
      READ(MDATA,*)
      READ(MDATA,*)
      READ(MDATA,*) 
      IF (MSHOW.GE.2) WRITE(MTERM,1)
   1  FORMAT(80('-'))
      IF (MSHOW.GE.2) WRITE(MTERM,*) '        INPUT DATA'
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      READ(MDATA,*)
      READ(MDATA,*)
C
      READ(MDATA,*) IMESH1
      IF (IMESH1.NE.1) IMESH1=0
      READ(MDATA,*) IRMESH
      IRMESH=ABS(IRMESH)
      READ(MDATA,*) CPARM1
      READ(MDATA,*) CMESH1
      MMESH1=61
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Parametrization file = ',CPARM1
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Coarse grid file     = ',CMESH1
C
      READ(MDATA,*) CFILE1
      MFILE1=62
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'MFILE,CFILE: ', MFILE1,CFILE1
      MFILE=MFILE1
C
      READ(MDATA,*) ISTART
      IF (ABS(ISTART).GT.2) ISTART=0
      READ(MDATA,*) CSTART
      MSTART=63
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'ISTART,MSTART,CSTART: ', ISTART,MSTART,CSTART
C
      READ(MDATA,*) ISOL
      IF (ABS(ISOL).GT.1) ISOL=1
      READ(MDATA,*) CSOL
      MSOL=64
      IF (MSHOW.GE.2) WRITE(MTERM,*)'ISOL,MSOL,CSOL: ', ISOL,MSOL,CSOL
C
C-----------------------------------------------------------------------
C *** Open file for user output
C-----------------------------------------------------------------------
C
      CALL  OF0 (MFILE1,CFILE1,1)
C
      IF (MSHOW.GE.0) WRITE(MFILE,1)
      IF (MSHOW.GE.0) WRITE(MFILE,*) '        INPUT DATA'
      IF (MSHOW.GE.0) WRITE(MFILE,1)
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Parametrization file = ',CPARM1
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Coarse grid file     = ',CMESH1
C
C-----------------------------------------------------------------------
C *** Values for /OUTPUT/
C-----------------------------------------------------------------------
C
      READ(MDATA,*) 
      READ(MDATA,*)
      READ(MDATA,*)
C
      READ(MDATA,*) M
      M=ABS(M)
C
      READ(MDATA,*) MT
      MT=ABS(MT)
C
      READ(MDATA,*) ICHECK
      ICHECK=ABS(ICHECK)
C
      READ(MDATA,*) MSHOW
      MSHOW=ABS(MSHOW)
C
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'message level for file output:  M = ',M
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'message level for terminal output:  MT = ',MT
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'level for tracing:  ICHECK = ',ICHECK
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'output level:  MSHOW = ',MSHOW
      IF (MSHOW.GE.2) WRITE(MTERM,1)
C
C-----------------------------------------------------------------------
C *** Values for /IPARM/,etc.
C-----------------------------------------------------------------------
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Integer parameters of /IPARM/ :'
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Integer parameters of /IPARM/,etc. :'
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      WRITE(MFILE,1)
      READ(MDATA,*) 
      READ(MDATA,*)
      READ(MDATA,*)
C
      READ(MDATA,*)  NLMIN
      NLMIN=ABS(NLMIN)
      IF (NLMIN.EQ.0) NLMIN=1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'minimum mg-level:  NLMIN = ', NLMIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'minimum mg-level:  NLMIN = ', NLMIN
C
      READ(MDATA,*)  NLMAX
      NLMAX=ABS(NLMAX)
      IF (NLMAX.LT.NLMIN) NLMAX=NLMIN
      NLEV=NLMAX
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'maximum mg-level:  NLMAX = ', NLMAX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'maximum mg-level:  NLMAX = ', NLMAX
C
      READ(MDATA,*) IELT
      IF ((IELT.LT.0).OR.(IELT.GT.3)) IELT=3
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'element type   = ',IELT
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'element type   = ',IELT
C
      READ(MDATA,*)  ISTOK
      IF (ISTOK.NE.1) ISTOK=0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Stokes calculation:  ISTOK = ', ISTOK
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Stokes calculation:  ISTOK = ', ISTOK
C
      READ(MDATA,*) IRHS
      IF ((IRHS.LT.0).OR.(IRHS.GT.2)) IRHS=2
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'RHS    generation   = ',IRHS
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'RHS    generation   = ',IRHS
C
      READ(MDATA,*) IBDR
      IF ((IBDR.LT.0).OR.(IBDR.GT.2)) IBDR=2
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Boundary generation = ',IBDR
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Boundary generation = ',IBDR
C
      READ(MDATA,*) IERANA
      IERANA=ABS(IERANA)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Error evaluation    = ',IERANA
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Error evaluation    = ',IERANA
C
      READ(MDATA,*) IMASS
      IF (IMASS.NE.1) IMASS=0
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'mass evaluation     = ',IMASS
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'mass evaluation     = ',IMASS
C
      READ(MDATA,*) IMASSL
      IF (IMASSL.NE.1) IMASSL=0
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'lumped mass eval.   = ',IMASSL
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'lumped mass eval.   = ',IMASSL
C
      READ(MDATA,*) IUPW
      IF ((IUPW.GT.1).OR.(IUPW.LT.0)) IUPW=1
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'convective part     = ',IUPW
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'convective part     = ',IUPW
C
      READ(MDATA,*) IPRECA
      IF ((IPRECA.LT.0).OR.(IPRECA.GT.4)) IPRECA=1
      IF ((IPRECA.EQ.4).AND.(IUPW.EQ.1))  IPRECA=1
      IF ((IPRECA.EQ.4).AND.(ISTOK.EQ.1)) IPRECA=1
      IF (IPRECA.EQ.3)                    IPRECA=2
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Accuracy for ST     = ',IPRECA
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Accuracy for ST     = ',IPRECA
C
      READ(MDATA,*) IPRECB
      IF ((IPRECB.LT.0).OR.(IPRECB.GT.4)) IPRECB=2
      IF (IPRECB.EQ.1) IPRECB=0
      IF (IPRECB.EQ.2) IPRECB=3
      IF (IPRECB.EQ.4) IPRECB=3
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Accuracy for B      = ',IPRECB
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Accuracy for B      = ',IPRECB
C
      READ(MDATA,*) ICUBM
      ICUBM=ABS(ICUBM)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ICUB mass matrix        = ',ICUBM
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ICUB mass matrix        = ',ICUBM
C
      READ(MDATA,*) ICUBA
      ICUBA=ABS(ICUBA)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ICUB diff. matrix       = ',ICUBA
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ICUB diff. matrix       = ',ICUBA
C
      READ(MDATA,*) ICUBN
      ICUBN=ABS(ICUBN)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ICUB conv. matrix       = ',ICUBN
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ICUB conv. matrix       = ',ICUBN
C
      READ(MDATA,*) ICUBB
      ICUBB=ABS(ICUBB)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ICUB matrices B1,B2     = ',ICUBB
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ICUB matrices B1,B2     = ',ICUBB
C
      READ(MDATA,*) ICUBF
      ICUBF=ABS(ICUBF)
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'ICUB right hand side    = ',ICUBF
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'ICUB right hand side    = ',ICUBF
C
      READ(MDATA,*) INLMIN
      IF (INLMIN.LT.-1) INLMIN=-1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'minimum of nonlinear iterations: INLMIN = ',
     *  INLMIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'minimum of nonlinear iterations: INLMIN = ',
     *  INLMIN
C
      READ(MDATA,*) INLMAX
      IF (INLMAX.LT.-1) INLMAX=-1
      IF (INLMAX.LT.INLMIN) INLMAX=INLMIN
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'maximum of nonlinear iterations: INLMAX = ',
     *  INLMAX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'maximum of nonlinear iterations: INLMAX = ',
     *  INLMAX
C
      ITEXL=0
      IF ((INLMIN.EQ.INLMAX).AND.(INLMIN.EQ. 1)) THEN
       ITEXL=1
       TIML31=1D0
       TIML32=1D0
       TIML11=1D0
       TIML12=1D0
      ENDIF
      IF ((INLMIN.EQ.INLMAX).AND.(INLMIN.EQ.-1)) THEN
       INLMIN=1
       INLMAX=1
      ENDIF
C
C
      READ(MDATA,*)  ICYC
      ICYCLE=ABS(ICYC)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'type of mg-cycle:  ICYCLE = ', ICYCLE
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'type of mg-cycle:  ICYCLE = ', ICYCLE
C
      READ(MDATA,*) ILMIN
      ILMIN=ABS(ILMIN)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'minimum of linear mg steps :  ILMIN = ', ILMIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'minimum of linear mg steps :  ILMIN = ', ILMIN
C
      READ(MDATA,*) ILMAX
      ILMAX=ABS(ILMAX)
      IF (ILMAX.LT.ILMIN) ILMAX=ILMIN
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'maximum of linear mg steps :  ILMAX = ', ILMAX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'maximum of linear mg steps :  ILMAX = ', ILMAX
C
      READ(MDATA,*)  IINT
      IF ((ABS(IINT).NE.1).AND.(ABS(IINT).NE.2)) IINT=2
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'type of interpolation:  IINT = ', IINT
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'type of interpolation:  IINT = ', IINT
C
      READ(MDATA,*) ISM
      IF (ISM.NE.1) ISM=1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'type of smoother :  ISM = ',ISM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'type of smoother :  ISM = ',ISM
C
      READ(MDATA,*) ISL
      IF (ISL.NE.1) ISL=1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'type of solver :  ISL = ',ISL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'type of solver :  ISL = ',ISL
C
      READ(MDATA,*) NSM
      NSM=ABS(NSM)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'number of smoothing steps :  NSM = ', NSM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'number of smoothing steps :  NSM = ', NSM
C
      READ(MDATA,*) NSL
      NSL=ABS(NSL)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'number of solver steps :  NSL = ', NSL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'number of solver steps :  NSL = ', NSL
C
      READ(MDATA,*) NSMFAC
      IF (NSMFAC.LT.1) NSMFAC=1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'factor sm. steps on coarser lev.:NSMFAC=',NSMFAC
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'factor sm. steps on coarser lev.:NSMFAC=',NSMFAC
C
      DO 11  II=1,NNLEV
      KPOSM(II)=NSM
11    KPRSM(II)=NSM
C
      DO 12  II=1,NLEV
      KPOSM(II)=KPOSM(II)*NSMFAC**(NLEV-II)
      KPRSM(II)=KPRSM(II)*NSMFAC**(NLEV-II)
12    CONTINUE
C
      DO 13  II=1,NNLEV
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'KPRSM,KPOSM ON LEVEL: ',II,KPRSM(II),KPOSM(II)
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'KPRSM,KPOSM ON LEVEL: ',II,KPRSM(II),KPOSM(II)
13    CONTINUE
C
C
C-----------------------------------------------------------------------
C *** Values for /RPARM/,etc.
C-----------------------------------------------------------------------
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Real parameters of /RPARM/,etc. :'
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Real parameters of /RPARM/,etc. :'
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.0) WRITE(MFILE,1)
      READ(MDATA,*) 
      READ(MDATA,*)
      READ(MDATA,*)
C
      READ(MDATA,*) RE
      RE=ABS(RE)
      IF (RE.LT.1D-8) RE=1D-8
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Viscosity parameter:  1/NU = ', RE
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Viscosity parameter:  1/NU = ', RE
C
      NY=1.D0/RE
C
      READ(MDATA,*) UPSAM
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'parameter for Samarskij-upwind:  UPSAM = ', UPSAM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'parameter for Samarskij-upwind:  UPSAM = ', UPSAM
C
      READ(MDATA,*) OMGMIN
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'lower limit for optimal OMEGA: OMGMIN = ', OMGMIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'lower limit for optimal OMEGA: OMGMIN = ', OMGMIN
C
      READ(MDATA,*) OMGMAX
      IF (OMGMAX.LT.OMGMIN) OMGMAX=OMGMIN
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'upper limit for optimal OMEGA: OMGMAX = ', OMGMAX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'upper limit for optimal OMEGA: OMGMAX = ', OMGMAX
C
      READ(MDATA,*) OMGINI
      IF (OMGINI.LT.OMGMIN) OMGINI=OMGMIN
      IF (OMGINI.GT.OMGMAX) OMGINI=OMGMAX
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'start value for optimal OMEGA: OMGINI = ', OMGINI
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'start value for optimal OMEGA: OMGINI = ', OMGINI
C
      READ(MDATA,*) EPSD
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for U-defects   :        EPSD   = ', EPSD 
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for U-defects   :        EPSD   = ', EPSD 
      READ(MDATA,*) EPSDIV
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for DIV-defects :        EPSDIV = ', EPSDIV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for DIV-defects :        EPSDIV = ', EPSDIV
      READ(MDATA,*) EPSUR
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for U-changes :          EPSUR  = ', EPSUR
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for U-changes :          EPSUR  = ', EPSUR
      READ(MDATA,*) EPSPR
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for P-changes :          EPSPR  = ', EPSPR
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for P-changes :          EPSPR  = ', EPSPR
      READ(MDATA,*) DMPD
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'defect improvement  :          DMPD   = ', DMPD
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'defect improvement  :          DMPD   = ', DMPD
      READ(MDATA,*) DMPMG
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'damping of MG residuals     :  DMPMG  = ', DMPMG
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'damping of MG residuals     :  DMPMG  = ', DMPMG
      READ(MDATA,*) EPSMG
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for MG residuals      :  EPSMG  = ', EPSMG
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for MG residuals      :  EPSMG  = ', EPSMG
      READ(MDATA,*) DMPSL
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'damping of residuals for solving:  DMPSL = ',DMPSL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'damping of residuals for solving:  DMPSL = ',DMPSL
      READ(MDATA,*) EPSSL
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'limit of changes for solving:    EPSSL = ',EPSSL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'limit of changes for solving:    EPSSL = ',EPSSL
C
C
      READ(MDATA,*) RLXSM
      RLXSM=ABS(RLXSM)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'relaxation for the U-smoother: RLXSM = ', RLXSM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'relaxation for the U-smoother: RLXSM = ', RLXSM
C
      READ(MDATA,*) RLXSL
      RLXSL=ABS(RLXSL)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'relaxation for the U-solver :  RLXSL = ', RLXSL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'relaxation for the U-solver :  RLXSL = ', RLXSL
C
      READ(MDATA,*) AMINMG
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'lower limit optimal MG-ALPHA: AMINMG = ', AMINMG
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'lower limit optimal MG-ALPHA: AMINMG = ', AMINMG
      READ(MDATA,*) AMAXMG
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*)'upper limit optimal MG-ALPHA: AMAXMG = ', AMAXMG
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*)'upper limit optimal MG-ALPHA: AMAXMG = ', AMAXMG
C
C
C-----------------------------------------------------------------------
C *** Values for /NS.../
C-----------------------------------------------------------------------
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'Parameters of /NS.../ :'
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'Parameters of /NS.../ :'
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.0) WRITE(MFILE,1)
      READ(MDATA,*) 
      READ(MDATA,*)
      READ(MDATA,*)
C
      READ(MDATA,*) ISTAT
      IF ((ISTAT.LT.0).OR.(ISTAT.GT.1)) ISTAT=0
      WRITE(MTERM,*) 'Time dependency          : ISTAT  = ', ISTAT
      WRITE(MFILE,*) 'Time dependency          : ISTAT  = ', ISTAT
C
      READ(MDATA,*) NITNS
      NITNS=ABS(NITNS)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Number of time steps     : NITNS  = ', NITNS
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Number of time steps     : NITNS  = ', NITNS
C
      READ(MDATA,*) EPSNS
      EPSNS=ABS(EPSNS)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'limit for time derivative: EPSNS  = ', EPSNS
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'limit for time derivative: EPSNS  = ', EPSNS
C
      READ(MDATA,*) TIMENS
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Total time               : TIMENS = ', TIMENS
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Total time               : TIMENS = ', TIMENS
C
      READ(MDATA,*) THETA
      IF (THETA.LT.0D0) THETA=0D0
      IF (THETA.GT.1D0) THETA=1D0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Theta                    : THETA  = ', THETA
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Theta                    : THETA  = ', THETA
C
      READ(MDATA,*) TSTEP
      EPSNS=ABS(EPSNS)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Time step                : TSTEP  = ', TSTEP
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Time step                : TSTEP  = ', TSTEP
C
      READ(MDATA,*) IFRSTP
      IF (IFRSTP.NE.1) IFRSTP=0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Fractional step          : IFRSTP = ', IFRSTP
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Fractional step          : IFRSTP = ', IFRSTP
C
      READ(MDATA,*) INSAV
      IF (INSAV.LT.0) INSAV=0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Stepsize for nonsteady savings: INSAV = ', INSAV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Stepsize for nonsteady savings: INSAV = ', INSAV
C
      READ(MDATA,*) INSAVN
      IF (INSAVN.LT. 0) INSAVN=0
      IF (INSAVN.GT.10) INSAVN=10
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Number of files               : INSAVN = ',
     *  INSAVN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Number of files               : INSAVN = ',
     *  INSAVN
C
      READ(MDATA,*) DTFILM
      DTFILM=ABS(DTFILM)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Time step for Film            : DTFILM = ',
     *  DTFILM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Time step for Film            : DTFILM = ',
     *  DTFILM
      DTFILO=TIMENS
C
      READ(MDATA,*) DTAVS
      DTAVS=ABS(DTAVS)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Time step for AVS             : DTAVS = ',
     *  DTAVS
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Time step for AVS             : DTAVS = ',
     *  DTAVS
      DTAVSO=TIMENS
C
      READ(MDATA,*) DTGMV
      DTGMV=ABS(DTGMV)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Time step for GMV             : DTGMV = ',
     *  DTGMV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Time step for GMV             : DTGMV = ',
     *  DTGMV
      DTGMVO=TIMENS
C
      READ(MDATA,*) IFUSAV
      IFUSAV=MIN(IFUSAV,NLMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Level for velocity            : IFUSAV = ', 
     * IFUSAV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Level for velocity            : IFUSAV = ',
     *  IFUSAV
C
      READ(MDATA,*) IFPSAV
      IFPSAV=MIN(IFPSAV,NLMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Level for pressure            : IFPSAV = ',
     *  IFPSAV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Level for pressure            : IFPSAV = ',
     *  IFPSAV
C
      READ(MDATA,*) IFXSAV
      IFXSAV=MIN(IFXSAV,NLMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Level for streamlines         : IFXSAV = ',
     *  IFXSAV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Level for streamlines         : IFXSAV = ',
     *  IFXSAV
C
      READ(MDATA,*) IAVS
      IAVS=MIN(IAVS,NLMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Level for AVS                 : IAVS = ',
     *  IAVS
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Level for AVS                 : IAVS = ',
     *  IAVS
C
      READ(MDATA,*) IGMV
      IGMV=MIN(IGMV,NLMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Level for GMV                 : IGMV = ',
     *  IGMV
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Level for GMV                 : IGMV = ',
     *  IGMV
C
      READ(MDATA,*) IFINIT
      IFINIT=ABS(IFINIT)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Start file                    : IFINIT = ',
     *  IFINIT
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Start file                    : IFINIT = ',
     *  IFINIT
C
      READ(MDATA,*) IADTIM
      IF (ABS(IADTIM).GT.3) IADTIM=0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Type of adaptivity            : IADTIM = ',
     *  IADTIM
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Type of adaptivity            : IADTIM = ',
     *  IADTIM
C
      READ(MDATA,*) TIMEMX
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Max. Time                     : TIMEMX = ',
     *  TIMEMX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Max. Time                     : TIMEMX = ',
     *  TIMEMX
C
      READ(MDATA,*) DTMIN
      DTMIN=ABS(DTMIN)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Min. Timestep                 : DTMIN  = ',
     *  DTMIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Min. Timestep                 : DTMIN  = ',
     *  DTMIN
C
      READ(MDATA,*) DTMAX
      DTMAX=ABS(DTMAX)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Max. Timestep                 : DTMAX  = ',
     *  DTMAX
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Max. Timestep                 : DTMAX  = ',
     *  DTMAX
C
      READ(MDATA,*) DTFACT
      DTFACT=ABS(DTFACT)
      IF (DTFACT.LT.1D0) DTFACT=1D0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Max. Timestep change          : DTFACT = ',
     *  DTFACT
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Max. Timestep change          : DTFACT = ',
     *  DTFACT
C
      READ(MDATA,*) TIMEIN
      TIMEIN=ABS(TIMEIN)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Time for start procedure      : TIMEIN = ',
     *  TIMEIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Time for start procedure      : TIMEIN = ',
     *  TIMEIN
C
      READ(MDATA,*) EPSADI
      EPSADI=ABS(EPSADI)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'EPS for start procedure       : EPSADI = ',
     *  EPSADI
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'EPS for start procedure       : EPSADI = ',
     *  EPSADI
C
      READ(MDATA,*) EPSADL
      EPSADL=ABS(EPSADL)
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'EPS for acceptance            : EPSADL = ',
     *  EPSADL
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'EPS for acceptance            : EPSADL = ',
     *  EPSADL
C
      READ(MDATA,*) EPSADU
      EPSADU=ABS(EPSADU)
      IF (EPSADU.GT.1D0) EPSADU=1D0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'EPS for not acceptance        : EPSADU = ',
     *  EPSADU
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'EPS for not acceptance        : EPSADU = ',
     *  EPSADU
C
      READ(MDATA,*) IEPSAD
      IF ((IEPSAD.LT.0).OR.(IEPSAD.GT.8)) IEPSAD=1
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Acceptance criterion          : IEPSAD = ',
     *  IEPSAD
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Acceptance criterion          : IEPSAD = ',
     *  IEPSAD
C
      READ(MDATA,*) IADIN
      IF ((IADIN.LT.0).OR.(IADIN.GT.2)) IADIN=0
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Start procedure               : IADIN  = ',
     *  IADIN
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Start procedure               : IADIN  = ',
     *  IADIN
C
      READ(MDATA,*) IREPIT
      IF (IREPIT.LT.1) IREPIT=1
      IF (IREPIT.GT.9) IREPIT=9
      IF (MSHOW.GE.2) 
     * WRITE(MTERM,*) 'Max.numbers of repetitions    : IREPIT = ',
     *  IREPIT
      IF (MSHOW.GE.0) 
     * WRITE(MFILE,*) 'Max.numbers of repetitions    : IREPIT = ',
     *  IREPIT
C
C
C
      IF (ISTAT.EQ.0) THEN
       IAUSAV=INSAV
      ELSE
       IAUSAV=0
      ENDIF
C
      IMTIME=2
      TTMG =0D0
      TTS  =0D0
      TTE  =0D0
      TTD  =0D0
      TTP  =0D0
      TTR  =0D0
C
      TTGRID=0D0
      TTPOST=0D0
      TTADF =0D0
      TTUPW =0D0
      TTBDR =0D0
      TTLC  =0D0
C
C
      IF (ISTAT.EQ.0) THEN
       IADTIM=0
       TSTEP =1D0
       THETA =1D0
       IFRSTP=0
      ENDIF
C
      IF ((ISTAT.NE.0).AND.(IFRSTP.EQ.1)) THEN
       THETA =1D0-SQRT(0.5D0)
       THETAP=1D0-2D0*THETA
       FALPHA=THETAP/(1D0-THETA)
       FBETA =THETA /(1D0-THETA)
       THSTEP=3D0*TSTEP*FALPHA*THETA
      ELSE
       THSTEP=TSTEP*THETA
      ENDIF
C
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.0) WRITE(MFILE,1)
C
C=======================================================================
C     Point-value files
C=======================================================================
C
      OPEN (UNIT=40,FILE='#points/tf_0')
      OPEN (UNIT=41,FILE='#points/u1_0')
      OPEN (UNIT=42,FILE='#points/u2_0')
      OPEN (UNIT=43,FILE='#points/u3_0')
      OPEN (UNIT=44,FILE='#points/u4_0')
      OPEN (UNIT=45,FILE='#points/p1_0')
      OPEN (UNIT=46,FILE='#points/p2_0')
      OPEN (UNIT=47,FILE='#points/p3_0')
      OPEN (UNIT=48,FILE='#points/p4_0')
      OPEN (UNIT=49,FILE='#points/p5_0')
      OPEN (UNIT=50,FILE='#points/p6_0')
      OPEN (UNIT=51,FILE='#points/p7_0')
      OPEN (UNIT=52,FILE='#points/p8_0')
      OPEN (UNIT=53,FILE='#points/f1_0')
C
C
C
      END

************************************************************************
      PROGRAM  CC2D  
************************************************************************
*
*   Purpose: - solver for the stationary and nonstationary 
*              incompressible Navier Stokes equations via time adaptive 
*              fixed point defect correction
*              plus coupled multigrid for linear problems
*            - nonlinear iteration for Oseen equations:
*                   - fixed point defect correction as outer iteration
*                   - mg as solver for linear auxiliary Oseen problems
*                   - nonlinear parameter optimization for the 
*                     correction from the linear solver step
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      INCLUDE 'cc2d.inc'
C
      PARAMETER (NNARR=299,NNLEV=9,NNAB=21)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CDATA*60
C
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSADAT/ TIMEMX,DTMIN,DTMAX,DTFACT,TIMEIN,EPSADI,EPSADL,
     *                EPSADU,IEPSAD,IADIN,IREPIT,IADTIM
      COMMON /NSSAV/  INSAV,INSAVN
      COMMON /NSSAVF/ DTFILM,DTFILO,DTAVS,DTAVSO,DTGMV,DTGMVO,
     *                IFUSAV,IFPSAV,IFXSAV,IAVS,IGMV,IFINIT
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
      COMMON /NSCOUN/ NNONL,NMG
      COMMON /NSEXL/  ITEXL,LTML,TIML11,TIML12,TIML31,TIML32
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTIME/ TTMG,TTS,TTE,TTD,TTP,TTR,IMTIME
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C     E X T E R N A L S
C-----------------------------------------------------------------------
C *** Parametrization of the domain
      EXTERNAL PARX,PARY,TMAX
C *** Coefficient of exact solution
      EXTERNAL UE,PE,UEX,UEY
C *** definition of finite elements
      EXTERNAL E030,E031,EM30,EM31,E010
      EXTERNAL ZVALUE1
C=======================================================================
C     Initialization
C=======================================================================
      CALL ZTIME(TTTSUM)
C
      CALL ZTIME(TTT0)
      CALL ZINIT(NNWORK,'feat.msg','#data/CC2D.ERR','#data/CC2D.PRT',
     *                             '#data/CC2D.SYS','#data/CC2D.TRC') 
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      MDATA=79
      CDATA='#data/cc2d.dat'
      CALL  INIT1 (MDATA,CDATA,MFILE,MSHOW,IWORKG,IWMAXG)
      IWORKI=IWORK
      IWMAXI=IWMAX
C
      IFILEN=0
      ITFILM=IFINIT-1
      NSUBST=0
      NNONL =0
      NMG   =0
C
      TIMEST=TIMENS
      CALL ZTIME(TTT0)
C
      IF (ISTAT.NE.0) THEN
       ISETLV=2
       ILEV=NLMAX
       CALL  SETLEV (ISETLV)
C
       LRHS=0
       IF (IRHS.GE.1) THEN
        CALL ZNEW(NUP,1,LRHS  ,'DRHS  ')
        IF (IER.NE.0) GOTO 99998
        CALL LCP1(DWORK(KF1),DWORK(L(LRHS)),NUP)
       ENDIF
C
       CALL ZNEW(NUP,-1,LTM0  ,'DMT0  ')
       IF (IER.NE.0) GOTO 99998
C
       IF (ITEXL.NE.0) THEN
        CALL ZNEW(NUP,-1,LTML ,'DMTL  ')
        IF (IER.NE.0) GOTO 99998
        IF (ABS(IADTIM).EQ.3) THEN
         CALL ZNEW(NUP,-1,LTMLO,'DMTLO ')
         IF (IER.NE.0) GOTO 99998
         CALL LCP1(DWORK(KU1),DWORK(L(LTML)),NUP)
        ENDIF
       ENDIF
C
       IF (IADTIM.NE.0) THEN
        CALL ZNEW(NUP,-2,LTM3  ,'DMT3  ')
        IF (IER.NE.0) GOTO 99998
       ENDIF
      ENDIF
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Begin of nonsteady loop
C=======================================================================
C
C***********************************************************************
C *** NNITR = max number of repetitions for |IADAPT|=3
      NNITR=IREPIT
C***********************************************************************
C
      DO 100 ITNS=1,NITNS
      ITNSR=0
C
      IF (ISTAT.NE.0) THEN
       CALL ZTIME(TTT0)
       CALL LCP1(DWORK(KU1),DWORK(L(LTM0)),NUP)
       IF ((ITEXL.NE.0).AND.(ABS(IADTIM).EQ.3)) THEN
        CALL LCP1(DWORK(L(LTML)),DWORK(L(LTMLO)),NUP)
        TIMO31=TIML31
        TIMO32=TIML32
        TIMO11=TIML11
        TIMO12=TIML12
       ENDIF
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
      ENDIF
C
110   TSTEPO=    TSTEP
      TSTEP =3D0*TSTEPO
      TIMNSH=TIMENS
C
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
C
      IF (IADTIM.EQ.0) GOTO 120
C
C=======================================================================
C *** first time step: 1 step
C=======================================================================
C
      NITNSL=1
C
      CALL ZTIME(TTT0)
      IF (ITEXL.NE.0) THEN
       IF (ITNS.EQ.1) THEN
        ITEXL =-1
        CALL LCP1(DWORK(KU1),DWORK(L(LTML)),NUP)
       ELSE
        ITEXL = 1
        TIML11=TIML32
       ENDIF
      ENDIF
C
      IFRSTH=0
      IF ((NITNSL.EQ.1).AND.(IFRSTP.EQ.1)) THEN
       THETAH=THETA
       THETA =0.5D0
       IFRSTH=1
       IFRSTP=0
      ENDIF
C
      TSTEP=TSTEP/DBLE(NITNSL)
C
      IF (MSHOW.GE.2) WRITE(MTERM,2)
      IF (MSHOW.GE.2) WRITE(MTERM,2002) ITNS,TIMENS,TSTEP
      IF (MSHOW.GE.2) WRITE(MTERM,2)
      IF (MSHOW.GE.1) WRITE(MFILE,2)
      IF (MSHOW.GE.1) WRITE(MFILE,2002) ITNS,TIMENS,TSTEP
      IF (MSHOW.GE.1) WRITE(MFILE,2)
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      BSTOP=.FALSE.
      BNL1 =.FALSE.
      CALL MGSTP(MFILE,MSHOW,NITNSL,LRHS,BSTOP,BNL1)
      TSTEP=TSTEP*DBLE(NITNSL)
      NSUBST=NSUBST+NITNSL
C
      IF ((NITNSL.EQ.1).AND.(IFRSTH.EQ.1)) THEN
       THETA =THETAH
       IFRSTP=1
      ENDIF
C
      CALL ZTIME(TTT0)
      ISETLV=2
      ILEV=NLEV
      CALL  SETLEV (ISETLV)
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
      IF ((BSTOP).AND.(ITNSR.LE.NNITR)) THEN
       CALL ZTIME(TTT0)
       ITNSR=ITNSR+1
       CALL LCP1(DWORK(L(LTM0)),DWORK(KU1),NUP)
       IF ((ITEXL.NE.0).AND.(ABS(IADTIM).EQ.3)) THEN
        CALL LCP1(DWORK(L(LTMLO)),DWORK(L(LTML)),NUP)
        TIML31=TIMO31
        TIML32=TIMO32
        TIML11=TIMO11
        TIML12=TIMO12
       ENDIF
       TSTEPN=TSTEPO/SQRT(DTFACT)
       TSTEP=TSTEPN
       TIMENS=TIMNSH
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
       GOTO 110
      ENDIF
C
C
      CALL ZTIME(TTT0)
      DO 112 IUP=1,NUP
112   VWORK(L(LTM3)+IUP-1)=REAL(DWORK(KU1+IUP-1))
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      TIMENS=TIMNSH
C
C=======================================================================
C *** second time step: 3 steps
C=======================================================================
C
120   IF (ISTAT.NE.0) THEN
       CALL ZTIME(TTT0)
       CALL LCP1(DWORK(L(LTM0)),DWORK(KU1),NUP)
       NITNSL=3
C
       IF (ITEXL.NE.0) THEN
        IF (ITNS.EQ.1) THEN
         ITEXL=-3
         CALL LCP1(DWORK(KU1),DWORK(L(LTML)),NUP)
        ELSE
         ITEXL= 3
        ENDIF
       ENDIF
C
       TSTEP=TSTEP/DBLE(NITNSL)
       IF (MSHOW.GE.2) WRITE(MTERM,2)
       IF (MSHOW.GE.2) WRITE(MTERM,2001) ITNS,TIMENS,TSTEP
       IF (MSHOW.GE.2) WRITE(MTERM,2)
       IF (MSHOW.GE.1) WRITE(MFILE,2)
       IF (MSHOW.GE.1) WRITE(MFILE,2001) ITNS,TIMENS,TSTEP
       IF (MSHOW.GE.1) WRITE(MFILE,2)
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
      ELSE
       NITNSL=1
       TSTEP=1D0
      ENDIF
C
      BSTOP=.FALSE.
      BNL2 =.FALSE.
      CALL MGSTP(MFILE,MSHOW,NITNSL,LRHS,BSTOP,BNL2)
      IF (IER.NE.0) GOTO 99998
      TSTEP=TSTEP*DBLE(NITNSL)
      NSUBST=NSUBST+NITNSL
C
      IF ((ISTAT.EQ.0).OR.(IADTIM.EQ.0)) THEN
       TSTEP=TSTEPO
       GOTO 900
      ENDIF
C
      CALL ZTIME(TTT0)
      ISETLV=2
      ILEV=NLEV
      CALL  SETLEV (ISETLV)
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
      IF (((BSTOP).OR.(.NOT.BNL2)).AND.(ITNSR.LE.NNITR)) THEN
       IF (((.NOT.BSTOP).AND.(.NOT.BNL2)).AND.(ABS(IADTIM).EQ.1)) 
     *        GOTO 130
       CALL ZTIME(TTT0)
       ITNSR=ITNSR+1
       CALL LCP1(DWORK(L(LTM0)),DWORK(KU1),NUP)
       IF ((ITEXL.NE.0).AND.(ABS(IADTIM).EQ.3)) THEN
        CALL LCP1(DWORK(L(LTMLO)),DWORK(L(LTML)),NUP)
        TIML31=TIMO31
        TIML32=TIMO32
        TIML11=TIMO11
        TIML12=TIMO12
       ENDIF
       IF (.NOT.BNL2) TSTEPN=TSTEPO/SQRT(DTFACT)
       IF (BSTOP)     TSTEPN=TSTEPO/DTFACT
       TSTEP=TSTEPN
       TIMENS=TIMNSH
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
       GOTO 110
      ENDIF
C
C=======================================================================
C     Time step control
C=======================================================================
C
130   CALL ZTIME(TTT0)
      ISETLV=2
      ILEV=NLEV
      CALL  SETLEV (ISETLV)
C
      DO 132 IUP=1,NUP
132   DWORK(L(LD1)+IUP-1)=DWORK(KU1+IUP-1)-DBLE(VWORK(L(LTM3)+IUP-1))
C
C
      RELU21=0D0
      RELUM1=0D0
      RELP21=0D0
      RELPM1=0D0
C
      IF ((IEPSAD.GE.1).OR.(IEPSAD.EQ.-1)) THEN
       CALL LL21(DWORK(KU1)   ,2*NU,DSXN)
       RELU20=DSXN/(SQRT(DBLE(2*NU)))
       IF (RELU20.LE.1D0) RELU20=1D0
       CALL LL21(DWORK(L(LD1)),2*NU,DSXN)
       RELU21=DSXN/(SQRT(DBLE(2*NU))*RELU20)
      ENDIF
C
      IF ((IEPSAD.GE.1).OR.(IEPSAD.EQ.-2)) THEN
       CALL LLI1(DWORK(KU1   ),2*NU,DSXN,INDMAX)
       RELUM0=DSXN
       IF (RELUM0.LE.1D0) RELUM0=1D0
       CALL LLI1(DWORK(L(LD1)),2*NU,DSXN,INDMAX)
       RELUM1=DSXN/RELUM0
      ENDIF
C
      IF ((IEPSAD.GE.1).OR.(IEPSAD.EQ.-3)) THEN
       CALL LL21(DWORK(KU1   +2*NU),NP,DSXN)
       RELP20=DSXN/(SQRT(DBLE(NP)))
       IF (RELP20.LE.1D0) RELP20=1D0
       CALL LL21(DWORK(L(LD1)+2*NU),NP,DSXN)
       RELP21=DSXN/(SQRT(DBLE(NP))*RELP20)
      ENDIF
C
      IF ((IEPSAD.GE.1).OR.(IEPSAD.EQ.-4)) THEN
       CALL LLI1(DWORK(KU1   +2*NU),NP,DSXN,INDMAX)
       RELPM0=DSXN
       IF (RELPM0.LE.1D0) RELPM0=1D0
       CALL LLI1(DWORK(L(LD1)+2*NU),NP,DSXN,INDMAX)
       RELPM1=DSXN/RELPM0
      ENDIF
C
C
      IF (ABS(IEPSAD).EQ.1)  RELT1=RELU21
      IF (ABS(IEPSAD).EQ.2)  RELT1=RELUM1
      IF (ABS(IEPSAD).EQ.3)  RELT1=RELP21
      IF (ABS(IEPSAD).EQ.4)  RELT1=RELPM1
      IF (     IEPSAD.EQ.5)  RELT1=MAX(RELU21,RELP21)
      IF (     IEPSAD.EQ.6)  RELT1=MAX(RELUM1,RELPM1)
      IF (     IEPSAD.EQ.7)  RELT1=MAX(RELU21,RELUM1,RELP21,RELPM1)
      IF (     IEPSAD.EQ.8)  RELT1=MIN(RELU21,RELUM1,RELP21,RELPM1)
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C
      IF ((ABS(IADTIM).GE.1)) THEN
C
       CALL ZTIME(TTT0)
       CALL CRITAD(TIMEIN,TIMENS,TIMEST,EPSADI,EPSADL,EPSAD,IADIN)
C
      IF ((IFRSTP.NE.1).AND.(THETA.EQ.1D0)) THEN
        TSTEPN=TSTEPO*2D0*EPSAD/RELT1
        CTPROJ=2D0
       ELSE
        TSTEPN=TSTEPO*SQRT(8D0*EPSAD/RELT1)
        CTPROJ=8D0
       ENDIF
C
       IF ((ABS(IADTIM).GT.1)) THEN
        IF ((TSTEPN.GT.TSTEPO).AND.(.NOT.BNL1)) TSTEPN=TSTEPO
        IF ((TSTEPN.LT.TSTEPO/SQRT(DTFACT)).AND.(.NOT.BNL1)) 
     *       TSTEPN=TSTEPO/SQRT(DTFACT)
       ENDIF
C
       IF  (TSTEPN.LT.TSTEPO/DTFACT) TSTEPN=TSTEPO/DTFACT
C
       IF (ITNSR.GT.0) THEN
        HTFACT=DTFACT**(1D0/DBLE(ITNSR+1))
        IF (TSTEPN.GT.TSTEPO*HTFACT) TSTEPN=TSTEPO*HTFACT
       ELSE       
        IF (TSTEPN.GT.TSTEPO*DTFACT) TSTEPN=TSTEPO*DTFACT       
       ENDIF       
       IF (TSTEPN.LT.DTMIN) TSTEPN=DTMIN       
       IF (TSTEPN.GT.DTMAX) TSTEPN=DTMAX       
C
       ITYP=0
       DRELTN=TSTEPN/TSTEPO
       TSTEP =TSTEPN
       IF ((ABS(IADTIM).EQ.3).AND.(DRELTN.LT.EPSADU)) ITYP=1
C
      IF (MSHOW.GE.2) WRITE(MTERM,3)
      IF (MSHOW.GE.1) WRITE(MFILE,3)
      IF (MSHOW.GE.2) WRITE(MTERM,10002) TSTEPO,
     *    RELU21/CTPROJ,RELUM1/CTPROJ,RELP21/CTPROJ,RELPM1/CTPROJ
      IF (MSHOW.GE.1) WRITE(MFILE,10002) TSTEPO,
     *    RELU21/CTPROJ,RELUM1/CTPROJ,RELP21/CTPROJ,RELPM1/CTPROJ
C
      IF (MSHOW.GE.2) WRITE(MTERM,3001) ITYP,ITNS,TSTEPN,TSTEPO
      IF (MSHOW.GE.1) WRITE(MFILE,3001) ITYP,ITNS,TSTEPN,TSTEPO
      IF (MSHOW.GE.2) WRITE(MTERM,3)
      IF (MSHOW.GE.2) WRITE(MTERM,*)
      IF (MSHOW.GE.1) WRITE(MFILE,3)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
C
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
C
C
       IF ((ITYP.EQ.1).AND.(ITNSR.LE.NNITR)) THEN
        CALL ZTIME(TTT0)
        ITNSR=ITNSR+1
        CALL LCP1(DWORK(L(LTM0)),DWORK(KU1),NUP)
        IF ((ITEXL.NE.0).AND.(ABS(IADTIM).EQ.3)) THEN
         CALL LCP1(DWORK(L(LTMLO)),DWORK(L(LTML)),NUP)
         TIML31=TIMO31
         TIML32=TIMO32
         TIML11=TIMO11
         TIML12=TIMO12
        ENDIF
        TIMENS=TIMNSH
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
        GOTO 110
       ENDIF
C
C=======================================================================
C     Extrapolation step
C=======================================================================
C      
       CALL ZTIME(TTT0)
       IF ((IFRSTP.NE.1).AND.(THETA.EQ.1D0)) THEN
        EX1= 4D0/3D0
        EX2=-1D0/3D0
       ELSE
        EX1= 9D0/8D0
        EX2=-1D0/8D0
       ENDIF
C
       IF (((IADTIM.LT.-1).AND.(BNL1)).OR.(IADTIM.EQ.-1)) THEN
        DO 142 IUP=1,NUP
142     DWORK(KU1+IUP-1)= EX1*DWORK(KU1+IUP-1)
     *                   +EX2*DBLE(VWORK(L(LTM3)+IUP-1))
       ENDIF
C
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
C
      ENDIF
C
C=======================================================================
C
900   CALL ZTIME(TTT0)
      ISETLV=2
      ILEV=NLEV
      CALL  SETLEV (ISETLV)
C
C=======================================================================
C     Error handling
C=======================================================================
C
      IF (IERANA.GE.1)  THEN
       ICUBER=IERANA
       IF (IELT.EQ.0) 
     *  CALL ELPQU(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),E031,ICUBER,UE,UEX,UEY,MFILE)
       IF (IELT.EQ.1) 
     *  CALL ELPQU(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),E030,ICUBER,UE,UEX,UEY,MFILE)
       IF (IELT.EQ.2) 
     *  CALL ELPQN(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),EM31,ICUBER,UE,UEX,UEY,MFILE)
       IF (IELT.EQ.3) 
     *  CALL ELPQN(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             DWORK(L(LCORVG)),EM30,ICUBER,UE,UEX,UEY,MFILE)
C
       CALL ELPQP(DWORK(KP),DWORK(L(LDP)),KWORK(L(LVERT)),
     *            KWORK(L(LMID)),DWORK(L(LCORVG)),E010,ICUBER,PE,MFILE)
C
       IF (IERANA.NE.1) THEN
        ICUBER=1
        IF (IELT.EQ.0) 
     *   CALL ELPQU(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),
     *              KWORK(L(LMID)),DWORK(L(LCORVG)),E031,ICUBER,
     *              UE,UEX,UEY,MFILE)
        IF (IELT.EQ.1) 
     *   CALL ELPQU(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),
     *              KWORK(L(LMID)),DWORK(L(LCORVG)),E030,ICUBER,
     *              UE,UEX,UEY,MFILE)
        IF (IELT.EQ.2) 
     *   CALL ELPQN(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),
     *              KWORK(L(LMID)),DWORK(L(LCORVG)),EM31,ICUBER,
     *              UE,UEX,UEY,MFILE)
        IF (IELT.EQ.3) 
     *   CALL ELPQN(DWORK(KU1),DWORK(KU2),KWORK(L(LVERT)),
     *              KWORK(L(LMID)),DWORK(L(LCORVG)),EM30,ICUBER,
     *              UE,UEX,UEY,MFILE)
C
        CALL ELPQP(DWORK(KP),DWORK(L(LDP)),KWORK(L(LVERT)),
     *             KWORK(L(LMID)),DWORK(L(LCORVG)),E010,ICUBER,PE,MFILE)
       ENDIF
C
      ENDIF
C
      IFPOST=1
      CALL FPOST(IFPOST,IFILEN,ITFILM,UE,MFILE,MSHOW)
C
      CALL ZTIME(TTT1)
      TTPOST=TTPOST+TTT1-TTT0
C
C=======================================================================
C
      IF (ISTAT.EQ.0) GOTO 999
C
C=======================================================================
C
      CALL ZTIME(TTT0)
      CALL LCP1(DWORK(L(LTM0)),DWORK(L(LD1)),NUP)
      CALL LLC1(DWORK(KU1)    ,DWORK(L(LD1)),NUP,-1D0,1D0)
C
      RELU2=0D0
      RELP2=0D0
      RELUM=0D0
      RELPM=0D0
C
      CALL LL21(DWORK(L(LD1)),2*NU,DSXN)
      RELU2=DSXN/(SQRT(DBLE(2*NU))*3D0*TSTEPO)
      CALL LL21(DWORK(L(LD1)+2*NU),NP,DSXN)
      RELP2=DSXN/(SQRT(DBLE(NP))*3D0*TSTEPO)
C
      IF ((ABS(IEPSAD).EQ.2).OR.(IEPSAD.GE.5)) THEN
       CALL LLI1(DWORK(L(LD1)),2*NU,DSXN,INDMAX)
       RELUM=DSXN/(3D0*TSTEPO)
      ENDIF
C
      IF ((ABS(IEPSAD).EQ.4).OR.(IEPSAD.GE.5)) THEN
       CALL LLI1(DWORK(L(LD1)+2*NU),NP,DSXN,INDMAX)
       RELPM=DSXN/(3D0*TSTEPO)
      ENDIF
C
      IF (ABS(IEPSAD).EQ.1)  RELT=RELU2
      IF (ABS(IEPSAD).EQ.2)  RELT=RELUM
      IF (ABS(IEPSAD).EQ.3)  RELT=RELP2
      IF (ABS(IEPSAD).EQ.4)  RELT=RELPM
      IF (    IEPSAD .EQ.5)  RELT=MAX(RELU2,RELP2)
      IF (    IEPSAD .EQ.6)  RELT=MAX(RELUM,RELPM)
      IF (    IEPSAD .EQ.7)  RELT=MAX(RELU2,RELUM,RELP2,RELPM)
      IF (    IEPSAD .EQ.8)  RELT=MIN(RELU2,RELUM,RELP2,RELPM)
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      IF (MSHOW.GE.2) WRITE(MTERM,2)
      IF (MSHOW.GE.2) WRITE(MTERM,20001) ITNS,NSUBST,TIMENS,RELU2,RELP2,
     *                                   RELT
      IF (MSHOW.GE.2) WRITE(MTERM,2)
      IF (MSHOW.GE.2) WRITE(MTERM,*)
C
      IF (MSHOW.GE.1) WRITE(MFILE,2)
      IF (MSHOW.GE.0) WRITE(MFILE,20001) ITNS,NSUBST,TIMENS,RELU2,RELP2,
     *                                   RELT
      IF (MSHOW.GE.1) WRITE(MFILE,2)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
C
      IF ((RELT.LE.EPSNS).OR.(TIMENS.GE.TIMEMX)) GOTO 999
C
      CALL ZTIME(TTT1)
      TTTOTH=TTT1-TTTSUM
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'total time : ', TTTOTH
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'total time : ', TTTOTH
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'mavec time : ', TTADF
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'mavec time : ', TTADF
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'konv. time : ', TTUPW
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'konv. time : ', TTUPW
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'bdry  time : ', TTBDR
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'bdry  time : ', TTBDR
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'LC    time : ', TTLC
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'LC    time : ', TTLC
      IF (MSHOW.GE.3) WRITE(MTERM,*) 'MG    time : ', TTMG
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'MG    time : ', TTMG
C
100   CONTINUE
C
      ITNS=NITNS
C
C=======================================================================
C *** Postprocessing
C=======================================================================
C
999   CALL ZTIME(TTT0)
C
      IFPOST=0
      CALL FPOST(IFPOST,IFILEN,ITFILM,UE,MFILE,MSHOW)
C
      CALL ZTIME(TTT1)
      TTPOST=TTPOST+TTT1-TTT0
C
C=======================================================================
C     Statistics
C=======================================================================
C
      IF (MSHOW.GE.2) WRITE (MTERM,*)
      IF (MSHOW.GE.0) WRITE (MFILE,*)
      IF (MSHOW.GE.2) WRITE (MTERM,*) 'STATISTICS :'
      IF (MSHOW.GE.0) WRITE (MFILE,*) 'STATISTICS :'
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'NWORK :      ',NWORK
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'NWORK :      ',NWORK
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWORKG:      ',IWORKG
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWORKG:      ',IWORKG
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWMAXG:      ',IWMAXG
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWMAXG:      ',IWMAXG
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWORKI:      ',IWORKI
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWORKI:      ',IWORKI
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWMAXI:      ',IWMAXI
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWMAXI:      ',IWMAXI
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWORK :      ',IWORK
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWORK :      ',IWORK
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'IWMAX :      ',IWMAX
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'IWMAX :      ',IWMAX
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.0) WRITE(MFILE,1)
C
      CALL ZTIME(TTT1)
      TTTSUM=TTT1-TTTSUM
      TTTH  =TTGRID+TTPOST+TTADF+TTUPW+TTBDR+TTLC+TTMG
      TTLIN =TTADF+TTUPW+TTBDR+TTLC
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'total time : ', TTTSUM
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'total time : ', TTTSUM
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'appr. time : ', TTTH
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'appr. time : ', TTTH
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'grid  time : ', TTGRID
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'grid  time : ', TTGRID
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'post  time : ', TTPOST
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'post  time : ', TTPOST
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'lin.  time : ', TTLIN
      IF (MSHOW.GE.0) WRITE(MFILE,*) 'lin.  time : ', TTLIN
      IF (MSHOW.GE.2) WRITE(MTERM,*) '-> mavec time : ', TTADF
      IF (MSHOW.GE.0) WRITE(MFILE,*) '-> mavec time : ', TTADF
      IF (MSHOW.GE.2) WRITE(MTERM,*) '-> konv. time : ', TTUPW
      IF (MSHOW.GE.0) WRITE(MFILE,*) '-> konv. time : ', TTUPW
      IF (MSHOW.GE.2) WRITE(MTERM,*) '-> bdry  time : ', TTBDR
      IF (MSHOW.GE.0) WRITE(MFILE,*) '-> bdry  time : ', TTBDR
      IF (MSHOW.GE.2) WRITE(MTERM,*) '-> LC    time : ', TTLC
      IF (MSHOW.GE.0) WRITE(MFILE,*) '-> LC    time : ', TTLC
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) 'mg    time : ', TTMG
      IF (MSHOW.GE.1) WRITE(MFILE,*) 'mg    time : ', TTMG
C
      IF (MSHOW.GE.2) WRITE(MTERM,*) '#substeps  : ', NSUBST
      IF (MSHOW.GE.0) WRITE(MFILE,*) '#substeps  : ', NSUBST
      IF (MSHOW.GE.2) WRITE(MTERM,*) '#nonlinear : ', NNONL
      IF (MSHOW.GE.1) WRITE(MFILE,*) '#nonlinear : ', NNONL
      IF (MSHOW.GE.2) WRITE(MTERM,*) '#mg        : ', NMG
      IF (MSHOW.GE.1) WRITE(MFILE,*) '#mg        : ', NMG
      IF (MSHOW.GE.2) WRITE(MTERM,1)
      IF (MSHOW.GE.1) WRITE(MFILE,1)
C
      IF (MSHOW.GE.2) THEN
      WRITE(MTERM,*)
      WRITE(MTERM,*) ' MULTIGRID COMPONENTS [in percent]:'
      WRITE(MTERM,*) ' smoothing     :', 1.D2*TTS/TTMG
      WRITE(MTERM,*) ' solver        :', 1.D2*TTE/TTMG
      WRITE(MTERM,*) ' defect calc.  :', 1.D2*TTD/TTMG
      WRITE(MTERM,*) ' prolongation  :', 1.D2*TTP/TTMG
      WRITE(MTERM,*) ' restriction   :', 1.D2*TTR/TTMG
      WRITE(MTERM,1)
      ENDIF
C
      IF (MSHOW.GE.0) THEN
      WRITE(MFILE,*)
      WRITE(MFILE,*) ' MULTIGRID COMPONENTS [in percent]:'
      WRITE(MFILE,*) ' smoothing     :', 1.D2*TTS/TTMG
      WRITE(MFILE,*) ' solver        :', 1.D2*TTE/TTMG
      WRITE(MFILE,*) ' defect calc.  :', 1.D2*TTD/TTMG
      WRITE(MFILE,*) ' prolongation  :', 1.D2*TTP/TTMG
      WRITE(MFILE,*) ' restriction   :', 1.D2*TTR/TTMG
      WRITE(MFILE,1)
      ENDIF
C
      GOTO 99999
C=======================================================================
C     Error case
C=======================================================================
99998 WRITE(MTERM,*) 'IER', IER
      WRITE(MTERM,*) 'IN SUBROUTINE ',SUB
C
99999 CLOSE(MFILE)
C
C
C
   1  FORMAT(80('-'))
   2  FORMAT(80('$'))
   3  FORMAT(80('@'))
1000  FORMAT (6E12.5)
1001  FORMAT(' IT DIV-L2',3X,'RHOMGP')
1003  FORMAT(I3,2(D9.2))
2001  FORMAT('MACRO STEP ',I4,' AT TIME = ',D10.3,
     *       ' WITH 3 STEPS: DT3 = ',D10.3)
2002  FORMAT('MACRO STEP ',I4,' AT TIME = ',D10.3,
     *       ' WITH 1 STEP : DT1 = ',D10.3)
3001  FORMAT('CHOICE ',I2,'(',I4,')',1X,'   ---- NEW DT = ',D10.3,
     *       ' -- OLD DT = ',D10.3)
10002 FORMAT ('OLD DT=',D9.2,
     *        1X,'U(L2)=',D9.2,1X,'U(MX)=',D9.2,
     *        1X,'P(L2)=',D9.2,1X,'P(MX)=',D9.2)
10003 FORMAT ('OLD DT=',D9.2,
     *        1X,'FWREL=',D9.2,1X,'AWREL=',D9.2,
     *        1X,'FW3  =',D9.2,1X,'FA3  =',D9.2)
20001 FORMAT ('#',I4,1X,'(',I4,')',1X,'TIME=',D10.3,1X,'RELU(L2)=',
     *        D9.2,1X,'RELP(L2)=',D9.2,1X,'REL=',D9.2)
C
C
C
      END

      SUBROUTINE ELPQU(DU1,DU2,KVERT,KMID,DCORVG,ELE,ICUB,U,UX,UY,MFILE)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4)
      CHARACTER FMT*15,SUB*6,CPARAM*120
      DIMENSION DU1(*), DU2(*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      SAVE
C
      SUB='ELPQU'
      IER=0
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IF (IER.NE.0) GOTO 99999
      IDFL=NDFL(IELTYP)
      IF (IER.LT.0) GOTO 99999
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
      DO 1 IDER=1,NNDER
1     BDER(IDER)=.FALSE.
      BDER(1)=.TRUE.
      BDER(2)=.TRUE.
      BDER(3)=.TRUE.
C
      ERRL2= 0D0
      ERRH1= 0D0
      DIVL2= 0D0
      DIVLI=-1D0
      DNL2=  0D0
      DNH1=  0D0
      CALL ELE(0D0,0D0,-2)
C
      DO 100 IEL=1,NEL
C
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
      DO 110 IVE=1,NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
110   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
      DO 200 ICUBP=1,NCUBP
C
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C	
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C	
      OM=DOMEGA(ICUBP)*DETJ

      CALL ELE(XI1,XI2,-3)
      IF (IER.LT.0) GOTO 99999
C  
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1+0.5D0*
     *  (DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2   
C
      UH1 =0D0
      UH2 =0D0
      UH1X=0D0
      UH2X=0D0
      UH1Y=0D0
      UH2Y=0D0
      DO 210 JDOFE=1,IDFL
      IEQ=KDFG(JDOFE)
      ILO=KDFL(JDOFE)
      UH1 =UH1 +DU1(IEQ)*DBAS(ILO,1)
      UH2 =UH2 +DU2(IEQ)*DBAS(ILO,1)
      UH1X=UH1X+DU1(IEQ)*DBAS(ILO,2)
      UH2X=UH2X+DU2(IEQ)*DBAS(ILO,2)
      UH1Y=UH1Y+DU1(IEQ)*DBAS(ILO,3)
      UH2Y=UH2Y+DU2(IEQ)*DBAS(ILO,3)
210   CONTINUE
C
      ERRL2=ERRL2+OM*((U (XX,YY,1)-UH1 )**2+(U (XX,YY,2)-UH2 )**2)
      ERRH1=ERRH1+OM*((UX(XX,YY,1)-UH1X)**2+(UY(XX,YY,1)-UH1Y)**2)
      ERRH1=ERRH1+OM*((UX(XX,YY,2)-UH2X)**2+(UY(XX,YY,2)-UH2Y)**2)
      DIVL2=DIVL2+OM*(UH1X+UH2Y)**2
      DIVLI=MAX(DIVLI,ABS(UH1X+UH2Y))
      DNL2=DNL2+OM*(U (XX,YY,1)**2+U (XX,YY,2)**2)
      DNH1=DNH1+OM*(UX(XX,YY,1)**2+UY(XX,YY,1)**2)
      DNH1=DNH1+OM*(UX(XX,YY,2)**2+UY(XX,YY,2)**2)
C
200   CONTINUE
100   CONTINUE
C
      IF (DNL2.LT.1D-15) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '* ELPQU * EXACT SOLUTION ZERO !!!'
       WRITE(MFILE,*)
       WRITE(MFILE,*) '* ELPQU * EXACT SOLUTION ZERO !!!'
       DNL2=1D0
      ENDIF
C
      IF (DNH1.LT.1D-15) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '* ELPQU * EXACT DERIVATIVE ZERO !!!'
       WRITE(MFILE,*)
       WRITE(MFILE,*) '* ELPQU * EXACT DERIVATIVE ZERO !!!'
       DNH1=1D0
      ENDIF
C
c     IF (MT.GT.0) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '*ELPQU*REL. L2-H1-ERROR',
     *                 SQRT(ERRL2/DNL2),SQRT(ERRH1/DNH1),IELTYP,ICUB
       WRITE(MTERM,*) '*ELPQU*DIVERGENZ       ',SQRT(DIVL2),DIVLI
c      ENDIF
C
       IF (MTERM.NE.MFILE) THEN
        WRITE(MFILE,*)
        WRITE(MFILE,*) '*ELPQU*REL. L2-H1-ERROR',
     *                 SQRT(ERRL2/DNL2),SQRT(ERRH1/DNH1),IELTYP,ICUB
        WRITE(MFILE,*) '*ELPQU*DIVERGENZ       ',SQRT(DIVL2),DIVLI
       ENDIF
C
C
C
99999 END
C
C=======================================================================
C
      SUBROUTINE ELPQP(P,PERR,KVERT,KMID,DCORVG,ELE,ICUB,EP,MFILE)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4)
      CHARACTER FMT*15,SUB*6,CPARAM*120
      DIMENSION P(*),PERR(*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      SAVE
C
      SUB='ELPQP'
      IER=0
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IF (IER.NE.0) GOTO 99999
      IDFL=NDFL(IELTYP)
      IF (IER.LT.0) GOTO 99999
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
      DO 1 IDER=1,NNDER
1     BDER(IDER)=.FALSE.
      BDER(1)=.TRUE.
      BDER(2)=.FALSE.
      BDER(3)=.FALSE.
C
      ERRL2=0D0
      DNL2=0D0
      CALL ELE(0D0,0D0,-2)
C
      DO 100 IEL=1,NEL
C
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
      DO 110 IVE=1,NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
110   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
      DO 200 ICUBP=1,NCUBP
C
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C	
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C	
      OM=DOMEGA(ICUBP)*DETJ
C
      CALL ELE(XI1,XI2,-3)
      IF (IER.LT.0) GOTO 99999
C
C   
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1+0.5D0*
     *  (DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2   
C
      PH=0D0
      DO 210 JDOFE=1,IDFL
      IEQ=KDFG(JDOFE)
      ILO=KDFL(JDOFE)
      PH =PH +P(IEQ)*DBAS(ILO,1)
210   CONTINUE
C
C
      ERRL2=ERRL2+OM*(EP(XX,YY)-PH)**2
      DNL2 =DNL2 +OM* EP(XX,YY)**2
      PERR(IEQ)=ABS(EP(XX,YY)-PH)
C
200   CONTINUE
100   CONTINUE
C
      IF (DNL2.LT.1D-15) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '* ELPQP * EXACT SOLUTION ZERO !!!'
       WRITE(MFILE,*)
       WRITE(MFILE,*) '* ELPQP * EXACT SOLUTION ZERO !!!'
       DNL2=1D0
       DNH1=1D0
      ENDIF

c     IF (MT.GT.0) THEN
       WRITE(MTERM,*) '*ELPQP*REL. L2-ERROR   '
     *                 ,SQRT(ERRL2/DNL2),IELTYP,ICUB
       WRITE(MTERM,*)
c      ENDIF
C
       IF (MTERM.NE.MFILE) THEN
        WRITE(MFILE,*) '*ELPQP*REL. L2-ERROR   '
     *                  ,SQRT(ERRL2/DNL2),IELTYP,ICUB
        WRITE(MFILE,*)
       ENDIF
C
C
C
99999 END
C
C=======================================================================
C
      SUBROUTINE ELPQN(DU1,DU2,KVERT,KMID,DCORVG,ELE,ICUB,U,UX,UY,MFILE)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNCOF=6)
      CHARACTER FMT*15,SUB*6,CPARAM*120
      DIMENSION DU1(*), DU2(*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),DCORVG(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
      SAVE
C
      SUB='ELPQN'
      IER=0
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IF (IER.NE.0) GOTO 99999
      IDFL=NDFL(IELTYP)
      IF (IER.LT.0) GOTO 99999
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
      DO 1 IDER=1,NNDER
1     BDER(IDER)=.FALSE.
      BDER(1)=.TRUE.
      BDER(2)=.TRUE.
      BDER(3)=.TRUE.
C
      ERRL2= 0D0
      ERRH1= 0D0
      DIVL2= 0D0
      DIVLI=-1D0
      DNL2=  0D0
      DNH1=  0D0
C
      DO 100 IEL=1,NEL
C
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
      DO 110 IVE=1,NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
110   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
      CALL ELE(0D0,0D0,-2)
C
      DO 200 ICUBP=1,NCUBP
C
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C	
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C	
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1+0.5D0*
     *  (DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2   
C
      OM=DOMEGA(ICUBP)*DETJ
C
      CALL ELE(XX,YY,-3)
      IF (IER.LT.0) GOTO 99999
C  
      UH1 =0D0
      UH2 =0D0
      UH1X=0D0
      UH2X=0D0
      UH1Y=0D0
      UH2Y=0D0
      DO 210 JDOFE=1,IDFL
      IEQ=KDFG(JDOFE)
      ILO=KDFL(JDOFE)
      UH1 =UH1 +DU1(IEQ)*DBAS(ILO,1)
      UH2 =UH2 +DU2(IEQ)*DBAS(ILO,1)
      UH1X=UH1X+DU1(IEQ)*DBAS(ILO,2)
      UH2X=UH2X+DU2(IEQ)*DBAS(ILO,2)
      UH1Y=UH1Y+DU1(IEQ)*DBAS(ILO,3)
      UH2Y=UH2Y+DU2(IEQ)*DBAS(ILO,3)
210   CONTINUE
C
      ERRL2=ERRL2+OM*((U (XX,YY,1)-UH1 )**2+(U (XX,YY,2)-UH2 )**2)
      ERRH1=ERRH1+OM*((UX(XX,YY,1)-UH1X)**2+(UY(XX,YY,1)-UH1Y)**2)
      ERRH1=ERRH1+OM*((UX(XX,YY,2)-UH2X)**2+(UY(XX,YY,2)-UH2Y)**2)
      DIVL2=DIVL2+OM*(UH1X+UH2Y)**2
      DIVLI=MAX(DIVLI,ABS(UH1X+UH2Y))
      DNL2=DNL2+OM*(U (XX,YY,1)**2+U (XX,YY,2)**2)
      DNH1=DNH1+OM*(UX(XX,YY,1)**2+UY(XX,YY,1)**2)
      DNH1=DNH1+OM*(UX(XX,YY,2)**2+UY(XX,YY,2)**2)
C
200   CONTINUE
100   CONTINUE
C
      IF (DNL2.LT.1D-15) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '* ELPQN * EXACT SOLUTION ZERO !!!'
       WRITE(MFILE,*)
       WRITE(MFILE,*) '* ELPQN * EXACT SOLUTION ZERO !!!'
       DNL2=1D0
      ENDIF
C
      IF (DNH1.LT.1D-15) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '* ELPQN * EXACT DERIVATIVE ZERO !!!'
       WRITE(MFILE,*)
       WRITE(MFILE,*) '* ELPQN * EXACT DERIVATIVE ZERO !!!'
       DNH1=1D0
      ENDIF
C
c     IF (MT.GT.0) THEN
       WRITE(MTERM,*)
       WRITE(MTERM,*) '*ELPQN*REL. L2-H1-ERROR',
     *                 SQRT(ERRL2/DNL2),SQRT(ERRH1/DNH1),IELTYP,ICUB
       WRITE(MTERM,*) '*ELPQN*DIVERGENZ       ',SQRT(DIVL2),DIVLI
c      ENDIF
C
       IF (MTERM.NE.MFILE) THEN
        WRITE(MFILE,*)
        WRITE(MFILE,*) '*ELPQN*REL. L2-H1-ERROR',
     *                 SQRT(ERRL2/DNL2),SQRT(ERRH1/DNH1),IELTYP,ICUB
        WRITE(MFILE,*) '*ELPQN*DIVERGENZ       ',SQRT(DIVL2),DIVLI
       ENDIF
C
C
C
99999 END
C

************************************************************************
      SUBROUTINE MGSTP(MFILE,MSHOW,NITNSL,LRHS,BSTOP,BNLEND)
************************************************************************
*
*   Purpose: - performs 1 macro step of coupled method
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299, NNLEV=9,NNAB=21,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      PARAMETER (NBLOCF=2)
      DIMENSION BCONF(NBLOCF),ARRDF(NBLOCF),BSNGLF(NBLOCF)
      DIMENSION KFN(NBLOCF),KF(NNAB,NBLOCF),LF(NBLOCF)
      CHARACTER ARRDF*6
      DATA BCONF  /.FALSE.,.FALSE./,ARRDF/'DF1   ','DF2   '/
      DATA BSNGLF /.FALSE.,.FALSE./,KFN/1,1/
C
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for time discretization
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      COMMON /NSFRAC/ THETAP,FALPHA,FBETA,IFRSTP
      COMMON /NSSAV/  INSAV,INSAVN
      COMMON /NSSAVF/ DTFILM,DTFILO,DTAVS,DTAVSO,DTGMV,DTGMVO,
     *                IFUSAV,IFPSAV,IFXSAV,IAVS,IGMV,IFINIT
      COMMON /NSADAT/ TIMEMX,DTMIN,DTMAX,DTFACT,TIMEIN,EPSADI,EPSADL,
     *                EPSADU,IEPSAD,IADIN,IREPIT,IADTIM
      COMMON /NSTIME/ TTGRID,TTPOST,TTADF,TTUPW,TTBDR,TTLC
      COMMON /NSEXL/  ITEXL,LTML,TIML11,TIML12,TIML31,TIML32
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTIME/ TTMG,TTS,TTE,TTD,TTP,TTR,IMTIME
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGBDRY/ KLMBD(NNLEV),KLDBD(NNLEV),KNMBD(NNLEV),
     *                KLNPRO(NNLEV),INEUM
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
      SAVE
C
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C-----------------------------------------------------------------------
C     E X T E R N A L S
C-----------------------------------------------------------------------
C *** Parametrization of the domain
      EXTERNAL PARX,PARY,TMAX
C *** Coefficient of stiffness matrix, right hand side, exact solution
      EXTERNAL COEFFN,RHS,UE,PE,UEX,UEY
C *** definition of finite elements
      EXTERNAL E030,E031,EM31,EM30
C
C=======================================================================
C
      KF(1,1)=1
      KF(1,2)=1
C
C=======================================================================
C *** Begin of nonsteady loop
C=======================================================================
C
      DO 100 ITNSL=1,NITNSL
      CALL ZTIME(TTT0)
C
      ITMOD=MOD(ITNSL-1,3)+1
C
      ISETLV=2
      ILEV=NLEV
      CALL  SETLEV (ISETLV)
C
      IF (IFRSTP.EQ.1) THEN
       IF (ITMOD.EQ.2) THEN
        TSTEPH=3D0*TSTEP*THETAP
       ELSE
        TSTEPH=3D0*TSTEP*THETA
       ENDIF
      ELSE
       TSTEPH=TSTEP
      ENDIF
      TIMENS=TIMENS+TSTEPH
C
      IF (ISTAT.EQ.0) TIMENS=0D0     
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
C=======================================================================
C
      IF (ISTAT.NE.0) THEN
C
       CALL ZTIME(TTT0)
       IF (IFRSTP.EQ.1) THEN
        IF (ITMOD.EQ.2) THEN
         TSTEPB= 3D0*TSTEP*THETAP
         THSTEP=-3D0*TSTEP*FALPHA*THETAP
         TMSTEP= 3D0*TSTEP*FALPHA*THETA
         TRSTEP= 3D0*TSTEP*FBETA *THETAP
        ELSE
         TSTEPB= 3D0*TSTEP*THETA
         THSTEP=-3D0*TSTEP*FBETA*THETA
         TMSTEP= 3D0*TSTEP*FALPHA*THETA
         TRSTEP= 3D0*TSTEP*FALPHA*THETA
        ENDIF
       ELSE
        TSTEPB= TSTEP
        THSTEP= TSTEP*(THETA-1D0)
        TMSTEP= TSTEP*THETA
        TRSTEP= TSTEP*THETA
       ENDIF      
C
       IF (ITEXL.EQ.1) THEN
        TIML12=TIML11
        TIML11=TSTEPH
       ENDIF
C
       IF (ITEXL.EQ.3) THEN
        TIML32=TIML31
        TIML31=TSTEPH
       ENDIF       
C
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
C
C***********************************************************************
C
       CALL LLC1(DWORK(KP),DWORK(KP),NP,0D0,TSTEPH)
C
C***********************************************************************
C
       CALL ZTIME(TTT0)
       IF (IBDR.GE.2) THEN
        DO 10 ILEV=NLMIN,NLMAX
        NVT =KNVT(ILEV)
        NMT =KNMT(ILEV)
        NEL =KNEL(ILEV)
        NVBD=KNVBD(ILEV)
C
        CALL XLCP3(KLNPRO(ILEV),KLNPR(ILEV),NVT+NMT)
        IF (IER.NE.0) GOTO 99999
C
        NMBD =0
        INEUM=0
        KNMBD(ILEV)=0
        CALL ZDISP(0,KLMBD(ILEV),'KMBD  ')
        CALL ZDISP(0,KLDBD(ILEV),'DDBD  ')
        IF (IER.NE.0) GOTO 99999
        CALL ZNEW (NVBD,3,KLMBD(ILEV),'KMBD  ')
        CALL ZNEW (NVBD,1,KLDBD(ILEV),'DDBD  ')
        IF (IER.NE.0) GOTO 99999
C
        CALL BDRNEU(KWORK(L(KLMBD(ILEV))),KWORK(L(KLVBD(ILEV))),
     *              KWORK(L(KLEBD(ILEV))),KWORK(L(KLVERT(ILEV))),
     *              KWORK(L(KLMID(ILEV))),KWORK(L(KLNPR(ILEV))),
     *              DWORK(L(KLDBD(ILEV))),DWORK(L(KLMBDP(ILEV))),
     *              NMBD,INEUM)
        KNMBD(ILEV)=NMBD
C
10      CONTINUE
       ENDIF
C      
       CALL ZTIME(TTT1)
       TTBDR=TTBDR+TTT1-TTT0
C      
C***********************************************************************
C
       ISETLV=2
       ILEV=NLEV
       CALL SETLEV(ISETLV)
C
       CALL ZTIME(TTT0)
       IF (IRHS.EQ.0) THEN
        CALL LCL1(DWORK(KF1),NUP)
       ENDIF
C
       IF (IRHS.EQ.1) THEN
        CALL LLC1(DWORK(L(LRHS)),DWORK(KF1),NUP,TSTEPB,0D0)
       ENDIF
       CALL ZTIME(TTT1)
       TTLC=TTLC+TTT1-TTT0
C
       IF (IRHS.EQ.2) THEN
        CALL ZTIME(TTT0)
        CALL LLC1(DWORK(L(LRHS)),DWORK(KF1),NUP,-THSTEP,0D0)
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        IF (IBDR.GE.1) THEN
         TIMENS=TIMENS-TSTEPH
         CALL PDSET  (KWORK(L(KLVBD(NLEV))),KWORK(L(KLEBD(NLEV))),
     *                KWORK(L(KLVERT(NLEV))),KWORK(L(KLMID(NLEV))),
     *                KWORK(L(KLNPR(NLEV))),DWORK(L(LCORVG)),
     *                DWORK(L(KLMBDP(NLEV))),DWORK(KF1),DWORK(KF2),
     *                -THSTEP)
         TIMENS=TIMENS+TSTEPH
        ENDIF
        CALL ZTIME(TTT1)
        TTBDR=TTBDR+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        LF(1)=0
        LF(2)=0
        IF (IELT.EQ.0) 
     *   CALL  XVB0 (LF,NU,NBLOCF,ICLRF,E031,RHS,BCONF,KF,KFN,ICUBF,
     *               ARRDF,BSNGLF)
        IF (IELT.EQ.1) 
     *   CALL  XVB0 (LF,NU,NBLOCF,ICLRF,E030,RHS,BCONF,KF,KFN,ICUBF,
     *               ARRDF,BSNGLF)
        IF (IELT.EQ.2) 
     *   CALL  XVBM0(LF,NU,NBLOCF,ICLRF,EM31,RHS,BCONF,KF,KFN,ICUBF,
     *               ARRDF,BSNGLF)
        IF (IELT.EQ.3) 
     *   CALL  XVBM0(LF,NU,NBLOCF,ICLRF,EM30,RHS,BCONF,KF,KFN,ICUBF,
     *               ARRDF,BSNGLF)
        IF (IER.NE.0) GOTO 99999
        LF1=LF(1)
        LF2=LF(2)
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        IF (IBDR.GE.1) THEN
         CALL PDSET (KWORK(L(KLVBD(NLEV))),KWORK(L(KLEBD(NLEV))),
     *               KWORK(L(KLVERT(NLEV))),KWORK(L(KLMID(NLEV))),
     *               KWORK(L(KLNPR(NLEV))),DWORK(L(LCORVG)),
     *               DWORK(L(KLMBDP(NLEV))),DWORK(L(LF1)),DWORK(L(LF2)),
     *               TRSTEP)
        ENDIF
        CALL ZTIME(TTT1)
        TTBDR=TTBDR+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        CALL  LLC1 (DWORK(L(LF1)),DWORK(KF1),NU,TRSTEP,1D0)
        CALL  LLC1 (DWORK(L(LF2)),DWORK(KF2),NU,TRSTEP,1D0)
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        CALL BDRSET (DWORK(KF1),DWORK(KF2),DWORK(KF1),
     *               DWORK(KF2),KWORK(L(KLMBD(ILEV))),
     *               DWORK(L(KLDBD(ILEV))),KWORK(L(LNPR)),
     *               KNMBD(ILEV),NVT,PARX,PARY,UE)
        CALL ZTIME(TTT1)
        TTBDR=TTBDR+TTT1-TTT0
C
        CALL ZTIME(TTT0)
        CALL  LCP1 (DWORK(L(LF1)), DWORK(L(LRHS)),   NU)
        CALL  LCP1 (DWORK(L(LF2)), DWORK(L(LRHS)+NU),NU)
C
        CALL  ZDISP (0,LF1,ARRDF(1))
        CALL  ZDISP (0,LF2,ARRDF(2))
        IF (IER.NE.0) GOTO 99999
        CALL ZTIME(TTT1)
        TTLC=TTLC+TTT1-TTT0
       ENDIF
C
C***********************************************************************
C
       CALL ZTIME(TTT0)
       ISETLV=2
       ILEV=NLEV
       CALL  SETLEV (ISETLV)
C
       IF (IBDR.GE.1) THEN
        IF ((IFRSTP.EQ.1).AND.(ITMOD.EQ.2)) TIMENS=TIMENS-TSTEPH
        CALL PDSET (KWORK(L(KLVBD(NLEV))),KWORK(L(KLEBD(NLEV))),
     *              KWORK(L(KLVERT(NLEV))),KWORK(L(KLMID(NLEV))),
     *              KWORK(L(KLNPR(NLEV))),DWORK(L(LCORVG)),
     *              DWORK(L(KLMBDP(NLEV))),DWORK(KF1),DWORK(KF2),TSTEPB)
        IF ((IFRSTP.EQ.1).AND.(ITMOD.EQ.2)) TIMENS=TIMENS+TSTEPH
       ENDIF
       CALL ZTIME(TTT1)
       TTBDR=TTBDR+TTT1-TTT0
C
      CALL ZTIME(TTT0)
      CALL XMADF1(KM1,KST1,KA1,KCOLA,KLDA,KF1,KF2,KU1,KU2,NA,NU,THSTEP)
      CALL ZTIME(TTT1)
      TTADF=TTADF+TTT1-TTT0
ccc       DO 20 INU=1,NU
ccc       WRITE(6,*) INU,VWORK(KA1+KWORK(KLDA+INU-1)-1),
ccc     *            VWORK(KST1+KWORK(KLDA+INU-1)-1),VWORK(KM1+INU-1),
ccc     *            DWORK(KU1+INU-1),DWORK(KU2+INU-1),
ccc     *            DWORK(KF1+INU-1),DWORK(KF2+INU-1)
ccc 20    CONTINUE
C
C
       IF (THSTEP.NE.0D0) THEN
C
        CALL ZTIME(TTT0)
        THSTEP=-THSTEP
        IF (IUPW.EQ.1) THEN
         CALL GUPWD (DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *               1D0,0D0,DWORK(KU1),DWORK(KU2),
     *               DWORK(KF1),DWORK(KF2),VWORK(KA1),KWORK(KCOLA),
     *               KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *               DWORK(L(LCORVG)),2)
        ELSE
         IF (IELT.EQ.0) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),E031,COEFFN,2,-1D0)
         IF (IELT.EQ.1) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),E030,COEFFN,2,-1D0)
         IF (IELT.EQ.2) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),EM31,COEFFN,2,-1D0)
         IF (IELT.EQ.3) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),EM30,COEFFN,2,-1D0)
        ENDIF
        THSTEP=-THSTEP
        CALL ZTIME(TTT1)
        TTUPW=TTUPW+TTT1-TTT0
       ELSE
        IF ((IPRECA.EQ.4).AND.(IMASS.EQ.1)) THEN
         CALL ZTIME(TTT0)
         TOSTEP=THSTEP
         THSTEP=1D0
         IF (IELT.EQ.0) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *               DWORK(L(LCORVG)),E031,COEFFN,2,0D0)
         IF (IELT.EQ.1) 
     *    CALL SUPWDG(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),E030,COEFFN,2,0D0)
         IF (IELT.EQ.2) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),EM31,COEFFN,2,0D0)
         IF (IELT.EQ.3) 
     *    CALL SUPWNP(DWORK(KU1),DWORK(KU2),DWORK(KU1),DWORK(KU2),
     *                1D0,0D0,DWORK(KU1),DWORK(KU2),
     *                DWORK(KF1),DWORK(KF2),VWORK(KA1),NA,KWORK(KCOLA),
     *                KWORK(KLDA),KWORK(L(LVERT)),KWORK(L(LMID)),
     *                DWORK(L(LCORVG)),EM30,COEFFN,2,0D0)
        ENDIF
        THSTEP=TOSTEP
        CALL ZTIME(TTT1)
        TTUPW=TTUPW+TTT1-TTT0
       ENDIF
C
       CALL ZTIME(TTT0)
       CALL BDRSET (DWORK(KU1),DWORK(KU2),DWORK(KF1),
     *              DWORK(KF2),KWORK(L(KLMBD(ILEV))),
     *              DWORK(L(KLDBD(ILEV))),KWORK(L(LNPR)),
     *              KNMBD(ILEV),NVT,PARX,PARY,UE)
       CALL ZTIME(TTT1)
       TTBDR=TTBDR+TTT1-TTT0
C
       THSTEP=TMSTEP
C
      ENDIF
C
************************************************************************
C *** fixed point defect correction for stationary NS equations
C***********************************************************************
C
      CALL  NSDEF (MFILE,MSHOW,BSTOP,BNLEND)
      IF (IER.NE.0) GOTO 99999
C
      IF ((.NOT.BNLEND).AND.(ABS(IADTIM).GT.1)) RETURN
C
C=======================================================================
C *** Unexpected STOP !!!
C=======================================================================
      IF (BSTOP) RETURN
C
      CALL ZTIME(TTT0)
      ILEV=NLEV
      ISETLV=2
      CALL  SETLEV (ISETLV)
C
C***********************************************************************
C
      CALL LLC1(DWORK(KP),DWORK(KP),NP,0D0,1D0/TSTEPH)
C
C***********************************************************************
C
      CALL LL21(DWORK(KU1),2*NU,DSXN)
      RELU2=DSXN/SQRT(DBLE(NU))
      CALL LL21(DWORK(KU1+2*NU),NP,DSXN)
      RELP2=DSXN/SQRT(DBLE(NP))
      THSTEP=TSTEPH
C
      CALL ZTIME(TTT1)
      TTLC=TTLC+TTT1-TTT0
C
      IF (MSHOW.GE.2) WRITE(MTERM,3)
      IF (MSHOW.GE.2) WRITE(MTERM,10002) ITNSL,ITNS,TIMENS,RELU2,RELP2
      IF (MSHOW.GE.2) WRITE(MTERM,3)
      IF (MSHOW.GE.2) WRITE(MTERM,*)
C
      IF (MSHOW.GE.1) WRITE(MFILE,3)
      IF (MSHOW.GE.1) WRITE(MFILE,10002) ITNSL,ITNS,TIMENS,RELU2,RELP2
      IF (MSHOW.GE.1) WRITE(MFILE,3)
      IF (MSHOW.GE.1) WRITE(MFILE,*)
C
C=======================================================================
C *** Return if stationary calculation !!!
C=======================================================================
      IF (ISTAT.EQ.0) RETURN
C
100   CONTINUE
C
C
C
   1  FORMAT(80('-'))
   3  FORMAT(80('+'))
1000  FORMAT (6E12.5)
1001  FORMAT(' IT DIV-L2',3X,'RHOMGP')
1003  FORMAT(I4,2(D9.2))
10002 FORMAT ('#',I4,'(',I4,')',1X,'TIME=',D10.3,2X,'NORM(U)=',
     *        D14.7,2X,'NORM(P)=',D14.7)
C
C
C
99999 END

************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* XABM7                                                                *
*                                                                      *
* Purpose  Allocation of the blocks in vector DA , KOFF and COECON     *
*          Call of ABM7                                                *
*                                                                      *
* Subroutines/functions called  ABM7, ZNEW, ZDISP, ZLEN, ZTYPE, ZCLEAR *
*                                                                      *
* Version from  12/08/94                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* LA       I*4    Vector of numbers of the arrays                      *
*                 New arrays are allocated on DWORK for LA(IBLOC)=0    *
* LCOL     I*4    Numbers of the pointer arrays KCOL and KLD           *
* LLD      I*4    calculated by AP7                                    *
* ICLEAR   I*4    ICLEAR=1  all matrices are cleared                   *
* ARR      C*6    Names of blocks (for error messages only)            *
* BSNGL    L*4    NBLOC logical values                                 *
*                 .TRUE. means that corresponding array is converted   *
*                 to single precision after completion                 *
* For the description of the remaining parameters see AB07             *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* LA       I*4    Vector of numbers of arrays on DA                    *
* IER      I*4    Error indicator                                      *
*                 -114 Type of at least one array is not double prec.  *
*                 -115 Length of at least one array is < NA            *
*                                                                      *
************************************************************************
*                                                                      *
* ABM7                                                                 *
*                                                                      *
* Purpose  Calculation of NBLOC matrices corresponding to              *
*          bilinear forms  a(v,u)                                      *
*          Nonparametric quadrilateral elements                        *
*          Same trial and test functions                               *
*          Storage technique 7/8                                       *
*          Each matrix makes use of the same pointer vectors           *
*          Double precision version                                    *
*                                                                      *
* Subroutines/functions called NDFL, NDFGL, CB2Q                       *
*                                                                      *
* Version from  12/08/94                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* KCOL     I*4    Pointer vectors for each matrix on DA corresponding  *
* KLD      I*4    to storage technique 7/8 (calculated by AP7)         *
* NA       I*4    Number of elements per matrix                        *
* NEQ      I*4    Number of equations per matrix                       *
* NBLOC    I*4    Number of matrices stored on DA                      *
* KOFF     I*4    Matrix IBLOC starts at position KOFF(IBLOC)+1 on DA  *
* KVERT    I*4    Arrays describing the triangulation                  *
* KMID     I*4                                                         *
* DCORVG   R*8                                                         *
* ELE      SUBR   EXTERNAL SUBROUTINE - values of basis functions      *
* COEFF    R*8    EXTERNAL FUNCTION - coefficients of the bilinear form*
* BCON     LOG    BCON(IBLOC)=.TRUE. means constant coefficients in    *
*                 matrix IBLOC                                         *
* KAB      I*4    Pairs of multiindices occuring in the bilinear forms *
*                 specified separately for each matrix                 *
* KABN     I*4    Number of additive terms in each bilinear form       *
* ICUB     I*4    Number of cubature formula in CB2Q                   *
* ISYMM    I*4    0  storage technique 7                               *
*                 1  storage technique 8                               *
*                 2  storage technique 7 but for symmetric matrices    *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* DA       R*8    Calculated matrices                                  *
* IER      I*4    Error indicator                                      *
*                 -116 Wrong value in array KAB                        *
*                                                                      *
************************************************************************
C
      SUBROUTINE XABM7(LA,LCOL,LLD,NA,NEQ,NBLOC,ICLEAR,ELE,
     *                 COEFF,BCON,KAB,KABN,ICUB,ISYMM,ARR,BSNGL)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER ARR*12
C
      PARAMETER (NNARR=299,NNAB=21,NNDER=6)
      DIMENSION VWORK(1),KWORK(1)
      DIMENSION LA(*),KAB(2,NNAB,*),KABN(*),BCON(*),ARR(*),BSNGL(*)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(1)
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      EXTERNAL COEFF,ELE
      SAVE
C
      SUB='XABM7'
      IF (ICHECK.GE.997) CALL OTRC('XABM7 ','12/08/94')
      IER=0
C
      DO 1 IBLOC=1,NBLOC
      IF (LA(IBLOC).EQ.0) THEN
       CALL ZNEW(NA,1,LA(IBLOC),ARR(IBLOC))
       IF (IER.NE.0) GOTO 99999
      ELSE
C ***  Check input parameter
       CALL ZTYPE(LA(IBLOC),ITYPE)
       IF (ITYPE.NE.1) THEN
        WRITE (CPARAM,'(A6,I15)') ARR(IBLOC),IBLOC
        CALL WERR(-114,'XABM7 ')
        GOTO 99999
       ENDIF
       CALL ZLEN(LA(IBLOC),ILEN)
       IF (ILEN.LT.NA) THEN
        WRITE (CPARAM,'(A6,I15)') ARR(IBLOC),IBLOC
        CALL WERR(-115,'XABM7 ')
        GOTO 99999
       ENDIF
       IF (ICLEAR.EQ.1) CALL ZCLEAR(LA(IBLOC),ARR(IBLOC))
      ENDIF
1     CONTINUE
C
      CALL ZNEW(NBLOC,-3,LOFF,'KOFF  ')
      IF (IER.NE.0) GOTO 99999
      CALL ZNEW(NBLOC*NNDER**2,1,LOECON,'COECON')
      IF (IER.NE.0) GOTO 99999
C
      DO 2 IBLOC=1,NBLOC
      KWORK(L(LOFF)+IBLOC-1)=L(LA(IBLOC))-1
2     CONTINUE
C
      CALL ABM7(DWORK(1),KWORK(L(LCOL)),KWORK(L(LLD)),NA,NEQ,
     *          NBLOC,KWORK(L(LOFF)),KWORK(L(LVERT)),KWORK(L(LMID)),
     *          DWORK(L(LCORVG)),ELE,COEFF,
     *          BCON,DWORK(L(LOECON)),KAB,KABN,ICUB,ISYMM)
      IF (IER.NE.0) GOTO 99999
C
      CALL ZDISP(0,LOECON,'COECON')
      CALL ZDISP(0,LOFF,'KOFF  ')
C
      DO 3 IBLOC=NBLOC,1,-1
      IF (BSNGL(IBLOC)) THEN
       CALL ZCTYPE(2,LA(IBLOC),ARR(IBLOC))
       IF (IER.NE.0) GOTO 99999
      ENDIF
3     CONTINUE
C
99999 END
C
C
C
      SUBROUTINE ABM7(DA,KCOL,KLD,NA,NEQ,NBLOC,KOFF,KVERT,KMID,
     *                DCORVG,ELE,COEFF,BCON,COECON,
     *                KAB,KABN,ICUB,ISYMM)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNAB=21,NNCOF=6)
      DIMENSION KCOL(*),KVERT(NNVE,*),KMID(NNVE,*),KOFF(*)
      DIMENSION KLD(*),KDFG(NNBAS),KDFL(NNBAS),DA(*),DCORVG(2,*)
      DIMENSION BCON(*),KAB(2,NNAB,*),KABN(*),COECON(NNDER,NNDER,*)
      DIMENSION KENTRY(NNBAS,NNBAS)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     1                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
      EXTERNAL COEFF,ELE
      SAVE
C
      SUB='ABM7'
      IF (ICHECK.GE.997) CALL OTRC('ABM7  ','12/08/94')
C
C *** Preparation - evaluation of parameters
      IER=0
      BSYMM=ISYMM.GE.1
C *** Which derivatives of basis functions are needed?
      DO 1 I = 1,NNDER
1     BDER(I)=.FALSE.
      DO 2 IBLOC=1,NBLOC
      DO 3 I=1,KABN(IBLOC)
      DO 3 J=1,2
      I1=KAB(J,I,IBLOC)
      IF (I1.LE.0.OR.I1.GT.NNDER) THEN
       WRITE (CPARAM,'(I15)') IBLOC
       CALL WERR(-116,'AB07  ')
       GOTO 99999
      ENDIF
3     BDER(I1)=.TRUE.
2     CONTINUE
C *** Dummy call of ELE sets number of element
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IDFL=NDFL(IELTYP)
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
C
      BFIRST=.TRUE.
C *** Dummy call of COEFF for nonlinear problems
C *** COEFF must set BDER(IDER)=.TRUE. if derivative IDER is needed
      AUX=COEFF(0D0,0D0,-1,-1,0,BFIRST)
      BCON0=.TRUE.
C
      DO 4 IBLOC=1,NBLOC
      IF (BCON(IBLOC)) THEN
       DO 5 I=1,KABN(IBLOC)
       IA=KAB(1,I,IBLOC)
       IB=KAB(2,I,IBLOC)
5      COECON(IA,IB,IBLOC)=COEFF(0D0,0D0,IA,IB,IBLOC,BFIRST)
      ELSE
       BCON0=.FALSE.
      ENDIF
4     CONTINUE
C********************************************************************
C *** Calculation of the matrix - storage technique 7 or 8
C********************************************************************
C
C *** Loop over all elements
      JDOFE1=1
      DO 100 IEL=1,NEL
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
C *** Determine entry positions in matrix
      DO 110 JDOFE=1,IDFL
      ILD=KLD(KDFG(JDOFE))
      KENTRY(JDOFE,JDOFE)=ILD
      IF (BSYMM) JDOFE1=JDOFE
      JCOL0=ILD
      DO 111 IDOFE=JDOFE1,IDFL
      IF (IDOFE.EQ.JDOFE) GOTO 111
      IDFG=KDFG(IDOFE)
      DO 112 JCOL=JCOL0,NA
      IF (KCOL(JCOL).EQ.IDFG) GOTO 113
112   CONTINUE
113   JCOL0=JCOL+1
      KENTRY(JDOFE,IDOFE)=JCOL
111   CONTINUE
110   CONTINUE
C
C *** Evaluation of coordinates of the vertices
      DO 120 IVE = 1, NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
120   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
C *** Dummy call - ELE may save arithmetic operations
      CALL ELE(0D0,0D0,-2)
      IF (IER.LT.0) GOTO 99999
C
C *** Loop over all cubature points
      DO 200 ICUBP = 1,NCUBP
C
C *** Cubature points on the reference element
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C
C *** Jacobian of the bilinear mapping onto the reference element
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C
C *** Cubature points on the actual element + weights
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1+0.5D0*
     *         (DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2
      OM=DOMEGA(ICUBP)*DETJ
C
      CALL ELE(XX,YY,-3)
      IF (IER.LT.0) GOTO 99999
C
C *** Summing up over all pairs of multiindices
      BFIRST=.TRUE.
      DO 300 IBLOC=1,NBLOC
C
      DO 301 IALBET=1,KABN(IBLOC)
      IA=KAB(1,IALBET,IBLOC)
      IB=KAB(2,IALBET,IBLOC)
      IF (.NOT.BCON(IBLOC)) THEN
       AUX=COEFF(XX,YY,IA,IB,IBLOC,BFIRST)*OM
      ELSE
       AUX=COECON(IA,IB,IBLOC)*OM
      ENDIF
C
      DO 310 JDOFE=1,IDFL
      DB=DBAS(KDFL(JDOFE),IA)
      IF (BSYMM) JDOFE1=JDOFE
      DO 310 IDOFE=JDOFE1,IDFL
      JCOLB=KENTRY(JDOFE,IDOFE)+KOFF(IBLOC)
      DA(JCOLB)=DA(JCOLB)+DB*DBAS(KDFL(IDOFE),IB)*AUX
310   CONTINUE
301   CONTINUE
C
      BFIRST=.FALSE.
300   CONTINUE
C
200   CONTINUE
100   CONTINUE
C
      IF (ISYMM.GT.1) THEN
       DO 400 IBLOC=1,NBLOC
C
       DO 401 IROW=1,NEQ
       DO 402 ICOL=KLD(IROW)+1,KLD(IROW+1)-1
       J1=KCOL(ICOL)
       IF (J1.GE.IROW) GOTO 401
       DO 403 ICOL1=KLD(J1+1)-1,KLD(J1),-1
       IF (KCOL(ICOL1).EQ.IROW) GOTO 404
403    CONTINUE
       GOTO 402
404    ICOLB=ICOL+KOFF(IBLOC)
       ICOL1B=ICOL1+KOFF(IBLOC)
C ***  Elements ICOL and ICOL1 in block IBLOC
       DA(ICOLB)=DA(ICOL1B)
402    CONTINUE
401    CONTINUE
C
400    CONTINUE
      ENDIF
C
99999 END
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* XMABM7                                                               *
*                                                                      *
* Purpose  Calculate matrices corresponding to bilinear forms          *
*          (multigrid version)                                         *
*          Successive call of XABM7                                    *
*                                                                      *
* Subroutines/functions called  XABM7                                  *
*                                                                      *
* Version from  12/08/94                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* NLEV     I*4    Number of levels                                     *
*                 for which matrices are generated                     *
* KLA      I*4    NBLOC*NLEV numbers of arrays                         *
* KLCOL    I*4    NLEV numbers of pointer vectors                      *
* KLLD     I*4                                                         *
* NBLOC    I*4                                                         *
* ICLEAR   I*4                                                         *
* ELE      SUBR                                                        *
* COEFF    SUBR                                                        *
* BCON     L*4                                                         *
* KAB      I*4    See parameters of XAB07 and AB07                     *
* KABN     I*4                                                         *
* ICUB     I*4                                                         *
* ISYMM    I*4                                                         *
* CARR     C*6    Names of matrices for all levels                     *
* BSNGL    L*4    NBLOC*NLEV logical values                            *
*                 .TRUE. meand that corresponding array is converted   *
*                 to single precision after completion                 *
* Meshes on COMMON /MGTRD/ and /MGTRA/                                 *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* KLA      I*4    NBLOC*NLEV numbers of arrays on DA                   *
*                                                                      *
************************************************************************
C
      SUBROUTINE XMABM7(KLA,KLCOL,KLLD,KNA,KNEQ,NBLOC,ICLEAR,ELE,
     *                  COEFF,BCON,KAB,KABN,ICUB,ISYMM,CARR,BSNGL)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CARR*12
C
      PARAMETER (NNARR=299,NNAB=21,NNLEV=9)
      DIMENSION KLA(NBLOC,*),KLCOL(*),KLLD(*)
      DIMENSION KNA(*),KNEQ(*),KAB(2,NNAB,*),KABN(*),BCON(*)
      DIMENSION CARR(NBLOC,*),BSNGL(NBLOC,*)
      DIMENSION VWORK(1),KWORK(1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(1)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      EXTERNAL ELE,COEFF
      SAVE
C
      SUB='XMABM7'
      IF (ICHECK.GE.997) CALL OTRC('XMABM7','12/08/94')
      IER=0
C
C
      DO 10 ILEV=NLMIN,NLMAX
C
      NEL =KNEL(ILEV)
      NVT =KNVT(ILEV)
      NMT =KNMT(ILEV)
      NVEL=KNVEL(ILEV)
      NVBD=KNVBD(ILEV)
C
      LCORVG=KLCVG(ILEV)
      LCORMG=KLCMG(ILEV)
      LVERT =KLVERT(ILEV)
      LMID  =KLMID(ILEV)
      LADJ  =KLADJ(ILEV)
      LVEL  =KLVEL(ILEV)
      LMEL  =KLMEL(ILEV)
      LNPR  =KLNPR(ILEV)
      LMM   =KLMM(ILEV)
      LVBD  =KLVBD(ILEV)
      LEBD  =KLEBD(ILEV)
      LBCT  =KLBCT(ILEV)
      LVBDP =KLVBDP(ILEV)
      LMBDP =KLMBDP(ILEV)
C
      CALL XABM7(KLA(1,ILEV),KLCOL(ILEV),KLLD(ILEV),KNA(ILEV),
     *           KNEQ(ILEV),NBLOC,ICLEAR,ELE,COEFF,BCON,
     *           KAB,KABN,ICUB,ISYMM,CARR(1,ILEV),BSNGL(1,ILEV))
      IF (IER.NE.0) GOTO 99999
C
10    CONTINUE
C     
99999 END
C
C
C
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* XMAB09                                                               *
*                                                                      *
* Purpose  Calculate matrices corresponding to bilinear forms          *
*          (multigrid version)                                         *
*          Successive call of XAB09                                    *
*                                                                      *
* Subroutines/functions called  XAB09                                  *
*                                                                      *
* Version from  07/21/92                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* NLEV     I*4    Number of levels                                     *
*                 for which matrices are generated                     *
* KLA      I*4    NBLOC*NLEV numbers of arrays                         *
* KLCOL    I*4    NLEV numbers of pointer vectors                      *
* KLLD     I*4                                                         *
* NBLOC    I*4                                                         *
* ICLEAR   I*4                                                         *
* ELE1     SUBR                                                        *
* ELE2     SUBR                                                        *
* ELE3     SUBR                                                        *
* COEFF    SUBR                                                        *
* BCON     L*4                                                         *
* KAB      I*4    See parameters of XAB07 and AB07                     *
* KABN     I*4                                                         *
* ICUB     I*4                                                         *
* CARR     C*6    Names of matrices for all levels                     *
* BSNGL    L*4    NBLOC*NLEV logical values                            *
*                 .TRUE. meand that corresponding array is converted   *
*                 to single precision after completion                 *
* Meshes on COMMON /MGTRD/ and /MGTRA/                                 *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* KLA      I*4    NBLOC*NLEV numbers of arrays on DA                   *
*                                                                      *
************************************************************************
C
      SUBROUTINE XMAB09(KLA,KLCOL,KLLD,KNA,NBLOC,ICLEAR,ELE1,ELE2,ELE3,
     *                  COEFF,BCON,KAB,KABN,ICUB,CARR,BSNGL)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CARR*6
C
      PARAMETER (NNARR=299,NNAB=21,NNLEV=9)
      DIMENSION KLA(NBLOC,*),KLCOL(*),KLLD(*)
      DIMENSION KNA(*),KAB(2,NNAB,*),KABN(*),BCON(*)
      DIMENSION CARR(NBLOC,*),BSNGL(NBLOC,*)
      DIMENSION VWORK(1),KWORK(1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(1)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      EXTERNAL ELE1,ELE2,ELE3,COEFF
      SAVE
C
      SUB='XMAB09'
      IF (ICHECK.GE.997) CALL OTRC('XMAB09','07/21/92')
      IER=0
C
C
      DO 10 ILEV=NLMIN,NLMAX
C
      NEL =KNEL(ILEV)
      NVT =KNVT(ILEV)
      NMT =KNMT(ILEV)
      NVEL=KNVEL(ILEV)
      NVBD=KNVBD(ILEV)
C
      LCORVG=KLCVG(ILEV)
      LCORMG=KLCMG(ILEV)
      LVERT =KLVERT(ILEV)
      LMID  =KLMID(ILEV)
      LADJ  =KLADJ(ILEV)
      LVEL  =KLVEL(ILEV)
      LMEL  =KLMEL(ILEV)
      LNPR  =KLNPR(ILEV)
      LMM   =KLMM(ILEV)
      LVBD  =KLVBD(ILEV)
      LEBD  =KLEBD(ILEV)
      LBCT  =KLBCT(ILEV)
      LVBDP =KLVBDP(ILEV)
      LMBDP =KLMBDP(ILEV)
C
      CALL XAB09(KLA(1,ILEV),KLCOL(ILEV),KLLD(ILEV),KNA(ILEV),
     *           NBLOC,ICLEAR,ELE1,ELE2,ELE3,COEFF,BCON,
     *           KAB,KABN,ICUB,CARR(1,ILEV),BSNGL(1,ILEV))
      IF (IER.NE.0) GOTO 99999
C
10    CONTINUE
C     
99999 END
c
c
c
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* XMAP9                                                                *
*                                                                      *
* Purpose  Calculate pointer vectors                                   *
*          (multigrid version)                                         *
*          Successive call of XAP9                                     *
*                                                                      *
* Subroutines/functions called  XAP9                                   *
*                                                                      *
* Version from  07/21/92                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* NLEV     I*4    Number of levels                                     *
* ELE      SUBR                                                        *
* ISYMM    I*4                                                         *
* Meshes on COMMON /MGTRD/ and /MGTRA/                                 *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* KNA      I*4    Number of entries for each level                     *
* KNEQ     I*4    Number of unknowns for each level                    *
* IER      I*4    Error indicator                                      *
*                 Set by ZNEW                                          *
*                                                                      *
************************************************************************
      SUBROUTINE XMAP9(KLCOL,KLLD,KNA,KNEQ,ELE1,ELE2)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      PARAMETER (NNARR=299,NNLEV=9)
      DIMENSION KLCOL(*),KLLD(*),KNA(*),KNEQ(*)
      DIMENSION VWORK(1),KWORK(1)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(1)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C
      SUB='XMAP9 '
      IF (ICHECK.GE.997) CALL OTRC('XMAP9 ','07/21/92')
      IER=0
C
      DO 10 ILEV=NLMIN,NLMAX
C
      NEL =KNEL(ILEV)
      NVT =KNVT(ILEV)
      NMT =KNMT(ILEV)
      NVEL=KNVEL(ILEV)
      NVBD=KNVBD(ILEV)
C
      LCORVG=KLCVG(ILEV)
      LCORMG=KLCMG(ILEV)
      LVERT =KLVERT(ILEV)
      LMID  =KLMID(ILEV)
      LADJ  =KLADJ(ILEV)
      LVEL  =KLVEL(ILEV)
      LMEL  =KLMEL(ILEV)
      LNPR  =KLNPR(ILEV)
      LMM   =KLMM(ILEV)
      LVBD  =KLVBD(ILEV)
      LEBD  =KLEBD(ILEV)
      LBCT  =KLBCT(ILEV)
      LVBDP =KLVBDP(ILEV)
      LMBDP =KLMBDP(ILEV)
C
      CALL XAP9(KLCOL(ILEV),KLLD(ILEV),KNA(ILEV),KNEQ(ILEV),ELE1,ELE2)
      IF (IER.NE.0) GOTO 99999
C     
10    CONTINUE
C     
99999 END
c
c
c
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* XMSB2                                                                *
*                                                                      *
* Purpose  Generate sequence of meshes for multigrid applications      *
*          by successive calls of XSB0X  (two-level ordering)          *
*                                                                      *
* Subroutines/functions called  XSB0X, WERR, ZCPY                      *
*                                                                      *
* Version from  05/11/91                                               *
*                                                                      *
* INPUT    TYPE                                                        *
* -----    ----                                                        *
* NLEV     I*4    desired number of l                                  *
* IMID     I*4                                                         *
* IADJ     I*4                                                         *
* IVEL     I*4                                                         *
* IDISP    I*4                                                         *
* IBDP     I*4     See parameter list of XSB0X                         *
* S2DI     SUBR                                                        *
* S2DB     SUBR                                                        *
* PARX     FNCT                                                        *
* PARY     FNCT                                                        *
* TMAX     FNCT                                                        *
* Coarse grid on /TRIAD and /TRIAA/                                    *
*                                                                      *
* OUTPUT   TYPE                                                        *
* ------   ----                                                        *
* DCORVG   R*8   Cartesian coordinates of vertices                     *                                                                      *                                                                      *
************************************************************************
C
      SUBROUTINE XMSB2(IMID,IADJ,IVEL,IDISP,IBDP,
     *                 S2DI,S2DB,PARX,PARY,TMAX)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      EXTERNAL S2DI,S2DB,PARX,PARY,TMAX
      SAVE 
C
      SUB='XMSB2 '
      IF (ICHECK.GE.997) CALL OTRC('XMSB2 ','11/05/91')
C
      NLEV=NLMAX
C
      IF (NLEV.GT.NNLEV) THEN
       CALL WERR(-180,'XMSB2 ')
       GOTO 99999
      ENDIF
C
C
      IADJ0=1
      IBDP0=2
C
C
      DO 10 ILEV=1,NLEV
      IF (ILEV.EQ.NLEV) THEN
       IADJ0=IADJ
       IBDP0=IBDP
      ENDIF
      IF (ILEV.EQ.1) THEN
       CALL XSB0X(0,IMID,IADJ0,IVEL,IDISP,IBDP0,
     *            S2DI,S2DB,PARX,PARY,TMAX)
      ELSE
       CALL XSB0X(1,IMID,IADJ0,IVEL,IDISP,IBDP0,
     *            S2DI,S2DB,PARX,PARY,TMAX)
      ENDIF
C
************************************************************************
C
C      GREPS=0.20D0
C      IF (ILEV.EQ.NLEV) CALL GRDIST(DWORK(L(LCORVG)),KWORK(L(LNPR)),
C     *                              NVT,GREPS)
C
************************************************************************
C
      IF (ILEV.GE.2) 
     * CALL CHCOOR(DWORK(L(LCORVG)),KWORK(L(LVERT)),KWORK(L(LMID)),
     *             KWORK(L(LADJ)),KWORK(L(LNPR)),NEL,NVT)
************************************************************************
C
      IF (ILEV.GE.NLMIN) THEN
C
C *** Save dimensions for all levels between NLMIN and NLMAX
C
      KNEL(ILEV) =NEL
      KNVT(ILEV) =NVT
      KNMT(ILEV) =NMT
      KNVEL(ILEV)=NVEL
      KNVBD(ILEV)=NVBD     
C
C
C *** Save arrays for all levels between NLMIN and NLMAX
C
C
      IF (ILEV.LT.NLEV) THEN
C
C       CALL ZCPY(LCORVG,'DCORVG',KLCVG(ILEV),'DCVG0 ')
C       IF (IER.NE.0) GOTO 99999
       IF (LCORMG.NE.0) THEN
        CALL ZCPY(LCORMG,'DCORMG',KLCMG(ILEV),'DCMG0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       CALL ZCPY(LVERT,'KVERT ',KLVERT(ILEV),'KVERT0')
       IF (IER.NE.0) GOTO 99999
       IF (LMID.NE.0) THEN
        CALL ZCPY(LMID,'KMID  ',KLMID(ILEV),'KMID0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       IF (IADJ.EQ.1) THEN
        CALL ZCPY(LADJ,'KADJ  ',KLADJ(ILEV),'KADJ0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       IF (LVEL.NE.0) THEN
        CALL ZCPY(LVEL,'KVEL  ',KLVEL(ILEV),'KVEL0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       IF (LMEL.NE.0) THEN
        CALL ZCPY(LMEL,'KMEL  ',KLMEL(ILEV),'KMEL0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       CALL ZCPY(LNPR,'KNPR  ',KLNPR(ILEV),'KNPR0 ')
       IF (IER.NE.0) GOTO 99999
       CALL ZCPY(LMM,'KMM   ',KLMM(ILEV),'KMM0  ')
       IF (IER.NE.0) GOTO 99999
       IF (IBDP.GE.0) THEN
        CALL ZCPY(LVBD,'KVBD  ',KLVBD(ILEV),'KVBD0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       IF (IBDP.GE.1) THEN
       CALL ZCPY(LEBD,'KEBD  ',KLEBD(ILEV),'KEBD0 ')
       IF (IER.NE.0) GOTO 99999
       ENDIF
       CALL ZCPY(LBCT,'KLBCT ',KLBCT(ILEV),'KBCT0 ')
       IF (IER.NE.0) GOTO 99999
       IF (IBDP.GE.2) THEN
        CALL ZCPY(LVBDP,'DVBDP ',KLVBDP(ILEV),'DVBDP0')
        IF (IER.NE.0) GOTO 99999
       ENDIF
       IF (IBDP.GE.2.AND.LMBDP.NE.0) THEN
        CALL ZCPY(LMBDP,'DMBDP ',KLMBDP(ILEV),'DMBDP0')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
      ELSE
C
       KLCVG(ILEV) =LCORVG
       KLCMG(ILEV) =LCORMG
       KLVERT(ILEV)=LVERT
       KLMID(ILEV) =LMID
       KLADJ(ILEV) =LADJ
       KLVEL(ILEV) =LVEL
       KLMEL(ILEV) =LMEL
       KLNPR(ILEV) =LNPR
       KLMM(ILEV)  =LMM
       KLVBD(ILEV) =LVBD
       KLEBD(ILEV) =LEBD
       KLBCT(ILEV) =LBCT
       KLVBDP(ILEV)=LVBDP
       KLMBDP(ILEV)=LMBDP
C
      ENDIF
C
      DO 20 ILEVH=1,NLEV-1
      KLCVG(ILEVH)=LCORVG
20    CONTINUE
C
      ENDIF
C
10    CONTINUE
C
C
99999 END
C
C
C
************************************************************************
C
      SUBROUTINE XMORS2(IRMESH)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CTRIF(NNLEV)*15
C
      DATA CTRIF/ '#tries/#tria1  ','#tries/#tria2  ','#tries/#tria3  ',
     *            '#tries/#tria4  ','#tries/#tria5  ','#tries/#tria6  ',
     *            '#tries/#tria7  ','#tries/#tria8  ','#tries/#tria9  '/
C
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      SAVE 
C
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C
      SUB='XMORS2'
      IF (ICHECK.GE.997) CALL OTRC('XMORS2','06/05/95')
C
C
C
      NLEV=NLMAX
C
      IF (IRMESH.GT.1) THEN
       IFMT=1
      ELSE
       IFMT=0
      ENDIF
C 
      DO 10 ILEV=NLMIN,NLMAX
C
C *** Read refined mesh in file CTRIF(ILEV) with format IFMT
      CALL XORS(65,CTRIF(ILEV),IFMT)
      REWIND(65)
      CLOSE(65)
C
C *** Save dimensions for all levels between NLMIN and NLMAX
      KNEL(ILEV) =NEL
      KNVT(ILEV) =NVT
      KNMT(ILEV) =NMT
      KNVEL(ILEV)=NVEL
      KNVBD(ILEV)=NVBD     
C
C
C *** Save arrays for all levels between NLMIN and NLMAX
      IF (ILEV.LT.NLMAX) THEN
C
       IF (LCORMG.NE.0) THEN
        CALL ZCPY(LCORMG,'DCORMG',KLCMG(ILEV),'DCMG0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       CALL ZCPY(LVERT,'KVERT ',KLVERT(ILEV),'KVERT0')
       IF (IER.NE.0) GOTO 99999
C
       IF (LMID.NE.0) THEN
        CALL ZCPY(LMID,'KMID  ',KLMID(ILEV),'KMID0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (LADJ.NE.0) THEN
        CALL ZCPY(LADJ,'KADJ  ',KLADJ(ILEV),'KADJ0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (LVEL.NE.0) THEN
        CALL ZCPY(LVEL,'KVEL  ',KLVEL(ILEV),'KVEL0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (LMEL.NE.0) THEN
        CALL ZCPY(LMEL,'KMEL  ',KLMEL(ILEV),'KMEL0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       CALL ZCPY(LNPR,'KNPR  ',KLNPR(ILEV),'KNPR0 ')
       IF (IER.NE.0) GOTO 99999
C
       CALL ZCPY(LMM,'KMM   ',KLMM(ILEV),'KMM0  ')
       IF (IER.NE.0) GOTO 99999
C
       IF (LVBD.NE.0) THEN
        CALL ZCPY(LVBD,'KVBD  ',KLVBD(ILEV),'KVBD0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (LEBD.NE.0) THEN
        CALL ZCPY(LEBD,'KEBD  ',KLEBD(ILEV),'KEBD0 ')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       CALL ZCPY(LBCT,'KLBCT ',KLBCT(ILEV),'KBCT0 ')
       IF (IER.NE.0) GOTO 99999
C
       IF (LVBDP.NE.0) THEN
        CALL ZCPY(LVBDP,'DVBDP ',KLVBDP(ILEV),'DVBDP0')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
       IF (LMBDP.NE.0) THEN
        CALL ZCPY(LMBDP,'DMBDP ',KLMBDP(ILEV),'DMBDP0')
        IF (IER.NE.0) GOTO 99999
       ENDIF
C
C
      ELSE
C
C
       KLCVG(ILEV) =LCORVG
       KLCMG(ILEV) =LCORMG
       KLVERT(ILEV)=LVERT
       KLMID(ILEV) =LMID
       KLADJ(ILEV) =LADJ
       KLVEL(ILEV) =LVEL
       KLMEL(ILEV) =LMEL
       KLNPR(ILEV) =LNPR
       KLMM(ILEV)  =LMM
       KLVBD(ILEV) =LVBD
       KLEBD(ILEV) =LEBD
       KLBCT(ILEV) =LBCT
       KLVBDP(ILEV)=LVBDP
       KLMBDP(ILEV)=LMBDP
C
      ENDIF
C
10    CONTINUE
C
      DO 20 ILEV=1,NLMAX-1
      KLCVG(ILEV)=LCORVG
20    CONTINUE
C
C
C
99999 END
C
C
C
************************************************************************
* FINITE ELEMENT ANALYSIS TOOLBOX  FEAT  (Release 1.3)                 *
*                                                                      *
* Authors: H. Blum, J. Harig, S. Mueller, S. Turek                     *
*          Institute of Applied Mathematics                            *
*          University of Heidelberg                                    *
*          D-6900 HEIDELBERG                                           *
*                                                                      *
************************************************************************
*                                                                      *
* ORALCn                                                               *
*                                                                      *
* Purpose  Get arrays from file, previously stored by XOWA or OWAn     *
*                                                                      *
* Subroutines/functions called  ORALC0                                 *
*                                                                      *
* Version from  10/11/94                                               *
*                                                                      *
* INPUT   TYPE                                                         *
* -----    ----                                                        *
* MFILE   I*4    I/O unit - previouly opened (by OF0)                  *
* IFMT    I*4    0  Format free input                                  *
*                1  Formatted input                                    *
* A1      R*8    Scaling factor: DX=DX+A1*DX(readin)                   *
*                                                                      *
* OUTPUT  TYPE                                                         *
* ------  ----                                                         *
* DX      R*8    Double precision array - version ORA1                 *
* VX      R*4    Single precision array - version ORA2                 *
* ARR     C*6    Name of array read from data file                     *
* IER     I*4    Error indicator                                       *
*                -110  Error while reading from unit  MFILE            *
*                -113  Wrong value of  ITYPE  read from  MFILE         *
*                                                                      *
************************************************************************
C
      SUBROUTINE ORALC1(DX,A1,ARR,MFILE,IFMT)
C
C *** Double precision version
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER ARR*6
      DIMENSION DX(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      SAVE /OUTPUT/,/ERRCTL/,/CHAR/
C
      SUB='ORALC1'
      IF (ICHECK.GE.997) CALL OTRC('ORALC1','10/11/94')
C
      IER=0
C
      IF (IFMT.NE.0) GOTO 99997
C
      READ (MFILE,ERR=99997,END=99997) ARR,ITYPE,ILEN,ILEN8,JRECL
C
      IF (ITYPE.NE.1) GOTO 99997
C
      CALL ORALCD(DX,A1,ILEN8,MFILE,JRECL)
      IF (IER.NE.0) GOTO 99999
C
      LNR=0
      WRITE (CPARAM,'(A6,2I15)') ARR,LNR,MFILE
      CALL OMSG(7,'ORALC1')
      GOTO 99999
C
99997 WRITE (CPARAM,'(I15)') MFILE
      CALL WERR(-110,'XORALC')
C
99999 END
C
C
C
      SUBROUTINE ORALC2(VX,A1,ARR,MFILE,IFMT)
C
C *** Single precision version
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER ARR*6
      DIMENSION VX(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      SAVE /OUTPUT/,/ERRCTL/,/CHAR/
C
      SUB='ORALC2'
      IF (ICHECK.GE.997) CALL OTRC('ORALC2','10/11/94')
C
      IER=0
C
      IF (IFMT.NE.0) GOTO 99997
C
      READ (MFILE,ERR=99997,END=99997) ARR,ITYPE,ILEN,ILEN8,JRECL
C
      IF (ITYPE.NE.2) GOTO 99997
C
      CALL ORALCV(VX,A1,ILEN8,MFILE,JRECL)
      IF (IER.NE.0) GOTO 99999
C
      LNR=0
      WRITE (CPARAM,'(A6,2I15)') ARR,LNR,MFILE
      CALL OMSG(7,'ORALC2')
      GOTO 99999
C
99997 WRITE (CPARAM,'(I15)') MFILE
      CALL WERR(-110,'XORALC')
C
99999 END
C
C
C
      SUBROUTINE ORALCD(DX,A1,N,MFILE,IRECL8)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      DIMENSION DX(*),DXH(512)
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ERRCTL/ IER,ICHECK
      SAVE /CHAR/,/ERRCTL/
C
      IF (ICHECK.EQ.999) CALL OTRC('ORALCD','10/11/94')
C
      IREC=N/IRECL8
      DO 1 JREC=1,IREC
      J1=(JREC-1)*IRECL8
      READ (MFILE,ERR=99998,END=99998) (DXH(I),I=1,IRECL8)
      DO 1 I=1,IRECL8
      DX(J1+I)=DX(J1+I)+DXH(I)
1     CONTINUE
      IF (MOD(N,IRECL8).EQ.0) GOTO 99999
      J1=IREC*IRECL8
      READ (MFILE,ERR=99998,END=99998) (DXH(I),I=1,MOD(N,IRECL8))
      DO 2 I=1,MOD(N,IRECL8)
      DX(J1+I)=DX(J1+I)+DXH(I)
2     CONTINUE
      GOTO 99999
C
99998 WRITE (CPARAM,'(I15)') MFILE
      CALL WERR(-110,'ORALCD')
C
99999 END
C
C
C
      SUBROUTINE ORALCV(VX,A1,N,MFILE,IRECL8)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      DIMENSION VX(*),VXH(512)
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ERRCTL/ IER,ICHECK
      SAVE /CHAR/,/ERRCTL/
C
      IF (ICHECK.EQ.999) CALL OTRC('ORALCV','10/11/94')
C
      IREC=N/IRECL8
      DO 1 JREC=1,IREC
      J1=(JREC-1)*IRECL8
      READ (MFILE,ERR=99998,END=99998) (VXH(I),I=1,IRECL8)
      DO 1 I=1,IRECL8
      VX(J1+I)=VX(J1+I)+VXH(I)
1     CONTINUE
      IF (MOD(N,IRECL8).EQ.0) GOTO 99999
      J1=IREC*IRECL8
      READ (MFILE,ERR=99998,END=99998) (VXH(I),I=1,MOD(N,IRECL8))
      DO 2 I=1,MOD(N,IRECL8)
      VX(J1+I)=VX(J1+I)+VXH(I)
2     CONTINUE
      GOTO 99999
C
99998 WRITE (CPARAM,'(I15)') MFILE
      CALL WERR(-110,'ORALCV')
C
99999 END
C
C
C
      SUBROUTINE OWA2V(VX,ARR,NX,MFILE,IFMT)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER ARR*6,CFORM*15
      DIMENSION VX(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      SAVE /OUTPUT/,/ERRCTL/,/CHAR/
C
      SUB='OWA2V'
      IF (ICHECK.GE.997) CALL OTRC('OWA2V ','10/11/94')
C
      IER=0
      BFMT=IFMT.EQ.1
C
      IF (BFMT) THEN
       CFORM=FMT(1)
       WRITE (MFILE,'(2A15,2I15)') ARR,CFORM,1,NX
      ELSE
       WRITE (MFILE) ARR,2,NX,NX,IRECL8
      ENDIF
C
      IF (BFMT) THEN
       WRITE (MFILE,CFORM) (VX(I),I=1,NX)
      ELSE
       CALL OWA0V(VX,NX,MFILE,IRECL8)
      ENDIF
C
      LNR=0
      WRITE (CPARAM,'(A6,2I15)') ARR,LNR,MFILE
      CALL OMSG(8,'XOWA2V')
C
99999 END
C
C
C
      SUBROUTINE OWA0V(VX,N,MFILE,IRECL8)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      DIMENSION VX(*)
      COMMON /ERRCTL/ IER,ICHECK
      SAVE /ERRCTL/
C
      IF (ICHECK.EQ.999) CALL OTRC('OWA0V ','10/11/94')
C
      IREC=N/IRECL8
      DO 1 JREC=1,IREC
      J1=(JREC-1)*IRECL8
1     WRITE (MFILE) (VX(J1+I),I=1,IRECL8)
      IF (MOD(N,IRECL8).EQ.0) GOTO 99999
      J1=IREC*IRECL8
      WRITE (MFILE) (VX(J1+I),I=1,MOD(N,IRECL8))
C
99999 END
C
C
C
      SUBROUTINE XVBM0(LB,NEQ,NBLOC,ICLEAR,ELE,COEFF,BCON,KB,KBN,ICUB,
     *                 ARR,BSNGL)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER ARR*6
C
      PARAMETER (NNARR=299,NNAB=21,NNDER=6)
      DIMENSION VWORK(1),KWORK(1)
      DIMENSION LB(*),KB(NNAB,*),KBN(*),BCON(*),ARR(*),BSNGL(*)
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(1)
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      EXTERNAL COEFF,ELE
      SAVE
C
      SUB='XVBM0'
      IF (ICHECK.GE.997) CALL OTRC('XVBM0 ','12/04/90')
      IER=0
C
      DO 1 IBLOC=1,NBLOC
      IF (LB(IBLOC).EQ.0) THEN
       CALL ZNEW(NEQ,1,LB(IBLOC),ARR(IBLOC))
       IF (IER.NE.0) GOTO 99999
      ELSE
C ***  Check input parameter
       CALL ZTYPE(LB(IBLOC),ITYPE)
       IF (ITYPE.NE.1) THEN
        WRITE (CPARAM,'(A6,I15)') ARR(IBLOC),IBLOC
        CALL WERR(-114,'XVBM0 ')
        GOTO 99999
       ENDIF
       CALL ZLEN(LB(IBLOC),ILEN)
       IF (ILEN.LT.NEQ) THEN
        WRITE (CPARAM,'(A6,I15)') ARR(IBLOC),IBLOC
        CALL WERR(-115,'XVBM0 ')
        GOTO 99999
       ENDIF
       IF (ICLEAR.EQ.1) CALL ZCLEAR(LB(IBLOC),ARR(IBLOC))
      ENDIF
1     CONTINUE
C
      CALL ZNEW(NBLOC,-3,LOFF,'KOFF  ')
      IF (IER.NE.0) GOTO 99999
      CALL ZNEW(NBLOC*NNDER,1,LOECON,'COECON')
      IF (IER.NE.0) GOTO 99999
C
      DO 2 IBLOC=1,NBLOC
      KWORK(L(LOFF)+IBLOC-1)=L(LB(IBLOC))-1
2     CONTINUE
C
      CALL VBM0(DWORK(1),NBLOC,KWORK(L(LOFF)),KWORK(L(LVERT)),
     *          KWORK(L(LMID)),DWORK(L(LCORVG)),
     *          ELE,COEFF,BCON,DWORK(L(LOECON)),KB,KBN,ICUB)
      IF (IER.NE.0) GOTO 99999
C
      CALL ZDISP(0,LOECON,'COECON')
      CALL ZDISP(0,LOFF,'KOFF  ')
C
      DO 3 IBLOC=NBLOC,1,-1
      IF (BSNGL(IBLOC)) THEN
       CALL ZCTYPE(2,LB(IBLOC),ARR(IBLOC))
       IF (IER.NE.0) GOTO 99999
      ENDIF
3     CONTINUE
C
99999 END
C
C
C
      SUBROUTINE VBM0(DB,NBLOC,KOFF,KVERT,KMID,DCORVG,
     *                ELE,COEFF,BCON,COECON,KB,KBN,ICUB)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNAB=21,NNCOF=6)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),KOFF(*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS),DB(*),DCORVG(2,*)
      DIMENSION BCON(*),KB(NNAB,*),KBN(*),COECON(NNDER,*)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     1                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
      EXTERNAL ELE,COEFF
      SAVE
C
      SUB='VB0M'
      IF (ICHECK.GE.997) CALL OTRC('VB0M  ','12/04/90')
C
C *** Preparation - evaluation of parameters
      IER=0
C
C *** Which derivatives of basis functions are needed?
      DO 1 IDER=1,NNDER
1     BDER(IDER)=.FALSE.
      DO 2 IBLOC=1,NBLOC
      DO 3 IBN=1,KBN(IBLOC)
      IB=KB(IBN,IBLOC)
      IF (IB.LE.0.OR.IB.GT.NNDER) THEN
       WRITE (CPARAM,'(I15)') IBLOC
       CALL WERR(-117,'VB0M  ')
       GOTO 99999
      ENDIF
3     BDER(IB)=.TRUE.
2     CONTINUE
C
C *** Dummy call of ELE sets number of element
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IDFL=NDFL(IELTYP)
      CALL CB2Q(ICUB)
      IF (IER.NE.0) GOTO 99999
C
      BFIRST=.TRUE.
C *** Dummy call of COEFF for nonlinear problems
C *** COEFF must set BDER(IDER)=.TRUE. if derivative IDER is needed
      AUX=COEFF(0D0,0D0,-1,0,BFIRST)
      BCON0=.TRUE.
C
      DO 4 IBLOC=1,NBLOC
      IF (BCON(IBLOC)) THEN
       DO 5 IBN=1,KBN(IBLOC)
       IB=KB(IBN,IBLOC)
5      COECON(IB,IBLOC)=COEFF(0D0,0D0,IB,IBLOC,BFIRST)
      ELSE
       BCON0=.FALSE.
      ENDIF
4     CONTINUE
************************************************************************
C *** Calculation of the linear form
************************************************************************
C
C *** Loop over all elements
      DO 100 IEL=1,NEL
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
      IF (IER.LT.0) GOTO 99999
C
C *** Evaluation of coordinates of the vertices
      DO 110 IVE=1,NVE
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
110   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
C *** Dummy call - ELE may save arithmetic operations
      CALL ELE(0D0,0D0,-2)
      IF (IER.LT.0) GOTO 99999
C
C *** Loop over all cubature points
      DO 200 ICUBP=1,NCUBP
C
C *** Cubature points on the reference element
      XI1=DXI(ICUBP,1)
      XI2=DXI(ICUBP,2)
C
C *** Jacobian of the bilinear mapping onto the reference element
      DJAC(1,1)=0.5D0*(DX(2)-DX(1)+DJ2)+0.5D0*DJ2*XI2
      DJAC(1,2)=0.5D0*DJ1+0.5D0*DJ2*XI1
      DJAC(2,1)=0.5D0*DJ4-0.5D0*DJ3*XI2
      DJAC(2,2)=0.5D0*(DY(3)-DY(1)-DJ4)-0.5D0*DJ3*XI1
      DETJ=DJAC(1,1)*DJAC(2,2)-DJAC(1,2)*DJAC(2,1)
C
C *** Cubature points on the actual element + weights
      XX=0.5D0*(DX(1)+DX(2)+DJ1)+0.5D0*(DX(2)-DX(1)+DJ2)*XI1
     *  +0.5D0*DJ1*XI2+0.5D0*DJ2*XI1*XI2
      YY=0.5D0*(DY(1)+DY(3)+DJ3)+0.5D0*DJ4*XI1+0.5D0*
     *         (DY(3)-DY(1)-DJ4)*XI2-0.5D0*DJ3*XI1*XI2
      OM=DOMEGA(ICUBP)*DETJ
C
      CALL ELE(XX,YY,-3)
      IF (IER.LT.0) GOTO 99999
C
C *** Summing up over all multiindices
      BFIRST=.TRUE.
      DO 300 IBLOC=1,NBLOC
C
      DO 301 IBN=1,KBN(IBLOC)
      IB=KB(IBN,IBLOC)
      IF (.NOT.BCON(IBLOC)) THEN
       AUX=COEFF(XX,YY,IB,IBLOC,BFIRST)*OM
      ELSE
       AUX=COECON(IB,IBLOC)*OM
      ENDIF
C
      DO 310 JDOFE=1,IDFL
      IGLOB=KDFG(JDOFE)+KOFF(IBLOC)
      DB(IGLOB)=DB(IGLOB)+DBAS(KDFL(JDOFE),IB)*AUX
310   CONTINUE
301   CONTINUE
C
      BFIRST=.FALSE.
300   CONTINUE
C
200   CONTINUE
100   CONTINUE
C
99999 END

      SUBROUTINE XGMV2D(MUNIT,CFILE,NEL,NVT,KVERT,DCORVG,VU,VV,VP,VISO,
     *                  TIMENS)
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CFILE*(*)
      DIMENSION KVERT(4,*),DCORVG(2,*)
      DIMENSION VU(*),VV(*),VP(*),VISO(*)
C
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
C
C
      DO 1 IFIRST = 1,60
      IF (CFILE(IFIRST:IFIRST).EQ.' ') GOTO 2
1     CONTINUE
2     WRITE(CFILE(IFIRST:IFIRST+4),'(A4)') '.gmv'
C
      OPEN (UNIT=MUNIT,FILE=CFILE)
C
C
      WRITE(MUNIT,'(A)')'gmvinput ascii'
      WRITE(MUNIT,*)'nodes ',NVT
C
      DO 100 IVT=1,NVT
100   WRITE(MUNIT,1000) REAL(DCORVG(1,IVT))
      DO 101 IVT=1,NVT
101   WRITE(MUNIT,1000) REAL(DCORVG(2,IVT))
      DO 102 IVT=1,NVT
102   WRITE(MUNIT,1000) 0.E0
C
      WRITE(MUNIT,*)'cells ',NEL
      DO 110 IEL=1,NEL
      WRITE(MUNIT,*)'quad 4'
110   WRITE(MUNIT,1100) KVERT(1,IEL),KVERT(2,IEL),
     *                  KVERT(3,IEL),KVERT(4,IEL)
C
C      WRITE(MUNIT,*)'materials 1 0'
C      WRITE(MUNIT,*)'mat1'
C      DO 120 IEL=1,NEL
C 120  WRITE(MUNIT,*)'1'
C
      WRITE(MUNIT,*)  'velocity 1'
      DO 130 IVT=1,NVT
130   WRITE(MUNIT,1000) VU(IVT)
      DO 140 IVT=1,NVT
140   WRITE(MUNIT,1000) VV(IVT)
      DO 150 IVT=1,NVT
150   WRITE(MUNIT,1000) 0E0

      WRITE(MUNIT,*)  'variable'

      WRITE(MUNIT,*)  'pressure 1'
      DO 160 IVT=1,NVT
160   WRITE(MUNIT,1000) VP(IVT)

      WRITE(MUNIT,*)  'streamfunction 1'
      DO 170 IVT=1,NVT
170   WRITE(MUNIT,1000) VISO(IVT)

      WRITE(MUNIT,*)  'endvars'
      WRITE(MUNIT,*)  'probtime ',REAL(TIMENS)
      WRITE(MUNIT,*)  'endgmv'
C
C
C
      REWIND (MUNIT)
      CLOSE  (MUNIT)
C
C
1000  FORMAT(E15.8)
1100  FORMAT(8I8)
C
      END
C
C
C
      SUBROUTINE XAVS2D(MUNIT,CFILE,NEL,NVT,KVERT,DCORVG,VU,VV,VP,VISO)
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CFILE*(*)
      DIMENSION KVERT(4,*),DCORVG(2,*)
      DIMENSION VU(*),VV(*),VP(*),VISO(*)
C
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
C
C
      DO 1 IFIRST = 1,60
      IF (CFILE(IFIRST:IFIRST).EQ.' ') GOTO 2
1     CONTINUE
2     WRITE(CFILE(IFIRST:IFIRST+4),'(A4)') '.inp'
C
C=======================================================================
C     NVEC = FUNKT.WERTE PRO KNOTEN
C=======================================================================
      NVEC = 5
C
      OPEN (UNIT=MUNIT,FILE=CFILE)
C
C
      WRITE(MUNIT,*) NVT,NEL,NVEC,0,0
C
      DO 100 IVT=1,NVT
100   WRITE(MUNIT,1000) IVT,REAL(DCORVG(1,IVT)),REAL(DCORVG(2,IVT)),0E0
C
      DO 110 IEL=1,NEL
110   WRITE(MUNIT,1100) IEL,1,'quad',KVERT(1,IEL),KVERT(2,IEL),
     *                               KVERT(3,IEL),KVERT(4,IEL)
C
C
      WRITE(MUNIT,*) 3,3,1,1
      WRITE(MUNIT,*)  'vel'//',','m/s'
      WRITE(MUNIT,*)  'p'  //',','m/s'
      WRITE(MUNIT,*)  'stream'//',','m/s'      
C
      DO 200 IVT=1,NVT
200   WRITE(MUNIT,2000) IVT,VU(IVT),VV(IVT),0E0,VP(IVT),VISO(IVT)
C
C
      REWIND (MUNIT)
      CLOSE  (MUNIT)
C
C
1000  FORMAT(I8,3E15.8)
1100  FORMAT(2I8,A7,8I8)
2000  FORMAT(I8,5E15.8)
C
      END

************************************************************************
      SUBROUTINE    BDRNEU  (KMBD,KVBD,KEBD,KVERT,KMID,KNPR,DDBD,DMBDP,
     *                       NMBD,INEUM)
************************************************************************
*    Purpose:  sets the DIRICHLET- and NEUMANN components
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      DIMENSION KMBD(*),KVBD(*),KEBD(*),KVERT(NNVE,*),KMID(NNVE,*)
      DIMENSION KNPR(*),DDBD(*),DMBDP(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
      SAVE
C
      NMBD =0
      INEUM=0
C
      DO 1 IVBD=1,NVBD
      CALL GETMBD(IMID,IV1,IV2,IVBD,KVBD,KEBD,KVERT,KMID,KNPR,INPR)
      IF (IMID.EQ.0) GOTO 1
C
      DPAR=DMBDP(IVBD)
      NMBD=NMBD+1
      KMBD(NMBD)=IMID
      DDBD(NMBD)=DPAR
C
      INPART=0
      CALL NEUDAT(INPART,INPRN,DPARN1,DPARN2,TIMENS)
      NPART=INPART
C      
      DO 10 INPART=1,NPART
      CALL NEUDAT(INPART,INPRN,DPARN1,DPARN2,TIMENS)
      IF ((DPAR.GT.DPARN1).AND.(DPAR.LT.DPARN2)
     *                    .AND.(INPR.EQ.INPRN)) THEN
       INEUM=1
       KNPR(NVT+IMID)=0
       KMBD(NMBD)=-KMBD(NMBD)
      ENDIF
10    CONTINUE
C
1     CONTINUE
C
      END
C
************************************************************************
      SUBROUTINE PDSET (KVBD,KEBD,KVERT,KMID,KNPR,DCORVG,DMBDP,DF1,DF2,
     *                  TSTEPB)
************************************************************************
*    Purpose:  sets the PRESSURE DROP values
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION KVBD(*),KEBD(*),KVERT(NNVE,*),KMID(NNVE,*),KNPR(*)
      DIMENSION DCORVG(2,*),DMBDP(*),DF1(*),DF2(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /NSPAR/  TSTEP,THETA,THSTEP,TIMENS,EPSNS,NITNS,ITNS,ISTAT
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
      SAVE
C
C
      DO 10 IVBD=1,NVBD
      CALL GETMBD(IMID,IV1,IV2,IVBD,KVBD,KEBD,KVERT,KMID,KNPR,INPR)
      IF (IMID.EQ.0) GOTO 10
C
      DPAR=DMBDP(IVBD)
C
      INPART=0
      CALL NEUDAT(INPART,INPRN,DPARN1,DPARN2,TIMENS)
      NPART=INPART
C      
      DO 20 INPART=1,NPART
      CALL NEUDAT(INPART,INPRN,DPARN1,DPARN2,TIMENS)
      IF ((DPAR.GT.DPARN1).AND.(DPAR.LT.DPARN2)
     *                    .AND.(INPR.EQ.INPRN)) THEN
       PX1  =DCORVG(1,IV1)
       PY1  =DCORVG(2,IV1)
       PX2  =DCORVG(1,IV2)
       PY2  =DCORVG(2,IV2)
       DN1  =-PY2+PY1
       DN2  = PX2-PX1
       PMEAN= FDATIN(7,INPR,DPAR,DPAR,TIMENS,RE)
       DF1(IMID)=DF1(IMID)+PMEAN*DN1*TSTEPB
       DF2(IMID)=DF2(IMID)+PMEAN*DN2*TSTEPB
      ENDIF
20    CONTINUE
C
10    CONTINUE
      END
C
************************************************************************
      SUBROUTINE    BDRSET  (DU1,DU2,DF1,DF2,KMBD,DDBD,KNPR,NMBD,NVT,
     *                       PARX,PARY,UE)
************************************************************************
*    Purpose:  updates the solution vector (DU1,DU2) and the right hand 
*              side (DF1,DF2) for all DIRICHLET boundary nodes
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION DU1(*),DU2(*),DF1(*),DF2(*),DDBD(*)
      DIMENSION KMBD(*),KNPR(*)
      EXTERNAL PARX,PARY,UE
C
C
      DO 1 IMBD=1,NMBD
      IMID=KMBD(IMBD)
      IF (IMID.LT.0) GOTO 1
      INPR=KNPR(KNPR(NVT+IMID))
      DPAR=DDBD(IMBD)
C
      PX=PARX(DPAR,INPR)
      PY=PARY(DPAR,INPR)
C
      U1=UE(PX,PY,1)
      U2=UE(PX,PY,2)
      DU1(IMID)=U1
      DU2(IMID)=U2
      DF1(IMID)=U1
      DF2(IMID)=U2
1     CONTINUE
      END
C
************************************************************************
      SUBROUTINE    BDRDEF  (DX,KMBD,NMBD,A1)
************************************************************************
*    Purpose:  sets the NEUMANN-components of the vector DX to A1
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DIMENSION DX(*),KMBD(*)
C
C *** loop over all boundary vertices
C
      DO 1 IMBD=1,NMBD
      IMID=KMBD(IMBD)
      IF (IMID.GT.0) GOTO 1
      DX(-IMID)=A1*DX(-IMID)
1     CONTINUE
      END
C
************************************************************************
      SUBROUTINE   BDRYA  (VA,KCOL,KLD,KMBD,NMBD)
************************************************************************
*    Purpose:  updates the matrix entries for all DIRICHLET boundary
*              nodes
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      REAL VA
C
      PARAMETER (NNVE=4)
      DIMENSION VA(*),KCOL(*),KLD(*),KMBD(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      SAVE 
C
      DO 1 IMBD=1,NMBD
      IMID=KMBD(IMBD)
      IF (IMID.LT.0) GOTO 1
C
C *** The diagonal element is set to 1
      VA(KLD(IMID))=1E0
C
      DO 2 ICOL=KLD(IMID)+1,KLD(IMID+1)-1
2     VA(ICOL)=0E0
C
1     CONTINUE
      END
C
************************************************************************
      SUBROUTINE    BDRY0  (D1,D2,KMBD,NMBD)
************************************************************************
*    Purpose:  sets the DIRICHLET-components of the vector (D1,D2) to
*              zero
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION D1(*),D2(*)
      DIMENSION KMBD(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      SAVE
C
C
      DO 1 IMBD=1,NMBD
      IMID=KMBD(IMBD)
      IF (IMID.LT.0) GOTO 1
      D1(IMID)=0D0
      D2(IMID)=0D0
1     CONTINUE
C
      END
C
************************************************************************
      SUBROUTINE GETMBD (IMID,IVT1,IVT2,IVBD,KVBD,KEBD,KVERT,KMID,KNPR,
     *                   INPR)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION KVBD(*),KEBD(*),KVERT(NNVE,*),KMID(NNVE,*),KNPR(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
      IVT1=KVBD(IVBD)
      INPR=KNPR(IVT1)
      IEL=KEBD(IVBD)
      IF (IEL.EQ.0) THEN
        IMID=0
        GOTO 99999
      ENDIF
C
      DO 1  I=1,4
      IVERT=I
      IF (KVERT(I,IEL).EQ.IVT1) GOTO 2
   1  CONTINUE
C
C *** Error
      WRITE(MTERM,*) 'ERROR in GETMBD: vertice not found'
      RETURN
C
   2  IMID=KMID(IVERT,IEL)-NVT
      IVERT2=IVERT+1
      IF (IVERT2.GT.NNVE) IVERT2=1
      IVT2=KVERT(IVERT2,IEL)
C
99999 END
C
************************************************************************
      SUBROUTINE BDPRES(DP,KVERT,KNPR,KVBD,KMM,DCORVG,DVBDP,NVBD,P1,P2)
************************************************************************
*    Purpose:  Calculates integral boundary pressure
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION DP(*),KVERT(NNVE,*),KNPR(*),KVBD(*),KMM(2,*)
      DIMENSION DCORVG(2,*),DVBDP(*)
C
      COMMON /NSPTS/  KPU(2),KPP(4),KPX(4),KPI(2),DPI(2,2),DPF(2)
      SAVE
C
C
C
      P1=0D0
      DLEN=0D0
C
C
      IF (KPI(1).EQ.0) GOTO 19
C
      DO 10 IVBD=1,NVBD
C      
      DPAR=DVBDP(IVBD)
      IF ((DPAR.GE.DPI(1,1)).AND.(DPAR.LT.DPI(2,1))
     *                      .AND.(KNPR(KVBD(IVBD)).EQ.KPI(1))) THEN
       IVT1=KVBD(IVBD)
       PX1=DCORVG(1,IVT1)
       PY1=DCORVG(2,IVT1)
      ELSE
       GOTO 10
      ENDIF
C
      IF (IVT1.EQ.KMM(2,KPI(1))) THEN
       IVT2=KMM(1,KPI(1))
       PX2=DCORVG(1,IVT2)
       PY2=DCORVG(2,IVT2)
      ELSE
       IVBDH=IVBD+1
       DPARH=DVBDP(IVBDH)
       IVT2=KVBD(IVBDH)
       PX2=DCORVG(1,IVT2)
       PY2=DCORVG(2,IVT2)
      ENDIF
C
      DL=SQRT((PX2-PX1)**2+(PY2-PY1)**2)
      DLEN=DLEN+DL
      P1=P1+0.5D0*DL*(DP(IVT1)+DP(IVT2))
C
10    CONTINUE
C
      P1=P1/DLEN
C
C
C
19    P2=0D0
      DLEN=0D0
C
C
      IF (KPI(2).EQ.0) RETURN
C
      DO 20 IVBD=1,NVBD
C      
      DPAR=DVBDP(IVBD)
      IF ((DPAR.GE.DPI(1,2)).AND.(DPAR.LT.DPI(2,2))
     *                      .AND.(KNPR(KVBD(IVBD)).EQ.KPI(2))) THEN
       IVT1=KVBD(IVBD)
       PX1=DCORVG(1,IVT1)
       PY1=DCORVG(2,IVT1)
      ELSE
       GOTO 20
      ENDIF
C
      IF (IVT1.EQ.KMM(2,KPI(2))) THEN
       IVT2=KMM(1,KPI(2))
       PX2=DCORVG(1,IVT2)
       PY2=DCORVG(2,IVT2)
      ELSE
       IVBDH=IVBD+1
       DPARH=DVBDP(IVBDH)
       IVT2=KVBD(IVBDH)
       PX2=DCORVG(1,IVT2)
       PY2=DCORVG(2,IVT2)
      ENDIF
C
      DL=SQRT((PX2-PX1)**2+(PY2-PY1)**2)
      DLEN=DLEN+DL
      P2=P2+0.5D0*DL*(DP(IVT1)+DP(IVT2))
C
20    CONTINUE
C
      P2=P2/DLEN
C
C
C
      END
C
************************************************************************
      SUBROUTINE BDFORC(DU1,DU2,DP,KVERT,KMID,KVBD,KEBD,KMM,DCORVG,ELE,
     *                  DFW,DAW)
************************************************************************
*    Purpose:  Calculates lift (DFW) and drag (DAW)
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNAB=21,NNCOF=6)
      DIMENSION DU1(*),DU2(*),DP(*),DCORVG(2,*)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),KVBD(*),KEBD(*),KMM(2,*)
      DIMENSION KDFG(NNBAS),KDFL(NNBAS)
C
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     *                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COAUX1/ KDFG,KDFL,IDFL
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
C
      COMMON /NSPTS/  KPU(2),KPP(4),KPX(4),KPI(2),DPI(2,2),DPF(2)
      SAVE
C
C
C
      DFW=0D0
      DAW=0D0
      DLEN=0D0
C
C
      IF ((DPF(1).EQ.0D0).OR.(DPF(2).EQ.0D0)) RETURN
C
C
      BDER(1)=.TRUE.
      BDER(2)=.TRUE.
      BDER(3)=.TRUE.
C
      IELTYP=-1
      CALL ELE(0D0,0D0,IELTYP)
      IDFL=NDFL(IELTYP)
C
      NCUBP=1
      ICUBP=1
C
      IW1=1
      IW2=1
C
      DO 10 IVBD=1,NVBD
      IVT=KVBD(IVBD)
      IF (IVT.EQ.KMM(1,2)) GOTO 15
10    CONTINUE
C
      WRITE(6,*) 'ERROR 1 IN BDFORC'
      RETURN
C
15    IVBD1=IVBD
      ISTOP=0
C
      DO 100 IVBD=IVBD1,NVBD
      IF (ISTOP.EQ.1) GOTO 1000
      IEL =KEBD(IVBD)
      IVT1=KVBD(IVBD)
      IF (IVT1.EQ.KMM(2,2)) THEN
       IVT2=KVBD(IVBD1)
       ISTOP=1
      ELSE
       IVT2=KVBD(IVBD+1)
      ENDIF
C
      DO 101 II=1,4
101   IF (KVERT(II,IEL).EQ.IVT1) GOTO 102
      WRITE(6,*) 'WRONG 1'
      IW1=IW1+1
102   DO 103 II=1,4
103   IF (KVERT(II,IEL).EQ.IVT2) GOTO 104
      WRITE(6,*) 'WRONG 2'
      IW2=IW2+1
104   CONTINUE
C
      PX1=DCORVG(1,IVT1)
      PX2=DCORVG(1,IVT2)
      PY1=DCORVG(2,IVT1)
      PY2=DCORVG(2,IVT2)
      PXM=0.5D0*(PX1+PX2)
      PYM=0.5D0*(PY1+PY2)
      DLH=SQRT((PX2-PX1)**2+(PY2-PY1)**2)
C
      DTX= (PX2-PX1)/DLH
      DTY= (PY2-PY1)/DLH
      DNX=-(PY2-PY1)/DLH
      DNY= (PX2-PX1)/DLH
      DPCONT=DP(IEL)
      DLEN=DLEN+DLH
C
      CALL NDFGL(IEL,1,IELTYP,KVERT,KMID,KDFG,KDFL)
C
      DO 120 IVE = 1,4
      JP=KVERT(IVE,IEL)
      KVE(IVE)=JP
      DX(IVE)=DCORVG(1,JP)
      DY(IVE)=DCORVG(2,JP)
120   CONTINUE
C
      DJ1=0.5D0*(-DX(1)-DX(2)+DX(3)+DX(4))
      DJ2=0.5D0*( DX(1)-DX(2)+DX(3)-DX(4))
      DJ3=0.5D0*(-DY(1)+DY(2)-DY(3)+DY(4))
      DJ4=0.5D0*(-DY(1)+DY(2)+DY(3)-DY(4))
C
      XX=PXM
      YY=PYM
C
      CALL ELE(0D0,0D0,-2)
      CALL ELE(XX,YY,-3)
C
      DUT=0
      DO 130 JDFL=1,IDFL
      DUT=DUT+DU1(KDFG(JDFL))*DBAS(KDFL(JDFL),2)*DTX*DNX
     *       +DU2(KDFG(JDFL))*DBAS(KDFL(JDFL),2)*DTY*DNX
     *       +DU1(KDFG(JDFL))*DBAS(KDFL(JDFL),3)*DTX*DNY
     *       +DU2(KDFG(JDFL))*DBAS(KDFL(JDFL),3)*DTY*DNY
130   CONTINUE
C
      DFW=DFW+DLH*(DPF(1)*DUT*DNY-DPCONT*DNX)
      DAW=DAW-DLH*(DPF(1)*DUT*DNX+DPCONT*DNY)
C
100   CONTINUE
C
1000  DFW=2D0*DFW/DPF(2)      
      DAW=2D0*DAW/DPF(2) 
C
C
C
99999 END
C

*=======================================================================
	SUBROUTINE RDPARM (CDATA, MDATA)
*=======================================================================
*
*  Purpose:  - reads the parameter file 'cdata' and initializes
*              the corresponding data structure
*=======================================================================
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
      CHARACTER*(*) CDATA
      PARAMETER (NNARR=299, NNWORK=1)
C
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /TDATA/ NBCT,NNCOMP,NNNPAR,
     *               LNCOMP,LICPTR,LITYP,LNSPLN,LNPAR,
     *               LIPPTR,LXPAR,LYPAR
C
      DIMENSION KWORK(1)
      EQUIVALENCE (DWORK(1),KWORK(1))
C
      SAVE
C
C=======================================================================
C   open file 'cdata'
C=======================================================================
      OPEN(UNIT=MDATA,FILE=CDATA,ERR=222)
      GOTO 221
222   WRITE(*,*)'ERROR IN RDPARM: OPEN FAILED'
      STOP
221   CONTINUE
C=======================================================================
C   determine dimensions for creating arrays
C=======================================================================
      READ(MDATA,*,ERR=111)
      READ(MDATA,*,ERR=111) NBCT
C *** NBCT=0 MEANS: RDPARM IS A DUMMY PROCESS (NO PREPROCESSING)
      IF (NBCT.EQ.0) GOTO 99999
C *** LOOP OVER NBCT BOUNDARY PARTS
      NNNPAR=0
      NNCOMP=0
      DO IBCT=1,NBCT
        READ(MDATA,*,ERR=111)
	READ(MDATA,*,ERR=111) IIBCT
	IF(IBCT.NE.IIBCT) THEN
	  WRITE(*,*)'ERROR IN RDPARM: CONFLICT WITH IBCT'
	  STOP
        ENDIF
        READ(MDATA,*,ERR=111)
        READ(MDATA,*,ERR=111) NCOMP
	NNCOMP=NNCOMP + NCOMP
C
C ***   LOOP OVER NCOMP COMPONENTS OF PART IBCT
        NNPAR=0
        READ(MDATA,*,ERR=111)
	DO ICOMP=1,NCOMP
	  READ(MDATA,*,ERR=111) ITYP, NSPLIN, NPAR
	  NNPAR=NNPAR + NPAR
	ENDDO
	NNNPAR=NNNPAR + NNPAR
C
      ENDDO
C=======================================================================
C      read error
C=======================================================================
        GOTO 103
 111    WRITE(*,*)'ERROR IN RDPARM: READ ERROR --> STOP'
	STOP
 103    CONTINUE
C=======================================================================
C   allocation of all needed arrays
C=======================================================================
        CALL ZNEW(NBCT,3,LNCOMP,'NCOMP ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NBCT,3,LICPTR,'ICPTR ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NNCOMP,3,LITYP,'ITYP  ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NNCOMP,3,LNSPLN,'NSPLN ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NNCOMP,3,LNPAR,'NPAR  ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NNCOMP,3,LIPPTR,'IPPTR ')
        IF (IER.NE.0) GOTO 99998
C
        CALL ZNEW(NNNPAR,1,LXPAR,'DXPAR ')
        IF (IER.NE.0) GOTO 99998
        CALL ZNEW(NNNPAR,1,LYPAR,'DYPAR ')
        IF (IER.NE.0) GOTO 99998
C=======================================================================
C   fill the arrays
C=======================================================================
        CLOSE(MDATA)
        OPEN(UNIT=MDATA,FILE=CDATA,ERR=222)
C--------------------------------------------------------------
C     determine KWORK/DWORK-pointers 
C--------------------------------------------------------------
      KITYP=L(LITYP)
      KNSPLN=L(LNSPLN)
      KNPAR=L(LNPAR)
      KIPPTR=L(LIPPTR)
      KXPAR=L(LXPAR)
      KYPAR=L(LYPAR)
C--------------------------------------------------------------
      READ(MDATA,*,ERR=111)
      READ(MDATA,*,ERR=111) 
C *** LOOP OVER NBCT BOUNDARY PARTS
      ICPTR=0
      IPPTR=0
      KKPAR=0
      DO IBCT=1,NBCT
C       SET POINTER ICPTR FOR THE BOUNDARY PART 'IBCT'
        KWORK(L(LICPTR)+IBCT-1)=ICPTR
C
        READ(MDATA,*,ERR=111)
	READ(MDATA,*,ERR=111) IIBCT
	IF(IBCT.NE.IIBCT) THEN
	  WRITE(*,*)'ERROR IN RDPARM: CONFLICT WITH IBCT'
	  STOP
        ENDIF
        READ(MDATA,*,ERR=111)
        READ(MDATA,*,ERR=111) NCOMP
	KWORK(L(LNCOMP)+IBCT-1)=NCOMP
C
C ***   LOOP OVER NCOMP COMPONENTS OF PART IBCT
        NNPAR=0
        READ(MDATA,*,ERR=111)
	DO ICOMP=0,NCOMP-1
	  READ(MDATA,*,ERR=111) ITYP, NSPLIN, NPAR
	  NNPAR=NNPAR + NPAR
	  KWORK(KITYP+ICPTR)=ITYP
	  KWORK(KNSPLN+ICPTR)=NSPLIN
	  KWORK(KNPAR+ICPTR)=NPAR
	  KWORK(KIPPTR+ICPTR)=IPPTR
	  ICPTR=ICPTR+1
	  IPPTR=IPPTR + NPAR
	ENDDO
C
      ENDDO
C
C ***   LOOP OVER NNNPAR PARAMETER PAIRS OF BOUNDARY PART IBCT
        READ(MDATA,*,ERR=111)
	KXPAR=L(LXPAR)
	KYPAR=L(LYPAR)
	DO IPAR=0,NNNPAR-1
	  READ(MDATA,*,ERR=111) XPAR, YPAR
	  DWORK(KXPAR+IPAR)=XPAR
	  DWORK(KYPAR+IPAR)=YPAR
	ENDDO
C
C=======================================================================
C   error case for ZNEW
C=======================================================================
      GOTO 99999
99998 WRITE(*,*) 'ERROR IN RDPARM: ZNEW WITH IER=', IER
      STOP
C=======================================================================
99999 CONTINUE
C
      END

************************************************************************
      SUBROUTINE   INTUVD (DU1,DU2,DL1,DL2,DAUX,NVT,NEL,NVBD,
     *                     KMID,KVERT,KVBD,KMBD,DCORVG,UE)
************************************************************************
*
*    Purpose:  - Interpolates the solution vector (DU1,DU2) to
*                the vector (DL1,DL2) of dimension NVT with
*                values in the vertices
*              - the values of vertices at the boundary are computed
*                via the exact function UE
*
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
C
      DIMENSION DU1(*),DU2(*),DL1(*),DL2(*),DAUX(*),
     *          KVERT(NNVE,*),KMID(NNVE,*),KVBD(*),KMBD(*),DCORVG(2,*)
C
      SAVE
C-----------------------------------------------------------------------
      DO 1 IVT=1,NVT
      DL1 (IVT)=0D0
      DL2 (IVT)=0D0
1     DAUX(IVT)=0D0
C
C
      DO 10 IEL=1,NEL
C
      IM1=KMID(1,IEL)-NVT
      IM2=KMID(2,IEL)-NVT
      IM3=KMID(3,IEL)-NVT
      IM4=KMID(4,IEL)-NVT
C
      IV1=KVERT(1,IEL)
      IV2=KVERT(2,IEL)
      IV3=KVERT(3,IEL)
      IV4=KVERT(4,IEL)
C
      DUH1=DU1(IM1)
      DUH2=DU1(IM2)
      DUH3=DU1(IM3)
      DUH4=DU1(IM4)
C
      DVH1=DU2(IM1)
      DVH2=DU2(IM2)
      DVH3=DU2(IM3)
      DVH4=DU2(IM4)
C
      DAUX(IV1)=DAUX(IV1)+1D0
      DAUX(IV2)=DAUX(IV2)+1D0
      DAUX(IV3)=DAUX(IV3)+1D0
      DAUX(IV4)=DAUX(IV4)+1D0
C
      DL1(IV1)=DL1(IV1) + 0.75D0*(DUH1+DUH4) - 0.25D0*(DUH2+DUH3)
      DL1(IV2)=DL1(IV2) + 0.75D0*(DUH2+DUH1) - 0.25D0*(DUH3+DUH4)
      DL1(IV3)=DL1(IV3) + 0.75D0*(DUH3+DUH2) - 0.25D0*(DUH4+DUH1)
      DL1(IV4)=DL1(IV4) + 0.75D0*(DUH4+DUH3) - 0.25D0*(DUH1+DUH2)
C
      DL2(IV1)=DL2(IV1) + 0.75D0*(DVH1+DVH4) - 0.25D0*(DVH2+DVH3)
      DL2(IV2)=DL2(IV2) + 0.75D0*(DVH2+DVH1) - 0.25D0*(DVH3+DVH4)
      DL2(IV3)=DL2(IV3) + 0.75D0*(DVH3+DVH2) - 0.25D0*(DVH4+DVH1)
      DL2(IV4)=DL2(IV4) + 0.75D0*(DVH4+DVH3) - 0.25D0*(DVH1+DVH2)
C
10    CONTINUE
C
      DO 20  IV=1,NVT
      DL1(IV)=DL1(IV)/DAUX(IV)
      DL2(IV)=DL2(IV)/DAUX(IV)
 20   CONTINUE
C
C=======================================================================
C *** boundary values
C=======================================================================
C
      DO 30  I=1,NVBD
      I1=I
      IF (I.EQ.1) THEN 
       I0=NVBD
      ELSE
       I0=I-1
      ENDIF
C
      IV =KVBD(I)
      IM1=KMBD(I1)
      IM0=KMBD(I0)
      IF ((IM1.LT.0).OR.(IM0.LT.0)) GOTO 30
C
      X=DCORVG(1,IV)
      Y=DCORVG(2,IV)
      DL1(IV)=UE(X,Y,1)
      DL2(IV)=UE(X,Y,2)
30    CONTINUE
C
      END
c
c
************************************************************************
      SUBROUTINE   INTPV (DP,DPL,DAUX,AREA,KVERT)
************************************************************************
*    Purpose:  - Interpolates the solution pressure DP to
*                the (REAL) vector VPL of dimension NVT with
*                values in the vertices
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      REAL AREA
      PARAMETER (NNVE=4)
C
      DIMENSION DP(*),DPL(*),DAUX(*),KVERT(NNVE,*),AREA(*)
C
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      SAVE
C-----------------------------------------------------------------------
c
      DO 1 IVT=1,NVT
      DPL (IVT)=0D0
1     DAUX(IVT)=0D0
C
C
      DO 10 IEL=1,NEL
C
      DPIEL=DP(IEL)
      DAREA=DBLE(AREA(IEL))
C
      IV1=KVERT(1,IEL)
      IV2=KVERT(2,IEL)
      IV3=KVERT(3,IEL)
      IV4=KVERT(4,IEL)
C
      DPL(IV1)=DPL(IV1)+0.25D0*DAREA*DPIEL
      DPL(IV2)=DPL(IV2)+0.25D0*DAREA*DPIEL
      DPL(IV3)=DPL(IV3)+0.25D0*DAREA*DPIEL
      DPL(IV4)=DPL(IV4)+0.25D0*DAREA*DPIEL
C
      DAUX(IV1)=DAUX(IV1)+0.25D0*DAREA
      DAUX(IV2)=DAUX(IV2)+0.25D0*DAREA
      DAUX(IV3)=DAUX(IV3)+0.25D0*DAREA
      DAUX(IV4)=DAUX(IV4)+0.25D0*DAREA
C
10    CONTINUE
C
C
      DO 20 IVT=1,NVT
20    DPL(IVT)=DPL(IVT)/DAUX(IVT)
C
C
C      VPH=0E0
C      DO 30 IVT=1,NVT
C30    VPH=VPH+VPL(IVT)
C      VMWP=VPH/REAL(NVT)
C
C
C      DO 40 IVT=1,NVT
C40    VPL(IVT)=VPL(IVT)-VMWP
C
C
      END
c
c
c
************************************************************************
      SUBROUTINE   SETARE  (AREA,NEL,KVERT,DCORVG)
************************************************************************
*
*   Purpose: - writes on  AREA(IEL)  the area of the element IEL,
*              IEL=1,...,NEL
*            - writes on  AREA(NEL+1) the sum of all  AREA(IEL)
*            - KVERT,DCORVG are the usual FEAT arrays
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      REAL AREA
C
      PARAMETER (NNVE=4)
C
      DIMENSION  AREA(*),KVERT(NNVE,*),DCORVG(2,*)
C=======================================================================
      SUM=0.D0
      DO  11  IEL=1,NEL
C
      I1=KVERT(1,IEL)
      I2=KVERT(2,IEL)
      I3=KVERT(3,IEL)
      I4=KVERT(4,IEL)
C
      X1=DCORVG(1,I1)
      X2=DCORVG(1,I2)
      X3=DCORVG(1,I3)
      X4=DCORVG(1,I4)
C
      Y1=DCORVG(2,I1)
      Y2=DCORVG(2,I2)
      Y3=DCORVG(2,I3)
      Y4=DCORVG(2,I4)
C
      AAA=0.5D0*(  DABS((X1-X2)*(Y3-Y2)-(Y1-Y2)*(X3-X2))
     *            +DABS((X1-X4)*(Y3-Y4)-(Y1-Y4)*(X3-X4)) )
      AREA(IEL)=REAL(AAA)
      SUM=SUM+AAA
  11  CONTINUE
C
      AREA(NEL+1)=REAL(SUM)
C
      END
c
c
c
************************************************************************
      SUBROUTINE    TOL20A  (P,AREA,NEL,INEUM)
************************************************************************
*
*    Purpose: - Transforms the vector P into the space L2_0
*             - uses the vector AREA with the areas of all elements
*               and on AREA(NEL+1) the sum of all AREA(IEL)
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      REAL AREA
C
      DIMENSION P(*),AREA(*)
C
      IF (INEUM.EQ.1) RETURN
C
      PINT=0.D0
      DO 2  IEL=1,NEL
  2   PINT=PINT+P(IEL)*DBLE(AREA(IEL))
C
      C=PINT/DBLE(AREA(NEL+1))
C
      DO 3  IEL=1,NEL
  3   P(IEL)=P(IEL)-C
C
      END
c
c
c
************************************************************************
      SUBROUTINE   SETLEV (ISETLV)
************************************************************************
*
*   Purpose:  sets all data for current level ILEV (from /MGPAR/)
*            
*   Input:
*   -------
*     ILEV        - current level number (from /MGPAR/)
*     ISETLV >=1  - update of /TRIAA/,TRIAD/ 
*            >=2  - update of /LEVDIM/,/ADRFLD/
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** global constants
      PARAMETER (NNARR=299,NNLEV=9,  NNWORK=1)
C
      CHARACTER SUB*6,FMT*15,CPARAM*120
C
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C *** Standard COMMON blocks
C
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
C
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
C
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
C
C *** COMMON blocks for multigrid data management
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGTRD/  KNEL(NNLEV),KNVT(NNLEV),KNMT(NNLEV),
     *                KNVEL(NNLEV),KNVBD(NNLEV)
      COMMON /MGTRA/  KLCVG(NNLEV),KLCMG(NNLEV),KLVERT(NNLEV),
     *                KLMID(NNLEV),KLADJ(NNLEV),KLVEL(NNLEV),
     *                KLMEL(NNLEV),KLNPR(NNLEV),KLMM(NNLEV),
     *                KLVBD(NNLEV),KLEBD(NNLEV),KLBCT(NNLEV),
     *                KLVBDP(NNLEV),KLMBDP(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
      COMMON /MGDIM/  KNA(NNLEV),KNB(NNLEV),KNU(NNLEV),KNP(NNLEV),
     *                KNUP(NNLEV)
C
      COMMON /LEVDIM/ NA,NB,NU,NP,NUP
      COMMON /ADRFLD/ KA1,KST1,KM1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                KU1,KU2,KP,KF1,KF2,KFP,KAUX1,KAUX2,KAUXP
C
C
      SAVE 
C-----------------------------------------------------------------------
C *** elementary check
      IF (ILEV.LT.NLMIN .OR. ILEV.GT.NLMAX .OR. ISETLV.LT.1  .OR.
     *    ISETLV.GT.2 )  THEN
        WRITE(MTERM,*) 'ERROR in SETLEV: ILEV or ISETLV is wrong'
        STOP
      ENDIF
C
C *** update of /TRIAD/,/TRIAA/
C
      NEL =KNEL  (ILEV)
      NVT =KNVT  (ILEV)
      NMT =KNMT  (ILEV)
      NVEL=KNVEL (ILEV)
      NVBD=KNVBD (ILEV)
C
      LCORVG=KLCVG  (ILEV)
      LCORMG=KLCMG  (ILEV)
      LVERT =KLVERT (ILEV)
      LMID  =KLMID  (ILEV)
      LADJ  =KLADJ  (ILEV)
      LVEL  =KLVEL  (ILEV)
      LMEL  =KLMEL  (ILEV)
      LNPR  =KLNPR  (ILEV)
      LMM   =KLMM   (ILEV)
      LVBD  =KLVBD  (ILEV)
      LEBD  =KLEBD  (ILEV)
      LBCT  =KLBCT  (ILEV)
      LVBDP =KLVBDP (ILEV)
      LMBDP =KLMBDP (ILEV)
C
C *** update of /LEVDIM/,/ADRFLD/ if  ISETLV=2
C
      IF (ISETLV.EQ.2)  THEN
C
         NA =KNA  (ILEV)
         NB =KNB  (ILEV)
         NU =KNU  (ILEV)
         NP =KNP  (ILEV)
         NUP=KNUP (ILEV)
C
         KA1  =L(KLA    (ILEV))
         KST1 =L(KLST   (ILEV))
         KM1  =L(KLM    (ILEV))
         KCOLA=L(KLCOLA (ILEV))
         KLDA =L(KLLDA  (ILEV))
         KB1  =L(KLB1   (ILEV))
         KB2  =L(KLB2   (ILEV))
         KCOLB=L(KLCOLB (ILEV))
         KLDB =L(KLLDB  (ILEV))
         KU1  =L(KLUP   (ILEV))
         KU2  =KU1+NU
         KP   =KU2+NU
         KF1  =L(KLF12P (ILEV))
         KF2  =KF1+NU
         KFP  =KF2+NU
         KAUX1=L(KLAUX  (ILEV))
         KAUX2=KAUX1+NU
         KAUXP=KAUX2+NU
C
      ENDIF
C
      END
c
c
c
************************************************************************
      SUBROUTINE   U2ISO (DCORVG,KVERT,KMID,KADJ,DVIND,DX,DU1,DU2)
************************************************************************
*
*   Purpose: - calculates streamlines
*
************************************************************************
C=======================================================================
C     Declarations
C=======================================================================
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
C *** global constants
      PARAMETER (NNVE=4,NNARR=299,NNWORK=1)
      DIMENSION DCORVG(2,*),KVERT(NNVE,*),KMID(NNVE,*),KADJ(NNVE,*),
     *          DVIND(*),DX(*),DU1(*),DU2(*)
      CHARACTER SUB*6,FMT*15,CPARAM*120
C-----------------------------------------------------------------------
C     C O M M O N S 
C-----------------------------------------------------------------------
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
C
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      SAVE
C-----------------------------------------------------------------------
C *** Standard dimensioning for workspace concept
      REAL  VWORK
      DIMENSION VWORK(1),KWORK(1)
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
C=======================================================================
      SUB='U2ISO '
C
C
C
C-----------------------------------------------------------------------
      DO 1 IVT=1,NVT
      DX   (IVT)=0D0
1     DVIND(IVT)=0D0
C
C
C *** start with element 1 and its first vertex
      DX(KVERT(1,1))   =0D0
      DVIND(KVERT(1,1))=1D0
C
C
      DO 10 IEH=1,NEL
C
      IEL=IEH
      IH=0
C
      DO 12 IVE= 1,NVE
      JVE=KVERT(IVE,IEL)
      IHV=INT(DVIND(JVE))
      IH=IH+IHV
      IF (IHV.GE.1) IND=IVE
12    CONTINUE
C
C
      IF ((IH.GE.NVE).OR.(IH.EQ.0)) GOTO 20
C
C
13    DO 14 IVE=1,NVE-1
C
      INDH=MOD(IND,NVE)+1
      IVTH=KVERT(INDH,IEL)
C
      IF (DVIND(IVTH).GE.1D0) GOTO 14
      DVIND(IVTH)=1D0
C
      IVT =KVERT(IND,IEL)
      IMID=KMID (IND,IEL)-NVT
C
      PX1=DCORVG(1,IVT)
      PY1=DCORVG(2,IVT)
      PX2=DCORVG(1,IVTH)
      PY2=DCORVG(2,IVTH)
      DN1 = PY2-PY1
      DN2 =-PX2+PX1
C
      DX(IVTH)=DX(IVT)+(DU1(IMID)*DN1+DU2(IMID)*DN2)
14    IND=INDH
C
C
20    DO 22 IME=1,NVE
C
      IELH=KADJ(IME,IEL)
      IF (IELH.EQ.0) GOTO 22
      IH=0
C
      DO 24 IVE=1,NVE
      JVE=KVERT(IVE,IELH)
      IHV=INT(DVIND(JVE))
      IH=IH+IHV
      IF (IHV.GE.1) INDH=IVE
24    CONTINUE
C
C
      IF ((IH.LT.NVE).AND.(IH.GT.0)) GOTO 30
C
C
22    CONTINUE
      GOTO 10
C
C
30    IEL=IELH
      IND=INDH
      GOTO 13
C
10    CONTINUE
C
      DXH=DX(1)
      DO 40 IVT=1,NVT
      DX(IVT)=DX(IVT)-DXH
40    CONTINUE
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE C2N2DM (DPC,DPL,KMID,KADJ,NEL,NMT,NVT,IPAR)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (NNVE=4)
      DIMENSION DPC(*),DPL(*),KMID(NNVE,*),KADJ(NNVE,*)
C
C-----------------------------------------------------------------------
C
C *** constant to nonconforming = 0
      IF (IPAR.EQ.0) THEN
C
       DO 10 IEL=1,NEL
       DPH  =DPC(IEL)
C
       DO 20 IVE=1,4
       IADJ=KADJ(IVE,IEL)
       IMID=KMID(IVE,IEL)-NVT
C
       IF (IADJ.EQ.0)   DPL(IMID)=DPH
       IF (IADJ.GT.IEL) DPL(IMID)=0.5D0*(DPH+DPC(IADJ))
C
20     CONTINUE
10     CONTINUE
C
      ELSE
C
       DO 110 IEL=1,NEL
       DPC(IEL)=0.25D0*( DPL(KMID(1,IEL)-NVT)+DPL(KMID(2,IEL)-NVT)
     *                  +DPL(KMID(3,IEL)-NVT)+DPL(KMID(4,IEL)-NVT))
110    CONTINUE
C
      ENDIF      
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE GRDIST(DCORVG,KNPR,NVT,DIEPS)
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      DIMENSION DCORVG(2,*),KNPR(*)
C
      H=1D0/(SQRT(DBLE(NVT))-1)
      HDIST=DIEPS*H
C
      DO 1 IVT=1,NVT
      IF (KNPR(IVT).EQ.0) THEN
       DCORVG(1,IVT)=DCORVG(1,IVT)+DBLE((-1)**MOD(IVT,17))*HDIST
       DCORVG(2,IVT)=DCORVG(2,IVT)+DBLE((-1)**IVT)*HDIST
      ENDIF
1     CONTINUE
C
      END
C
C
C
************************************************************************
      SUBROUTINE CHCOOR(DCORVG,KVERT,KMID,KADJ,KNPR,NEL,NVT)
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DIMENSION DCORVG(2,*),KVERT(4,*),KMID(4,*),KADJ(4,*),KNPR(*)
C
      DO 10 IEL=1,NEL/4
C
      IADJ3=KADJ(2,IEL)
      IADJ4=KADJ(3,IEL)
      IVT1=KVERT(2,IEL)
      IVT2=KVERT(4,IEL)
      IVT3=KVERT(2,IADJ3)
      IVT4=KVERT(4,IADJ4)
      IVTM=KVERT(3,IEL)
C
      PX1=DCORVG(1,IVT1)
      PX2=DCORVG(1,IVT2)
      PX3=DCORVG(1,IVT3)
      PX4=DCORVG(1,IVT4)
C
      PY1=DCORVG(2,IVT1)
      PY2=DCORVG(2,IVT2)
      PY3=DCORVG(2,IVT3)
      PY4=DCORVG(2,IVT4)
C
      PXM=DCORVG(1,IVTM)
      PYM=DCORVG(2,IVTM)
C
      PX=0.25D0*(PX1+PX2+PX3+PX4)
      PY=0.25D0*(PY1+PY2+PY3+PY4)
C
      DCORVG(1,IVTM)=PX
      DCORVG(2,IVTM)=PY
C
10    CONTINUE
C
      END
C
C
C
C
************************************************************************
      SUBROUTINE EM30(XI1,XI2,IPAR)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNCOF=6)
      DIMENSION DXM(4),DYM(4),DLX(4),DLY(4),A(4,4),F(4),CKH(4),CK(4,4)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     1                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
      SAVE /OUTPUT/,/ERRCTL/,/ELEM/,/CHAR/,/CUB/
C
      F1(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=1D0
      F2(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA1*X  +CB1*Y
      F3(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA2*X  +CB2*Y
      F4(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA3*X*X+CB3*X*Y+CC3*Y*Y
C
C
      SUB='EM30'
      IF (ICHECK.GE.998) CALL OTRC('EM30  ','01/08/94')
C
C
C *** Dummy call
      IF (IPAR.EQ.-1) THEN
       IER=0
       IPAR=30
       GOTO 99999
      ENDIF
C
C
      IF (IPAR.EQ.-2) THEN
       DO 20 IVE=1,NVE
       DXM(IVE)=0.5D0*(DX(IVE)+DX(MOD(IVE,4)+1))
       DYM(IVE)=0.5D0*(DY(IVE)+DY(MOD(IVE,4)+1))
       DLX(IVE)=0.5D0*(DX(MOD(IVE,4)+1)-DX(IVE))
       DLY(IVE)=0.5D0*(DY(MOD(IVE,4)+1)-DY(IVE))
20     CONTINUE
C
       CA1=(DXM(2)-DXM(4))/SQRT((DXM(2)-DXM(4))**2+(DYM(2)-DYM(4))**2)
       CB1=(DYM(2)-DYM(4))/SQRT((DXM(2)-DXM(4))**2+(DYM(2)-DYM(4))**2)
       CA2=(DXM(3)-DXM(1))/SQRT((DXM(1)-DXM(3))**2+(DYM(1)-DYM(3))**2)
       CB2=(DYM(3)-DYM(1))/SQRT((DXM(1)-DXM(3))**2+(DYM(1)-DYM(3))**2)
       CA3=CA1**2-CA2**2
       CB3=2D0*(CA1*CB1-CA2*CB2)
       CC3=CB1**2-CB2**2
C
       DO 22 IA=1,4
       PXL=DXM(IA)-SQRT(1D0/3D0)*DLX(IA)
       PYL=DYM(IA)-SQRT(1D0/3D0)*DLY(IA)
       PXU=DXM(IA)+SQRT(1D0/3D0)*DLX(IA)
       PYU=DYM(IA)+SQRT(1D0/3D0)*DLY(IA)
       A(IA,1)=0.5D0*( F1(PXL,PYL,CA1,CB1,CA2,CB2,CA3,CB3,CC3)
     *                +F1(PXU,PYU,CA1,CB1,CA2,CB2,CA3,CB3,CC3))
       A(IA,2)=0.5D0*( F2(PXL,PYL,CA1,CB1,CA2,CB2,CA3,CB3,CC3)
     *                +F2(PXU,PYU,CA1,CB1,CA2,CB2,CA3,CB3,CC3))
       A(IA,3)=0.5D0*( F3(PXL,PYL,CA1,CB1,CA2,CB2,CA3,CB3,CC3)
     *                +F3(PXU,PYU,CA1,CB1,CA2,CB2,CA3,CB3,CC3))
       A(IA,4)=0.5D0*( F4(PXL,PYL,CA1,CB1,CA2,CB2,CA3,CB3,CC3)
     *                +F4(PXU,PYU,CA1,CB1,CA2,CB2,CA3,CB3,CC3))
22     CONTINUE
C
       CALL INVERT(A,F,CKH,0)       
C
       DO 24 IK1=1,4
       DO 24 IK2=1,4
24     CK(IK1,IK2)=A(IK2,IK1)
C
       DO 26 IK=1,4
       COB(IK,1)=CK(IK,4)*CA3
       COB(IK,2)=CK(IK,4)*CC3
       COB(IK,3)=CK(IK,4)*CB3
       COB(IK,4)=CK(IK,2)*CA1+CK(IK,3)*CA2
       COB(IK,5)=CK(IK,2)*CB1+CK(IK,3)*CB2
       COB(IK,6)=CK(IK,1)
26     CONTINUE
      ENDIF
C
C

      IER=-1
C *** No second order derivatives available
C *** Used for second order problems only
      IF (BDER(4).OR.BDER(5).OR.BDER(6)) GOTO 99999
C
      IER=0
C
      IF (.NOT.BDER(1)) GOTO 101
C
C *** Function values
      DBAS(1,1)= COB(1,1)*XI1**2+COB(1,2)*XI2**2+COB(1,3)*XI1*XI2
     *          +COB(1,4)*XI1   +COB(1,5)*XI2   +COB(1,6)
      DBAS(2,1)= COB(2,1)*XI1**2+COB(2,2)*XI2**2+COB(2,3)*XI1*XI2
     *          +COB(2,4)*XI1   +COB(2,5)*XI2   +COB(2,6)
      DBAS(3,1)= COB(3,1)*XI1**2+COB(3,2)*XI2**2+COB(3,3)*XI1*XI2
     *          +COB(3,4)*XI1   +COB(3,5)*XI2   +COB(3,6)
      DBAS(4,1)= COB(4,1)*XI1**2+COB(4,2)*XI2**2+COB(4,3)*XI1*XI2
     *          +COB(4,4)*XI1   +COB(4,5)*XI2   +COB(4,6)
101   IF (.NOT.(BDER(2).OR.BDER(3))) GOTO 99999
C
C *** First order derivatives
      IF (.NOT.BDER(2)) GOTO 102
      DBAS(1,2)= 2D0*COB(1,1)*XI1+COB(1,3)*XI2+COB(1,4)
      DBAS(2,2)= 2D0*COB(2,1)*XI1+COB(2,3)*XI2+COB(2,4)
      DBAS(3,2)= 2D0*COB(3,1)*XI1+COB(3,3)*XI2+COB(3,4)
      DBAS(4,2)= 2D0*COB(4,1)*XI1+COB(4,3)*XI2+COB(4,4)
C
102   IF (.NOT.BDER(3)) GOTO 99999
      DBAS(1,3)= 2D0*COB(1,2)*XI2+COB(1,3)*XI1+COB(1,5)
      DBAS(2,3)= 2D0*COB(2,2)*XI2+COB(2,3)*XI1+COB(2,5)
      DBAS(3,3)= 2D0*COB(3,2)*XI2+COB(3,3)*XI1+COB(3,5)
      DBAS(4,3)= 2D0*COB(4,2)*XI2+COB(4,3)*XI1+COB(4,5)
C
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE EM31(XI1,XI2,IPAR)
C
      IMPLICIT DOUBLE PRECISION (A,C-H,O-U,W-Z),LOGICAL(B)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      PARAMETER (NNBAS=21,NNDER=6,NNCUBP=36,NNVE=4,NNCOF=6)
      DIMENSION DXM(4),DYM(4),A(4,4),F(4),CKH(4),CK(4,4)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /ELEM/   DX(NNVE),DY(NNVE),DJAC(2,2),DETJ,
     1                DBAS(NNBAS,NNDER),BDER(NNDER),KVE(NNVE),IEL
      COMMON /CUB/    DXI(NNCUBP,3),DOMEGA(NNCUBP),NCUBP,ICUBP
      COMMON /COFBAS/ COB(NNBAS,NNCOF)
      SAVE /OUTPUT/,/ERRCTL/,/ELEM/,/CHAR/,/CUB/
C
      F1(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=1D0
      F2(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA1*X  +CB1*Y
      F3(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA2*X  +CB2*Y
      F4(X,Y,CA1,CB1,CA2,CB2,CA3,CB3,CC3)=CA3*X*X+CB3*X*Y+CC3*Y*Y
C
C
      SUB='EM31'
      IF (ICHECK.GE.998) CALL OTRC('EM31  ','01/08/94')
C
C
C *** Dummy call
      IF (IPAR.EQ.-1) THEN
       IER=0
       IPAR=31
       GOTO 99999
      ENDIF
C
C
      IF (IPAR.EQ.-2) THEN
       DO 20 IVE=1,NVE
       DXM(IVE)=0.5D0*(DX(IVE)+DX(MOD(IVE,4)+1))
       DYM(IVE)=0.5D0*(DY(IVE)+DY(MOD(IVE,4)+1))
20     CONTINUE
C
       CA1=(DXM(2)-DXM(4))/SQRT((DXM(2)-DXM(4))**2+(DYM(2)-DYM(4))**2)
       CB1=(DYM(2)-DYM(4))/SQRT((DXM(2)-DXM(4))**2+(DYM(2)-DYM(4))**2)
       CA2=(DXM(3)-DXM(1))/SQRT((DXM(1)-DXM(3))**2+(DYM(1)-DYM(3))**2)
       CB2=(DYM(3)-DYM(1))/SQRT((DXM(1)-DXM(3))**2+(DYM(1)-DYM(3))**2)
       CA3=CA1**2-CA2**2
       CB3=2D0*(CA1*CB1-CA2*CB2)
       CC3=CB1**2-CB2**2
C
       DO 22 IA=1,4
       A(IA,1)=F1(DXM(IA),DYM(IA),CA1,CB1,CA2,CB2,CA3,CB3,CC3)       
       A(IA,2)=F2(DXM(IA),DYM(IA),CA1,CB1,CA2,CB2,CA3,CB3,CC3)       
       A(IA,3)=F3(DXM(IA),DYM(IA),CA1,CB1,CA2,CB2,CA3,CB3,CC3)       
       A(IA,4)=F4(DXM(IA),DYM(IA),CA1,CB1,CA2,CB2,CA3,CB3,CC3)
22     CONTINUE
C
       CALL INVERT(A,F,CKH,0)       
C
       DO 24 IK1=1,4
       DO 24 IK2=1,4
24     CK(IK1,IK2)=A(IK2,IK1)
C
       DO 26 IK=1,4
       COB(IK,1)=CK(IK,4)*CA3
       COB(IK,2)=CK(IK,4)*CC3
       COB(IK,3)=CK(IK,4)*CB3
       COB(IK,4)=CK(IK,2)*CA1+CK(IK,3)*CA2
       COB(IK,5)=CK(IK,2)*CB1+CK(IK,3)*CB2
       COB(IK,6)=CK(IK,1)
26     CONTINUE
      ENDIF
C
C

      IER=-1
C *** No second order derivatives available
C *** Used for second order problems only
      IF (BDER(4).OR.BDER(5).OR.BDER(6)) GOTO 99999
C
      IER=0
C
      IF (.NOT.BDER(1)) GOTO 101
C
C *** Function values
      DBAS(1,1)= COB(1,1)*XI1**2+COB(1,2)*XI2**2+COB(1,3)*XI1*XI2
     *          +COB(1,4)*XI1   +COB(1,5)*XI2   +COB(1,6)
      DBAS(2,1)= COB(2,1)*XI1**2+COB(2,2)*XI2**2+COB(2,3)*XI1*XI2
     *          +COB(2,4)*XI1   +COB(2,5)*XI2   +COB(2,6)
      DBAS(3,1)= COB(3,1)*XI1**2+COB(3,2)*XI2**2+COB(3,3)*XI1*XI2
     *          +COB(3,4)*XI1   +COB(3,5)*XI2   +COB(3,6)
      DBAS(4,1)= COB(4,1)*XI1**2+COB(4,2)*XI2**2+COB(4,3)*XI1*XI2
     *          +COB(4,4)*XI1   +COB(4,5)*XI2   +COB(4,6)
101   IF (.NOT.(BDER(2).OR.BDER(3))) GOTO 99999
C
C *** First order derivatives
      IF (.NOT.BDER(2)) GOTO 102
      DBAS(1,2)= 2D0*COB(1,1)*XI1+COB(1,3)*XI2+COB(1,4)
      DBAS(2,2)= 2D0*COB(2,1)*XI1+COB(2,3)*XI2+COB(2,4)
      DBAS(3,2)= 2D0*COB(3,1)*XI1+COB(3,3)*XI2+COB(3,4)
      DBAS(4,2)= 2D0*COB(4,1)*XI1+COB(4,3)*XI2+COB(4,4)
C
102   IF (.NOT.BDER(3)) GOTO 99999
      DBAS(1,3)= 2D0*COB(1,2)*XI2+COB(1,3)*XI1+COB(1,5)
      DBAS(2,3)= 2D0*COB(2,2)*XI2+COB(2,3)*XI1+COB(2,5)
      DBAS(3,3)= 2D0*COB(3,2)*XI2+COB(3,3)*XI1+COB(3,5)
      DBAS(4,3)= 2D0*COB(4,2)*XI2+COB(4,3)*XI1+COB(4,5)
C
C
99999 END
C
C
C
************************************************************************
      SUBROUTINE INVERT(A,F,X,IPAR)
      DOUBLE PRECISION A,B,F,X
      PARAMETER (NDIM=4)
      DIMENSION A(NDIM,NDIM),B(NDIM,NDIM),F(NDIM),X(NDIM),
     *          MERKX(NDIM),MERKY(NDIM)
C
C
      IF (IPAR.EQ.0) THEN
       CALL AUSTAU(NDIM,NDIM,A,B,MERKX,MERKY,IFEHL)
       DO 10 IA=1,NDIM
       DO 10 IB=1,NDIM
10     A(IA,IB)=B(IA,IB)
      ENDIF
C
      IF (IPAR.EQ.1) THEN
       DO 20 IA=1,NDIM
       X(IA)=0D0
       DO 22 IB=1,NDIM
       X(IA)=X(IA)+A(IA,IB)*F(IB)
22     CONTINUE
20     CONTINUE
      ENDIF
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE AUSTAU(NDIM,N,A,B,MERKX,MERKY,IFEHL)
      DOUBLE PRECISION A,B,HILF,PIVOT
      DIMENSION A(NDIM,N),B(NDIM,N),MERKX(N),MERKY(N)
C
      IFEHL=1
      DO 100 I=1,N
      MERKX(I)=0
      MERKY(I)=0
      DO 100 L=1,N
100   B(I,L)=A(I,L)
C
      DO 400 I=1,N
      PIVOT=0D0
      DO 200 IX=1,N
      IF (MERKX(IX).NE.0) GOTO 200
      DO 180 IY=1,N
      IF (MERKY(IY).NE.0) GOTO 180
      IF (ABS(B(IX,IY)).LE.ABS(PIVOT)) GOTO 180
      PIVOT=B(IX,IY)
      INDX=IX
      INDY=IY
180   CONTINUE
200   CONTINUE
C
      IF (ABS(PIVOT).LE.0.0) GOTO 770
      MERKX(INDX)=INDY
      MERKY(INDY)=INDX
      B(INDX,INDY)=1D0/PIVOT
      DO 300 L=1,N
      IF (L.EQ.INDX) GOTO 300
      DO 280 M=1,N
      IF (M.EQ.INDY) GOTO 280
      B(L,M)=B(L,M)-B(L,INDY)*B(INDX,M)/PIVOT
280   CONTINUE
300   CONTINUE
C
      DO 390 IX=1,N
      IF (IX.NE.INDX) B(IX,INDY)=B(IX,INDY)/PIVOT
390   CONTINUE
      DO 400 IY=1,N
      IF (IY.NE.INDY) B(INDX,IY)=-B(INDX,IY)/PIVOT
400   CONTINUE
C
C
      DO 500 I=2,N
      IX=I-1
      IF (MERKX(IX).EQ.IX) GOTO 500
      DO 450 J=1,N
      IY=J
      IF (MERKX(IY).EQ.IX) GOTO 460
450   CONTINUE
460   DO 490 K=1,N
      HILF=B(IX,K)
      B(IX,K)=B(IY,K)
490   B(IY,K)=HILF
      MERKX(IY)=MERKX(IX)
500   MERKX(IX)=IX
      DO 600 I=2,N
      IX=I-1
      IF (MERKY(IX).EQ.IX) GOTO 600
      DO 550 J=1,N
      IY=J
      IF (MERKY(IY).EQ.IX) GOTO 560
550   CONTINUE
560   DO 590 K=1,N
      HILF=B(K,IX)
      B(K,IX)=B(K,IY)
590   B(K,IY)=HILF
      MERKY(IY)=MERKY(IX)
600   MERKY(IX)=IX
C
      IFEHL=0
770   RETURN
      END
C
C
C
************************************************************************
      SUBROUTINE CRITAD(TIMEIN,TIMENS,TIMEST,EPSADI,EPSADL,EPSAD,IADIN)
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      PARAMETER (PI=3.1415926535897931D0)
C
      EPSAD=EPSADL
C
      IF (TIMEIN.GT.0) THEN
       TDIFF=TIMENS-TIMEST
C
       IF (IADIN.EQ.0) THEN
        IF (TDIFF.LE.TIMEIN) THEN
         EPSAD=EPSADI
        ELSE
         EPSAD=EPSADL
        ENDIF
       ENDIF
C
       IF (IADIN.EQ.1) THEN
        IF (TDIFF.LE.TIMEIN) THEN
         EPSAD=EPSADI+TDIFF/TIMEIN*(EPSADL-EPSADI)
        ELSE
         EPSAD=EPSADL
        ENDIF
       ENDIF
C
       IF (IADIN.EQ.2) THEN
        IF (TDIFF.LE.TIMEIN) THEN
         EPSAD=EPSADI**(1D0-TDIFF/TIMEIN)*EPSADL**(TDIFF/TIMEIN)
        ELSE
         EPSAD=EPSADL
        ENDIF
       ENDIF
C
      ENDIF
C
C
C     
      END
C
C
C

************************************************************************
      SUBROUTINE BBUILD(KVERT,KMID,KADJ,DCORVG,B1,B2,KCOLB,KLDB,
     *                  NB,NEL,NVT,NMT)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
      DOUBLE PRECISION B1,B2
C
      PARAMETER (NNVE=4)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),KADJ(NNVE,*),DCORVG(2,*)
      DIMENSION B1(*),B2(*),KCOLB(*),KLDB(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
C
C
      ILD=0
C
      DO 10 IEL=1,NEL
C
      DO 20 IVE=1,4
      IADJ=KADJ(IVE,IEL)
      IF ((IADJ.GT.0).AND.(IADJ.LT.IEL)) GOTO 20
C
      IVEN=IVE+1
      IF (IVEN.EQ.5) IVEN=1
C
      IMID=KMID (IVE ,IEL)-NVT
      IVT =KVERT(IVE ,IEL)
      IVTN=KVERT(IVEN,IEL)
C
      PX =DCORVG(1,IVT)
      PY =DCORVG(2,IVT)
      PXN=DCORVG(1,IVTN)
      PYN=DCORVG(2,IVTN)
C
      DN1=-PYN+PY
      DN2= PXN-PX
C
      ILD=ILD+1
      KLDB (IMID)=ILD
      KCOLB(ILD )=IEL
      B1   (ILD )=DN1
      B2   (ILD )=DN2
C
      IF (IADJ.GT.0) THEN
       ILD=ILD+1
       KCOLB(ILD)= IADJ
       B1   (ILD)=-DN1
       B2   (ILD)=-DN2
      ENDIF
C
20    CONTINUE
C
10    CONTINUE
C
      NB         =ILD
      KLDB(NMT+1)=ILD+1
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE BMUL1 (KVERT,KMID,KADJ,DCORVG,DP,DF1,DF2,
     *                  NEL,NVT,NMT,A1,A2)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),KADJ(NNVE,*),DCORVG(2,*)
      DIMENSION DP(*),DF1(*),DF2(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
C
C
      DO 10 IEL=1,NEL
C
      DO 20 IVE=1,4
      IADJ=KADJ(IVE,IEL)
      IF ((IADJ.GT.0).AND.(IADJ.LT.IEL)) GOTO 20
C
      IVEN=IVE+1
      IF (IVEN.EQ.5) IVEN=1
C
      IMID=KMID (IVE ,IEL)-NVT
      IVT =KVERT(IVE ,IEL)
      IVTN=KVERT(IVEN,IEL)
C
      PX =DCORVG(1,IVT)
      PY =DCORVG(2,IVT)
      PXN=DCORVG(1,IVTN)
      PYN=DCORVG(2,IVTN)
C
      DN1=-PYN+PY
      DN2= PXN-PX
C
      IF (IADJ.GT.0) THEN
       DF1(IMID)=A2*DF1(IMID)+A1*DN1*(DP(IEL)-DP(IADJ))
       DF2(IMID)=A2*DF2(IMID)+A1*DN2*(DP(IEL)-DP(IADJ))
      ELSE
       DF1(IMID)=A2*DF1(IMID)+A1*DN1*DP(IEL)
       DF2(IMID)=A2*DF2(IMID)+A1*DN2*DP(IEL)
      ENDIF
C
20    CONTINUE
C
10    CONTINUE
C
C
C
      END
C
C
C
************************************************************************
      SUBROUTINE BTMUL1(KVERT,KMID,KADJ,DCORVG,DU1,DU2,DFP,
     *                  NEL,NVT,NMT,A1)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)
C
      PARAMETER (NNVE=4)
      DIMENSION KVERT(NNVE,*),KMID(NNVE,*),KADJ(NNVE,*),DCORVG(2,*)
      DIMENSION DFP(*),DU1(*),DU2(*)
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      SAVE
C
C
C
      DO 10 IEL=1,NEL
      DFP(IEL)=0D0
C
      DO 20 IVE=1,4
      IVEN=IVE+1
      IF (IVEN.EQ.5) IVEN=1
C
      IMID=KMID (IVE ,IEL)-NVT
      IVT =KVERT(IVE ,IEL)
      IVTN=KVERT(IVEN,IEL)
C
      PX =DCORVG(1,IVT)
      PY =DCORVG(2,IVT)
      PXN=DCORVG(1,IVTN)
      PYN=DCORVG(2,IVTN)
C
      DN1=-PYN+PY
      DN2= PXN-PX
C
      DFP(IEL)=DFP(IEL)+A1*(DN1*DU1(IMID)+DN2*DU2(IMID))
C
20    CONTINUE
C
10    CONTINUE
C
C
C
      END

************************************************************************
      SUBROUTINE XMADF1(KM1,KST1,KA1,KCOLA,KLDA,KF1,KF2,KU1,KU2,
     *                  NA,NU,THSTEP)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)      
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CFILST*12,CFILM*12,CFILE*12
      DIMENSION CFILST(NNLEV),CFILM(NNLEV)
      DATA CFILST/'#ns/ST1     ','#ns/ST2     ','#ns/ST3     ',
     *            '#ns/ST4     ','#ns/ST5     ','#ns/ST6     ',
     *            '#ns/ST7     ','#ns/ST8     ','#ns/ST9     '/
      DATA CFILM /'#ns/MA1     ','#ns/MA2     ','#ns/MA3     ',
     *            '#ns/MA4     ','#ns/MA5     ','#ns/MA6     ',
     *            '#ns/MA7     ','#ns/MA8     ','#ns/MA9     '/
C
      DIMENSION VWORK(1),KWORK(1)
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C-----------------------------------------------------------------------
C
      IF (IPRECA.EQ.0) THEN
C
       IF (IMASS.EQ.1) THEN
        IF (THSTEP.NE.0D0) THEN
         CALL LLC2(VWORK(KST1)  ,VWORK(KA1),NA,THSTEP,0D0)
         CALL LLC2(VWORK(KM1),VWORK(KA1),NA,1D0,1D0)
        ELSE
         CALL LCP2(VWORK(KM1),VWORK(KA1),NA)
        ENDIF
       ELSE
        IF (THSTEP.NE.0D0) THEN
         CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
         DO 100 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
100      VWORK(KA1+INUA)=VWORK(KA1+INUA)+VWORK(KM1+INU-1)
        ELSE
         CALL LCL2(VWORK(KA1),NA)
         DO 110 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
110      VWORK(KA1+INUA)=VWORK(KM1+INU-1)
        ENDIF
       ENDIF
C
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU1),DWORK(KF1),1D0,1D0)
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU2),DWORK(KF2),1D0,1D0)
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.1) THEN
C
       IF (IMASS.EQ.0) THEN
        IF (THSTEP.NE.0D0) THEN
         CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU1),DWORK(KF1),THSTEP,1D0)
         CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU2),DWORK(KF2),THSTEP,1D0)
C
         DO 200 INU=1,NU
         DWORK(KF1+INU-1)= DWORK(KF1+INU-1)
     *                    +DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
         DWORK(KF2+INU-1)= DWORK(KF2+INU-1)
     *                    +DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
200      CONTINUE
C
         DO 210 INA=1,NA
210      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1))
C
         DO 220 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
220      VWORK(KA1+INUA)=VWORK(KA1+INUA)+REAL(DWORK(KM1+INU-1))
        ELSE
         DO 230 INU=1,NU
         DWORK(KF1+INU-1)= DWORK(KF1+INU-1)
     *                    +DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
         DWORK(KF2+INU-1)= DWORK(KF2+INU-1)
     *                    +DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
230      CONTINUE
C
         CALL LCL2(VWORK(KA1),NA)
C
         DO 240 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
240      VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
        ENDIF
       ELSE
        IF (THSTEP.NE.0D0) THEN
         CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU1),DWORK(KF1),THSTEP,1D0)
         CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU2),DWORK(KF2),THSTEP,1D0)
         CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU1),DWORK(KF1),1D0,1D0)
         CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU2),DWORK(KF2),1D0,1D0)
C
         DO 250 INA=1,NA
250      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1)
     *                               +DWORK(KM1+INA-1))
        ELSE
         CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU1),DWORK(KF1),1D0,1D0)
         CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                DWORK(KU2),DWORK(KF2),1D0,1D0)
C
         CALL LCL2(VWORK(KA1),NA)
C
         DO 260 INA=1,NA
260      VWORK(KA1+INA-1)=REAL(DWORK(KM1+INA-1))
        ENDIF
       ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.2) THEN
C
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA2 (VWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC2(VWORK(KA1),VWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL2(VWORK(KA1),NA)
       ENDIF
C
       IF (IMASS.EQ.1) THEN
        CALL  OF0 (59,CFILM(ILEV),0)
        CFILE='MASMAT'
        CALL  ORALC2 (VWORK(KA1),1D0,CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 300 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
300      VWORK(KA1+INUA)=VWORK(KA1+INUA)+VWORK(KM1+INU-1)
        ELSE
         DO 310 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
310      VWORK(KA1+INUA)=VWORK(KM1+INU-1)
        ENDIF
       ENDIF
C
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU1),DWORK(KF1),1D0,1D0)
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU2),DWORK(KF2),1D0,1D0)
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.3) THEN
C
       CALL ZCTYPE(1,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA1 (DWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC1(DWORK(KA1),DWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL1(DWORK(KA1),NA)
       ENDIF
C
       IF (IMASS.EQ.1) THEN
        CALL  OF0 (59,CFILM(ILEV),0)
        CFILE='MASMAT'
        CALL  ORALC1 (DWORK(KA1),1D0,CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 400 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
400      DWORK(KA1+INUA)=DWORK(KA1+INUA)+DWORK(KM1+INU-1)
        ELSE
         DO 410 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
410      DWORK(KA1+INUA)=DWORK(KM1+INU-1)
        ENDIF
       ENDIF
C
       CALL  LAX17 (DWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU1),DWORK(KF1),1D0,1D0)
       CALL  LAX17 (DWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU2),DWORK(KF2),1D0,1D0)
C
       CALL ZCTYPE(2,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.4) THEN
C
       IF (IMASS.EQ.0) THEN
        DO 510 INU=1,NU
        DWORK(KF1+INU-1)= DWORK(KF1+INU-1)
     *                   +DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
        DWORK(KF2+INU-1)= DWORK(KF2+INU-1)
     *                   +DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
510     CONTINUE
C
        CALL LCL2(VWORK(KA1),NA)
C
        DO 520 INU=1,NU
        INUA=KWORK(KLDA+INU-1)-1
520     VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
       ELSE
        CALL LCL2(VWORK(KA1),NA)
       ENDIF
C
      ENDIF
C
C
C
99998 END
C
C
C
************************************************************************
      SUBROUTINE XMADF2(KM1,KST1,KA1,KCOLA,KLDA,KB1,KB2,KCOLB,KLDB,
     *                  KD1,KD2,KDP,KU1,KU2,KP,NA,NU,NP,KMBD,NMBD,INEUM,
     *                  THSTEP,ISTAT)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)      
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CFILST*12,CFILM*12,CFILE*12
      DIMENSION CFILST(NNLEV),CFILM(NNLEV)
      DATA CFILST/'#ns/ST1     ','#ns/ST2     ','#ns/ST3     ',
     *            '#ns/ST4     ','#ns/ST5     ','#ns/ST6     ',
     *            '#ns/ST7     ','#ns/ST8     ','#ns/ST9     '/
      DATA CFILM /'#ns/MA1     ','#ns/MA2     ','#ns/MA3     ',
     *            '#ns/MA4     ','#ns/MA5     ','#ns/MA6     ',
     *            '#ns/MA7     ','#ns/MA8     ','#ns/MA9     '/
C
      DIMENSION KMBD(*)
      DIMENSION VWORK(1),KWORK(1)
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      COMMON /TRIAA/  LCORVG,LCORMG,LVERT,LMID,LADJ,LVEL,LMEL,LNPR,LMM,
     *                LVBD,LEBD,LBCT,LVBDP,LMBDP
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C-----------------------------------------------------------------------
C
      IF (IPRECA.EQ.0) THEN
C
       IF (ISTAT.EQ.1) THEN
        IF (IMASS.EQ.1) THEN
         IF (THSTEP.NE.0D0) THEN
          CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
          CALL LLC2(VWORK(KM1 ),VWORK(KA1),NA,1D0,1D0)
         ELSE
          CALL LCP2(VWORK(KM1),VWORK(KA1),NA)
         ENDIF
        ELSE
         IF (THSTEP.NE.0D0) THEN
          CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
          DO 100 INU=1,NU
          INUA=KWORK(KLDA+INU-1)-1
100       VWORK(KA1+INUA)=VWORK(KA1+INUA)+VWORK(KM1+INU-1)
         ELSE
          CALL LCL2(VWORK(KA1),NA)
          DO 110 INU=1,NU
          INUA=KWORK(KLDA+INU-1)-1
110       VWORK(KA1+INUA)=VWORK(KM1+INU-1)
         ENDIF
        ENDIF
       ELSE
        CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
       ENDIF

C
       IF (INLMAX.GT.1) THEN
        CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU1),DWORK(KD1),-1D0,1D0)
        CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU2),DWORK(KD2),-1D0,1D0)
       ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.1) THEN
C
      IF (ISTAT.EQ.1) THEN
       IF (IMASS.EQ.0) THEN
        IF (THSTEP.NE.0D0) THEN
         IF (INLMAX.GT.1) THEN
          CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU1),DWORK(KD1),-THSTEP,1D0)
          CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU2),DWORK(KD2),-THSTEP,1D0)
C
          DO 200 INU=1,NU
          DWORK(KD1+INU-1)= DWORK(KD1+INU-1)
     *                     -DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
          DWORK(KD2+INU-1)= DWORK(KD2+INU-1)
     *                     -DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
200       CONTINUE
         ENDIF
C
         DO 210 INA=1,NA
210      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1))
C
         DO 220 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
220      VWORK(KA1+INUA)=VWORK(KA1+INUA)+REAL(DWORK(KM1+INU-1))
        ELSE
         IF (INLMAX.GT.1) THEN
          DO 230 INU=1,NU
          DWORK(KD1+INU-1)= DWORK(KD1+INU-1)
     *                     -DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
          DWORK(KD2+INU-1)= DWORK(KD2+INU-1)
     *                     -DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
230       CONTINUE
         ENDIF
C
         CALL LCL2(VWORK(KA1),NA)
C
         DO 240 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
240      VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
        ENDIF
       ELSE
        IF (THSTEP.NE.0D0) THEN
         IF (INLMAX.GT.1) THEN
          CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU1),DWORK(KD1),-THSTEP,1D0)
          CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU2),DWORK(KD2),-THSTEP,1D0)
          CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU1),DWORK(KD1),-1D0,1D0)
          CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU2),DWORK(KD2),-1D0,1D0)
         ENDIF
C
         DO 250 INA=1,NA
250      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1)
     *                               +DWORK(KM1+INA-1))
        ELSE
         IF (INLMAX.GT.1) THEN
          CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU1),DWORK(KD1),-1D0,1D0)
          CALL  LAX17 (DWORK(KM1),KWORK(KCOLA),KWORK(KLDA),NU,
     *                 DWORK(KU2),DWORK(KD2),-1D0,1D0)
         ENDIF
C
         CALL LCL2(VWORK(KA1),NA)
C
         DO 260 INA=1,NA
260      VWORK(KA1+INA-1)=REAL(DWORK(KM1+INA-1))
        ENDIF
       ENDIF
      ELSE
       IF (INLMAX.GT.1) THEN
        CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU1),DWORK(KD1),-THSTEP,1D0)
        CALL  LAX17 (DWORK(KST1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU2),DWORK(KD2),-THSTEP,1D0)
       ENDIF
       DO 270 INA=1,NA
270    VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1))
      ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.2) THEN
C
      IF (ISTAT.EQ.1) THEN
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA2 (VWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC2(VWORK(KA1),VWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL2(VWORK(KA1),NA)
       ENDIF
C
       IF (IMASS.EQ.1) THEN
        CALL  OF0 (59,CFILM(ILEV),0)
        CFILE='MASMAT'
        CALL  ORALC2 (VWORK(KA1),1D0,CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 300 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
300      VWORK(KA1+INUA)=VWORK(KA1+INUA)+VWORK(KM1+INU-1)
        ELSE
         DO 310 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
310      VWORK(KA1+INUA)=VWORK(KM1+INU-1)
        ENDIF
       ENDIF
      ELSE
       CALL  OF0 (59,CFILST(ILEV),0)
       CFILE='STMAT '
       CALL  ORA2 (VWORK(KA1),CFILE,59,0)
       REWIND(59)
       CLOSE (59)
       IF (IER.NE.0) RETURN
       CALL LLC2(VWORK(KA1),VWORK(KA1),NA,THSTEP,0D0)
      ENDIF
C
      IF (INLMAX.GT.1) THEN
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU1),DWORK(KD1),-1D0,1D0)
       CALL  LAX37 (VWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *              DWORK(KU2),DWORK(KD2),-1D0,1D0)
      ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.3) THEN
C
       CALL ZCTYPE(1,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA1 (DWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC1(DWORK(KA1),DWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL1(DWORK(KA1),NA)
       ENDIF
C
       IF (ISTAT.EQ.1) THEN
        IF (IMASS.EQ.1) THEN
         CALL  OF0 (59,CFILM(ILEV),0)
         CFILE='MASMAT'
         CALL  ORALC1 (DWORK(KA1),1D0,CFILE,59,0)
         REWIND(59)
         CLOSE (59)
         IF (IER.NE.0) RETURN
        ELSE
         IF (THSTEP.NE.0D0) THEN
          DO 400 INU=1,NU
          INUA=KWORK(KLDA+INU-1)-1
400       DWORK(KA1+INUA)=DWORK(KA1+INUA)+DWORK(KM1+INU-1)
         ELSE
          DO 410 INU=1,NU
          INUA=KWORK(KLDA+INU-1)-1
410       DWORK(KA1+INUA)=DWORK(KM1+INU-1)
         ENDIF
        ENDIF
       ENDIF
C
       IF (INLMAX.GT.1) THEN
        CALL  LAX17 (DWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU1),DWORK(KD1),-1D0,1D0)
        CALL  LAX17 (DWORK(KA1),KWORK(KCOLA),KWORK(KLDA),NU,
     *               DWORK(KU2),DWORK(KD2),-1D0,1D0)
       ENDIF
C
       CALL ZCTYPE(2,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.4) THEN
C
      IF (ISTAT.EQ.1) THEN
       IF (IMASS.EQ.0) THEN
        IF (INLMAX.GT.1) THEN
         DO 510 INU=1,NU
         DWORK(KD1+INU-1)= DWORK(KD1+INU-1)
     *                    -DWORK(KM1+INU-1)*DWORK(KU1+INU-1)
         DWORK(KD2+INU-1)= DWORK(KD2+INU-1)
     *                    -DWORK(KM1+INU-1)*DWORK(KU2+INU-1)
510      CONTINUE
        ENDIF
C
        CALL LCL2(VWORK(KA1),NA)
C
        DO 520 INU=1,NU
        INUA=KWORK(KLDA+INU-1)-1
520     VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
       ELSE
        CALL LCL2(VWORK(KA1),NA)
       ENDIF
      ELSE
       CALL LCL2(VWORK(KA1),NA)
      ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECB.EQ.0) THEN
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD1),KMBD,NMBD,0.5D0)
       CALL  LAX39 (VWORK(KB1),KWORK(KCOLB),KWORK(KLDB),NU,
     *              DWORK(KP),DWORK(KD1),-1D0,1D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD1),KMBD,NMBD,2.0D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD2),KMBD,NMBD,0.5D0)
       CALL  LAX39 (VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),NU,
     *              DWORK(KP),DWORK(KD2),-1D0,1D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD2),KMBD,NMBD,2.0D0)
      ENDIF
C
      IF (IPRECB.EQ.1) THEN
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD1),KMBD,NMBD,0.5D0)
       CALL  LAX19 (DWORK(KB1),KWORK(KCOLB),KWORK(KLDB),NU,
     *              DWORK(KP),DWORK(KD1),-1D0,1D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD1),KMBD,NMBD,2.0D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD2),KMBD,NMBD,0.5D0)
       CALL  LAX19 (DWORK(KB2),KWORK(KCOLB),KWORK(KLDB),NU,
     *              DWORK(KP),DWORK(KD2),-1D0,1D0)
       IF (INEUM.EQ.1) CALL  BDRDEF(DWORK(KD2),KMBD,NMBD,2.0D0)
      ENDIF
C
      IF (IPRECB.EQ.2) THEN
       CALL BMUL1 (KWORK(L(LVERT)),KWORK(L(LMID)),KWORK(L(LADJ)),
     *             DWORK(L(LCORVG)),DWORK(KP),DWORK(KD1),DWORK(KD2),
     *             NEL,NVT,NMT,-1D0,1D0)
      ENDIF
C
C=======================================================================
C
      IF (INLMAX.GT.1) CALL  BDRY0 (DWORK(KD1),DWORK(KD2),KMBD,NMBD)
C
C=======================================================================
C
      IF (IPRECB.EQ.0) THEN
       CALL  LTX39 (VWORK(KB1),KWORK(KCOLB),KWORK(KLDB),NU,NP,
     *              DWORK(KU1),DWORK(KDP),-1D0,1D0)
       CALL  LTX39 (VWORK(KB2),KWORK(KCOLB),KWORK(KLDB),NU,NP,
     *              DWORK(KU2),DWORK(KDP),-1D0,1D0)
      ENDIF
C
      IF (IPRECB.EQ.1) THEN
       CALL  LTX19 (DWORK(KB1),KWORK(KCOLB),KWORK(KLDB),NU,NP,
     *              DWORK(KU1),DWORK(KDP),-1D0,1D0)
       CALL  LTX19 (DWORK(KB2),KWORK(KCOLB),KWORK(KLDB),NU,NP,
     *              DWORK(KU2),DWORK(KDP),-1D0,1D0)
      ENDIF
C
      IF (IPRECB.EQ.2) THEN
       WRITE(6,*) 'BTMUL ???'
       CALL BTMUL1(KWORK(L(LVERT)),KWORK(L(LMID)),KWORK(L(LADJ)),
     *             DWORK(L(LCORVG)),DWORK(KU1),DWORK(KU2),DWORK(KDP),
     *             NEL,NVT,NMT,-1D0)
      ENDIF
C
C
C
99998 END
C
C
C
************************************************************************
      SUBROUTINE XMADF3(KM1,KST1,KA1,KCOLA,KLDA,NA,NU,THSTEP,ISTAT)
************************************************************************
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z),LOGICAL(B)      
      PARAMETER (NNARR=299,NNLEV=9,NNWORK=1)
      CHARACTER SUB*6,FMT*15,CPARAM*120
      CHARACTER CFILST*12,CFILM*12,CFILE*12
      DIMENSION CFILST(NNLEV),CFILM(NNLEV)
      DATA CFILST/'#ns/ST1     ','#ns/ST2     ','#ns/ST3     ',
     *            '#ns/ST4     ','#ns/ST5     ','#ns/ST6     ',
     *            '#ns/ST7     ','#ns/ST8     ','#ns/ST9     '/
      DATA CFILM /'#ns/MA1     ','#ns/MA2     ','#ns/MA3     ',
     *            '#ns/MA4     ','#ns/MA5     ','#ns/MA6     ',
     *            '#ns/MA7     ','#ns/MA8     ','#ns/MA9     '/
C
      DIMENSION VWORK(1),KWORK(1)
C
C *** Standard COMMON blocks
      COMMON          NWORK,IWORK,IWMAX,L(NNARR),DWORK(NNWORK)
      COMMON /ERRCTL/ IER,ICHECK
      COMMON /CHAR/   SUB,FMT(3),CPARAM
      COMMON /OUTPUT/ M,MT,MKEYB,MTERM,MERR,MPROT,MSYS,MTRC,IRECL8
      COMMON /MGPAR/  ILEV,NLEV,NLMIN,NLMAX,
     *                ICYCLE,KPRSM(NNLEV),KPOSM(NNLEV)
      COMMON /MGFLD/  KLA(NNLEV),KLST(NNLEV),KLM(NNLEV),KLCOLA(NNLEV),
     *                KLLDA(NNLEV),KLB1(NNLEV),KLB2(NNLEV),
     *                KLCOLB(NNLEV),KLLDB(NNLEV),
     *                KLUP(NNLEV),KLF12P(NNLEV),KLAUX(NNLEV),
     *                KLAREA(NNLEV),LU1OLD,LU2OLD,LPOLD,LD1,LD2,LDP
C
C *** user COMMON blocks
      INTEGER  VIPARM 
      DIMENSION VIPARM(100)                     
      EQUIVALENCE (IAUSAV,VIPARM)   
      COMMON /IPARM/ IAUSAV,IELT,ISTOK,IRHS,IBDR,IERANA,IMASS,IMASSL,
     *               IUPW,IPRECA,IPRECB,ICUBM,ICUBA,ICUBN,ICUBB,ICUBF,
     *               INLMIN,INLMAX,ICYC,ILMIN,ILMAX,IINT,ISM,ISL,
     *               NSM,NSL,NSMFAC
C
      DOUBLE PRECISION VRPARM,NY
      DIMENSION VRPARM(100)
      EQUIVALENCE (NY,VRPARM)                          
      COMMON /RPARM/  NY,RE,UPSAM,OMGMIN,OMGMAX,OMGINI,EPSD,EPSDIV,
     *                EPSUR,EPSPR,DMPD,DMPMG,EPSMG,DMPSL,EPSSL,
     *                RLXSM,RLXSL,AMINMG,AMAXMG
C
      EQUIVALENCE (DWORK(1),VWORK(1),KWORK(1))
      SAVE
C-----------------------------------------------------------------------
C
      IF (IPRECA.EQ.0) THEN
C
      IF (ISTAT.EQ.1) THEN
       IF (IMASS.EQ.1) THEN
        IF (THSTEP.NE.0D0) THEN
         CALL LLC2(VWORK(KST1)  ,VWORK(KA1),NA,THSTEP,0D0)
         CALL LLC2(VWORK(KM1),VWORK(KA1),NA,1D0,1D0)
        ELSE
         CALL LCP2(VWORK(KM1),VWORK(KA1),NA)
        ENDIF
       ELSE
        IF (THSTEP.NE.0D0) THEN
         CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
         DO 100 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
100      VWORK(KA1+INUA)=VWORK(KA1+INUA)+VWORK(KM1+INU-1)
        ELSE
         CALL LCL2(VWORK(KA1),NA)
         DO 110 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
110      VWORK(KA1+INUA)=VWORK(KM1+INU-1)
        ENDIF
       ENDIF
      ELSE
       CALL LLC2(VWORK(KST1),VWORK(KA1),NA,THSTEP,0D0)
      ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.1) THEN
C
      IF (ISTAT.EQ.1) THEN
       IF (IMASS.EQ.0) THEN
        IF (THSTEP.NE.0D0) THEN
         DO 210 INA=1,NA
210      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1))
C
         DO 220 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
220      VWORK(KA1+INUA)=VWORK(KA1+INUA)+REAL(DWORK(KM1+INU-1))
        ELSE
         CALL LCL2(VWORK(KA1),NA)
         DO 240 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
240      VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
        ENDIF
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 250 INA=1,NA
250      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1)
     *                               +DWORK(KM1+INA-1))
        ELSE
         CALL LCL2(VWORK(KA1),NA)
         DO 260 INA=1,NA
260      VWORK(KA1+INA-1)=REAL(DWORK(KM1+INA-1))
        ENDIF
       ENDIF
      ELSE
         CALL LCL2(VWORK(KA1),NA)
         DO 270 INA=1,NA
270      VWORK(KA1+INA-1)=REAL(THSTEP*DWORK(KST1+INA-1))        
      ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.2) THEN
C
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA2 (VWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC2(VWORK(KA1),VWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL2(VWORK(KA1),NA)
       ENDIF
C
       IF (IMASS.EQ.1) THEN
        CALL  OF0 (59,CFILM(ILEV),0)
        CFILE='MASMAT'
        CALL  ORALC2 (VWORK(KA1),1D0,CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 300 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
300      VWORK(KA1+INUA)=VWORK(KA1+INUA)+REAL(DWORK(KM1+INU-1))
        ELSE
         DO 310 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
310      VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
        ENDIF
       ENDIF
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.3) THEN
C
       CALL ZCTYPE(1,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
       IF (THSTEP.NE.0D0) THEN
        CALL  OF0 (59,CFILST(ILEV),0)
        CFILE='STMAT '
        CALL  ORA1 (DWORK(KA1),CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
        CALL LLC1(DWORK(KA1),DWORK(KA1),NA,THSTEP,0D0)
       ELSE
        CALL LCL1(DWORK(KA1),NA)
       ENDIF
C
       IF (IMASS.EQ.1) THEN
        CALL  OF0 (59,CFILM(ILEV),0)
        CFILE='MASMAT'
        CALL  ORALC1 (DWORK(KA1),1D0,CFILE,59,0)
        REWIND(59)
        CLOSE (59)
        IF (IER.NE.0) RETURN
       ELSE
        IF (THSTEP.NE.0D0) THEN
         DO 400 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
400      DWORK(KA1+INUA)=DWORK(KA1+INUA)+DWORK(KM1+INU-1)
        ELSE
         DO 410 INU=1,NU
         INUA=KWORK(KLDA+INU-1)-1
410      DWORK(KA1+INUA)=DWORK(KM1+INU-1)
        ENDIF
       ENDIF
C
       CALL ZCTYPE(2,KLA(ILEV),'VA    ')
       IF (IER.NE.0) GOTO 99998
       KA1=L(KLA(ILEV))
C
      ENDIF
C
C=======================================================================
C
      IF (IPRECA.EQ.4) THEN
C     
         CALL LCL2(VWORK(KA1),NA)
         IF (ISTAT.EQ.1) THEN
            IF (IMASS.EQ.0) THEN
               DO 510 INU=1,NU
                  INUA=KWORK(KLDA+INU-1)-1
                  VWORK(KA1+INUA)=REAL(DWORK(KM1+INU-1))
 510           CONTINUE
            ENDIF
         ENDIF
C     
      ENDIF
C     
C=======================================================================
C
99998 END
C
C
C
************************************************************************
      SUBROUTINE RESDFK(U1,U2,P,D1,D2,DP,F1,F2,FP,NU,NP,RESU,RESDIV)
************************************************************************
*    Purpose:  Computes the norms RESU, RESDIV
*-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION(A,C-H,O-U,W-Z)
      DIMENSION U1(*),U2(*),P(*),D1(*),D2(*),DP(*),F1(*),F2(*),FP(*)
      COMMON /TRIAD/  NEL,NVT,NMT,NVE,NVEL,NBCT,NVBD
      SAVE 
C
C-----------------------------------------------------------------------
C     Compute the relative l2-norms  RESU,RESDIV
C-----------------------------------------------------------------------
C
      CALL LL21 (F1,NU,RESF1)
      CALL LL21 (F2,NU,RESF2)
      RESF=MAX(RESF1,RESF2)
      IF (ABS(RESF).LT.1D-8) RESF=1D0
C
      CALL LL21 (D1,NU,RESU1)
      CALL LL21 (D2,NU,RESU2)
      RESU=SQRT(RESU1*RESU1+RESU2*RESU2)/RESF
C
C
      CALL LL21 (U1,NU,DNRMU1)
      CALL LL21 (U2,NU,DNRMU2)
      DNORMU=SQRT(DNRMU1*DNRMU1+DNRMU2*DNRMU2)
      IF (ABS(DNORMU).LT.1D-8) DNORMU=1D0
C
      CALL LL21 (DP,NP,RESDIV)
      RESDIV=RESDIV/DNORMU
C
      END
C
C
C
